
#include <windows.h>       /* required for all Windows applications */
#include <stdio.h>
#include "resource.h"
#include <stdlib.h>        /* atoi                                  */
#include <memory.h>         
#include <io.h>         
#include <fcntl.h>
#include <commctrl.h>
#include <sys/types.h>
#include <sys/stat.h>



#include "windrvr.h"
#include "DVB.h"

int VES_TYPE=0;

void Get_Ves_Typ();

DWORD cpu_to_be32(DWORD value);
void SAA7146_WDebi(DWORD config, int addr, DWORD val, int count);
DWORD SAA7146_RDebi(DWORD config, int addr, DWORD val, int count);
void SAA7146_SetGPIO( int port, DWORD data);
int SAA7146_FirmVersion();
int SAA7146_RequestParameter(unsigned short tag, short *Buff, short length);
int SAA7146_OutCommand( short *buf, short length);
int SAA7146_OutCom( int type, int com, short num1, short num2, short num3, short num4, short num5, short num6 ,short num7 ,short num8, short num9, short num10 );
int writereg(unsigned char addr, unsigned char flags,int reg, int data);
unsigned char readreg(unsigned char addr, unsigned char flags,unsigned char reg);
int master_xfer(struct i2c_msg msgs[], int num);
int i2c_master_send(unsigned char addr, unsigned char flags,const char *buf ,int count);
void SAA7146_SetColourFormat(int nColourFormat);
void Set_TV_Freq( unsigned __int64 freq,int LNBNr);
void ARM_ClearMailBox();
void ARM_ClearIrq();
void debiirq();
void video_setmode( int v);
void gpioirq();
void DVB_SET_FRONTEND(struct frontend *front);
void OSDSetColor(unsigned char color, unsigned char  r, unsigned char  g, unsigned char  b, unsigned char  blend);
BOOL Alloc_DVB_Display_DMA(DWORD dwSize, int NR);
int SAA7146_FirmRead(LPSTR FileName, unsigned char *Daten, int Bytes);


void Set22K(int state);
void SetDiSEqC(int input);
void DVB_Reset( void );
void DVB_SetVolume(unsigned char volleft, unsigned char volright);


extern BOOL UnloadDeviceDriver( const TCHAR * Name,BOOL DRemove);
extern BOOL LoadDeviceDriver( const TCHAR * Name, const TCHAR * Path, HANDLE * lphDevice,BOOL Install);






BOOL Init_DVB_Karte(HWND hWnd)
{
FILE* SettingFile;

		OSVERSIONINFO osvi;
		char VersionString[255];
		char Path[255];
		char DumpLine[255];
        int ret;
        long RegRet;
		HKEY hKey;
        unsigned int i,j;
        unsigned char b;


for ( i = 0; i < MAXFILTER; i++ ) Filter[i].pid=0xffff;

if ( Device_Handle == 1 ) {

		osvi.dwOSVersionInfoSize=sizeof(osvi);
		if (GetVersionEx(&osvi) == TRUE ) {
            if ( osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS ) { 
			if  (osvi.dwMinorVersion > 0) strcpy(VersionString,"Windows 98");
			  else strcpy(VersionString,"Windows 95");
			};
            if ( osvi.dwPlatformId == VER_PLATFORM_WIN32_NT ) { 
			NT=TRUE;
			if  (osvi.dwMajorVersion == 4 ) strcpy(VersionString,"Windows NT 4.0");
			  else if  (osvi.dwMajorVersion < 4 ) strcpy(VersionString,"Windows NT 3.51");
 			  else if  (osvi.dwMajorVersion > 4 ) strcpy(VersionString,"Windows NT 5.0");
			};
		}
		
	 SetDlgItemText(SplashWnd,IDC_TEXT1,VersionString);

	 if ( NT == TRUE ) {

		 // Hack 
		 // Ich benutze eine Windriver 4.00 Evaluation Version ( Gutes Teil ))
		 // Eigentlich nur 30 Tage Laufzeit aber ein Lschen folgender Registry-Werte
		 // verlngert die Laufzeit :-)
		 // Diese Version von Windriver kann im Internet von //www.krftech.com gesaugt werden
		 // Zur neuen bersetzung wird die Windrvr.h bentigt ( Ist in der Evaluation enthalten )

         RegRet=RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Network", &hKey);
		 if ( RegRet == ERROR_SUCCESS ) {
			 // ( Werte fr Windriver 4.00 )
      		 RegDeleteValue(hKey,"DriverFigIA");
      		 RegDeleteValue(hKey,"DriverFigLA");
      	 	 RegDeleteValue(hKey,"DriverFigUA");
			 // ( Werte fr Windriver 4.31 )
      		 RegDeleteValue(hKey,"DriverFigId");
      		 RegDeleteValue(hKey,"DriverFigLd");
      	 	 RegDeleteValue(hKey,"DriverFigUd");
             RegCloseKey(hKey);
		 };

		 
		 GetCurrentDirectory(  sizeof (Path),Path );
		 strcat(Path,"\\WINDRVR.SYS");
                    
		 if ( OrgDVBDriverName[0] != 0x00 ) {
			  UnloadDeviceDriver((const char *)OrgDVBDriverName,FALSE);
			  Sleep(500);
		 };

		 if ( ! LoadDeviceDriver( "MultiDec DVB-TV-Treiber", Path, &Device_Handle,TRUE  ) )  {
         		MessageBox(hWnd,"NT-Device-Treiber WinDrvr.sys kann nicht geladen werden","Multi-Decode",MB_ICONSTOP|MB_OK);
               return(FALSE);
		 };
	 } else {

         // Hack 
		 // Ich benutze eine Windriver 4.00 Evaluation Version ( Gutes Teil ))
		 // Eigentlich nur 30 Tage Laufzeit aber ein Lschen folgender Registry-Werte
		 // verlngert die Laufzeit :-)
		 // PS: WinDrvr.vxd beinhaltet einen Patch ansonsten kommt es beim starten zu 
		 //     einer Demo-Versions-Meldung 
		 // Diese Version von Windriver kann im Internet von //www.krftech.com gesaugt werden
		 // Zur neuen bersetzung wird die Windrvr.h bentigt ( Ist in der Evaluation enthalten )

         RegRet=RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Network", &hKey);
		 if ( RegRet == ERROR_SUCCESS ) {
			 // ( Werte fr Windriver 4.00 )
      		 RegDeleteValue(hKey,"DriverFigIA");
      		 RegDeleteValue(hKey,"DriverFigLA");
      	 	 RegDeleteValue(hKey,"DriverFigUA");
			 // ( Werte fr Windriver 4.31 )
      		 RegDeleteValue(hKey,"DriverFigId");
      		 RegDeleteValue(hKey,"DriverFigLd");
      	 	 RegDeleteValue(hKey,"DriverFigUd");
             RegCloseKey(hKey);
		 };

         Device_Handle=CreateFile("\\\\.\\WinDrvr.VXD",0,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_DELETE_ON_CLOSE,0);
		 if(Device_Handle==INVALID_HANDLE_VALUE)
	{
        DWORD x = GetLastError();
		if ( x != 50 ) {
		MessageBox(hWnd,"Windows 95/98 Device-Treiber WinDrvr.vxd kann nicht geladen werden","Multi-Decode",MB_ICONSTOP|MB_OK);
	    return(FALSE);
		};

	}
    }
};

    strcpy(DVBVendorID,"0x1131");
	strcpy(DVBDeviceID,"0x7146");

    ret=SAA7146_Open (&hSAA7146, 0x1131, 0x7146,  TRUE, FALSE );

    if ( ret == 0 ) {
            		   strcpy(DVBTyp,"SAA7146");
		               strcpy(VersionString,"DVB mit SAA7147 gefunden");
	} else if ( ret == 1 ) {
			MessageBox(hWnd,"Windows NT/95/98 Device-Treiber WinDrvr kann nicht angesprochen werden","Multi-Decode",MB_ICONSTOP|MB_OK);
			if ( NT == TRUE ) {
				          UnloadDeviceDriver("MultiDec DVB-TV-Treiber",TRUE);
						  if ( OrgDVBDriverName[0] != 0x00 ) LoadDeviceDriver( (const char *)OrgDVBDriverName, Path, &Device_Handle,FALSE  );
			}
               return(FALSE);
	} else if ( ret == 3 ) {
		    MessageBox(hWnd,"PCI-Karte mit SAA7147 kann nicht gelockt werden !\nDer Interrupt wird mehrfach verwendet!\n\nKein Zugriff auf die Karte mglich","Multi-Decode",MB_ICONSTOP|MB_OK);
			if ( NT == TRUE ) {
				          UnloadDeviceDriver("MultiDec DVB-TV-Treiber",TRUE);
						  if ( OrgDVBDriverName[0] != 0x00 ) LoadDeviceDriver( (const char *)OrgDVBDriverName, Path, &Device_Handle,FALSE  );
			}
               return(FALSE);
	} 


	if ( ret != 0 ) {
         				strcpy(VersionString,"Keine SAA7146");
                    	SetDlgItemText(SplashWnd,IDC_TEXT2,VersionString);
	                    Sleep(2000);
               return(FALSE);
	}						


    if ( SaveSettings == TRUE ) {
        if ((SettingFile =fopen("Setting.SAA","w")) != NULL )  {

			
			fprintf(SettingFile,"SAA7146_IER              0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER));
			fprintf(SettingFile,"SAA7146_ISR              0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, ISR));
			fprintf(SettingFile,"SAA7146_MC1              0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, MC1));
			fprintf(SettingFile,"SAA7146_MC2              0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, MC2));
			fprintf(SettingFile,"SAA7146_PSR              0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PSR));
			fprintf(SettingFile,"SAA7146_SSR              0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, SSR));


			fprintf(SettingFile,"SAA7146_DD1_INIT         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DD1_INIT));
			fprintf(SettingFile,"SAA7146_DD1_STREAM_B     0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DD1_STREAM_B));
			fprintf(SettingFile,"SAA7146_DD1_STREAM_A     0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DD1_STREAM_A));
			fprintf(SettingFile,"SAA7146_BRS_CTRL         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BRS_CTRL));
			fprintf(SettingFile,"SAA7146_HPS_CTRL         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, HPS_CTRL));
			fprintf(SettingFile,"SAA7146_HPS_V_SCALE      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, HPS_V_SCALE));
			fprintf(SettingFile,"SAA7146_HPS_V_GAIN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, HPS_V_GAIN));
			fprintf(SettingFile,"SAA7146_HPS_H_PRESCALE   0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, HPS_H_PRESCALE));
			fprintf(SettingFile,"SAA7146_HPS_H_SCALE      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, HPS_H_SCALE));
			fprintf(SettingFile,"SAA7146_BCS_CTRL         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BCS_CTRL));
			fprintf(SettingFile,"SAA7146_CHROMA_KEY_RANGE 0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, CHROMA_KEY_RANGE));
			fprintf(SettingFile,"SAA7146_CLIP_FORMAT_CTRL 0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, CLIP_FORMAT_CTRL));
			fprintf(SettingFile,"SAA7146_DEBI_CONFIG      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DEBI_CONFIG));
			fprintf(SettingFile,"SAA7146_DEBI_COMMAND     0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DEBI_COMMAND));
			fprintf(SettingFile,"SAA7146_DEBI_PAGE        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DEBI_PAGE));
			fprintf(SettingFile,"SAA7146_DEBI_AD          0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DEBI_AD));
			fprintf(SettingFile,"SAA7146_I2C_TRANSFER     0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, I2C_TRANSFER));
			fprintf(SettingFile,"SAA7146_I2C_STATUS       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, I2C_STATUS));
			fprintf(SettingFile,"SAA7146_RPS_PAGE0        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, RPS_PAGE0));
			fprintf(SettingFile,"SAA7146_RPS_PAGE1        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, RPS_PAGE1));
			fprintf(SettingFile,"SAA7146_RPS_THRESH0      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, RPS_THRESH0));
			fprintf(SettingFile,"SAA7146_RPS_THRESH1      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, RPS_THRESH1));
			fprintf(SettingFile,"SAA7146_RPS_TOV0         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, RPS_TOV0));
			fprintf(SettingFile,"SAA7146_RPS_TOV1         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, RPS_TOV1));
			fprintf(SettingFile,"SAA7146_GPIO_CTRL        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, GPIO_CTRL));
			fprintf(SettingFile,"SAA7146_EC1SSR           0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, EC1SSR));
			fprintf(SettingFile,"SAA7146_EC2SSR           0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, EC2SSR));
			fprintf(SettingFile,"SAA7146_ECT1R            0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, ECT1R));
			fprintf(SettingFile,"SAA7146_ECT2R            0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, ECT2R));
			fprintf(SettingFile,"SAA7146_ACON1            0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, ACON1));
			fprintf(SettingFile,"SAA7146_ACON2            0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, ACON2));
			fprintf(SettingFile,"SAA7146_EC1R             0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, EC1R));
			fprintf(SettingFile,"SAA7146_EC2R             0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, EC2R));
			fprintf(SettingFile,"SAA7146_PCI_BT_V1        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_BT_V1));
			fprintf(SettingFile,"SAA7146_PCI_BT_V2        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_BT_V2));
			fprintf(SettingFile,"SAA7146_PCI_BT_V3        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_BT_V3));
			fprintf(SettingFile,"SAA7146_PCI_BT_DEBI      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_BT_DEBI));
			fprintf(SettingFile,"SAA7146_PCI_BT_A         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_BT_A));
			fprintf(SettingFile,"SAA7146_PCI_VDP1         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_VDP1));
			fprintf(SettingFile,"SAA7146_PCI_VDP2         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_VDP2));
			fprintf(SettingFile,"SAA7146_PCI_VDP3         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_VDP3));
			fprintf(SettingFile,"SAA7146_PCI_ADP1         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_ADP1));
			fprintf(SettingFile,"SAA7146_PCI_ADP2         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_ADP2));
			fprintf(SettingFile,"SAA7146_PCI_ADP3         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_ADP3));
			fprintf(SettingFile,"SAA7146_PCI_ADP4         0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_ADP4));
			fprintf(SettingFile,"SAA7146_PCI_DMA_DDP      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PCI_DMA_DDP));
			fprintf(SettingFile,"**************  Video DMA 1  **************\n");
			fprintf(SettingFile,"SAA7146_BASE_ODD1        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_ODD1));
			fprintf(SettingFile,"SAA7146_BASE_EVEN1       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_EVEN1));
			fprintf(SettingFile,"SAA7146_PROT_ADDR1       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_ADDR1));
			fprintf(SettingFile,"SAA7146_PITCH1           0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PITCH1));
			fprintf(SettingFile,"SAA7146_BASE_PAGE1       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_PAGE1));
			fprintf(SettingFile,"SAA7146_NUM_LINE_BYTE1   0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, NUM_LINE_BYTE1));
			fprintf(SettingFile,"**************  Video DMA 2  **************\n");
			fprintf(SettingFile,"SAA7146_BASE_ODD2        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_ODD2));
			fprintf(SettingFile,"SAA7146_BASE_EVEN2       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_EVEN2));
			fprintf(SettingFile,"SAA7146_PROT_ADDR2       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_ADDR2));
			fprintf(SettingFile,"SAA7146_PITCH2           0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PITCH2));
			fprintf(SettingFile,"SAA7146_BASE_PAGE2       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_PAGE2));
			fprintf(SettingFile,"SAA7146_NUM_LINE_BYTE2   0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, NUM_LINE_BYTE2));
			fprintf(SettingFile,"**************  Video DMA 3  **************\n");
			fprintf(SettingFile,"SAA7146_BASE_ODD3        0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_ODD3));
			fprintf(SettingFile,"SAA7146_BASE_EVEN3       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_EVEN3));
			fprintf(SettingFile,"SAA7146_PROT_ADDR3       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_ADDR3));
			fprintf(SettingFile,"SAA7146_PITCH3           0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PITCH3));
			fprintf(SettingFile,"SAA7146_BASE_PAGE3       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_PAGE3));
			fprintf(SettingFile,"SAA7146_NUM_LINE_BYTE3   0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, NUM_LINE_BYTE3));
			fprintf(SettingFile,"**************  Audio DMA 1  **************\n");
			fprintf(SettingFile,"SAA7146_BASE_A1_IN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_A1_IN));
			fprintf(SettingFile,"SAA7146_PROT_A1_IN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_A1_IN));
			fprintf(SettingFile,"SAA7146_PAGE_A1_IN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PAGE_A1_IN));
			fprintf(SettingFile,"SAA7146_BASE_A1_OUT      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_A1_OUT));
			fprintf(SettingFile,"SAA7146_PROT_A1_OUT      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_A1_OUT));
			fprintf(SettingFile,"SAA7146_PAGE_A1_OUT      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PAGE_A1_OUT));
			fprintf(SettingFile,"**************  Audio DMA 2  **************\n");
			fprintf(SettingFile,"SAA7146_BASE_A2_IN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_A2_IN));
			fprintf(SettingFile,"SAA7146_PROT_A2_IN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_A2_IN));
			fprintf(SettingFile,"SAA7146_PAGE_A2_IN       0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PAGE_A2_IN));
			fprintf(SettingFile,"SAA7146_BASE_A2_OUT      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, BASE_A2_OUT));
			fprintf(SettingFile,"SAA7146_PROT_A2_OUT      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PROT_A2_OUT));
			fprintf(SettingFile,"SAA7146_PAGE_A2_OUT      0x%08x\n",SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PAGE_A2_OUT));
            fprintf(SettingFile,"\n");
			fprintf(SettingFile,"**************  A_TIME_SLOT1 Dump **************\n");
            i=0x180;
			j=0;
			while ( i <= 0x1bc ) {
			if ( j == 0 ) {
            fprintf(SettingFile,"0x%04x : ",i);
	        strcpy(DumpLine,". . . . . . . . . . . . . . . . "); 
    		};
					
            b=SAA7146_ReadByte(hSAA7146, SAA7146_AD_BAR0, i);
			if (( b >= 0x20 ) && ( b < 128 )) DumpLine[j*2]=b; 
            fprintf(SettingFile,"0x%02x ",b);
			j++;

			if ( j > 15 ) {
               fprintf(SettingFile,"%s\n",DumpLine);
			   j=0;
			};
			i++;
			};


			if ( j > 0 ) {
				while ( j < 16 ) {
					fprintf(SettingFile,"     ");
					j++;
				}
               fprintf(SettingFile,"%s\n",DumpLine);
			};
            fprintf(SettingFile,"\n");
  		    fprintf(SettingFile,"**************  A_TIME_SLOT2 Dump **************\n");
            i=0x1C0;
			j=0;
			while ( i <= 0x1FC ) {
			if ( j == 0 ) {
            fprintf(SettingFile,"0x%04x : ",i);
	        strcpy(DumpLine,". . . . . . . . . . . . . . . . "); 
    		};
            b=SAA7146_ReadByte(hSAA7146, SAA7146_AD_BAR0, i);
			if (( b >= 0x20 ) && ( b < 128 )) DumpLine[j*2]=b; 
            fprintf(SettingFile,"0x%02x ",b);
			j++;

			if ( j > 15 ) {
               fprintf(SettingFile,"%s\n",DumpLine);
			   j=0;
			};
			i++;
			};


			if ( j > 0 ) {
				while ( j < 16 ) {
					fprintf(SettingFile,"     ");
					j++;
				}
               fprintf(SettingFile,"%s\n",DumpLine);
			};
            fprintf(SettingFile,"\n");
  		    fprintf(SettingFile,"**************  VES-1893 Dump **************\n");
            i=0;
			j=0;
			while ( i < 54 ) {
			if ( j == 0 ) {
            fprintf(SettingFile,"0x%04x : ",i);
	        strcpy(DumpLine,". . . . . . . . . . . . . . . . "); 
    		};
 		    b=readreg((0x10 >> 1),0,i); 
			if (( b >= 0x20 ) && ( b < 128 )) DumpLine[j*2]=b; 
            fprintf(SettingFile,"0x%02x ",b);
			j++;
			if ( j > 15 ) {
               fprintf(SettingFile,"%s\n",DumpLine);
			   j=0;
			};
			i++;
			};


			if ( j > 0 ) {
				while ( j < 16 ) {
					fprintf(SettingFile,"     ");
					j++;
				}
               fprintf(SettingFile,"%s\n",DumpLine);
			};
            fprintf(SettingFile,"\n");
			fclose(SettingFile);
		}
	}


Has_DVB=TRUE;
    if (!SAA7146_IntEnable(hSAA7146, NULL)) {
						return(TRUE);
};


return(TRUE);


return(TRUE);
};



BOOL Alloc_SAA7146_DMA(DWORD dwSize, WD_DMA *dma,int Option )
{
    BZERO(*dma);
	if ( Option == DMA_KERNEL_BUFFER_ALLOC ) dma->pUserAddr=NULL;
	  else dma->pUserAddr=malloc(dwSize);
	dma->dwBytes=dwSize;
 
	dma->dwOptions=Option;
    WD_DMALock(hSAA7146->hWD,dma);
	if ( dma->hDma == 0 ) {
	                if ( dma->dwOptions != DMA_KERNEL_BUFFER_ALLOC)  free(dma->pUserAddr);
                    dma->pUserAddr=NULL;
					return(FALSE);
	}
	return TRUE;
}

void Free_SAA7146_DMA( WD_DMA *dma )
{
	LPVOID *MemPtr=NULL;
	if ( dma == NULL ) return;
	if ( dma->hDma != 0 ) {
			                if ( dma->dwOptions != DMA_KERNEL_BUFFER_ALLOC)  MemPtr=dma->pUserAddr;
		                    WD_DMAUnlock(hSAA7146->hWD,dma);
                            if ( MemPtr != NULL ) free(MemPtr);
							dma->pUserAddr=NULL;

	}
}


BOOL Init_DVB_Memory(void)
{


	if(!Alloc_DVB_Display_DMA(924800,0))  
	{
		MessageBox(hWnd,"DVB-Display Memory (Physikalisch Linear) nicht verfgbar","Multi-Decode",MB_ICONSTOP|MB_OK);
		return(FALSE);
	}
	if(!Alloc_DVB_Display_DMA(924800,1))
	{
		MessageBox(hWnd,"DVB-Display Memory (Physikalisch Linear) nicht verfgbar","Multi-Decode",MB_ICONSTOP|MB_OK);
		return(FALSE);
	}

	if(!Alloc_SAA7146_DMA(DEBI_MEM_SIZE,&debi_mem_dma,DMA_KERNEL_BUFFER_ALLOC))
	{
		MessageBox(hWnd,"Debi-Memory kann fr SAA-Zugriff nicht gelockt werden","Multi-Decode",MB_ICONSTOP|MB_OK);
		return(FALSE);
	}

	
	if(!Alloc_SAA7146_DMA(RPS_MEM_SIZE,&rps0_mem_dma,DMA_KERNEL_BUFFER_ALLOC))
	{
		MessageBox(hWnd,"RPS Memory kann fr SAA-Zugriff nicht gelockt werden","Multi-Decode",MB_ICONSTOP|MB_OK);
		return(FALSE);
	}



return(TRUE);
}


BOOL Alloc_DVB_Display_DMA(DWORD dwSize, int NR)
{
	DVB_Display_dma[NR]=calloc(sizeof(WD_DMA)+sizeof(WD_DMA_PAGE),1);
   	DVB_Display_dma[NR]->pUserAddr=NULL;
	DVB_Display_dma[NR]->dwBytes=dwSize;
    DVB_Display_dma[NR]->dwOptions=DMA_KERNEL_BUFFER_ALLOC;
    WD_DMALock(hSAA7146->hWD,DVB_Display_dma[NR]);
	if ( DVB_Display_dma[NR]->hDma == 0 ) {
                    DVB_Display_dma[NR]->pUserAddr=NULL;
					free(DVB_Display_dma[NR]);
					DVB_Display_dma[NR]=NULL;
					return(FALSE);
	}
	
	return TRUE;
}

void Free_DVB_Display_DMA(int NR)
{
	LPVOID *MemPtr=NULL;

	if ( DVB_Display_dma[NR] == NULL ) return;
	if ( DVB_Display_dma[NR]->hDma != 0 ) {
		                    WD_DMAUnlock(hSAA7146->hWD,DVB_Display_dma[NR]);
							free(DVB_Display_dma[NR]);
							DVB_Display_dma[NR]=NULL;
	}
	return ;
}


BOOL Init_DVB_HardWare(HWND hWnd)
{
int i;
unsigned x;
DWORD Buffer;

unsigned char *Debimem;
int DebiLen=0;

unsigned char *DRammem;
int DRamLen=0;

unsigned char *DPRammem;
int DPRamLen=0;
char Text[80];

if ( Keep_DVB_Loaded == TRUE ) {
   	    SetDlgItemText(SplashWnd,IDC_TEXT3,"Prfe Firmware");
	// Ist vieleicht noch geladen ??
		x=SAA7146_FirmVersion();
        if ( x == FirmID ) {
   	    SetDlgItemText(SplashWnd,IDC_TEXT3,"Firmware Aktiv");
		sprintf(Text,"Version %08x",x);
        SetDlgItemText(SplashWnd,IDC_TEXT4,Text);

        Get_Ves_Typ();
		if ( VES_TYPE == -1 ) return(FALSE);
		ARM_ClearIrq();
        ARM_ClearMailBox();
  	    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER , (MASK_27 | MASK_28 | MASK_03 ));
		SAA7146_SetColourFormat(ColourFormat);
        SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0,MC1, (MASK_21));
        return(TRUE);
		};
};

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1,0xbfff0000);

	Sleep(100);
//	 clear out any rps-signals pending 
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2,0xf8000000);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, ISR,0xffffffff);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER, 0x00000000);

	for( i = 0x0; i < 0xfc; i+=0x4 ) {
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, i,0x00000000);
	}

	for( i = 0x104; i < 0x1fc; i+=0x4 ) {
	    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, i,0x00000000);
	}

//	 clear out any rps-signals pending 
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2,0xf8000000);

//	 enable video-port-pins
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1,(MASK_10 | MASK_26));

//	 disable all interrupt-conditions, only enable RPS interrupts 
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, ISR,0xffffffff);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER, (MASK_27 | MASK_28));

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, PCI_BT_V1, 	0x0000101f);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, BCS_CTRL, 	0x80400040);

//	 set dd1 stream a & b 
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DD1_STREAM_B, 	0x00000000);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DD1_INIT, 	0x02000000);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, 	(MASK_09 | MASK_25 | MASK_10 | MASK_26));

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, 0x077c077c );


	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, GPIO_CTRL, 0x500000 );
       	
        /* enable DEBI */
    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, 0x08800880);
    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, 0x54, 0x04000000);
    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_09 | MASK_25 | MASK_10 | MASK_26));


        SAA7146_WDebi(0x6e0000, DPRAM_BASE, 0x76543210, 4);
        i=SAA7146_RDebi(DEBINOSWAP, DPRAM_BASE, 0, 4);


		if ( i!=0x10325476) {
		    			  SetDlgItemText(SplashWnd,IDC_TEXT3,"Falsche Antwort");
		    			  SetDlgItemText(SplashWnd,IDC_TEXT4,"von DVB-Hardware");
						  return FALSE;
		}
// XXNEUXX Zeile Wech
//		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1,(MASK_10 | MASK_26));

     	DebiLen=SAA7146_FirmRead("Boot_up.axf",NULL,0 );
		if ( DebiLen <= 0 ) {
		    			  SetDlgItemText(SplashWnd,IDC_TEXT3,"Boot-Sequenz");
		    			  SetDlgItemText(SplashWnd,IDC_TEXT4,"Boot_up.axf");
		    			  SetDlgItemText(SplashWnd,IDC_TEXT5,"nicht gefunden");
			return(FALSE);
		}
        Debimem=malloc(DEBI_MEM_SIZE);

		i=SAA7146_FirmRead("Boot_up.axf",Debimem,DebiLen  );
		
		if ( i <= 0 ) {
		    free(Debimem);
			return(FALSE);
		}


        SAA7146_SetGPIO( 0, GPIO_IRQLO);
        SAA7146_SetGPIO( 1, GPIO_INPUT);
        SAA7146_SetGPIO( 3, GPIO_INPUT);

		SAA7146_SetGPIO(RESET_LINE, GPIO_OUTLO);
		Sleep(10);

        SAA7146_WDebi(DEBISWAB, DPRAM_BASE,  Debimem, DebiLen);
        SAA7146_WDebi(DEBINOSWAP, BOOT_STATE, BOOTSTATE_BUFFER_FULL, 2);

		free(Debimem);

       	(void)SAA7146_Wait_for_Debi_done();
        SAA7146_SetGPIO(RESET_LINE, GPIO_OUTHI);


     	DRamLen=SAA7146_FirmRead("Root",NULL,0 );
        DRammem=malloc(DRamLen);
		if ( DRammem == NULL ) {
		    			  SetDlgItemText(SplashWnd,IDC_TEXT3,"Firmware");
		    			  SetDlgItemText(SplashWnd,IDC_TEXT4,"Root");
		    			  SetDlgItemText(SplashWnd,IDC_TEXT5,"nicht gefunden");

			return(FALSE);
		}
   	    SetDlgItemText(SplashWnd,IDC_TEXT3,"Lade Firmware");

		i=SAA7146_FirmRead("Root",DRammem,DRamLen );

        i=SAA7146_Load_Dram(DRammem, DRamLen);

        free(DRammem);
		if ( i < 0 ) return(FALSE);

        SAA7146_SetGPIO(RESET_LINE, GPIO_OUTLO);

        
     	DPRamLen=SAA7146_FirmRead("Dpram",NULL,0 );
        DPRammem=malloc(DPRamLen);
		if ( DPRammem == NULL ) {
		    			  SetDlgItemText(SplashWnd,IDC_TEXT4,"DPRam");
		    			  SetDlgItemText(SplashWnd,IDC_TEXT5,"nicht gefunden");

			return(FALSE);
		}
		i=SAA7146_FirmRead("Dpram",DPRammem,DPRamLen );
		SAA7146_WDebi(DEBISWAB, DPRAM_BASE, DPRammem, DPRamLen);

// XXNEUXX INSERT
       	(void)SAA7146_Wait_for_Debi_done();



        free(DPRammem);
		if ( i < 0 ) return(FALSE);
        SAA7146_SetGPIO(RESET_LINE, GPIO_OUTHI);

		ARM_ClearIrq();
        
		Sleep(50);
		FirmID=SAA7146_FirmVersion();
		sprintf(Text,"Version %08x",FirmID);
        SetDlgItemText(SplashWnd,IDC_TEXT4,Text);
		sprintf(Text,"Init Frontend",i);
        SetDlgItemText(SplashWnd,IDC_TEXT5,Text);
		Buffer=( SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) | MASK_03  ); //new
    	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER , Buffer );
		i=VES1820_Init();
	    VES_TYPE=0;

		if ( i < 0 ) {
                      i=VES1893_Init();
					  VES_TYPE=1;
					  if ( i >= 0 ) {
                      SetDlgItemText(SplashWnd,IDC_TEXT5,"VES-1893 OK");
                      strcpy(VESTyp,"VES1893"); 
					  };
		} else {
            strcpy(VESTyp,"VES1820"); 
			SetDlgItemText(SplashWnd,IDC_TEXT5,"VES-1820 OK");
		};

		if ( i < 0 ) {
		    VES_TYPE=-1;
			SetDlgItemText(SplashWnd,IDC_TEXT5,"VES-Init Fail");
			return(FALSE);
		};

SAA7146_SetColourFormat(ColourFormat);
SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0,MC1, (MASK_21));
return(TRUE);
};


void SAA7146_SetGPIO( int port, DWORD data)
{
        DWORD val;

   val=SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0,GPIO_CTRL);
   val&=~(0xff << (8*(port)));
   val|=(data)<<(8*(port));
   SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, GPIO_CTRL, val);
}


int SAA7146_DebiWrite(DWORD config, DWORD addr, DWORD val, DWORD count)
{
	DWORD Length=(count << 17) | (addr & 0xffff);
    DWORD PokeReg=(2 << 16) | 2;
	if (count <= 0 || count > 32764) return(-1);
	if (SAA7146_Wait_for_Debi_done() < 0) return(-1);

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_CONFIG,config );
	if (count <= 4)	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_AD,val);
	else SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_AD,debi_mem_dma.Page[0].pPhysicalAddr);

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_COMMAND,Length);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2,PokeReg);
	return 0;
}

DWORD SAA7146_DebiRead(DWORD config, DWORD addr, DWORD count)
{
	DWORD result = 0;
	DWORD Length=(count << 17) | 0x10000 | (addr & 0xffff);
    DWORD PokeReg=(2 << 16) | 2;

	if (count > 32764 || count <= 0) return 0;
	if (SAA7146_Wait_for_Debi_done() < 0) return 0;
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_AD,debi_mem_dma.Page[0].pPhysicalAddr);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_COMMAND,Length);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DEBI_CONFIG,config );
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2,PokeReg);
	if (count > 4) return count;
	SAA7146_Wait_for_Debi_done();
	result = SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, DEBI_AD);
        result &= (0xffffffffUL >> ((4-count)*8));
	return result;
}

int SAA7146_Wait_for_Debi_done()
{
	int i;

	/* wait for registers to be programmed */
	for (i = 0; i < 100000; i++)
    if ( SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, MC2) & 2) break;
	/* wait for transfer to complete */
	for (i = 0; i < 500000 &&
	     (SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, PSR) & SPCI_DEBI_S); i++)
                          	SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, MC2);
	
	if (i == 500000) return -1;
	return 0;
}


void SAA7146_WDebi(DWORD config, DWORD addr, DWORD val, DWORD count)
{
        if (count>4 && val) memcpy(debi_mem_dma.pUserAddr, (unsigned char *)val, count);
        SAA7146_DebiWrite(config, addr, val, count);
}

DWORD SAA7146_RDebi(DWORD config, DWORD addr, DWORD val, DWORD count)
{
    DWORD res;

        res=SAA7146_DebiRead(config, addr, count);
        if (count>4 && val) memcpy((unsigned char *) val, debi_mem_dma.pUserAddr, count);
        return res;
}






int SAA7146_Open (SAA7146_HANDLE *phSAA7146, DWORD dwVendorID, DWORD dwDeviceID,  DWORD options, BOOL Lock)
{
	int Ret = 0;

    SAA7146_HANDLE hSAA7146 = (SAA7146_HANDLE) malloc (sizeof (SAA7146_STRUCT));

    WD_PCI_SCAN_CARDS pciScan;
    WD_PCI_CARD_INFO pciCardInfo;

    BZERO(*hSAA7146);

    hSAA7146->cardReg.hCard = 0;
    hSAA7146->hWD = WD_Open();

    // check if handle valid & version OK
    if (hSAA7146->hWD==INVALID_HANDLE_VALUE)
    {
        //Cannot open WinDriver device
		Ret=1;
        goto Exit;
    }


    BZERO(pciScan);
    pciScan.searchId.dwVendorId = dwVendorID;
    pciScan.searchId.dwDeviceId = dwDeviceID;
    WD_PciScanCards (hSAA7146->hWD, &pciScan);
    if (pciScan.dwCards==0) // Found at least one card
    {
		Ret=2;
        // error - Cannot find PCI card
        goto Exit;
    }

    BZERO(pciCardInfo);
    pciCardInfo.pciSlot = pciScan.cardSlot[0];
    WD_PciGetCardInfo (hSAA7146->hWD, &pciCardInfo);
    hSAA7146->pciSlot = pciCardInfo.pciSlot;
    hSAA7146->cardReg.Card = pciCardInfo.Card;

    if (options & SAA7146_OPEN_USE_INT) hSAA7146->fUseInt = TRUE;
    else hSAA7146->fUseInt = FALSE;
    if (!hSAA7146->fUseInt)
    {
        DWORD i;
        // Remove interrupt item if not needed
        for (i=0; i<hSAA7146->cardReg.Card.dwItems; i++)
        {
            WD_ITEMS *pItem = &hSAA7146->cardReg.Card.Item[i];
            if (pItem->item==ITEM_INTERRUPT)
                pItem->item = ITEM_NONE;
        }
    }
    else
    {
        DWORD i;
        // make interrupt resource sharable
        for (i=0; i<hSAA7146->cardReg.Card.dwItems; i++)
        {
            WD_ITEMS *pItem = &hSAA7146->cardReg.Card.Item[i];
            if (pItem->item==ITEM_INTERRUPT)
                pItem->fNotSharable = Lock;
        }
    }

    hSAA7146->cardReg.fCheckLockOnly = FALSE;
    WD_CardRegister (hSAA7146->hWD, &hSAA7146->cardReg);
    if (hSAA7146->cardReg.hCard==0)
    {
        Ret=3;
        goto Exit;
  }

    if (!SAA7146_DetectCardElements(hSAA7146))
    {
		Ret=4;
        goto Exit;
    }

    // Open finished OK
    *phSAA7146 = hSAA7146;
    return Ret;

Exit:
    // Error during Open
    if (hSAA7146->cardReg.hCard) 
        WD_CardUnregister(hSAA7146->hWD, &hSAA7146->cardReg);
    if (hSAA7146->hWD!=INVALID_HANDLE_VALUE)
        WD_Close(hSAA7146->hWD);
    free (hSAA7146);
    return Ret;
}



BOOL SAA7146_DetectCardElements(SAA7146_HANDLE hSAA7146)
{
    DWORD i;
    DWORD ad_sp;

    BZERO(hSAA7146->Int);
    BZERO(hSAA7146->addrDesc);

    for (i=0; i<hSAA7146->cardReg.Card.dwItems; i++)
    {
        WD_ITEMS *pItem = &hSAA7146->cardReg.Card.Item[i];

        switch (pItem->item)
        {
        case ITEM_MEMORY:
        case ITEM_IO:
            {
                DWORD dwBytes;
                DWORD dwPhysAddr;
                BOOL fIsMemory;
                if (pItem->item==ITEM_MEMORY)
                {
                    dwBytes = pItem->I.Mem.dwBytes;
                    dwPhysAddr = pItem->I.Mem.dwPhysicalAddr;
                    fIsMemory = TRUE;
                }
                else 
                {
                    dwBytes = pItem->I.IO.dwBytes;
                    dwPhysAddr = pItem->I.IO.dwAddr;
                    fIsMemory = FALSE;
                }

                for (ad_sp=0; ad_sp<SAA7146_ITEMS; ad_sp++)
                {
                    DWORD dwPCIAddr;
                    DWORD dwPCIReg;

                    if (SAA7146_IsAddrSpaceActive(hSAA7146, ad_sp)) continue;
                    if (ad_sp<SAA7146_AD_EPROM) dwPCIReg = PCI_BAR0 + 4*ad_sp;
                    else dwPCIReg = PCI_ERBAR;
                    dwPCIAddr = SAA7146_ReadPCIReg(hSAA7146, dwPCIReg);
                    if (dwPCIAddr & 1)
                    {
                        if (fIsMemory) continue;
                        dwPCIAddr &= ~(0x3);
                    }
                    else
                    {
                        if (!fIsMemory) continue;
                        dwPCIAddr &= ~(0xf);
                    }
                    if (dwPCIAddr==dwPhysAddr)
                        break;
                }
                if (ad_sp<SAA7146_ITEMS)
                {
                    DWORD j;
                    hSAA7146->addrDesc[ad_sp].fActive = TRUE;
                    hSAA7146->addrDesc[ad_sp].index = i;
                    hSAA7146->addrDesc[ad_sp].fIsMemory = fIsMemory;
                    hSAA7146->addrDesc[ad_sp].dwMask = 0;
                    for (j=1; j<dwBytes && j!=0x80000000; j *= 2)
                    {
                        hSAA7146->addrDesc[ad_sp].dwMask = 
                            (hSAA7146->addrDesc[ad_sp].dwMask << 1) | 1;
                    }
                }
            }
            break;
        case ITEM_INTERRUPT:
            if (hSAA7146->Int.Int.hInterrupt) return FALSE;
            hSAA7146->Int.Int.hInterrupt = pItem->I.Int.hInterrupt;
            break;
        }
    }

    // check that all the items needed were found
    // check if interrupt found
    if (hSAA7146->fUseInt && !hSAA7146->Int.Int.hInterrupt) 
    {
        return FALSE;
    }

    // check that at least one memory space was found
    for (i = 0; i<SAA7146_ITEMS; i++)
        if (SAA7146_IsAddrSpaceActive(hSAA7146, i)) break;
    if (i==SAA7146_ITEMS) return FALSE;

    return TRUE;
}


void DVB_Close()
{
SAA7146_Close(hSAA7146);
hSAA7146=NULL;
};


void SAA7146_Close(SAA7146_HANDLE hSAA7146)
{
int i;


if ( Keep_DVB_Loaded == TRUE ) {

    video_setmode(0);

    DVB_SetVolume(0x00,0x00);

    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, MASK_28);	

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER, 0x00000000);
	i=0;
	for ( i=0; i < 50; i++ ) {
		Sleep(0);
		Sleep(0);
		Sleep(1);
		Sleep(0);
		Sleep(0);
	};
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, ISR,0xffffffff);
} else {

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1,0xbfff0000);


	/* disable all interrupt-conditions, only enable RPS interrupts */
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER, 0x00000000);
	i=0;
	for ( i=0; i < 50; i++ ) {
		Sleep(0);
		Sleep(0);
		Sleep(1);
		Sleep(0);
		Sleep(0);
	};

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, ISR,0xffffffff);
};

    // disable interrupts
    if (SAA7146_IntIsEnabled(hSAA7146))
        SAA7146_IntDisable(hSAA7146);

    // unregister card
    if (hSAA7146->cardReg.hCard) 
        WD_CardUnregister(hSAA7146->hWD, &hSAA7146->cardReg);

    // close WinDriver
    WD_Close(hSAA7146->hWD);
    free (hSAA7146);
}

void SAA7146_WritePCIReg(SAA7146_HANDLE hSAA7146, DWORD dwReg, DWORD dwData)
{
    WD_PCI_CONFIG_DUMP pciCnf;

    BZERO(pciCnf);
    pciCnf.pciSlot = hSAA7146->pciSlot;
    pciCnf.pBuffer = &dwData;
    pciCnf.dwOffset = dwReg;
    pciCnf.dwBytes = 4;
    pciCnf.fIsRead = FALSE;
    WD_PciConfigDump(hSAA7146->hWD,&pciCnf);
}

DWORD SAA7146_ReadPCIReg(SAA7146_HANDLE hSAA7146, DWORD dwReg)
{
    WD_PCI_CONFIG_DUMP pciCnf;
    DWORD dwVal;

    BZERO(pciCnf);
    pciCnf.pciSlot = hSAA7146->pciSlot;
    pciCnf.pBuffer = &dwVal;
    pciCnf.dwOffset = dwReg;
    pciCnf.dwBytes = 4;
    pciCnf.fIsRead = TRUE;
    WD_PciConfigDump(hSAA7146->hWD,&pciCnf);
    return dwVal;
}


BOOL SAA7146_IsAddrSpaceActive(SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace){
    return hSAA7146->addrDesc[addrSpace].fActive;
}

// General read/write function
void SAA7146_ReadWriteBlock(SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, BOOL fRead, PVOID buf, DWORD dwBytes, SAA7146_MODE mode)
{
    WD_TRANSFER trans;
    BOOL fMem = hSAA7146->addrDesc[addrSpace].fIsMemory;
    // safty check: is the address range active
    if (!SAA7146_IsAddrSpaceActive(hSAA7146, addrSpace)) return;
    BZERO(trans);
    if (fRead)
    {
        if (mode==SAA7146_MODE_BYTE) trans.cmdTrans = fMem ? RM_SBYTE : RP_SBYTE;
        else if (mode==SAA7146_MODE_WORD) trans.cmdTrans = fMem ? RM_SWORD : RP_SWORD;
        else if (mode==SAA7146_MODE_DWORD) trans.cmdTrans = fMem ? RM_SDWORD : RP_SDWORD;
    }
    else
    {
        if (mode==SAA7146_MODE_BYTE) trans.cmdTrans = fMem ? WM_SBYTE : WP_SBYTE;
        else if (mode==SAA7146_MODE_WORD) trans.cmdTrans = fMem ? WM_SWORD : WP_SWORD;
        else if (mode==SAA7146_MODE_DWORD) trans.cmdTrans = fMem ? WM_SDWORD : WP_SDWORD;
    }
    if (fMem)
        trans.dwPort = hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwTransAddr;
    else trans.dwPort = hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.IO.dwAddr;
    trans.dwPort += dwOffset;

    trans.fAutoinc = TRUE;
    trans.dwBytes = dwBytes;
    trans.dwOptions = 0;
    trans.Data.pBuffer = buf;
    WD_Transfer (hSAA7146->hWD, &trans);
}

BYTE SAA7146_ReadByte (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset)
{
    BYTE data;
    if (hSAA7146->addrDesc[addrSpace].fIsMemory)
    {
        PBYTE pData = (PBYTE) (hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwUserDirectAddr + dwOffset);
        data = *pData; // read from the memory mapped range directly
    }
    else SAA7146_ReadWriteBlock( hSAA7146, addrSpace, dwOffset, TRUE, &data, sizeof (BYTE), SAA7146_MODE_BYTE);
    return data;
}

WORD SAA7146_ReadWord (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset)
{
    WORD data;
    if (hSAA7146->addrDesc[addrSpace].fIsMemory)
    {
        PWORD pData = (PWORD) (hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwUserDirectAddr + dwOffset);
        data = *pData; // read from the memory mapped range directly
    }
    else SAA7146_ReadWriteBlock( hSAA7146, addrSpace, dwOffset, TRUE, &data, sizeof (WORD), SAA7146_MODE_WORD);
    return data;
}

DWORD SAA7146_ReadDword (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset)
{
    DWORD data;
    if (hSAA7146->addrDesc[addrSpace].fIsMemory)
    {
        PDWORD pData = (PDWORD) (hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwUserDirectAddr + dwOffset);
        data = *pData; // read from the memory mapped range directly
    }
    else SAA7146_ReadWriteBlock( hSAA7146, addrSpace, dwOffset, TRUE, &data, sizeof (DWORD), SAA7146_MODE_DWORD);
    return data;
}

void SAA7146_WriteByte (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, BYTE data)
{
    if (hSAA7146->addrDesc[addrSpace].fIsMemory)
    {
        PBYTE pData = (PBYTE) (hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwUserDirectAddr + dwOffset);
        *pData = data; // write to the memory mapped range directly
    }
    else SAA7146_ReadWriteBlock( hSAA7146, addrSpace, dwOffset, FALSE, &data, sizeof (BYTE), SAA7146_MODE_BYTE);
}

void SAA7146_WriteWord (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, WORD data)
{
    if (hSAA7146->addrDesc[addrSpace].fIsMemory)
    {
        PWORD pData = (PWORD) (hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwUserDirectAddr + dwOffset);
        *pData = data; // write to the memory mapped range directly
    }
    else SAA7146_ReadWriteBlock( hSAA7146, addrSpace, dwOffset, FALSE, &data, sizeof (WORD), SAA7146_MODE_WORD);
}

void SAA7146_WriteDword (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, DWORD data)
{
    if (hSAA7146->addrDesc[addrSpace].fIsMemory)
    {
        PDWORD pData = (PDWORD) (hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwUserDirectAddr + dwOffset);
        *pData = data; // write to the memory mapped range directly
    }
    else SAA7146_ReadWriteBlock( hSAA7146, addrSpace, dwOffset, FALSE, &data, sizeof (DWORD), SAA7146_MODE_DWORD);
}

BOOL SAA7146_IntIsEnabled (SAA7146_HANDLE hSAA7146)
{
    if (!hSAA7146->fUseInt) return FALSE;
    if (!hSAA7146->Int.hThread) return FALSE;
    return TRUE;
}



DWORD WINAPI SAA7146_IntThread (PVOID pData)
{
    SAA7146_HANDLE hSAA7146 = (SAA7146_HANDLE) pData;
	int status;
	int isr;
	int status1;
	int Picture;


    ProzessorMask=1<<(IrqProzessor);
    status=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         
 
	for (;;)
    {
	
        WD_IntWait (hSAA7146->hWD, &hSAA7146->Int.Int);
        if (hSAA7146->Int.Int.fStopped)
            break; // WD_IntDisable() was called
		if ( Current_Mode == 0 ) continue;
		isr=hSAA7146->Int.Trans[0].Data.Dword;
		status1=hSAA7146->Int.Trans[1].Data.Dword;
		Picture=(hSAA7146->Int.Trans[2].Data.Dword >> 11);

		if  (isr&MASK_19) {
//			debiirq();
			continue;
		}

        if (isr&MASK_03) {
//            gpioirq();
			continue;
	}


        switch(Picture) {

        case 1:     NextFrame=1;
					SetEvent(Decode_Event);
					break;
        case 2:     NextFrame=2;
					SetEvent(Decode_Event);
					break;
		default :
					break;
		}

	
	
	
	}
    return 0;
}


void debiirq()
{
int i;
unsigned short Buffer[6*1024];

        SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER,SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) & ~MASK_19 );
        debitype = SAA7146_RDebi(DEBINOSWAP, IRQ_STATE, 0, 2);
        debilen  = SAA7146_RDebi(DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
        switch (debitype&0xff) {

        case DATA_MPEG_RECORD:

                // MPEG-Daten Sichern
			    ARM_ClearMailBox();
                break;

        case DATA_COMMON_INTERFACE:
        {
                unsigned char pnr[2]={0x00, 0x2b};
                static int flag=0;
                int i;
/*
                printk("%02x ", *(u8 *)dvb->saa->debi);
                printk("%02x ", *(1+(u8 *)dvb->saa->debi));
                for (i=2; i<dvb->debilen; i++)
                  printk("%02x ", (*(i+(char *)dvb->saa->debi)));
                for (i=2; i<dvb->debilen; i++)
                  printk("%c", chtrans(*(i+(char *)dvb->saa->debi)));
                printk("\n");
*/
                ARM_ClearMailBox();
/*
				if (*((u8 *)dvb->saa->debi)==14){
                  if (!flag)
                    SendCICommand(dvb, CI_CMD_FAST_PSI, (u8 *) pnr, 2);
                  flag=1;
                }
                if (*((u8 *)dvb->saa->debi)==12) {
                  SendCICommand(dvb, 0x05, (u8 *)pnr, 2);
                }
// ELSE
    if (*((u8 *)dvb->saa->debi)==14){
                  if (!flag)
                    SendCICommand(dvb, 0x02, 0, 0);
                  flag=1;
                }
                if (*((u8 *)dvb->saa->debi)==12) {
                  SendCICommand(dvb, 0x05, (u8 *)pnr, 2);
                }
*/
  break;
        }
        case DATA_TELETEXT:
          /*
        {
                int i;
                for (i=0; i<dvb->debilen; i++)
                  printk("%c", chtrans(*(i+(char *)dvb->saa->debi)));
                printk("\n");
                dvb->saa->debi[dvb->debilen-1]=0;
                ARM_ClearMailBox(dvb);
                break;
        }
          */
        case DATA_FSECTION:
        {
/*                if (dvb->filter_flags[handle]&FILTER_UDP)
                        net_fsection(&dvb->net, (void*)dvb->saa->debi, 
                                     dvb->debilen, 3000+handle);
                if (dvb->filter_flags[handle]&FILTER_MEM)
                        fsection(dvb, handle, (void*)dvb->saa->debi, dvb->debilen);
*/
                 ARM_ClearMailBox();
                break;
        }

        case DATA_IPMPE:
//                net_ipmpe(&dvb->net, (void*)dvb->saa->debi, dvb->debilen);
                ARM_ClearMailBox();
                break;

        case DATA_MPEG_PLAY:
        case DATA_BMP_LOAD:
        default:
                ARM_ClearMailBox();
                break;
        }
               
 }

void gpioirq()
{
        
	int len;

	    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER,SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) & ~MASK_19 );

		ARM_ClearIrq();
        
        debitype = SAA7146_RDebi(DEBINOSWAP, IRQ_STATE, 0, 2);
        debilen  = SAA7146_RDebi(DEBINOSWAP, IRQ_STATE_EXT, 0, 2);

        switch (debitype&0xff) {
        case DATA_MPEG_RECORD:
/*                int blocksize, len;

                debilen=len=SAA7146_RDebi( DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
                blocksize = dvb->avin.head - dvb->avin.tail;
                if (blocksize <= 0) 
                        blocksize += dvb->avin.length;
                if (blocksize<=len) {
                        ARM_ClearMailBox();
                        return;
                }
*/
                SAA7146_Wait_for_Debi_done();
                SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER,SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) | MASK_19 );
                SAA7146_RDebi( DEBISWAB, DATA_BUFF_BASE, 0, debilen);
  break;


        case DATA_MPEG_PLAY:
/*                
                if (dvb->avout.head == dvb->avout.tail) {
                        iwdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
                        ARM_ClearMailBox(dvb);
                        return;
                }

                sync=((u16)*(u8 *)(dvb->avout.buf+((dvb->avout.head)&(dvb->avout.length-1))))<<8;
                sync|=*(u8 *)(dvb->avout.buf+((dvb->avout.head+1)&(dvb->avout.length-1)));
                
                while (sync!=0x4156 && 
                       dvb->avout.head!=dvb->avout.tail)
                {
                        dprintk("resync\n");
                        dvb->avout.head=(dvb->avout.head+1)&(dvb->avout.length-1);
                        sync=((u16)*(u8 *)(dvb->avout.buf+((dvb->avout.head)&(dvb->avout.length-1))))<<8;
                        sync|=*(u8 *)(dvb->avout.buf+((dvb->avout.head+1)&(dvb->avout.length-1)));
                } 

                len=dvb->avout.tail-dvb->avout.head;
                if (dvb->avout.head > dvb->avout.tail)
                        len+=dvb->avout.length;

                if (len<8)
                {
                        iwdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
                        ARM_ClearMailBox(dvb);
                        spin_unlock_irqrestore(&dvb->avout.lock, flags);
                        return;
                }
                
                blen=((u16)*((u8 *)(dvb->avout.buf+
                               ((dvb->avout.head+6)&(dvb->avout.length-1)))))<<8;
                blen|=((u16)*((u8 *)(dvb->avout.buf+
                               ((dvb->avout.head+7)&(dvb->avout.length-1)))));
                blen+=8;
                iwdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, blen, 2);
                //printk("blen: %08x    len: %08x  head: %08x  tail: %08x\n",
                //       blen, len, dvb->avout.head, dvb->avout.tail);
                if (len<blen) {
                        iwdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
                        dprintk("buffer empty\n");
                        ARM_ClearMailBox(dvb);
                        spin_unlock_irqrestore(&dvb->avout.lock, flags);
                        return;
                }
                if (blen>DATA_BUFF_SIZE) {
                        iwdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
                        printk("packet too large\n");
                        ARM_ClearMailBox(dvb);
                        spin_unlock_irqrestore(&dvb->avout.lock, flags);
                        return;
                }
                len=blen;
                if (dvb->avout.head + blen > dvb->avout.length)
                        split=dvb->avout.length-dvb->avout.head;
                if (split>0) {
                        memcpy(dvb->saa->debi, dvb->avout.buf+dvb->avout.head, split);
                        dvb->avout.head=0;
                        len-=split;
                }
                memcpy(split + (void*)dvb->saa->debi, 
                       dvb->avout.buf + dvb->avout.head, len);
                dvb->avout.head = (dvb->avout.head +len)&(dvb->avout.length-1);
                spin_unlock_irqrestore(&dvb->avout.lock, flags);

                wake_up_interruptible(&dvb->avout.queue);

                wait_for_debi_done(dvb);
                saa7146_write(dvb->saa->mem, IER, 
                              saa7146_read(dvb->saa->mem, IER) | MASK_19 );
                dprintk("enabled DEBI irq\n");
                iwdebi(dvb, DEBISWAB, DATA_BUFF_BASE, 0, blen);
                dprintk("wrote DEBI\n");
            */
                SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER,SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) | MASK_19 );
                ARM_ClearMailBox();
				break;

        case DATA_BMP_LOAD:
/*                int len=irdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, 0, 2);
                
                dprintk("bmp_load %d %d\n", dvb->bmplen, len);
                if (!len) {
                        ARM_ClearMailBox(dvb);
                        if (dvb->bmp_state==BMP_LOADINGS)
                          outcom(dvb, COMTYPE_OSD, BlitBmp, 4,
                               dvb->bmp_win, dvb->bmp_x, dvb->bmp_y, dvb->bmp_trans);
                        dvb->bmp_state=BMP_LOADED;
                        dprintk("blitbmp done\n");
                        break;
                }
                if (len>dvb->bmplen)
                        len=dvb->bmplen;
                iwdebi(dvb, DEBINOSWAP, IRQ_STATE_EXT, len, 2);
                memcpy(dvb->saa->debi, dvb->bmpbuf+dvb->bmpp, len);
                dvb->bmpp+=len;
                dvb->bmplen-=len;
                wait_for_debi_done(dvb);
                saa7146_write(dvb->saa->mem, IER, 
                              saa7146_read(dvb->saa->mem, IER) | MASK_19 );
                iwdebi(dvb, DEBISWAB, DATA_BUFF_BASE, 0, len);
                break;
  */

        case DATA_TELETEXT:
                len=(debilen+3)&(~3);

//                printk("TTLen: %08x\n", dvb->debilen);
                SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER,SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) | MASK_19 );
                SAA7146_RDebi( DEBISWAB, DATA_BUFF_BASE, 0, len);
                break;
        case DATA_FSECTION:
        case DATA_DEBUG_MESSAGE:
        case DATA_COMMON_INTERFACE:
        case DATA_IPMPE:
                len=(debilen+3)&(~3);
                if (!len || len>6*1024) {
                        ARM_ClearMailBox();
                        return;
                }

                SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER,SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, IER) | MASK_19 );
                SAA7146_RDebi( DEBISWAB, DATA_BUFF_BASE, 0, len);
                break;

        default:
                ARM_ClearMailBox();
                break;
        }      

	//printk("PSR %08x\n", saa7146_read(dvb->saa->mem, PSR));
	//printk("IER %08x\n", saa7146_read(dvb->saa->mem, IER));
        
	//printk("ARM IRQ STATE: %08x\n",rdebi(dvb, DEBINOSWAP, 0x40f4, 0, 4));
	//printk("ARM BUFF: %08x\n",rdebi(dvb, DEBINOSWAP, 0x4200, 0, 4));
	//printk("ARM BUFF: %08x\n",rdebi(dvb, DEBINOSWAP, 0x4204, 0, 4));
}


void ARM_ClearMailBox()
{
        SAA7146_WDebi(DEBINOSWAP, IRQ_RX, 0, 2);
}

void ARM_ClearIrq()
{
	SAA7146_RDebi(DEBINOSWAP, IRQ_RX, 0, 2);
}




BOOL SAA7146_IntEnable (SAA7146_HANDLE hSAA7146, SAA7146_INT_HANDLER funcIntHandler)
{
    ULONG threadId;
    SAA7146_ADDR addrSpace;
    if (!hSAA7146->fUseInt) return FALSE;
    // check if interrupt is already enabled
    if (hSAA7146->Int.hThread) return FALSE;
    BZERO(hSAA7146->Int.Trans);

    addrSpace = SAA7146_AD_BAR0; // put the address space of the register here
	hSAA7146->Int.Trans[0].dwPort = hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwTransAddr+ISR;
	hSAA7146->Int.Trans[0].cmdTrans = RM_DWORD;

	hSAA7146->Int.Trans[1].dwPort = hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwTransAddr+IER;
	hSAA7146->Int.Trans[1].cmdTrans = RM_DWORD;

	hSAA7146->Int.Trans[2].dwPort = hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwTransAddr+MC2;
	hSAA7146->Int.Trans[2].cmdTrans = RM_DWORD;

	hSAA7146->Int.Trans[3].dwPort = hSAA7146->cardReg.Card.Item[hSAA7146->addrDesc[addrSpace].index].I.Mem.dwTransAddr+ISR;
	hSAA7146->Int.Trans[3].cmdTrans = WM_DWORD;
    hSAA7146->Int.Trans[3].Data.Dword = (DWORD) 0xffffffff; // put the data to write to the control register here


    hSAA7146->Int.Int.dwCmds = 4;
    hSAA7146->Int.Int.Cmd = hSAA7146->Int.Trans;
    hSAA7146->Int.Int.dwOptions = INTERRUPT_CMD_COPY ;//| INTERRUPT_LEVEL_SENSITIVE;

	WD_IntEnable (hSAA7146->hWD, &hSAA7146->Int.Int);
    // check if WD_IntEnable failed
	if (!hSAA7146->Int.Int.fEnableOk)
        return FALSE;

    // create interrupt handler thread
    hSAA7146->Int.hThread = CreateThread (0, 0x1000,
        SAA7146_IntThread, hSAA7146, 0, &threadId);

    return TRUE;
}



void SAA7146_IntDisable (SAA7146_HANDLE hSAA7146)
{
    if (!hSAA7146->fUseInt) return;
    if (!hSAA7146->Int.hThread) return;
    WD_IntDisable (hSAA7146->hWD, &hSAA7146->Int.Int);
    WaitForSingleObject (hSAA7146->Int.hThread, INFINITE);
    hSAA7146->Int.hThread = NULL;
}

int SAA7146_FirmRead(LPSTR FileName, unsigned char *Daten, int Bytes)
{

	
	
	FILE *sFile;
    int fd;

	unsigned long	FileSize;
	
	fd=_open(FileName,_O_RDONLY | _O_BINARY);
	if ( fd == -1 ) return(FALSE); 
	FileSize=_filelength(fd);
    _close(fd);
    if ( Bytes == 0 ) return(FileSize);
	if ( FileSize > Bytes ) return(-1);

   sFile = fopen(FileName, "rb");
   if(sFile == NULL) {
	   return (-1);
	  }

   if ( fread(Daten, sizeof(unsigned char), FileSize, sFile) != (size_t)FileSize )  {
	   fclose(sFile);
      return (-1);
   }
   fclose(sFile);
   return(FileSize);
};

DWORD cpu_to_be32(DWORD value)
{
  return ((value << 24)
          | ((value << 8) & 0x00FF0000)
          | ((value >> 8) & 0x0000FF00)
          | (value >> 24));
}


int SAA7146_Load_Dram( unsigned char *data, int len)
{
	    char Text[128];
        int i;
        short blocks, rest;
        DWORD base;
        
        blocks=len/BOOT_MAX_SIZE;
        rest=len % BOOT_MAX_SIZE;
        base=DRAM_START_CODE;
        
        for (i=0; i<blocks; i++)
        {
			sprintf(Text,"Bytes %d",i*BOOT_MAX_SIZE);
			SetDlgItemText(SplashWnd,IDC_TEXT4,Text);
			if (SAA7146_WaitDebi( BOOT_STATE, BOOTSTATE_BUFFER_EMPTY) < 0) return -1;
                SAA7146_WDebi(DEBISWAB, BOOT_BLOCK, data+(i*(BOOT_MAX_SIZE)),BOOT_MAX_SIZE);
                SAA7146_WDebi(DEBISWAB, BOOT_BASE, cpu_to_be32(base), 4);
                SAA7146_WDebi(DEBINOSWAP, BOOT_SIZE, BOOT_MAX_SIZE, 2);
                SAA7146_WDebi(DEBINOSWAP, BOOT_STATE, BOOTSTATE_BUFFER_FULL, 2);
                base+=BOOT_MAX_SIZE;
        }

		sprintf(Text,"Bytes %d",(blocks*BOOT_MAX_SIZE)+rest);
		SetDlgItemText(SplashWnd,IDC_TEXT4,Text);
        
        if (rest > 0)
        {
                if (SAA7146_WaitDebi( BOOT_STATE, BOOTSTATE_BUFFER_EMPTY) < 0) return -1;
                if (rest>4) SAA7146_WDebi(DEBISWAB, BOOT_BLOCK,data+(i*(BOOT_MAX_SIZE)), rest);
                else SAA7146_WDebi(DEBISWAB, BOOT_BLOCK, i*(BOOT_MAX_SIZE)-4+data, rest+4);
                
                SAA7146_WDebi(DEBISWAB, BOOT_BASE, cpu_to_be32(base), 4);
                SAA7146_WDebi(DEBINOSWAP, BOOT_SIZE, rest, 2);
                SAA7146_WDebi(DEBINOSWAP, BOOT_STATE, BOOTSTATE_BUFFER_FULL, 2);
        }
        if (SAA7146_WaitDebi(BOOT_STATE, BOOTSTATE_BUFFER_EMPTY) < 0) return -1;
        SAA7146_WDebi(DEBINOSWAP, BOOT_SIZE, 0, 2);
        SAA7146_WDebi(DEBINOSWAP, BOOT_STATE, BOOTSTATE_BUFFER_FULL, 2);
        if (SAA7146_WaitDebi( BOOT_STATE, BOOTSTATE_BOOT_COMPLETE) < 0) return -1;
        return 0;
}


int SAA7146_WaitDebi( int adr, int state)
{
        int k;
        for (k=0; k<1000; k++, Sleep(10)) {
			if (SAA7146_RDebi(DEBINOSWAP, adr, 0, 2) == state) {
				return 0;
			};

		}
        return -1;
}


int SAA7146_FirmVersion()
{
        unsigned short Buffer[18];

        unsigned short tag = ((COMTYPE_REQUEST << 8) + ReqVersion);
 
        SAA7146_RequestParameter(tag, Buffer, 16);
        return (Buffer[0] << 16) + Buffer[1];
}

int SAA7146_RequestParameter(unsigned short tag, short *Buff, short length)
{
        short		i;
        DWORD	start;
	unsigned int flags;

       
        SAA7146_OutCommand( &tag, 0);
        
        start = 0;
        while ( SAA7146_RDebi( DEBINOSWAP, COMMAND, 0, 2) )	//warten bis abgeholt
        {
                if ( start > CmdTimeOut ) {
                        return DVB_ERR_TIMEOUT;
                }
				Sleep(1);
				start++;
        }
        
        for (i=0; i<length; i++)
                Buff[i] = SAA7146_RDebi(DEBINOSWAP, COM_BUFF + 2*i, 0, 2);

        return DVB_ERR_NONE;
}

int SAA7146_CommandRequest(unsigned short *Buff, int length, unsigned short *buf, int n)
{
        short i;
        unsigned int start;
       
         SAA7146_OutCommand( Buff, length);

        
        start = 0;
        while ( SAA7146_RDebi( DEBINOSWAP, COMMAND, 0, 2) )	//warten bis abgeholt
        {
                if ( start > CmdTimeOut ) {
                        return DVB_ERR_TIMEOUT;
                }
				Sleep(1);
				start++;
        }

        start = 0;
        while ( SAA7146_RDebi( DEBINOSWAP, HANDSHAKE_REG, 0, 2) )	//Handshake
        {
                if ( start > CmdTimeOut ) {
                        return DVB_ERR_TIMEOUT;
                }
				Sleep(1);
				start++;
        }


        for (i=0; i<n; i++)
                buf[i] = SAA7146_RDebi( DEBINOSWAP, COM_BUFF + 2*i, 0, 2);
        
        return 0;
}



int SAA7146_OutCommand( short *buf, short length)
{
        int i;
        DWORD	start;
	unsigned int flags;
        Sleep(5);
        start = 0;
        while ( SAA7146_RDebi(DEBINOSWAP, COMMAND, 0, 2 )) {
                if ( start > CmdTimeOut ) return DVB_ERR_TIMEOUT;
				Sleep(1);
				start++;
        }

        start = 0;
        while ( SAA7146_RDebi(DEBINOSWAP, MSGSTATE, 0, 2) & OSDQFull ) {
                if ( start > CmdTimeOut ) return DVB_ERR_TIMEOUT;
				Sleep(1);
				start++;
        }

        for (i=2; i<length; i++) SAA7146_WDebi(DEBINOSWAP, COMMAND + 2*i, (DWORD)buf[i], 2);

        SAA7146_WDebi(DEBINOSWAP, COMMAND + 2, (DWORD)buf[1], 2);
        SAA7146_WDebi(DEBINOSWAP, COMMAND    , (DWORD)buf[0], 2);
        return DVB_ERR_NONE;
};



int SAA7146_OutCom( int type, int com, short num1, short num2, short num3, short num4, short num5, short num6 ,short num7 ,short num8 ,short num9 ,short num10 )
{
        short buf[12];
        int i;

        buf[0]=(( type << 8 ) + com); 
        buf[1]=num1;

        if ( num1 > 0 ) {
        if ( num1 >= 1)  buf[2]=num2;
        if ( num1 >= 2)  buf[3]=num3;
        if ( num1 >= 3)  buf[4]=num4;
        if ( num1 >= 4)  buf[5]=num5;
        if ( num1 >= 5)  buf[6]=num6;
        if ( num1 >= 6)  buf[7]=num7;
        if ( num1 >= 7)  buf[8]=num8;
		if ( num1 >= 8)  buf[9]=num9;
		if ( num1 >= 9)  buf[10]=num10;
        }
        
        return SAA7146_OutCommand( buf, num1+2);
}


unsigned char gkconf(unsigned char reg)
{
        unsigned char mm1[] = {0x00};
        unsigned char mm2[] = {0x00};
        struct i2c_msg msgs[2];
        
        msgs[0].flags=0;
        msgs[1].flags=I2C_M_RD;
        msgs[0].addr=msgs[1].addr=0x50;
        mm1[0]=reg;
        msgs[0].len=1; msgs[1].len=1;
        msgs[0].buf=mm1; msgs[1].buf=mm2;
//        i2c_transfer(adap, msgs, 2);
  		master_xfer(msgs,2);
      
        return mm2[0];
}

void Get_Ves_Typ()
{
int i;

	ves_addr=(0x10 >> 1);  
    ves_flags=0x00;

    if ( (i2c_master_send(ves_addr,ves_flags,NULL,0) == 0 ) &&
		 (( readreg(ves_addr,ves_flags,0x1e)&0xf0) == 0xd0 )) {
          VES_TYPE=1;
          SetDlgItemText(SplashWnd,IDC_TEXT5,"VES-1893 OK");
          strcpy(VESTyp,"VES1893"); 
          return; 
	}
        ves_addr=(0x12 >> 1);
        if ( (i2c_master_send(ves_addr,ves_flags,NULL,0) == 0 ) &&
			((readreg(ves_addr,ves_flags,0x1a)&0xf0)==0x70)) {
            VES_TYPE=0;
            SetDlgItemText(SplashWnd,IDC_TEXT5,"VES-1820 OK");
            strcpy(VESTyp,"VES1820"); 
            return; 
        }
  VES_TYPE=-1;
  SetDlgItemText(SplashWnd,IDC_TEXT5,"VES-XXXX Fail");
}

int VES1893_Init()
{
        int i;
        unsigned char mm1[] = {0x00};
        unsigned char mm2[] = {0x00};
        struct i2c_msg msgs[2];
        unsigned char car[] = {0, 0};
        DWORD Para;        

        ves_addr=(0x10 >> 1);  

        if (i2c_master_send(ves_addr,ves_flags,NULL,0)) return -1;
        if ((readreg(ves_addr,ves_flags,0x1e)&0xf0)!=0xd0)  return -1;


//        printk("VES1893: init chip\n");
        ves_addr=(0x10 >> 1);  
        ves_flags=0;
/*    
        ves_con=0x0f;
        for (i=0; i<18; i++) ves_con^=i^gkconf((BYTE)i|0x80);

*/                
        if (writereg(ves_addr,ves_flags, 0, 0)<0) {
		//	printk("VES1893: send error\n");
		}
		
		for (i=0; i<54; i++) writereg(ves_addr,ves_flags, i, Init1893Tab[i]);
		
		writereg(ves_addr,ves_flags, 0x1a, 0x21);

 
                SendDAC(2, 1);
                Sleep(10);
                SendDAC(2, 0);
                Sleep(10);

                SendDAC(0, 0x44);
                SendDAC(1, 0x81);
                SendDAC(2, 0xf0);
				DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);

	            Para=((DWORD)(0x43&0x68)<<20);
				
                SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, DD1_STREAM_B,Para);  // NEW
                SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2,(MASK_09 | MASK_25 | MASK_10 | MASK_26));


		
		return 0;
}



int VES1820_Init()
{
        struct i2c_msg msgs[2];
        unsigned char mm1[] = {0xff};
        unsigned char mm2[] = {0x00};
        int i;

        ves_addr=(0x12 >> 1);
        if (i2c_master_send(ves_addr,ves_flags,NULL,0)) return -1;
        if ((readreg(ves_addr,ves_flags,0x1a)&0xf0)!=0x70)  return -1;


        ves_addr=(0x12 >> 1);  
        ves_flags=0;


        msgs[0].flags=0;
        msgs[1].flags=1;
        msgs[0].addr=msgs[1].addr=(0x28<<1);
        mm1[0]=0xff;
        msgs[0].len=1; msgs[1].len=1;
        msgs[0].buf=mm1; msgs[1].buf=mm2;
//        i2c_transfer( msgs, 2);
		master_xfer(msgs,2);
        ves_pwm=*mm2;
        if (ves_pwm == 0xff) ves_pwm=0x48;

//        printk("VES1820: init chip\n");
       
        if (writereg(ves_addr,ves_flags,0, 0)<0) {
			//printk("VES1820: send error\n");
};
        for (i=0; i<53; i++) writereg(ves_addr,ves_flags, i, Init1820PTab[i]);
        ves_srate=0;
        ves_reg0=0x69;

        writereg(ves_addr,ves_flags,0x34, ves_pwm);
        return 0;
}

BOOL DVBVideoPresent()
{
unsigned char b;

b=readreg(ves_addr,ves_flags,0x0e);
if ( b == 127 ) return(TRUE);
return(FALSE);
}

void DVB_SetVolume(unsigned char volleft, unsigned char volright)
{
        int err;
        if (volleft > 0x45) volleft=0x45;
        if (volright > 0x45)
                volright=0x45;
                SendDAC( 3, (unsigned char)(0x80+volleft));
                SendDAC(4, (unsigned char)volright);

}



int SendDAC( unsigned char addr, unsigned char data)
{
        return SAA7146_OutCom(COMTYPE_AUDIODAC, AudioDAC, 2, addr, data,0,0,0,0,0,0,0);
}



int writereg(unsigned char addr, unsigned char flags,int reg, int data)
{
        int ret;
        unsigned char msg[] = {0x00, 0x1f, 0x00};
        
        msg[1]=reg; msg[2]=data;
        ret=i2c_master_send(addr,flags,msg, 3);
//        if (ret!=3) 
//                printk("writereg error\n");
        return ret;
}

unsigned char readreg(unsigned char addr, unsigned char flags,unsigned char reg)
{
        unsigned char mm1[] = {0x00, 0x1e};
        unsigned char mm2[] = {0x00};
        struct i2c_msg msgs[2];
        
        msgs[0].flags=0;
        msgs[1].flags=I2C_M_RD;
        msgs[0].addr=msgs[1].addr=addr;
        mm1[1]=reg;
        msgs[0].len=2; msgs[1].len=1;
        msgs[0].buf=mm1; msgs[1].buf=mm2;
        //        i2c_transfer( msgs, 2);
		master_xfer(msgs,2);

        return mm2[0];
}



/* ---------------------------------------------*/
/* i2c-helper functions				*/
/* ---------------------------------------------*/

/* this functions gets the status from the saa7146 at address 'addr'
   and returns it */
DWORD i2c_status_check() 
{
	DWORD iicsta = 0;
	iicsta = SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA );
	return iicsta;
}

/* this function should be called after an i2c-command has been written. 
   if we are debugging, it checks, if the busy flags rises and falls correctly
   and reports a timeout (-1) or the error-bits set like in described in the specs,
   p.123, table 110 */
int i2c_busy_rise_and_fall( int timeout)
{
	int i = 0;
	DWORD status = 0;
		

	/* wait until busy-flag rises */
	for (i = 5; i > 0; i--) {

//		hprintk("saa7146: i2c_busy_rise_and_fall; rise wait %d\n",i);

		status = i2c_status_check();

		/* check busy flag */
		if ( 0 != (status & SAA7146_I2C_BUSY))
			break;
		/* see if anything can be done while we're waiting */
       Sleep(5);
	}

	/* we don't check the i-value, since it does not matter
	   if we missed the rise of the busy flag or the fall or
	   whatever. we just have to wait some undefined time
	   after an i2c-command has been written out */	
	
	/* wait until busy-flag is inactive or error is reported */
	for (i = timeout; i > 0; i--) {
	
//		hprintk("saa7146: i2c_busy_rise_and_fall; fall wait %d\n",i);

		status = i2c_status_check();

		/* check busy flag */
		if ( 0 == (status & SAA7146_I2C_BUSY))
			break;

		/* check error flag */
		if ( 0 != (status & SAA7146_I2C_ERR))
			break;

		/* see if anything can be done while we're waiting */
       Sleep(5);
	}
	
	/* did a timeout occur ? */
	if ( 0 == i ) {
//		hprintk("saa7146: i2c_busy_rise_and_fall: timeout #2\n");
		return -1;
	}
	
	/* report every error pending */
	switch( status & 0xfc ) {
		
		case SAA7146_I2C_SPERR:
//			hprintk("saa7146: i2c_busy_rise_and_fall: error due to invalid start/stop condition\n");
			break;

		case SAA7146_I2C_APERR:
//			hprintk("saa7146: i2c_busy_rise_and_fall: error in address phase\n");
			break;

		case SAA7146_I2C_DTERR:
//			hprintk("saa7146: i2c_busy_rise_and_fall: error in data transmission\n");
			break;

		case SAA7146_I2C_DRERR:
//			hprintk("saa7146: i2c_busy_rise_and_fall: error when receiving data\n");
			break;

		case SAA7146_I2C_AL:
//			hprintk("saa7146: i2c_busy_rise_and_fall: error because arb lost\n");
			break;
	}
				
	return status;	

}

/* this functions resets the saa7146 at address 'addr'
   and returns 0 if everything was fine, otherwise -1 */
int i2c_reset()
{
	DWORD status = 0;

//	hprintk("saa7146: ==> i2c_reset\n");

	status = i2c_status_check();

	/* clear data-byte for sure */
        SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA ,00);
	
	/* check if any operation is still in progress */
	if ( 0 != ( status & SAA7146_I2C_BUSY) ) {

		/* Yes, kill ongoing operation */
//		hprintk("saa7146: i2c_reset: busy_state detected\n"); 

		/* set ABORT-OPERATION-bit */
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA ,( SAA7146_I2C_BUS_BIT_RATE_480 | MASK_07));
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2 ,(MASK_00 | MASK_16));
		Sleep( SAA7146_I2C_DELAY );

		/* clear all error-bits pending; this is needed because p.123, note 1 */
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA ,SAA7146_I2C_BUS_BIT_RATE_480);
	    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_00 | MASK_16));
    	Sleep( SAA7146_I2C_DELAY );
 	}

	/* check if any other error is still present */
	if ( SAA7146_I2C_BUS_BIT_RATE_480 != (status = i2c_status_check()) ) {

		/* yes, try to kick it */
//		hprintk("saa7146: i2c_reset: error_state detected, status:0x%08x\n",status);

		/* clear all error-bits pending */
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA, SAA7146_I2C_BUS_BIT_RATE_480 );
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_00 | MASK_16));
		Sleep( SAA7146_I2C_DELAY );
 		/* the data sheet says it might be necessary to clear the status
		   twice after an abort */
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA, SAA7146_I2C_BUS_BIT_RATE_480 );
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_00 | MASK_16));
	}

	/* if any error is still present, a fatal error has occured ... */
	if ( SAA7146_I2C_BUS_BIT_RATE_480 != (status = i2c_status_check()) ) {
//		hprintk("saa7146: i2c_reset: fatal error, status:0x%08x\n",status);
		return -1;
	}

	return 0;
}

/* this functions writes out the data-bytes at 'data' to the saa7146
   at address 'addr' regarding the 'timeout' and 'retries' values;
   it returns 0 if ok, -1 if the transfer failed, -2 if the transfer
   failed badly (e.g. address error) */
int i2c_write_out( DWORD *data, int timeout)
{
	int status = 0;
		
//	hprintk("saa7146: ==> writeout: 0x%08x (before) (to:%d)\n",*data,timeout);
	
	/* write out i2c-command */
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0,SAA7146_IICTRF, *data);
   	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICSTA, SAA7146_I2C_BUS_BIT_RATE_480);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_00 | MASK_16));

	/* after writing out an i2c-command we have to wait for a while;
	   because we do not know, how long we have to wait, we simply look
	   what the busy-flag is doing, before doing something else */
	 
	/* reason: while fiddling around with the i2c-routines, I noticed
	   that after writing out an i2c-command, one may not read out the
	   status immediately after that. you *must* wait some time, before
	   even the busy-flag gets set */
	   
	status = i2c_busy_rise_and_fall(timeout);

	if ( -1 == status ) {
//		hprintk("saa7146: i2c_write_out; timeout\n");
		return -1;
	}

	/* we only handle address-errors here */
	if ( 0 != (status & SAA7146_I2C_APERR)) {
//		hprintk("saa7146: i2c_write_out; error in address phase\n");
		return -2;
	}

	/* check for some other mysterious error; we don't handle this here */
	if ( 0 != ( status & 0xff)) {
//		dprintk("saa7146: i2c_write_out: some error has occured\n");
        	return -1;
  	}
	
	/* read back data, just in case we were reading ... */
	*data = SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0, SAA7146_IICTRF);

//	hprintk("saa7146: writeout: 0x%08x (after)\n",*data);

	return 0;
}


int prepare(struct i2c_msg m[], int num)
{
	short h1, h2;
	short i, j, addr;
	short mem = 0, op_count = 0;

	/* determine size of needed memory */
	for(i = 0; i < num; i++) {
		mem += m[i].len + 1;
	}

	/* we need one unsigned int for three bytes to be send plus
	   one byte to address the device */
	mem = 1 + ((mem-1) / 3);

	if ( mem > I2C_MEM_SIZE ) {
//		hprintk("saa7146: prepare: i2c-message to big\n");
		return -1;
	}

	/* be careful: clear out the i2c-mem first */
	memset(i2c_mem,0,4*mem);

	/* loop through all messages */
	for(i = 0; i < num; i++) {

		/* insert the address of the i2c-slave. note: we get 7-bit-i2c-addresses,
		   so we have to perform a translation */
		addr = (m[i].addr*2) + ( (0 != (m[i].flags & I2C_M_RD)) ? 1 : 0); 
		h1 = op_count/3; h2 = op_count%3;
		i2c_mem[h1] |= ((unsigned char)addr << ((3-h2)*8));
		i2c_mem[h1] |= (SAA7146_I2C_START << ((3-h2)*2));
		op_count++;

		/* loop through all bytes of message i */
		for(j = 0; j < m[i].len; j++) {
			/* insert the data bytes */
			h1 = op_count/3; h2 = op_count%3;
			i2c_mem[h1] |= ((unsigned char)m[i].buf[j] << ((3-h2)*8));
			i2c_mem[h1] |= (SAA7146_I2C_CONT << ((3-h2)*2));
			op_count++;
		}
		
	}			

	/* have a look at the last byte inserted:
	  if it was: ...CONT change it to ...STOP */
	h1 = (op_count-1)/3; h2 = (op_count-1)%3;
	if ( SAA7146_I2C_CONT == (0x3 & (i2c_mem[h1] >> ((3-h2)*2))) ) {
		i2c_mem[h1] &= ~(0x2 << ((3-h2)*2));
		i2c_mem[h1] |= (SAA7146_I2C_STOP << ((3-h2)*2));
	}
	
	return mem;
	
}

int master_xfer(struct i2c_msg msgs[], int num)
{

	int result, count;
	int retries = 4;
	int i = 0;
	
	/* prepare the message(s), get number of unsigned ints to transfer */
	count = prepare(msgs, num);
	if ( 0 > count ) {
//		hprintk(KERN_ERR "saa7146_core.o: master_xfer: could not prepare i2c-message\n");
		return -1;
	}

	/* loop through number of retries ... */
	while ( 0 < retries ) {
	
		retries--;
	
		/* reset the i2c-device if necessary */
		if ( retries != 3 ) {
		result = i2c_reset();
		Sleep(1);
		if ( 0 > result ) {
//			hprintk(KERN_ERR "saa7146_core.o: master_xfer: could not reset i2c-bus\n");
			return -1;
		}	
		};
		/* see how many unsigned int have to be transferred; if there is only 1,
		   we do not start the whole rps1-engine... */

		for(i = 0; i < count; i++) {
			result = i2c_write_out( &i2c_mem[i], 100);
			if ( 0 != result) {
				/* if address-error occured, dont retry */
				if ( -2 == result ) {
				//	hprintk(KERN_ERR "saa7146_core.o: master_xfer: error in address phase\n");
					return -1;
				}
//				hprintk(KERN_ERR "saa7146_core.o: master_xfer: error tranferring,trying again\n");
				break;
			}
		}
		
		/* see if an error occured & the last retry failed */
		if( (0 != result) && (0 == retries) ) {
//			hprintk(KERN_ERR "saa7146_core.o: master_xfer: could not transfer i2c-message\n");
			return -1;
		}
		
		if( 0 == result )
			break;
	}
	
	/* if any things had to be read, get the results */
	result = clean_up(msgs, num);
	if ( 0 > result ) {
//		hprintk(KERN_ERR "saa7146_core.o: master_xfer: could not cleanup\n");
		return -1;
	}

	/* return the number of delivered messages */
	return num;	
}

int clean_up(struct i2c_msg m[], int num)
{
	unsigned short i, j;
	unsigned short op_count = 0;

	/* loop through all messages */
	for(i = 0; i < num; i++) {
		op_count++;
		/* loop throgh all bytes of message i */
		for(j = 0; j < m[i].len; j++) {
			/* write back all bytes that could have been read */
			m[i].buf[j] = (unsigned char )(i2c_mem[op_count/3] >> ((3-(op_count%3))*8));
			op_count++;
		}
	}
	
	return 0;
}


int i2c_master_send(unsigned char addr, unsigned char flags, const char *buf ,int count)
{
	int ret;
	struct i2c_msg msg;

		msg.addr   = addr;
		msg.flags =  flags & I2C_M_TEN;
		msg.len = count;
		(const char *)msg.buf = buf;

		 ret = master_xfer(&msg,1);
		/* if everything went ok (i.e. 1 msg transmitted), return #bytes
		 * transmitted, else error code.
		 */
		return (ret == 1 )? count : ret;
}

int i2c_master_recv( unsigned char addr, unsigned char flags, char *buf ,int count)
{
	struct i2c_msg msg;
	int ret;
		msg.addr   = addr;
		msg.flags = flags & I2C_M_TEN;
		msg.flags |= I2C_M_RD;
		msg.len = count;
		msg.buf = buf;

		ret = master_xfer(&msg,1);
	
		/* if everything went ok (i.e. 1 msg transmitted), return #bytes
	 	* transmitted, else error code.
	 	*/
		return (ret == 1 )? count : ret;
}

void ClrBit1893()
{
        writereg(ves_addr,ves_flags,0, Init1893Tab[0] & 0xfe);
        Sleep(1);
        writereg(ves_addr,ves_flags,0, Init1893Tab[0]);
}

void ClrBit1820()
{
        unsigned char val;
        
        val=ves_reg0;
//        if (ves_inversion) val&=0xdf;
        writereg(ves_addr,ves_flags, 0, val & 0xfe);
        writereg(ves_addr,ves_flags, 0, val);
}

void SetPWM() 
{
        writereg(ves_addr,ves_flags, 0x34, ves_pwm); 
}

int VES1893_SetSymbolrate(DWORD  Symbolrate, int doclr)
{
        DWORD BDR;
        DWORD ratio;
  	    unsigned char  ADCONF, FCONF, FNR;
	    DWORD BDRI;
	    DWORD tmp;
        Symbolrate=Symbolrate*1000;

        if (ves_srate==Symbolrate) {
                ClrBit1893();
                return 0;
        }
//        dprintk("setsymbolrate %d\n", srate);

	if (Symbolrate>90100000UL/2)
                Symbolrate=90100000UL/2;
        if (Symbolrate<500000)
          Symbolrate=500000;
        ves_srate=Symbolrate;
        
#define MUL (1UL<<24)
#define FIN (90100000UL>>4)
	ratio=(Symbolrate<<4)/FIN;
        
	tmp=((Symbolrate<<4)%FIN)<<8;
	ratio=(ratio<<8)+tmp/FIN;
        
	tmp=(tmp%FIN)<<8;
	ratio=(ratio<<8)+tmp/FIN;
        
	FNR = 0xFF;
	
	if (ratio < MUL/3)           FNR = 0;
	if (ratio < (MUL*11)/50)     FNR = 1;
	if (ratio < MUL/6)           FNR = 2;
	if (ratio < MUL/9)           FNR = 3;
	if (ratio < MUL/12)          FNR = 4;
	if (ratio < (MUL*11)/200)    FNR = 5;
	if (ratio < MUL/24)          FNR = 6;
	if (ratio < (MUL*27)/1000)   FNR = 7;
	if (ratio < MUL/48)          FNR = 8;
	if (ratio < (MUL*137)/10000) FNR = 9;

	if (FNR == 0xFF)
	{
		ADCONF = 0x89;		//bypass Filter
		FCONF  = 0x80;		//default
		FNR	= 0;
	}
	else
	{
		ADCONF = 0x81;
		FCONF  = 0x88 | (FNR >> 1) | ((FNR & 0x01) << 5); //default | DFN | AFS
	}

	/* got rid of floats in kernel
           dear Christian Theiss!
	   better don't let Linus know you used floats in your code ...
	*/

	//int( ((1<<21)<<(FNR>>1)) * float(dwSymbolrate) / 90100000.0 + 0.5);
	BDR = ((  (ratio<<(FNR>>1))  >>2)+1)>>1;

	//int(32 * 90100000.0 / float(dwSymbolrate) / (1<<(FNR>>1)) + 0.5);
	BDRI = (  ((90100000UL<<4) / ((Symbolrate << (FNR>>1))>>2)  ) +1 ) >> 1;

/*
        dprintk("FNR= %d\n", FNR);
        dprintk("ratio= %08x\n", ratio);
        dprintk("BDR= %08x\n", BDR);
        dprintk("BDRI= %02x\n", BDRI);
*/
	if (BDRI > 0xFF)
	        BDRI = 0xFF;

        writereg(ves_addr,ves_flags,6, 0xff&BDR);
	writereg(ves_addr,ves_flags,7, 0xff&(BDR>>8));
	writereg(ves_addr,ves_flags,8, 0x0f&(BDR>>16));

	writereg(ves_addr,ves_flags,9, BDRI);
	writereg(ves_addr,ves_flags,0x20, ADCONF);
	writereg(ves_addr,ves_flags,0x21, FCONF);

	writereg(ves_addr,ves_flags,0, 0);
	writereg(ves_addr,ves_flags,0, 1);

	if (doclr) ClrBit1893();
	return 0;
}

int VES1820_SetSymbolrate(DWORD Symbolrate, int DoCLB)
{
        int BDR; 
        int BDRI;
        short SFIL=0;
        DWORD XIN = 57840000UL;	//Quarzfrequenz fr VES1820 (Kabel) mit PHILIPS-Tuner
        int NDEC = 0;

        if (Symbolrate > XIN/2) Symbolrate=XIN/2;
        if (Symbolrate < 500000) Symbolrate=500000;

        if (Symbolrate < XIN/16) NDEC = 1;
        if (Symbolrate < XIN/32) NDEC = 2;
        if (Symbolrate < XIN/64) NDEC = 3;
        
        BDR = (int)((1 << 24) * (float)(Symbolrate) * (1 << NDEC) / (float)(XIN));
        
        BDRI = (int)(16 * (float)(XIN) / ((float)(Symbolrate) * (1 << NDEC)));
        if (BDRI > 0xFF) BDRI = 0xFF;               /* Delimiter Conditional */
        
        if (Symbolrate < XIN/12.3) SFIL = 1;
        if (Symbolrate < XIN/16)	 SFIL = 0;
        if (Symbolrate < XIN/14.6) SFIL = 1;
        if (Symbolrate < XIN/32)	 SFIL = 0;
        if (Symbolrate < XIN/49.2) SFIL = 1;
        if (Symbolrate < XIN/64)	 SFIL = 0;
        if (Symbolrate < XIN/98.4) SFIL = 1;
        
        SFIL = (SFIL << 4) | Init1820PTab[0x0E];
        
        NDEC = (NDEC << 6) | Init1820PTab[0x03];	// Building the Regs

        writereg(ves_addr,ves_flags,0x03, NDEC);
        writereg(ves_addr,ves_flags,0x0a, BDR&0xff);
        writereg(ves_addr,ves_flags,0x0b, BDR>>8);
        writereg(ves_addr,ves_flags,0x0c, (BDR>>16)&0x3f);

        writereg(ves_addr,ves_flags,0x0d, BDRI);
        writereg(ves_addr,ves_flags,0x0e, SFIL);

        SetPWM();
        
        if (DoCLB) ClrBit1820();
        
        ves_srate=Symbolrate;
        return 0;
}

int SetControl(unsigned char val)
{
        if (ves_ctr==val) return 0;
        if (val&0x20)
                if (!(ves_ctr&0x20)) {
                        Sleep(10);
                        ves_srate=0;         //force symbolrate reload
                }
        ves_ctr=val;
        writereg(ves_addr,ves_flags, 0x1f, val);
        return 0;
}

int SetFEC( int fec)
{
          if (fec>=8 || fec<0) 
                  return writereg(ves_addr,ves_flags,0x0d, 0x08);
          else
                  return writereg(ves_addr,ves_flags,0x0d, fec&7);
}


int SetQAM( QAM_TYPE QAM_Mode, int DoCLB)
{
        
        ves_reg0=(ves_reg0 & 0xe3) | (QAM_Mode << 2);

        writereg(ves_addr,ves_flags,0x01, QAM_Values[QAM_Mode].Reg1);
        writereg(ves_addr,ves_flags,0x05, QAM_Values[QAM_Mode].Reg5);
        writereg(ves_addr,ves_flags,0x08, QAM_Values[QAM_Mode].Reg8);
        writereg(ves_addr,ves_flags,0x09, QAM_Values[QAM_Mode].Reg9);
        
        if (DoCLB) ClrBit1820();
        return 0;
}



int calculate_h_scale_registers(unsigned int in_x, unsigned int out_x, int flip_lr, unsigned int *hps_ctrl, unsigned int *hps_v_gain, unsigned int *hps_h_prescale, unsigned int *hps_h_scale)
{
	unsigned int dcgx = 0, xpsc = 0, xacm = 0, cxy = 0, cxuv = 0;	/* horizontal prescaler */
	unsigned int xim = 0, xp = 0, xsci =0;				/* horizontal scaler */
	unsigned int pfuv = 0;						/* vertical scale & gain */

	unsigned int h_atten = 0, i = 0;					/* helper variables */

	if ( 0 == out_x ) {
//		printk("saa7146: ==> calculate_h_scale_registers: invalid value (=0).\n");
		return(-1);
	}
	
	/* mask out vanity-bit */
	*hps_ctrl &= ~MASK_29;
		
	/* calculate prescale-(xspc)-value:	[n   .. 1/2) : 1
				    		[1/2 .. 1/3) : 2
				    		[1/3 .. 1/4) : 3
						... 			*/
	if (in_x > out_x) {
		xpsc = in_x / out_x;
	}
	else {
		/* zooming */
		xpsc = 1;						
	}
	
	/* if flip_lr-bit is set, number of pixels after horizontal prescaling must be < 384 */
	if ( 0 != flip_lr ) {
	
		/* set vanity bit */
		*hps_ctrl |= MASK_29;
	
		while (in_x / xpsc >= 384 )
			xpsc++;
	}
	/* if zooming is wanted, number of pixels after horizontal prescaling must be < 768 */
	else {
		while ( in_x / xpsc >= 768 )
			xpsc++;
	}
	
	/* maximum prescale is 64 (p.69) */
	if ( xpsc > 64 )
		xpsc = 64;

	/* keep xacm clear*/
	xacm = 0;
	
	/* set horizontal filter parameters (CXY = CXUV) */
	cxy = hps_h_coeff_tab[( (xpsc - 1) < 63 ? (xpsc - 1) : 63 )].hps_coeff;
	cxuv = cxy;
	
	/* calculate and set horizontal fine scale (xsci) */
	
	/* bypass the horizontal scaler ? */
	if ( (in_x == out_x) && ( 1 == xpsc ) )
		xsci = 0x400;
	else	
		/* philips says: xsci = ( (1024 * in_x) / (out_x * xpsc) ) + xpsc; */
		xsci = ( (1024 * in_x) / (out_x * xpsc) ) + xpsc;

	/* set start phase for horizontal fine scale (xp) to 0 */	
	xp = 0;
	
	/* set xim, if we bypass the horizontal scaler */
	if ( 0x400 == xsci )
		xim = 1;
	else
		xim = 0;
		
	/* if the prescaler is bypassed, enable horizontal accumulation mode (xacm)
	   and clear dcgx */
	if( 1 == xpsc ) {
		xacm = 1;
		dcgx = 0;
	}
	else {
		xacm = 0;
		/* get best match in the table of attenuations for horizontal scaling */
		h_atten = hps_h_coeff_tab[( (xpsc - 1) < 63 ? (xpsc - 1) : 63 )].weight_sum;
	
		for (i = 0; h_attenuation[i] != 0; i++) {
			if (h_attenuation[i] >= h_atten)
				break;
		}
	
		dcgx = i;
	}

	/* the horizontal scaling increment controls the UV filter to reduce the bandwith to
	   improve the display quality, so set it ... */
	if ( xsci == 0x400)
		pfuv = 0x00;
	else if ( xsci < 0x600)
		pfuv = 0x01;
	else if ( xsci < 0x680)
		pfuv = 0x11;
	else if ( xsci < 0x700)
		pfuv = 0x22;
	else
		pfuv = 0x33;

	
	*hps_v_gain  &= MASK_W0|MASK_B2;
	*hps_v_gain  |= (pfuv << 24);	

	*hps_h_scale 	&= ~(MASK_W1 | 0xf000);
	*hps_h_scale	|= (xim << 31) | (xp << 24) | (xsci << 12);

	*hps_h_prescale	|= (dcgx << 27) | ((xpsc-1) << 18) | (xacm << 17) | (cxy << 8) | (cxuv << 0);

	return 0;
}


int calculate_v_scale_registers( unsigned int in_y, unsigned int out_y, unsigned int *hps_v_scale, unsigned int *hps_v_gain)
{
	unsigned int yacm = 0, ysci = 0, yacl = 0, ypo = 0, ype = 0;	/* vertical scaling */
	unsigned int dcgy = 0, cya_cyb = 0;				/* vertical scale & gain */
				
	unsigned int v_atten = 0, i = 0;					/* helper variables */

	/* error, if vertical zooming */
	if ( in_y < out_y ) {
	//	printk("saa7146: ==> calculate_v_scale_registers: we cannot do vertical zooming.\n");
		return (-1);
	}

	/* linear phase interpolation may be used if scaling is between 1 and 1/2
	   or scaling is between 1/2 and 1/4 (if interlace is set; see below) */
	if( ((2*out_y) >= in_y) || (((4*out_y) >= in_y) && saa_interlace != 0)) {

		/* convention: if scaling is between 1/2 and 1/4 we only use
		   the even lines, the odd lines get discarded (see function move_to)
		   if interlace is set */
		if( saa_interlace != 0 && (out_y*4) >= in_y && (out_y*2) <= in_y) 
			out_y *= 2;

		yacm = 0;
		yacl = 0;
		cya_cyb = 0x00ff;
		
		/* calculate scaling increment */
		if ( in_y > out_y )
			ysci = ((1024 * in_y) / (out_y + 1)) - 1024;
		else
			ysci = 0;

		dcgy = 0;

		/* calculate ype and ypo */
		ype = ysci / 16;
		ypo = ype + (ysci / 64);
		
	}
	else {
		yacm = 1;	

		/* calculate scaling increment */
		ysci = (((10 * 1024 * (in_y - out_y - 1)) / in_y) + 9) / 10;

		/* calculate ype and ypo */
		ypo = ype = ((ysci + 15) / 16);

		/* the sequence length interval (yacl) has to be set according
		   to the prescale value, e.g.	[n   .. 1/2) : 0
		   				[1/2 .. 1/3) : 1
						[1/3 .. 1/4) : 2
						... */
		if ( ysci < 512) {
			yacl = 0;
		}
		else {
			yacl = ( ysci / (1024 - ysci) );
		}

		/* get filter coefficients for cya, cyb from table hps_v_coeff_tab */	
		cya_cyb = hps_v_coeff_tab[ (yacl < 63 ? yacl : 63 ) ].hps_coeff;

		/* get best match in the table of attenuations for vertical scaling */
		v_atten = hps_v_coeff_tab[ (yacl < 63 ? yacl : 63 ) ].weight_sum;

		for (i = 0; v_attenuation[i] != 0; i++) {
			if (v_attenuation[i] >= v_atten)
				break;
		}
	
		dcgy = i;
	}

	/* ypo and ype swapped in spec ? */
	*hps_v_scale	|= (yacm << 31) | (ysci << 21) | (yacl << 15) | (ypo << 8 ) | (ype << 1);

	*hps_v_gain	&= ~(MASK_W0|MASK_B2);
	*hps_v_gain	|= (dcgy << 16) | (cya_cyb << 0);

	return 0;
}

void calculate_hxo_hyo_and_sources( int port_sel, int sync_sel, unsigned int *hps_h_scale, unsigned int *hps_ctrl)
{
	unsigned int hyo = 0, hxo = 0;
	
	hyo = modes_constants[saa_mode].v_offset;
	hxo = modes_constants[saa_mode].h_offset;
				
	*hps_h_scale	&= ~(MASK_B0 | 0xf00);
	*hps_ctrl	&= ~(MASK_W0 | MASK_B2 | MASK_30 | MASK_31 | MASK_28);

	*hps_h_scale	|= (hxo <<  0);
	*hps_ctrl	|= (hyo << 12);

	*hps_ctrl	|= ( port_sel == 0 ? 0x0 : MASK_30);
	*hps_ctrl	|= ( sync_sel == 0 ? 0x0 : MASK_28);
}

void calculate_output_format_register(unsigned short palette, unsigned int *clip_format)
{
	/* clear out the necessary bits */
	*clip_format &= 0x0000ffff;	
	/* set these bits new */
	*clip_format |=  (( ((palette&0xf00)>>8) << 30) | ((palette&0x00f) << 24) | (((palette&0x0f0)>>4) << 16));
}

void calculate_bcs_ctrl_register(unsigned int brightness, unsigned int contrast, unsigned int colour, unsigned int *bcs_ctrl)
{
	*bcs_ctrl = ((brightness << 24) | (contrast << 16) | (colour <<  0));
}


void SetDVBColor( int Color )
{

}

int calculate_video_dma1_grab( struct saa7146_video_dma* vdma1,int Display,BOOL Flip) 
{
	int depth = 0;

	unsigned char *dat;


	dat=DVB_Display_dma[Display]->Page[0].pPhysicalAddr;
	if ( Flip == FALSE ) {
	vdma1->pitch		= CurrentX*2*2;
	vdma1->base_even	= dat;
	vdma1->base_odd		= dat + (CurrentX*2);
	vdma1->prot_addr	= dat + ((CurrentY+1)*CurrentX*2);
	vdma1->num_line_byte	= ((modes_constants[saa_mode].v_field<<16) + modes_constants[saa_mode].h_pixels);
	vdma1->base_page	= 0 ;  
	} else {
	vdma1->pitch		= (unsigned int)CurrentX*2*-2;
	vdma1->base_even	= dat + ((CurrentY-1)*CurrentX*2);
	vdma1->base_odd		= dat + ((CurrentY-2)*CurrentX*2);
	vdma1->prot_addr	= dat ;
	vdma1->num_line_byte	= ((modes_constants[saa_mode].v_field<<16) + modes_constants[saa_mode].h_pixels);
	vdma1->base_page	= 0 ;  
	};

	/* convention: if scaling is between 1/2 and 1/4 we only use
	   the even lines, the odd lines get discarded (see vertical scaling) */

	if( saa_interlace != 0 && CurrentY*4 >= modes_constants[saa_mode].v_calc && CurrentY*2 <= modes_constants[saa_mode].v_calc) {
		vdma1->base_odd = vdma1->prot_addr;
		vdma1->pitch /= 2;
	}

	return 0;
}


int calculate_Direct_dma1_grab(WD_DMA *dma, int Pitch, int PosOffset ) 
{
	int depth = 0;

	unsigned char *dat;
	struct saa7146_video_dma vdma1;


	dat=dma->Page[0].pPhysicalAddr;
	dat=dat+PosOffset;

	vdma1.pitch		= SurfacePitch*2;
	vdma1.base_even	= dat;
	vdma1.base_odd		= dat + SurfacePitch;
	vdma1.prot_addr	= dat + (CurrentY*SurfacePitch*2);
	vdma1.num_line_byte	= ((modes_constants[saa_mode].v_field<<16) + modes_constants[saa_mode].h_pixels);
	vdma1.base_page	= 0 ;  
	/* convention: if scaling is between 1/2 and 1/4 we only use
	   the even lines, the odd lines get discarded (see vertical scaling) */
	if( saa_interlace != 0 && CurrentY*4 >= modes_constants[saa_mode].v_calc && CurrentY*2 <= modes_constants[saa_mode].v_calc) {
		vdma1.base_odd = vdma1.prot_addr;
		vdma1.pitch /= 2;
	}

	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, BASE_EVEN1,     vdma1.base_even);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, BASE_ODD1,      vdma1.base_odd);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, PROT_ADDR1,     vdma1.prot_addr);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, BASE_PAGE1,     vdma1.base_page);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, PITCH1,		vdma1.pitch);
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, NUM_LINE_BYTE1,	vdma1.num_line_byte);

	/* update the video dma 1 registers */
      SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0,  MC2, (MASK_02 | MASK_18));
	return 0;
}


void SAA7146_SetColourFormat(int nColourFormat)
{
	unsigned int	clip_format;
	unsigned short  palette;
	DWORD* rps0=rps0_mem_dma.pUserAddr;


	if ( nColourFormat == 2 ) palette = 0x210;             // RGB16
     else if ( nColourFormat == 3 ) palette = 0x213;          // RGB15
        else if ( nColourFormat == 4 ) palette = 0;          // YUV2

		saa_grab_format=palette;
		ColourFormat=nColourFormat;

	clip_format=SAA7146_ReadDword(hSAA7146, SAA7146_AD_BAR0,  CLIP_FORMAT_CTRL);
	
	//dprintk("saa7146: ==> set_output_format: pal:0x%03x\n",palette);
	
	/* call helper function */
	calculate_output_format_register(palette,&clip_format);
	//dprintk("saa7146: ==> set_output_format: 0x%08x\n",clip_format);

	/* update the hps registers */
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0,  CLIP_FORMAT_CTRL, clip_format);
    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_05 | MASK_21));

// und ins laufende rps einpoken
	if ( rps_clip_format[0] != 0 ) {
	  rps0[rps_clip_format[0]]=clip_format;
	  rps0[rps_clip_format[1]]=clip_format;
	}
}

void set_picture_prop(unsigned int brightness, unsigned int contrast, unsigned int colour)
{
	unsigned int	bcs_ctrl = 0;
	DWORD* rps0=rps0_mem_dma.pUserAddr;
	calculate_bcs_ctrl_register( brightness, contrast, colour, &bcs_ctrl);
    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, BCS_CTRL, bcs_ctrl);
	/* update the bcs register */
      SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_06 | MASK_22));

// und ins laufende rps einpoken
if ( rps_bcs_ctrl[0] != 0 ) {
	  rps0[rps_bcs_ctrl[0]]=bcs_ctrl;
	  rps0[rps_bcs_ctrl[1]]=bcs_ctrl;
};
}

/* ---------------------------------------------*/
/* overlay enable/disable			*/
/* ---------------------------------------------*/

/* enable(1) / disable(0) video */
void video_setmode( int v)
{
//	hprintk("saa7146: ==> video_setmode; m:%d\n",v);
	
	/* disable ? */
	if(v==0) {
		/* turn off rps */
            	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, MASK_28);	

		/* disable video dma1 */
      		 SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, MASK_22);
	}
	/* or enable ? */
	else {
		/* turn on rps */
		   SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, (MASK_12 | MASK_28));	
           Sleep(10);
		   /* fixme: enable video */
	        SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, (MASK_06 | MASK_22));

	}
};		


DWORD SAALogToPhys(WD_DMA *dma ,DWORD *pLog)
 { 
PHYS    BasePhysical; 
DWORD  *BaseLinear;
BaseLinear=dma->pUserAddr;
BasePhysical=(PHYS) dma->Page[0].pPhysicalAddr;

	return(BasePhysical+(pLog-BaseLinear)*4); 
};


int Direct_Mode(WD_DMA *dma, int Pitch, int PosOffset) 

	{
	unsigned int hps_v_scale = 0, hps_v_gain  = 0, hps_ctrl = 0, hps_h_prescale = 0, hps_h_scale = 0;
	unsigned int clip_format = 0; /* this can be 0, since we don't do clipping */
	unsigned int bcs_ctrl = 0;

	/* turn off rps */
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, MASK_28);	

	Sleep(50);

	    calculate_Direct_dma1_grab(dma,Pitch,PosOffset);
		
		calculate_v_scale_registers(modes_constants[saa_mode].v_calc, CurrentY, &hps_v_scale, &hps_v_gain);
		calculate_h_scale_registers(modes_constants[saa_mode].h_calc, CurrentX, 0, &hps_ctrl, &hps_v_gain, &hps_h_prescale, &hps_h_scale);
		calculate_hxo_hyo_and_sources(saa_grab_port, saa_grab_port, &hps_h_scale, &hps_ctrl);
		calculate_output_format_register(saa_grab_format,&clip_format);
		calculate_bcs_ctrl_register(InitialDVBBrightness, InitialDVBContrast, InitialDVBColor, &bcs_ctrl);
	

		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, HPS_V_SCALE,	hps_v_scale);
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, HPS_V_GAIN,	hps_v_gain);
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, HPS_CTRL,	hps_ctrl);
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, HPS_H_PRESCALE,hps_h_prescale);
		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, HPS_H_SCALE,	hps_h_scale);

	/* upload shadow-ram registers */
      	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_05 | MASK_06 | MASK_21 | MASK_22) );

    	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, BCS_CTRL, bcs_ctrl);
	/* update the bcs register */
      	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_06 | MASK_22));

		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, CLIP_FORMAT_CTRL,clip_format);
 		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC2, (MASK_05 | MASK_21));
 
 		/* disable video dma2 */
 		SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, (MASK_21));

		/* fixme: enable video */
	    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, (MASK_06 | MASK_22));


	return 0;
}



int init_rps0() {
	
int display;


	DWORD* rps0=rps0_mem_dma.pUserAddr;


	struct	saa7146_video_dma	vdma1;
	unsigned int hps_v_scale = 0, hps_v_gain  = 0, hps_ctrl = 0, hps_h_prescale = 0, hps_h_scale = 0;
	unsigned int clip_format = 0; /* this can be 0, since we don't do clipping */
	unsigned int bcs_ctrl = 0;

	int i = 0, count = 0;


	/* turn off rps */
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, MASK_28);	

	Sleep(50);

	/* write beginning of rps-program */
	count = 0;
		rps0[count++]  = CMD_PAUSE | MASK_12 ;	/* wait for o_fid_a */
		rps0[count++]  = CMD_PAUSE | MASK_11 ;	/* wait for e_fid_a */
		/* we only re-program the i-th buffer if the user had set some values for it earlier.
		   otherwise the calculation-functions may fail. */
		for ( display = 0; display < 2 ; display++ ) {
		calculate_video_dma1_grab(&vdma1,display,Flip);
		
		calculate_v_scale_registers(modes_constants[saa_mode].v_calc, CurrentY, &hps_v_scale, &hps_v_gain);
		calculate_h_scale_registers(modes_constants[saa_mode].h_calc, CurrentX, 0, &hps_ctrl, &hps_v_gain, &hps_h_prescale, &hps_h_scale);
		calculate_hxo_hyo_and_sources(saa_grab_port, saa_grab_port, &hps_h_scale, &hps_ctrl);
		calculate_output_format_register(saa_grab_format,&clip_format);
		calculate_bcs_ctrl_register(InitialDVBBrightness, InitialDVBContrast, InitialDVBColor, &bcs_ctrl);
	
		rps0[count++]  = CMD_WR_REG | (6 << 8) | HPS_CTRL/4;	/* upload hps-registers for next grab */
		rps0[count++]  = hps_ctrl;
		rps0[count++]  = hps_v_scale;
		rps0[count++]  = hps_v_gain;
		rps0[count++]  = hps_h_prescale;
		rps0[count++]  = hps_h_scale;
	    rps_bcs_ctrl[display] = count;
		rps0[count++]  = bcs_ctrl;

		rps0[count++]  = CMD_WR_REG | (1 << 8) | CLIP_FORMAT_CTRL/4;/* upload hps-registers for next grab */
	    rps_clip_format[display] = count;

		rps0[count++]  = clip_format;	

		rps0[count++]  = CMD_UPLOAD | MASK_05 | MASK_06;		/* upload hps1/2 */
	
		rps0[count++]  = CMD_WR_REG | (6 << 8) | BASE_ODD1/4;	/* upload video-dma1 registers for next grab */
		rps0[count++]  = vdma1.base_odd;
		rps0[count++]  = vdma1.base_even;
		rps0[count++]  = vdma1.prot_addr;
		rps0[count++]  = vdma1.pitch;
		rps0[count++] = vdma1.base_page;
		rps0[count++]  = vdma1.num_line_byte;

		rps0[count++]  = CMD_UPLOAD | MASK_02;		/* upload video-dma1 */

		rps0[count++]  = CMD_WR_REG_MASK | (MC1/4);		/* turn on video-dma1 */
		rps0[count++]  = MASK_06 | MASK_22;	    		/* => mask */
		rps0[count++]  = MASK_06 | MASK_22;			/* => values */

		rps0[count++]  = CMD_PAUSE | ( saa_grab_port == 0 ? MASK_12 : MASK_14);	/* wait for o_fid_a/b */
		rps0[count++]  = CMD_PAUSE | ( saa_grab_port == 0 ? MASK_11 : MASK_13);	/* wait for e_fid_a/b */

		rps0[count++]  = CMD_WR_REG_MASK | (MC1/4);		/* turn off video-dma1 and dma2 (clipping)*/
		rps0[count++]  = MASK_06 | MASK_22 | MASK_05 | MASK_21;	/* => mask */
		rps0[count++]  = MASK_22 | MASK_21;			/* => values */

		rps0[count++] = CMD_WR_REG | (1 << 8) | (MC2/4); 	/* Write MC2 */
		rps0[count++] = (1 << 27) | (1 << 28) | ((1+display) << 11);
		rps0[count++]  = CMD_INTERRUPT;				/* generate interrupt */

		}

		rps0[count++]  = CMD_JUMP;	/* jump to the beginning */
    	rps0[count++] = (DWORD)SAALogToPhys(&rps0_mem_dma,&rps0[2]);
	/* write the address of the rps-program */
	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, RPS_ADDR0,rps0_mem_dma.Page[0].pPhysicalAddr);
	/* turn on rps again */
//	SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, (MASK_12 | MASK_28));	

	return 0;
}




/* this funtion is called whenever a new grab is requested. if possible (that
   means: if the rps is not running) it re-programs the rps, otherwise it relys on
   the irq-handler to do that */
void set_up_grabbing()
{
	if (ModeRAWSurface == TRUE )  {
       Direct_Mode(Surface_dma,SurfacePitch,Offset_for_WindowOut);
   	   SetWindowText (hwndFPSField,"Sf-Raw");
	} else if (ModeRAWOverlay == TRUE )  {
       Direct_Mode(Overlay_dma,OverlayPitch,0);
   	   SetWindowText (hwndFPSField,"Ov-Raw");
	} else {
			init_rps0();
	}
}



void SetAVPID(struct frontend *front, unsigned short vpid, unsigned short apid, unsigned short ttpid)
{
                SAA7146_OutCom(COMTYPE_PIDFILTER, AudioPID,1, apid,0,0,0,0,0,0,0,0);
                SAA7146_OutCom(COMTYPE_PIDFILTER, VideoPID,1, vpid,0,0,0,0,0,0,0,0);
                SAA7146_OutCom( COMTYPE_TELETEXT, TTXDisable,0,0,0,0,0,0,0,0,0,0);
                if (ttpid!=0xffff) {
                        SAA7146_OutCom(COMTYPE_TELETEXT, TTXEnable, 2, 29, ttpid,0,0,0,0,0,0,0);
                        SAA7146_OutCom(COMTYPE_TELETEXT, ModifyTable, 4,0xffff, 0xffff, 0xffff, 0,0,0,0,0,0);
}
}


void Set_DVB_Channel(int Nummer)
{
char Zeile[128];

	if ( Programm[Nummer].Tuner_Auto == FALSE ) {
                dvb_front.power=Programm[Nummer].power;
                dvb_front.ttk=Programm[Nummer].ttk;
	} else {
	            dvb_front.power=LNB.Anschluss[Programm[Nummer].diseqc].Power;
            
				if ( LNB.Anschluss[Programm[Nummer].diseqc].Switch22khz == TRUE ) {
					if ( Programm[Nummer].freq/1000 >= LNB.Anschluss[Programm[Nummer].diseqc].SwitchFreq )  dvb_front.ttk= 1;
					  else dvb_front.ttk=0;
				};
	};


                CreateOSDWindow( 1, 2, 500, 40);
                MoveWindowAbs(1,20,400);
                SetColorBlend(2);
				OSDSetColor(1, 0, 0, 0, 0x0a);
				OSDSetColor(2, 0, 0, 100, 0x0a);
				OSDSetColor(3, 255, 255, 255, 0x0a);
                DrawBlock(1, 0, 0,720, 576,2);
				SetFont( 1, 3, 3, 2);
				sprintf(Zeile,"%d   %s",Nummer+1,Programm[Nummer].Name);

                WriteText( 1, 30, 1,Zeile);
                SetTimer(hWnd,201,8000,NULL);
                dvb_front.volt=Programm[Nummer].volt;
                dvb_front.fec=Programm[Nummer].fec;
                dvb_front.diseqc=Programm[Nummer].diseqc;
                dvb_front.freq=Programm[Nummer].freq;
                dvb_front.srate=Programm[Nummer].srate;
                dvb_front.video_pid=Programm[Nummer].video_pid;
                dvb_front.audio_pid=Programm[Nummer].audio_pid;
				dvb_front.tt_pid=Programm[Nummer].tt_pid;
                dvb_front.afc=Programm[Nummer].afc;


        if (DVBType==DVB_S) {
                        if ( LNB.Diseq == TRUE ) SetDiSEqC(dvb_front.diseqc);
                        Set22K( dvb_front.ttk);
        } else if (DVBType==DVB_C) {
			SAA7146_OutCom(COMTYPE_AUDIODAC, MainSwitch, 1,dvb_front.power,0,0,0,0,0,0,0,0);
        }
        Set_TV_Freq((unsigned __int64)dvb_front.freq,Programm[Nummer].diseqc); 
        DVB_SET_FRONTEND(&dvb_front); 
        SetAVPID(&dvb_front , dvb_front.video_pid, dvb_front.audio_pid, dvb_front.tt_pid);
		Sleep(10);
		DVB_Reset();
        //ShutDownFilters(dvb);
        /* Not fully tested with DVB-C yet */
        if ((DVBType==DVB_S) && dvb_front.AFC) AFC(&dvb_front,Programm[Nummer].diseqc);
        GetFront(&dvb_front);
}



void Run_DVB_Irq(BOOL State)
{

	RECT nowRect;

	if ( Has_DVB == TRUE ) {
		if ( State == FALSE ) {
        	/* turn off rps */
            video_setmode(0);
			SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, MC1, MASK_28);	
			SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER, 0x00000000);
		} else {
    	    SAA7146_WriteDword(hSAA7146, SAA7146_AD_BAR0, IER , (MASK_27 | MASK_28 | MASK_03 ));
            Init_Screen_Struct();
			DOSIZE=TRUE;
		}; 
	}
}



void SetMode( int mode)
{
        SAA7146_OutCom(COMTYPE_ENCODER, LoadVidCode, 1, mode,0,0,0,0,0,0,0,0);
}

void TestMode( int mode)
{
        SAA7146_OutCom(COMTYPE_ENCODER, SetTestMode, 1, mode,0,0,0,0,0,0,0,0);
}

void VidMode(int mode)
{
        SAA7146_OutCom( COMTYPE_ENCODER, SetVidMode, 1, mode,0,0,0,0,0,0,0,0);
}
           
void Set22K(int state)
{
        SAA7146_OutCom(COMTYPE_AUDIODAC, (state ? ON22K : OFF22K),0,0,0,0,0,0,0,0,0,0);
}

void SetDiSEqC(int input)
{
        if (input>3) return;
        SAA7146_OutCom(COMTYPE_AUDIODAC, SendDiSEqC,6, 4,(input&1) ? 0xff : 0x00,0xe0, 0x10, 0x38, 0xf0+input*4,0,0,0);
}

void SendDiSEqCMsg( int len, unsigned char *msg, int burst)
{
        int i;
        unsigned short buf[18] = { ((COMTYPE_AUDIODAC << 8) + SendDiSEqC),
                        16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        
        if (len>8)
                len=8;
	buf[1] = len+2;
        buf[2] = len;

        if (burst!=-1)
          buf[3]=burst ? 0xff : 0;
        else
          buf[3]=0xffff;

        for (i=0; i<len; i++)
                buf[i+4]=msg[i];
        
        SAA7146_OutCommand( buf, 18);
}

int GetFront(struct frontend *front)
{
                front->afc=((int)((char)(readreg(ves_addr,ves_flags,0x0a)<<1)))/2;
                front->afc=(front->afc*(int)(front->srate/8))/16;
                front->agc=(readreg(ves_addr,ves_flags,0x0b)<<8);
                front->sync=readreg(ves_addr,ves_flags,0x0e);
                front->nest=(readreg(ves_addr,ves_flags,0x1c)<<8);

                front->vber = readreg(ves_addr,ves_flags,0x15);
                front->vber|=(readreg(ves_addr,ves_flags,0x16)<<8);
                front->vber|=(readreg(ves_addr,ves_flags,0x17)<<16);

                if ((front->fec==8) && ((front->sync&0x1f) == 0x1f))
                        front->fec=(readreg(ves_addr,ves_flags,0x0d)>>4)&0x07;

        return 0;
}

void DVB_Reset( void )
{
	ClrBit1893();
};
                
int AFC(struct frontend *front,int Nr)
{
        unsigned char sync;
        int i;
        unsigned int sfreq=front->freq;
        unsigned int soff=front->srate/16;
        GetFront(front);
        for (i=2; i<10; i++) {    
                sync=front->sync;
                if ((sync&0x1f)==0x1f)
                        break;
                if (i&1) sfreq=front->freq+soff*(i/2);
					else sfreq=front->freq-soff*(i/2);
                Set_TV_Freq((unsigned __int64)sfreq,Nr); 
                Sleep(10);
                DVB_Reset(); 
                Sleep(20);
                GetFront(front);
        }
        if (i==10) 
          return -1;

        
        if (front->afc) {
                sfreq-=front->afc;
                Set_TV_Freq((unsigned __int64)sfreq,Nr ); 
                Sleep(10);
                DVB_Reset();
                GetFront(front);
        }
        front->freq=sfreq;
        return 0;
}

void DVB_SET_FRONTEND(struct frontend *front)
{
	if ( VES_TYPE == 1 ) {
		// VES1893
                SetControl((front->power ? 0x20 : 0)|(front->volt ? 0x10 : 0));
                SetFEC(front->fec);
                VES1893_SetSymbolrate(front->srate, 1);
	} else {
                ClrBit1820();
                SetQAM( front->qam, front->flags&7);
                VES1820_SetSymbolrate(front->srate, front->flags&7);
	};

}



/*
int SetFront(struct frontend *front)
{

        if (DVBType==DVB_S) {
                        SetDiSEqC(front->diseqc);
                        Set22K( front->ttk);
        } else if (DVBType==DVB_C) {
			SAA7146_OutCom(COMTYPE_AUDIODAC, MainSwitch, 1,front->power,0,0,0,0,0,0,0,0);
        }
       Set_TV_Freq((unsigned __int64)front->freq); 

        DVB_SET_FRONTEND(front); 

        SetAVPID(front , front->video_pid, front->audio_pid, front->tt_pid);
        Sleep(10);
		DVB_Reset();
        //ShutDownFilters(dvb);

        if ((DVBType==DVB_S) && front->AFC) AFC(front);
        return 0;
}
*/

/* All OSD commands supported by the Windows code */

int ResetBlend( unsigned char windownr)
{
        return SAA7146_OutCom(COMTYPE_OSD, SetNonBlend, 1, windownr,0,0,0,0,0,0,0,0);
}

int SetColorBlend(unsigned char windownr)
{
        return SAA7146_OutCom( COMTYPE_OSD, SetCBlend,  1, windownr,0,0,0,0,0,0,0,0);
}

int SetWindowBlend( unsigned char windownr, unsigned char blending)
{
        return SAA7146_OutCom( COMTYPE_OSD, SetWBlend, 2, windownr, blending,0,0,0,0,0,0,0);
}

int SetBlend_(unsigned char windownr,OSDPALTYPE colordepth, unsigned short index, unsigned char blending)
{
        return SAA7146_OutCom(COMTYPE_OSD, SetBlend, 4,windownr, colordepth, index, blending,0,0,0,0,0);
} 

int SetColor_(unsigned char windownr, OSDPALTYPE colordepth, unsigned short index, unsigned short colorhi, unsigned short colorlo)
{
        return SAA7146_OutCom(COMTYPE_OSD, SetColor, 5,windownr, colordepth, index, colorhi, colorlo,0,0,0,0);
} 

int BringToTop( unsigned char  windownr)
{
        return SAA7146_OutCom(COMTYPE_OSD, WTop, 1, windownr,0,0,0,0,0,0,0,0);
} 

int SetFont(unsigned char  windownr, unsigned char  fontsize,unsigned short  colorfg, unsigned short  colorbg)
{
        return SAA7146_OutCom(COMTYPE_OSD, Set_Font, 4,windownr, fontsize, colorfg, colorbg,0,0,0,0,0);
} 

unsigned short Swab16(unsigned char *dat)
{
	unsigned char b1;
	unsigned char b2;
	
	unsigned short ret;

	b1=dat[0];
	b2=dat[1];

	return(b1<<8|b2);
};


int WriteText(unsigned char win, unsigned short x, unsigned short y, unsigned char *buf)
{
        int i;
        unsigned int start;
        int length=strlen(buf)+1;

        start=0;
        while ( SAA7146_RDebi(DEBINOSWAP, BUFF1_BASE, 0, 2 ) )
                if ( start > 200) {
                        return -1;
                }

        for (i=0; i<length/2; i++)
                SAA7146_WDebi( DEBINOSWAP, BUFF1_BASE + i*2, Swab16(&buf[2*i]), 2);
        if (length&1)
                SAA7146_WDebi(DEBINOSWAP, BUFF1_BASE + i*2, 0, 2);
        return SAA7146_OutCom(COMTYPE_OSD, DText, 3, win, x, y,0,0,0,0,0,0);
}

int DrawLine( unsigned char windownr,unsigned short x, unsigned short y, unsigned short dx, unsigned short dy, unsigned short color)
{
        return SAA7146_OutCom(COMTYPE_OSD, DLine, 6,windownr, x, y, dx, dy, color,0,0,0);
} 

int DrawBlock( unsigned char windownr,unsigned short x, unsigned short y, unsigned short dx, unsigned short dy, unsigned short color)
{
        return SAA7146_OutCom(COMTYPE_OSD, DBox, 6,windownr, x, y, dx, dy, color,0,0,0);
} 

int HideWindow(unsigned char windownr)
{
        return SAA7146_OutCom(COMTYPE_OSD, WHide, 1, windownr,0,0,0,0,0,0,0,0);
} 

int MoveWindowRel( unsigned char windownr, unsigned short x, unsigned short y)
{
        return SAA7146_OutCom(COMTYPE_OSD, WMoveD, 3, windownr, x, y,0,0,0,0,0,0);
} 

int MoveWindowAbs( unsigned char windownr, unsigned short x, unsigned short y)
{
        return SAA7146_OutCom(COMTYPE_OSD, WMoveA, 3, windownr, x, y,0,0,0,0,0,0);
} 

int DestroyOSDWindow(unsigned char windownr)
{
        return SAA7146_OutCom(COMTYPE_OSD, WDestroy, 1, windownr,0,0,0,0,0,0,0,0);
} 

int CreateOSDWindow( unsigned char windownr,DISPTYPE disptype, unsigned short width, unsigned short height)
{
        return SAA7146_OutCom( COMTYPE_OSD, WCreate, 4,windownr, disptype, width, height,0,0,0,0,0);
} 



unsigned int RGB2YUV(unsigned short R, unsigned short G, unsigned short B)
{
        unsigned short y, u, v;
        unsigned short Y, Cr, Cb;
/*
		y = (9798 * R + 19235 * G + 3736 * B) / 32768;
		u = (((-4784 * R) - (9437 * G) + 4221 * B) / 32768) + 128;	
		v = ((20218 * R - 16941 * G - 3277 * B) / 32768) + 128;
        Y = y;
        Cb= u;
        Cr= v;


*/
        y = R * 77 + G * 150 + B * 29;  // Luma=0.299R+0.587G+0.114B 0..65535
        u = 2048+B * 8 -(y>>5);    // Cr 0..4095
        v = 2048+R * 10-(y>>5);    // Cb 0..4095

        Y = y/4788+16;
        Cb= u/18;
        Cr= v/18;


        return Cr|(Cb<<16)|(Y<<8);
}

void OSDSetColor(unsigned char color, unsigned char  r, unsigned char  g, unsigned char  b, unsigned char  blend)
{
        unsigned short ch, cl;
        unsigned int yuv;

        yuv=RGB2YUV(r,g,b);
        cl=(yuv&0xffff);
        ch=((yuv>>16)&0xffff);
        SetColor_(odswin, 16,color, ch, cl);
        SetBlend_(odswin, 16,color, blend);
}


int tuner_getstatus(void)
{
        char dat;
        i2c_master_recv(DVBTuners[DVBTuner].I2C/2,0, &dat, 1);
	return dat;
};


int tuner_islocked (void)
{
        return (tuner_getstatus() & TUNER_FL);
}

int tuner_afcstatus(void)
{
        return (tuner_getstatus() & TUNER_AFC) - 2;
}

int tuner_mode(void)
{
        return (tuner_getstatus() & TUNER_MODE) >> 3;
}

void Set_TV_Freq( unsigned __int64 mfreq,int LNBNr)
{
	unsigned char config;
    unsigned __int64 div2;
	unsigned short div;
    unsigned char buffer[4];
	int rc, swap=0;
    unsigned __int64 freq;
	int i;



    if (mfreq< (LNB.Anschluss[LNBNr].SwitchFreq*1000)) mfreq=(mfreq - LNB.Anschluss[LNBNr].LofLow*1000);
    else mfreq=(mfreq - LNB.Anschluss[LNBNr].LofHigh*1000);

   freq=mfreq*1000;

//  DVBTuners[DVBTuner].mode=0x02;


     freq*=DVBTuners[DVBTuner].step; // turn into Hz

	if (freq < DVBTuners[DVBTuner].thresh1) 
		config = DVBTuners[DVBTuner].VHF_L;
	else if (freq < DVBTuners[DVBTuner].thresh2) 
		config = DVBTuners[DVBTuner].VHF_H;
	else
		config = DVBTuners[DVBTuner].UHF;

	config &= ~DVBTuners[DVBTuner].mode;

	div2=freq + DVBTuners[DVBTuner].IFPCoff;
    div2/=DVBTuners[DVBTuner].res;
    div=(unsigned short)div2;

	
	/* some trickery which data is sent first */
        buffer[0] = buffer[2] = DVBTuners[DVBTuner].config;
        buffer[1] = buffer[3] = config;

        buffer[swap]     =  (unsigned char )((div>>8) & 0x7f);
        buffer[swap + 1] =  (unsigned char )(div & 0xff);

/*
buffer[0]=0x49;
buffer[1]=0xB8;
buffer[2]=0x95;
buffer[3]=0x30;
*/
        if (4 != (rc = i2c_master_send(DVBTuners[DVBTuner].I2C/2,0,buffer,4))) {
			// Ohhps
		};
}

static void set_radio_freq(int freq)
{
	unsigned char config;
	unsigned short div;
    unsigned char buffer[4];
	int rc;


	config = 0xa5;
	div=freq + (int)(16*10.7);
  	div&=0x7fff;

        buffer[0] = (div>>8) & 0x7f;
        buffer[1] = div      & 0xff;
        buffer[2] = DVBTuners[DVBTuner].config;
        buffer[3] = config;
        if (4 != (rc = i2c_master_send(DVBTuners[DVBTuner].I2C/2,0,buffer,4))) {
			// OOps
		};
}

int Get_Free_Filter(void)
{
	int i;

	for ( i = 0; i < MAXFILTER; i++ ) {
		if ( Filter[i].pid == 0xffff) return(i);
	};
return(-1);
}

int Get_Filter_by_Handle(unsigned short Handle )
{
	int i;

	for ( i = 0; i < MAXFILTER; i++ ) {
		if ( Filter[i].DVB_Handle == Handle) return(i);
	};
return(-1);
}


int SetBitFilter(struct bitfilter *filter)
{
        unsigned short buf[20];
        int ret;
		int index;
        
        memcpy(buf + 4, filter->data, 32);
        buf[0] = (COMTYPE_PID_FILTER << 8) + AddPIDFilter; 
        buf[1] = 16;	
        buf[2] = filter->pid;
        buf[3] = filter->mode;
          
        ret=SAA7146_CommandRequest( buf, 20, &(filter->handle), 1);          
        if ( ret >= 0 ) {
            index = Get_Free_Filter();
			if ( index >= 0 ) {
            LastFilter=index; 
            Filter[index].DVB_Handle=filter->handle;
			Filter[index].Buffer=malloc(32768);
			if ( Filter[index].Buffer != NULL ) {
			Filter[index].pid = filter->pid;
			Filter[index].BufferIndex=0;
			} else {
            // OHH kein Speicher fr Filter
			}
			} else {
            // OHH kein Filter mehr frei !!
			}
		};
        return ret;
};

int DelBitFilter(int FilterNummer)
{
        unsigned short buf[3];
        unsigned short answ[2];
        int ret;
        
        if (Filter[FilterNummer].pid == 0xffff) return 0;
        buf[0] = (COMTYPE_PID_FILTER << 8) + DelPIDFilter; 
        buf[1] = 1;	
        buf[2] = Filter[FilterNummer].DVB_Handle;
        ret=SAA7146_CommandRequest(buf, 3, answ, 2);          
        if (answ[1] != Filter[FilterNummer].DVB_Handle) {
			    //printk("dvb: filter shutdown error :%d\n", answ[1]);
                return(-1);
        }
		Filter[FilterNummer].pid = 0xffff;
		Filter[FilterNummer].BufferIndex=0;
		Filter[FilterNummer].DVB_Handle=0xffff;
        if ( Filter[FilterNummer].Buffer != NULL ) free(Filter[FilterNummer].Buffer);
		Filter[FilterNummer].Buffer=NULL;
        return ret;
}


int SetFilter(unsigned short pid, unsigned short section, unsigned short mode) 
{ 
	int ret;
    int i;
	struct bitfilter filt;
	filt.pid = pid;

	for ( i=0; i < 16 ; i++ ) filt.data[i]=0x0000;
	filt.data[0]= section;
	filt.mode   = mode;
	filt.handle = 0;
	filt.flags  = 0;
return(SetBitFilter(&filt));
};


BOOL Get_Pat( void )
{
int TimeOut=1000;
int i;
int ret;

if ( SetFilter(PID_PAT, (TID_PAT<<8)|0x00ff, 2) ==0xffff) return(FALSE);

// Warten auf TimeOut oder daten im Filter
Sleep(5000);


(void)DelBitFilter(LastFilter);

};



BOOL APIENTRY TunerDigiSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int i;


char Text[128];
float ffreq;
unsigned int freq;

	switch (message) {
        case WM_INITDIALOG:
			SaveTuner=DVBTuner;
            SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_RESETCONTENT , 0, 0 );
            SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_ADDSTRING , 0, (LONG)(LPSTR)"SP5659 (DVB-S)");
            SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_ADDSTRING , 0, (LONG)(LPSTR)"SPXXXX (DVB-C)");
			SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_SETCURSEL  , DVBTuner, 0); 
            PostMessage(hDlg,WM_USER,1,0);
            break;
case WM_USER:

	if ( wParam == 1 ) {
            i=SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);
			if (( i >= 0 ) && ( i < 2 )) {
			SetDlgItemInt(hDlg,IDT_MIN,DVBTuners[i].min/1000,FALSE);
            SetDlgItemInt(hDlg,IDT_MAX,DVBTuners[i].max/1000,FALSE);
            SetDlgItemInt(hDlg,IDT_RES,DVBTuners[i].res/1000,FALSE);
            SetDlgItemInt(hDlg,IDT_STEP,DVBTuners[i].step,FALSE);
			SetDlgItemInt(hDlg,IDT_THRESH1,DVBTuners[i].thresh1/1000,FALSE);
            SetDlgItemInt(hDlg,IDT_THRESH2,DVBTuners[i].thresh2/1000,FALSE);
            SetDlgItemInt(hDlg,IDT_VHF_L,DVBTuners[i].VHF_L,FALSE);
            SetDlgItemInt(hDlg,IDT_VHF_H,DVBTuners[i].VHF_H,FALSE);
            SetDlgItemInt(hDlg,IDT_UHF,DVBTuners[i].UHF,FALSE);
            SetDlgItemInt(hDlg,IDT_CONFIG,DVBTuners[i].config,FALSE);
            SetDlgItemInt(hDlg,IDT_I2C,DVBTuners[i].I2C,FALSE);
            SetDlgItemInt(hDlg,IDT_IFPCoff,DVBTuners[i].IFPCoff,FALSE);
            };

   			SetDlgItemInt(hDlg,IDM_MIN,DVBTuners[2].min/1000,FALSE);
            SetDlgItemInt(hDlg,IDM_MAX,DVBTuners[2].max/1000,FALSE);
            SetDlgItemInt(hDlg,IDM_RES,DVBTuners[2].res/1000,FALSE);
            SetDlgItemInt(hDlg,IDM_STEP,DVBTuners[2].step/1000,FALSE);

			SetDlgItemInt(hDlg,IDM_THRESH1,DVBTuners[2].thresh1/1000,FALSE);
            SetDlgItemInt(hDlg,IDM_THRESH2,DVBTuners[2].thresh2/1000,FALSE);
            SetDlgItemInt(hDlg,IDM_VHF_L,DVBTuners[2].VHF_L,FALSE);
            SetDlgItemInt(hDlg,IDM_VHF_H,DVBTuners[2].VHF_H,FALSE);
            SetDlgItemInt(hDlg,IDM_UHF,DVBTuners[2].UHF,FALSE);
            SetDlgItemInt(hDlg,IDM_CONFIG,DVBTuners[2].config,FALSE);
            SetDlgItemInt(hDlg,IDM_I2C,DVBTuners[2].I2C,FALSE);
            SetDlgItemInt(hDlg,IDM_IFPCoff,DVBTuners[2].IFPCoff,FALSE);
	};
            break;

		case WM_COMMAND:

			if (LOWORD(wParam) == IDC_COMBO1 ) {
				if ( HIWORD( wParam ) == CBN_SELCHANGE  ) {
                     SendMessage(hDlg,WM_USER,1,0);
				}
			}


			if (LOWORD(wParam) == IDOK ) {
			DVBTuner=2;
		    DVBTuners[2].min=GetDlgItemInt(hDlg,IDM_MIN,NULL,FALSE)*1000;
            DVBTuners[2].max=GetDlgItemInt(hDlg,IDM_MAX,NULL,FALSE)*1000;
            DVBTuners[2].res=GetDlgItemInt(hDlg,IDM_RES,NULL,FALSE)*1000;
            DVBTuners[2].step=GetDlgItemInt(hDlg,IDM_STEP,NULL,FALSE)*1000;
			DVBTuners[2].thresh1=GetDlgItemInt(hDlg,IDM_THRESH1,NULL,FALSE)*1000;
            DVBTuners[2].thresh2=GetDlgItemInt(hDlg,IDM_THRESH2,NULL,FALSE)*1000;
            DVBTuners[2].VHF_L=GetDlgItemInt(hDlg,IDM_VHF_L,NULL,FALSE);
            DVBTuners[2].VHF_H=GetDlgItemInt(hDlg,IDM_VHF_H,NULL,FALSE);
            DVBTuners[2].UHF=GetDlgItemInt(hDlg,IDM_UHF,NULL,FALSE);
            DVBTuners[2].config=GetDlgItemInt(hDlg,IDM_CONFIG,NULL,FALSE);
            DVBTuners[2].I2C=GetDlgItemInt(hDlg,IDM_I2C,NULL,FALSE);
			DVBTuners[2].IFPCoff=GetDlgItemInt(hDlg,IDM_IFPCoff,NULL,FALSE);
		    CheckMenuItem( GetMenu(hWnd), DVBTuner+1100, MF_CHECKED );
			CheckMenuItem( GetMenu(hWnd), SaveTuner+1100, MF_UNCHECKED );
			EndDialog(hDlg,TRUE);
			}
			
			if (LOWORD(wParam) == IDCANCEL ) {
				DVBTuner=SaveTuner;
              EndDialog(hDlg,TRUE);
			}
			 break;
    }

return(FALSE);
}






BOOL Set_Transponder(struct TTransponder *Transponder )
{
char Zeile[128];

	if ( Transponder->Tuner_Auto == FALSE ) {
                dvb_front.power=Transponder->power;
                dvb_front.ttk=Transponder->ttk;
	} else {
	            dvb_front.power=LNB.Anschluss[Transponder->diseqc].Power;
            
				if ( LNB.Anschluss[Transponder->diseqc].Switch22khz == TRUE ) {
					if ( Transponder->freq/1000 >= LNB.Anschluss[Transponder->diseqc].SwitchFreq )  dvb_front.ttk= 1;
					  else dvb_front.ttk=0;
				};
	};

                dvb_front.volt=Transponder->volt;
                dvb_front.fec=Transponder->fec;
                dvb_front.diseqc=Transponder->diseqc;
                dvb_front.freq=Transponder->freq;
                dvb_front.srate=Transponder->srate;
                dvb_front.video_pid=0;
                dvb_front.audio_pid=0;
				dvb_front.tt_pid=0;
                dvb_front.afc=0;


        if (DVBType==DVB_S) {
                        if ( LNB.Diseq == TRUE ) SetDiSEqC(dvb_front.diseqc);
                        Set22K( dvb_front.ttk);
        } else if (DVBType==DVB_C) {
			SAA7146_OutCom(COMTYPE_AUDIODAC, MainSwitch, 1,dvb_front.power,0,0,0,0,0,0,0,0);
        }
        Set_TV_Freq((unsigned __int64)dvb_front.freq,dvb_front.diseqc); 
        DVB_SET_FRONTEND(&dvb_front); 
        SetAVPID(&dvb_front , dvb_front.video_pid, dvb_front.audio_pid, dvb_front.tt_pid);
		Sleep(10);
		DVB_Reset();
        GetFront(&dvb_front);
        
		Transponder->sync=dvb_front.sync;
		Transponder->nest=dvb_front.nest;
        Transponder->afc=dvb_front.afc;
        Transponder->fec=dvb_front.fec;
        Transponder->vber=dvb_front.vber;
        Transponder->agc=dvb_front.agc;
	
		if ((dvb_front.sync&0x07)==0x07) return(TRUE);
		return(FALSE);
}

BOOL Set_Transponder_SRate(struct TTransponder *Transponder , unsigned int SRate)
{
	if ( SRate == 0 ) return(FALSE);
	if ( VES_TYPE == 1 ) {
                VES1893_SetSymbolrate(SRate, 1);
	} else {
                VES1820_SetSymbolrate(SRate, dvb_front.flags&7);
	};

		Sleep(10);
		DVB_Reset();
        GetFront(&dvb_front);
		Transponder->sync=dvb_front.sync;
		Transponder->nest=dvb_front.nest;
        Transponder->afc=dvb_front.afc;
        Transponder->fec=dvb_front.fec;
        Transponder->vber=dvb_front.vber;
        Transponder->agc=dvb_front.agc;
	
		if ((dvb_front.sync&0x07)==0x07) return(TRUE);
		return(FALSE);
}





