#include <winioctl.h>

extern BOOL DVB_Chip;

typedef unsigned long PHYS;

CRITICAL_SECTION m_cCrit;

typedef struct AllocData
{
	DWORD Size;		// Size to allocate/allocated 
	LPVOID Linear;	// Linear address 
	PHYS Physical;	// Physical address 
};


extern HANDLE DVBDevice;
extern BOOL DVBOK;

int DVBType=0;
#define DVB_S  0
#define DVB_C  1

BOOL Keep_DVB_Loaded=TRUE;
unsigned int FirmID=22;



unsigned char Init1893Tab[] =
{
        0x01, 0xA4, 0x35, 0x81, 0x2A, 0x0d, 0x55, 0xC4,
        0x09, 0x69, 0x00, 0x86, 0xcc, 0x28, 0x7F, 0x00,
        0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,	
        0x80, 0x00, 0x00, 0xb0, 0x14, 0x00, 0xDC, 0x20,
        0x81, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x55, 0x00, 0x00, 0x7f, 0x00
};


unsigned char Init1820PTab[] =
{
  0x69, 0x6A, 0x9B, 0x0A, 0x52, 0x46, 0x26, 0x1A,
  0x43, 0x6A, 0xAA, 0xAA, 0x1E, 0x85, 0x43, 0x28,
  0xE0, 0x00, 0xA1, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
  0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x40
};



struct i2c_msg {
	unsigned short addr;	/* slave address			*/
	unsigned short flags;		
#define I2C_M_TEN	0x10	/* we have a ten bit chip address	*/
#define I2C_M_RD	0x01
#if 0
#define I2C_M_PROBE	0x20
#endif
	short len;		/* msg length				*/
	char *buf;		/* pointer to msg data			*/
};


WORD m_wWindowWidth;
WORD m_wWindowHeight;



extern HDC                  DIB_Hdc;

int CmdTimeOut=100;

volatile DWORD *IC2_BaseAddress;





typedef enum
{
    SAA7146_MODE_BYTE   = 0,
    SAA7146_MODE_WORD   = 1,
    SAA7146_MODE_DWORD  = 2
} SAA7146_MODE;


typedef enum
{
    SAA7146_AD_BAR0 = 0,
    SAA7146_AD_BAR1 = 1,
    SAA7146_AD_BAR2 = 2,
    SAA7146_AD_BAR3 = 3,
    SAA7146_AD_BAR4 = 4,
    SAA7146_AD_BAR5 = 5,
    SAA7146_AD_EPROM = 6,
    SAA7146_ITEMS = 7
} SAA7146_ADDR;

typedef struct SAA7146_STRUCT *SAA7146_HANDLE;


typedef struct
{
    DWORD dwCounter;   // number of interrupts received
    DWORD dwLost;      // number of interrupts not yet dealt with
    BOOL fStopped;     // was interrupt disabled during wait
} SAA7146_INT_RESULT;
typedef void (WINAPI *SAA7146_INT_HANDLER)( SAA7146_HANDLE hSAA7146, SAA7146_INT_RESULT *intResult);

typedef struct
{
    WD_INTERRUPT Int;
    HANDLE hThread;
    WD_TRANSFER Trans[6];
    SAA7146_INT_HANDLER funcIntHandler;
} SAA7146_INT_INTERRUPT;

typedef struct
{
    DWORD index;
    DWORD dwMask;
    BOOL  fIsMemory;
    BOOL  fActive;
} SAA7146_ADDR_DESC;

typedef struct SAA7146_STRUCT
{
    HANDLE hWD;
    BOOL   fUseInt;
    SAA7146_INT_INTERRUPT Int;
    WD_PCI_SLOT pciSlot;
    SAA7146_ADDR_DESC addrDesc[SAA7146_ITEMS];
    WD_CARD_REGISTER cardReg;
} SAA7146_STRUCT;

// options for SAA7146_Open
enum { SAA7146_OPEN_USE_INT =   0x1 };

enum {
    PCI_IDR  = 0x00,
    PCI_CR   = 0x04,
    PCI_SR   = 0x06,
    PCI_REV  = 0x08,
    PCI_CCR  = 0x09,
    PCI_LSR  = 0x0c,
    PCI_LTR  = 0x0d,
    PCI_HTR  = 0x0e,
    PCI_BISTR= 0x0f,
    PCI_BAR0 = 0x10,
    PCI_BAR1 = 0x14,
    PCI_BAR2 = 0x18,
    PCI_BAR3 = 0x1c,
    PCI_BAR4 = 0x20,
    PCI_BAR5 = 0x24,
    PCI_CIS  = 0x28,
    PCI_SVID = 0x2c,
    PCI_SID  = 0x2e,
    PCI_ERBAR= 0x30,
    PCI_ILR  = 0x3c,
    PCI_IPR  = 0x3d,
    PCI_MGR  = 0x3e,
    PCI_MLR  = 0x3f
};

char DVBVendorID[10];
char DVBDeviceID[10];

extern BOOL NT;
extern HWND SplashWnd;
extern char OrgDVBDriverName[128];


int SAA7146_Open (SAA7146_HANDLE *phSAA7146, DWORD dwVendorID, DWORD dwDeviceID,  DWORD options,BOOL Lock);
void SAA7146_Close(SAA7146_HANDLE hSAA7146);
DWORD SAA7146_CountCards (DWORD dwVendorID, DWORD dwDeviceID);
BOOL SAA7146_IsAddrSpaceActive(SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace);

// General read/write function
void SAA7146_ReadWriteBlock(SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, BOOL fRead, PVOID buf, DWORD dwBytes, SAA7146_MODE mode);
BYTE SAA7146_ReadByte (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset);
WORD SAA7146_ReadWord (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset);
DWORD SAA7146_ReadDword (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset);
void SAA7146_WriteByte (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, BYTE data);
void SAA7146_WriteWord (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, WORD data);
void SAA7146_WriteDword (SAA7146_HANDLE hSAA7146, SAA7146_ADDR addrSpace, DWORD dwOffset, DWORD data);
// handle interrupts
void WINAPI SAA7146_IntHandlerRoutine(SAA7146_HANDLE hSAA7146, SAA7146_INT_RESULT *intResult);
BOOL SAA7146_IntIsEnabled (SAA7146_HANDLE hSAA7146);
BOOL SAA7146_IntEnable (SAA7146_HANDLE hSAA7146, SAA7146_INT_HANDLER funcIntHandler);
void SAA7146_IntDisable (SAA7146_HANDLE hSAA7146);
// access to PCI configuration registers
void SAA7146_WritePCIReg(SAA7146_HANDLE hSAA7146, DWORD dwReg, DWORD dwData);
DWORD SAA7146_ReadPCIReg(SAA7146_HANDLE hSAA7146, DWORD dwReg);
BOOL SAA7146_DetectCardElements(SAA7146_HANDLE hSAA7146);

extern HANDLE	Device_Handle;

extern BOOL Has_DVB;
extern int Current_Mode;

SAA7146_HANDLE hSAA7146=NULL;

extern char DVBTyp[30];
char VESTyp[30];
char VersionString[255];

extern HWND hWnd;

extern BOOL SaveSettings;

extern WD_DMA *DVB_Display_dma[2];
extern WD_DMA rps0_mem_dma;
extern WD_DMA debi_mem_dma;
extern WD_DMA *Surface_dma;
extern WD_DMA *Overlay_dma;

extern BOOL ModeRAWSurface;
extern BOOL ModeRAWOverlay;

extern HWND hwndFPSField;


int debiwait_maxwait = 1000;
int debitype;
int debilen;



#define I2C_MEM_SIZE		0x002000	/* 2048 */
#define	RPS_MEM_SIZE		0x000200	/* 512 Bytes */
#define	DEBI_MEM_SIZE		0x008000	/* 32 KB */

DWORD i2c_mem[I2C_MEM_SIZE];
unsigned char ves_addr=(0x12 >> 1);  
unsigned char ves_flags=0;
unsigned char ves_ctr;
unsigned char ves_pwm,ves_srate,ves_reg0,ves_con;
unsigned char ves_inv;

typedef enum  {	WCreate,
                WDestroy,
                WMoveD,
                WMoveA,
		    	WHide,
                WTop,
                DBox,
                DLine,
		    	DText,
		    	Set_Font,
                SetColor,
		    	SetBlend,
		    	SetWBlend,
		    	SetCBlend,
		    	SetNonBlend,
                LoadBmp,
				BlitBmp,
				ReleaseBmp
              } OSDCOM;

typedef enum OSDPALTYPE
{
	NoPalet =  0,      /* No palette */
	Pal1Bit =  2,      /* 2 colors for 1 Bit Palette    */
	Pal2Bit =  4,      /* 4 colors for 2 bit palette    */
	Pal4Bit =  16,     /* 16 colors for 4 bit palette   */
	Pal8Bit =  256     /* 256 colors for 16 bit palette */
} OSDPALTYPE, *POSDPALTYPE;

typedef enum DISPTYPE
{
	BITMAP1,                  /* 1 bit bitmap */
	BITMAP2,                  /* 2 bit bitmap */
	BITMAP4,                  /* 4 bit bitmap */
	BITMAP8,                  /* 8 bit bitmap */
//	BITMAP1HR,                /* 1 Bit bitmap half resolution */
//	BITMAP2HR,                /* 2 bit bitmap half resolution */
//	BITMAP4HR,                /* 4 bit bitmap half resolution */
//	BITMAP8HR,                /* 8 bit bitmap half resolution */
//	YCRCB422,                 /* 4:2:2 YCRCB Graphic Display */
//	YCRCB444,                 /* 4:4:4 YCRCB Graphic Display */
//	YCRCB444HR,               /* 4:4:4 YCRCB graphic half resolution */
//	VIDEO_MPEG,               /* Full Size MPEG Video Display */
//	VIDEOHSIZE,               /* MPEG Video Display Half Resolution */
//	VIDEOQSIZE,               /* MPEG Video Display Quarter Resolution */
//	VIDEOESIZE,               /* MPEG Video Display Quarter Resolution */
//	CURSOR                    /* Cursor */
} DISPTYPE, *PDISPTYPE;




typedef enum  { SetVidMode,
			    SetTestMode,
			    LoadVidCode,
				SetMonitorType
			  } ENC;


typedef enum  { TTXEnable,
		    	TTXDisable,
		    	ModifyTable,
		    	ReqestP29_P830,
                NoPageMemory,
                NoPESMemory, 
                PESPacket,
                TTXPage,
                P29_P830,
                DroppedPages
              } TTXCOM;


typedef enum  { VideoPID,
                AudioPID,
		    	WaitVideoPlay,
		    	WaitUnMute,
		    	InitFilt,
		    	AddFilt8,
		    	AddFilt16,
		    	DeleteFilt,
                FiltError,
		    	RecSection,
                NewVersion,
                CacheError,
		    	SetFiltBytes,
		    	SetRange,
		    	AddSecFilt,
		    	AddRangeFilt,
				AddFilt12,
				MultiPID,
				AddPIDFilter,
				DelPIDFilter,
				TestSec
              } PIDCOM;



typedef enum  { 	AudioDAC,
                	CabADAC,
		    	ON22K,
		    	OFF22K,
		    	MainSwitch,
		    	ADSwitch,
		    	SendDiSEqC,
		    	OFDM_Channel,
		    	OFDM_Guard,
		    	OFDM_MpegBer,
			SetRegister,
              } AUDCOM;


typedef enum QAM_TYPE
{	QAM_16,
	QAM_32,
	QAM_64,
	QAM_128,
	QAM_256
} QAM_TYPE, *PQAM_TYPE;

typedef struct {
  QAM_TYPE	QAM_Mode;
  int    		NoOfSym;
  unsigned char		Reg1;
  unsigned char		Reg5;
  unsigned char		Reg8;
  unsigned char		Reg9;
}QAM_SETTING;


QAM_SETTING QAM_Values[] = {	
  {QAM_16 ,  16, 145, 164, 162, 145},
  {QAM_32 ,  32, 150, 120, 116, 150},
  {QAM_64 ,  64, 106,  70,  67, 106},
  {QAM_128, 128, 126,  54,  52, 126},
  {QAM_256, 256, 107,  38,  35, 107}
};


extern int AnzahlProzessor;
extern int MainProzessor;
extern int IrqProzessor;
extern int VBIProzessor;
extern int AusgabeProzessor;
extern int ProzessorMask;




/* Values that need to be changed for PAL or NTSC systems */
/* Example for NTSC: insmod saa7146 mode=1 */

/* Number of vertical active lines */
#define V_ACTIVE_LINES_PAL	576
#define V_ACTIVE_LINES_NTSC	480

/* Number of lines in a field for HPS to process */
#define V_FIELD_PAL	288
#define V_FIELD_NTSC	240

/* Number of lines of vertical offset before processing */
#define V_OFFSET_PAL	0x15
#define V_OFFSET_NTSC	0x16

/* Number of horizontal pixels to process */
#define H_PIXELS_PAL	720
#define H_PIXELS_NTSC	640

/* Horizontal offset of processing window */
#define H_OFFSET_PAL	0x40
#define H_OFFSET_NTSC	0x06

/************************************************************************/
/* UNSORTED								*/
/************************************************************************/

#define ME1    0x0000000800
#define PV1    0x0000000008

/************************************************************************/
/* I2C									*/
/************************************************************************/

/* time we wait after certain i2c-operations */
#define SAA7146_I2C_DELAY 		10

#define	SAA7146_IICSTA		0x090
#define	SAA7146_I2C_ABORT	(1<<7)
#define	SAA7146_I2C_SPERR	(1<<6)
#define	SAA7146_I2C_APERR	(1<<5)
#define	SAA7146_I2C_DTERR	(1<<4)
#define	SAA7146_I2C_DRERR	(1<<3)
#define	SAA7146_I2C_AL		(1<<2)
#define	SAA7146_I2C_ERR		(1<<1)
#define	SAA7146_I2C_BUSY	(1<<0)

#define	SAA7146_IICTRF		0x08c
#define	SAA7146_I2C_START	(0x3)
#define	SAA7146_I2C_CONT	(0x2)
#define	SAA7146_I2C_STOP	(0x1)
#define	SAA7146_I2C_NOP		(0x0)

#define SAA7146_I2C_BUS_BIT_RATE_6400	(0x5<<8)
#define SAA7146_I2C_BUS_BIT_RATE_3200	(0x1<<8)
#define SAA7146_I2C_BUS_BIT_RATE_480	(0x4<<8)
#define SAA7146_I2C_BUS_BIT_RATE_320	(0x6<<8)
#define SAA7146_I2C_BUS_BIT_RATE_240	(0x7<<8)
#define SAA7146_I2C_BUS_BIT_RATE_120	(0x0<<8)
#define SAA7146_I2C_BUS_BIT_RATE_80	(0x2<<8)
#define SAA7146_I2C_BUS_BIT_RATE_60	(0x3<<8)

/************************************************************************/
/* CLIPPING								*/
/************************************************************************/

/* some defines for the various clipping-modes */
#define SAA7146_CLIPPING_RECT		0x4
#define SAA7146_CLIPPING_RECT_INVERTED	0x5
#define SAA7146_CLIPPING_MASK		0x6
#define SAA7146_CLIPPING_MASK_INVERTED	0x7

/************************************************************************/
/* RPS									*/
/************************************************************************/

#define CMD_NOP		0x00000000  /* No operation */
#define CMD_CLR_EVENT	0x00000000  /* Clear event */
#define CMD_SET_EVENT	0x10000000  /* Set signal event */
#define CMD_PAUSE	0x20000000  /* Pause */
#define CMD_CHECK_LATE	0x30000000  /* Check late */
#define CMD_UPLOAD	0x40000000  /* Upload */
#define CMD_STOP	0x50000000  /* Stop */
#define CMD_INTERRUPT	0x60000000  /* Interrupt */
#define CMD_JUMP	0x80000000  /* Jump */
#define CMD_WR_REG	0x90000000  /* Write (load) register */
#define CMD_RD_REG	0xa0000000  /* Read (store) register */
#define CMD_WR_REG_MASK	0xc0000000  /* Write register with mask */

/************************************************************************/
/* OUTPUT FORMATS 							*/
/************************************************************************/

/* output formats; each entry holds three types of information */
/* composed is used in the sense of "not-planar" */

#define RGB15_COMPOSED	0x213
/* this means: yuv2rgb-conversation-mode=2, dither=yes(=1), format-mode = 3 */
#define RGB16_COMPOSED	0x210
#define RGB24_COMPOSED	0x201
#define RGB32_COMPOSED	0x202

#define YUV411_COMPOSED		0x003
/* this means: yuv2rgb-conversation-mode=0, dither=no(=0), format-mode = 3 */
#define YUV422_COMPOSED		0x000
#define YUV411_DECOMPOSED	0x00b
#define YUV422_DECOMPOSED	0x009

/************************************************************************/
/* MISC 								*/
/************************************************************************/

/* Bit mask constants */
#define MASK_00   0x00000001    /* Mask value for bit 0 */
#define MASK_01   0x00000002    /* Mask value for bit 1 */
#define MASK_02   0x00000004    /* Mask value for bit 2 */
#define MASK_03   0x00000008    /* Mask value for bit 3 */
#define MASK_04   0x00000010    /* Mask value for bit 4 */
#define MASK_05   0x00000020    /* Mask value for bit 5 */
#define MASK_06   0x00000040    /* Mask value for bit 6 */
#define MASK_07   0x00000080    /* Mask value for bit 7 */
#define MASK_08   0x00000100    /* Mask value for bit 8 */
#define MASK_09   0x00000200    /* Mask value for bit 9 */
#define MASK_10   0x00000400    /* Mask value for bit 10 */
#define MASK_11   0x00000800    /* Mask value for bit 11 */
#define MASK_12   0x00001000    /* Mask value for bit 12 */
#define MASK_13   0x00002000    /* Mask value for bit 13 */
#define MASK_14   0x00004000    /* Mask value for bit 14 */
#define MASK_15   0x00008000    /* Mask value for bit 15 */
#define MASK_16   0x00010000    /* Mask value for bit 16 */
#define MASK_17   0x00020000    /* Mask value for bit 17 */
#define MASK_18   0x00040000    /* Mask value for bit 18 */
#define MASK_19   0x00080000    /* Mask value for bit 19 */
#define MASK_20   0x00100000    /* Mask value for bit 20 */
#define MASK_21   0x00200000    /* Mask value for bit 21 */
#define MASK_22   0x00400000    /* Mask value for bit 22 */
#define MASK_23   0x00800000    /* Mask value for bit 23 */
#define MASK_24   0x01000000    /* Mask value for bit 24 */
#define MASK_25   0x02000000    /* Mask value for bit 25 */
#define MASK_26   0x04000000    /* Mask value for bit 26 */
#define MASK_27   0x08000000    /* Mask value for bit 27 */
#define MASK_28   0x10000000    /* Mask value for bit 28 */
#define MASK_29   0x20000000    /* Mask value for bit 29 */
#define MASK_30   0x40000000    /* Mask value for bit 30 */
#define MASK_31   0x80000000    /* Mask value for bit 31 */

#define MASK_B0   0x000000ff    /* Mask value for byte 0 */
#define MASK_B1   0x0000ff00    /* Mask value for byte 1 */
#define MASK_B2   0x00ff0000    /* Mask value for byte 2 */
#define MASK_B3   0xff000000    /* Mask value for byte 3 */

#define MASK_W0   0x0000ffff    /* Mask value for word 0 */
#define MASK_W1   0xffff0000    /* Mask value for word 1 */

#define MASK_PA   0xfffffffc    /* Mask value for physical address */
#define MASK_PR   0xfffffffe 	/* Mask value for protection register */
#define MASK_ER   0xffffffff    /* Mask value for the entire register */

#define MASK_NONE 0x00000000    /* No mask */

/************************************************************************/
/* REGISTERS 								*/
/************************************************************************/

#define BASE_ODD1         0x00  /* Video DMA 1 registers  */
#define BASE_EVEN1        0x04
#define PROT_ADDR1        0x08
#define PITCH1            0x0C
#define BASE_PAGE1        0x10  /* Video DMA 1 base page */
#define NUM_LINE_BYTE1    0x14

#define BASE_ODD2         0x18  /* Video DMA 2 registers */
#define BASE_EVEN2        0x1C
#define PROT_ADDR2        0x20
#define PITCH2            0x24
#define BASE_PAGE2        0x28  /* Video DMA 2 base page */
#define NUM_LINE_BYTE2    0x2C

#define BASE_ODD3         0x30  /* Video DMA 3 registers */
#define BASE_EVEN3        0x34
#define PROT_ADDR3        0x38
#define PITCH3            0x3C         
#define BASE_PAGE3        0x40  /* Video DMA 3 base page */
#define NUM_LINE_BYTE3    0x44

#define PCI_BT_V1         0x48  /* Video/FIFO 1 */
#define PCI_BT_V2         0x49  /* Video/FIFO 2 */
#define PCI_BT_V3         0x4A  /* Video/FIFO 3 */
#define PCI_BT_DEBI       0x4B  /* DEBI */
#define PCI_BT_A          0x4C  /* Audio */

#define DD1_INIT          0x50  /* Init setting of DD1 interface */

#define DD1_STREAM_B      0x54  /* DD1 B video data stream handling */
#define DD1_STREAM_A      0x56  /* DD1 A video data stream handling */

#define BRS_CTRL          0x58  /* BRS control register */
#define HPS_CTRL          0x5C  /* HPS control register */
#define HPS_V_SCALE       0x60  /* HPS vertical scale */
#define HPS_V_GAIN        0x64  /* HPS vertical ACL and gain */
#define HPS_H_PRESCALE    0x68  /* HPS horizontal prescale   */
#define HPS_H_SCALE       0x6C  /* HPS horizontal scale */
#define BCS_CTRL          0x70  /* BCS control */
#define CHROMA_KEY_RANGE  0x74
#define CLIP_FORMAT_CTRL  0x78  /* HPS outputs formats & clipping */

#define DEBI_CONFIG       0x7C
#define DEBI_COMMAND      0x80
#define DEBI_PAGE         0x84
#define DEBI_AD           0x88	

#define I2C_TRANSFER      0x8C	
#define I2C_STATUS        0x90	

#define BASE_A1_IN        0x94	/* Audio 1 input DMA */
#define PROT_A1_IN        0x98
#define PAGE_A1_IN        0x9C
  
#define BASE_A1_OUT       0xA0  /* Audio 1 output DMA */
#define PROT_A1_OUT       0xA4
#define PAGE_A1_OUT       0xA8

#define BASE_A2_IN        0xAC  /* Audio 2 input DMA */
#define PROT_A2_IN        0xB0
#define PAGE_A2_IN        0xB4

#define BASE_A2_OUT       0xB8  /* Audio 2 output DMA */
#define PROT_A2_OUT       0xBC
#define PAGE_A2_OUT       0xC0

#define RPS_PAGE0         0xC4  /* RPS task 0 page register */
#define RPS_PAGE1         0xC8  /* RPS task 1 page register */

#define RPS_THRESH0       0xCC  /* HBI threshold for task 0 */
#define RPS_THRESH1       0xD0  /* HBI threshold for task 1 */

#define RPS_TOV0          0xD4  /* RPS timeout for task 0 */
#define RPS_TOV1          0xD8  /* RPS timeout for task 1 */

#define IER               0xDC  /* Interrupt enable register */

#define GPIO_CTRL         0xE0  /* GPIO 0-3 register */

#define EC1SSR            0xE4  /* Event cnt set 1 source select */
#define EC2SSR            0xE8  /* Event cnt set 2 source select */
#define ECT1R             0xEC  /* Event cnt set 1 thresholds */
#define ECT2R             0xF0  /* Event cnt set 2 thresholds */

#define ACON1             0xF4
#define ACON2             0xF8

#define MC1               0xFC   /* Main control register 1 */
#define MC2               0x100  /* Main control register 2  */

#define RPS_ADDR0         0x104  /* RPS task 0 address register */
#define RPS_ADDR1         0x108  /* RPS task 1 address register */

#define ISR               0x10C  /* Interrupt status register */                                                             
#define PSR               0x110  /* Primary status register */
#define SSR               0x114  /* Secondary status register */

#define EC1R              0x118  /* Event counter set 1 register */
#define EC2R              0x11C  /* Event counter set 2 register */         

#define PCI_VDP1          0x120  /* Video DMA pointer of FIFO 1 */
#define PCI_VDP2          0x124  /* Video DMA pointer of FIFO 2 */
#define PCI_VDP3          0x128  /* Video DMA pointer of FIFO 3 */
#define PCI_ADP1          0x12C  /* Audio DMA pointer of audio out 1 */
#define PCI_ADP2          0x130  /* Audio DMA pointer of audio in 1 */
#define PCI_ADP3          0x134  /* Audio DMA pointer of audio out 2 */
#define PCI_ADP4          0x138  /* Audio DMA pointer of audio in 2 */
#define PCI_DMA_DDP       0x13C  /* DEBI DMA pointer */

#define LEVEL_REP         0x140,
#define A_TIME_SLOT1      0x180,  /* from 180 - 1BC */
#define A_TIME_SLOT2      0x1C0,  /* from 1C0 - 1FC */

/************************************************************************/
/* ISR-MASKS 								*/
/************************************************************************/

#define SPCI_PPEF       0x80000000  /* PCI parity error */
#define SPCI_PABO       0x40000000  /* PCI access error (target or master abort) */
#define SPCI_PPED       0x20000000  /* PCI parity error on 'real time data' */
#define SPCI_RPS_I1     0x10000000  /* Interrupt issued by RPS1 */
#define SPCI_RPS_I0     0x08000000  /* Interrupt issued by RPS0 */
#define SPCI_RPS_LATE1  0x04000000  /* RPS task 1 is late */
#define SPCI_RPS_LATE0  0x02000000  /* RPS task 0 is late */
#define SPCI_RPS_E1     0x01000000  /* RPS error from task 1 */
#define SPCI_RPS_E0     0x00800000  /* RPS error from task 0 */
#define SPCI_RPS_TO1    0x00400000  /* RPS timeout task 1 */
#define SPCI_RPS_TO0    0x00200000  /* RPS timeout task 0 */
#define SPCI_UPLD       0x00100000  /* RPS in upload */
#define SPCI_DEBI_S     0x00080000  /* DEBI status */
#define SPCI_DEBI_E     0x00040000  /* DEBI error */
#define SPCI_IIC_S      0x00020000  /* I2C status */
#define SPCI_IIC_E      0x00010000  /* I2C error */
#define SPCI_A2_IN      0x00008000  /* Audio 2 input DMA protection / limit */
#define SPCI_A2_OUT     0x00004000  /* Audio 2 output DMA protection / limit */
#define SPCI_A1_IN      0x00002000  /* Audio 1 input DMA protection / limit */
#define SPCI_A1_OUT     0x00001000  /* Audio 1 output DMA protection / limit */
#define SPCI_AFOU       0x00000800  /* Audio FIFO over- / underflow */
#define SPCI_V_PE       0x00000400  /* Video protection address */
#define SPCI_VFOU       0x00000200  /* Video FIFO over- / underflow */
#define SPCI_FIDA       0x00000100  /* Field ID video port A */
#define SPCI_FIDB       0x00000080  /* Field ID video port B */
#define SPCI_PIN3       0x00000040  /* GPIO pin 3 */
#define SPCI_PIN2       0x00000020  /* GPIO pin 2 */
#define SPCI_PIN1       0x00000010  /* GPIO pin 1 */
#define SPCI_PIN0       0x00000008  /* GPIO pin 0 */
#define SPCI_ECS        0x00000004  /* Event counter 1, 2, 4, 5 */
#define SPCI_EC3S       0x00000002  /* Event counter 3 */
#define SPCI_EC0S       0x00000001  /* Event counter 0 */


#define	DPRAM_BASE	0x4000
#define DPRAM_SIZE	0x2000
#define BOOT_STATE	(DPRAM_BASE + 0x7F8)
#define BOOT_SIZE		(DPRAM_BASE + 0x7FA)
#define BOOT_BASE		(DPRAM_BASE + 0x7FC)
#define BOOT_BLOCK	(DPRAM_BASE + 0x800)
#define BOOT_MAX_SIZE	0x800

#define IRQ_STATE		(DPRAM_BASE + 0x0F4)
#define IRQ_STATE_EXT	(DPRAM_BASE + 0x0F6)
#define MSGSTATE		(DPRAM_BASE + 0x0F8)
#define FILT_STATE	(DPRAM_BASE + 0x0FA)
#define COMMAND		(DPRAM_BASE + 0x0FC)
#define COM_BUFF		(DPRAM_BASE + 0x100)
#define COM_BUFF_SIZE	0x20

#define BUFF1_BASE	(DPRAM_BASE + 0x120)
#define BUFF1_SIZE	0xE0

#define DATA_BUFF_BASE	(DPRAM_BASE + 0x200)
#define DATA_BUFF_SIZE	0x1C00

#define Reserved		(DPRAM_BASE + 0x1E00)
#define Reserved_SIZE	0x1FC

#define HANDSHAKE_REG	(DPRAM_BASE + 0x1FF8)
#define IRQ_RX		(DPRAM_BASE + 0x1FFC)
#define IRQ_TX		(DPRAM_BASE + 0x1FFE)

#define DRAM_START_CODE		0x2e000404
#define DRAM_MAX_CODE_SIZE	0x00100000

#define RESET_LINE			2
#define DEBI_DONE_LINE		1

#define DAC_CS	0x8000
#define DAC_CDS	0x0000

#define GPIO_INPUT  0x00
#define GPIO_IRQHI  0x10
#define GPIO_IRQLO  0x20
#define GPIO_IRQHL  0x30
#define GPIO_OUTLO  0x40
#define GPIO_OUTHI  0x50

#define DEBINOSWAP 0x4e0000
#define DEBISWAB   0x5e0000

#define BOOTSTATE_BUFFER_EMPTY	 0
#define BOOTSTATE_BUFFER_FULL	 1
#define BOOTSTATE_BOOT_COMPLETE	 2


#define COMTYPE_NOCOM            0
#define COMTYPE_TUNER			 1
#define COMTYPE_DEMODULATOR      2
#define COMTYPE_DESCRAMBLE       3
#define COMTYPE_PIDFILTER        4
#define COMTYPE_MPEGDECODER      5
#define COMTYPE_OSD              6
#define COMTYPE_BMP              7
#define COMTYPE_ENCODER          8
#define COMTYPE_CONFACCESS       9
#define COMTYPE_I2C              10
#define COMTYPE_AUDIODAC         11
#define COMTYPE_TELETEXT         12
#define COMTYPE_REQUEST          13
#define COMTYPE_SYSTEM           14
#define COMTYPE_REC_PLAY         15
#define COMTYPE_COMMON_IF        16
#define COMTYPE_PID_FILTER       17


#define AudioState       0
#define AudioBuffState   1
#define VideoState1      2
#define VideoState2      3
#define VideoState3      4
#define CrashCounter     5
#define ReqVersion       6
#define ReqVCXO          7
#define ReqRegister      8

#define DVB_ERR_NOSERVER		0
#define DVB_ERR_NONE			1
#define DVB_ERR_HARDWARE		2
#define DVB_ERR_ILLEGALDATA		3
#define DVB_ERR_NODATA			4
#define DVB_ERR_TIMEOUT			5
#define DVB_ERR_DENY			6
#define DVB_ERR_OVERFLOW		7
#define DVB_ERR_NOMEMORY		8
#define DVB_ERR_LOCK			9

#define	GPMQFull	0x0001			//Main Message Queue Full
#define	GPMQOver	0x0002			//Main Message Queue Overflow
#define	HPQFull	0x0004			//High Priority Msg Queue Full
#define	HPQOver	0x0008
#define	OSDQFull	0x0010			//OSD Queue Full
#define	OSDQOver	0x0020

#define DATA_TELETEXT            0x00 
#define DATA_FSECTION            0x01
#define DATA_IPMPE               0x02
#define DATA_MPEG_RECORD         0x03
#define DATA_DEBUG_MESSAGE       0x04
#define DATA_COMMON_INTERFACE    0x05
#define DATA_MPEG_PLAY           0x06
#define DATA_BMP_LOAD            0x07

#define CI_CMD_ERROR             0x00
#define CI_CMD_ACK               0x01
#define CI_CMD_SYSTEM_READY      0x02
#define CI_CMD_KEYPRESS          0x03
#define CI_CMD_ON_TUNED          0x04
#define CI_CMD_ON_SWITCH_PROGRAM 0x05
#define CI_CMD_SECTION_ARRIVED   0x06
#define CI_CMD_SECTION_TIMEOUT   0x07
#define	CI_CMD_TIME              0x08
#define	CI_CMD_ENTER_MENU        0x09
#define	CI_CMD_FAST_PSI          0x0a
#define	CI_CMD_GET_SLOT_INFO     0x0b
#define	CI_CMD_HALT_ARM          0xe0

#define	CI_MSG_NONE              0x00
#define	CI_MSG_CI_INFO           0x01
#define	CI_MSG_MENU              0x02
#define	CI_MSG_LIST              0x03
#define	CI_MSG_TEXT              0x04
#define	CI_MSG_REQUEST_INPUT     0x05
#define	CI_MSG_INPUT_COMPLETE    0x06
#define	CI_MSG_LIST_MORE         0x07
#define	CI_MSG_MENU_MORE         0x08
#define	CI_MSG_CLOSE_MMI_IMM     0x09
#define	CI_MSG_SECTION_REQUEST   0x0a
#define	CI_MSG_CLOSE_FILTER      0x0b
#define	CI_PSI_COMPLETE          0x0c
#define	CI_MODULE_READY          0x0d
#define	CI_SWITCH_PRG_REPLY      0x0e
#define	CI_MSG_TEXT_MORE         0x0f

#define	CI_MSG_CA_PMT            0xe0
#define	CI_MSG_ERROR             0xf0



#define	I2C_ADR_VES1877		0x10	// Sat-Front End (alt und neu)
#define	I2C_ADR_VES1820		0x12	// Kabel-Front End
#define	I2C_ADR_FEC92314	0x20	// DVB-T Frontend
#define	I2C_ADR_OFDM92314	0x40	// DVB-T Frontend
#define	I2C_ADR_TERTUNER	0xC0	// DVB-T-Tuner
#define	I2C_ADR_SATTUNER	0xC2    // SAT-Tuner
#define	I2C_ADR_PHILIPS_TUNER 0xC2
#define	I2C_ADR_CABTUNER	0xC4  // Kabel-Tuner


#define PID_PAT 0x00	/* Program Association Table */
#define PID_BAT 0x01	/* Bouquet Association Table */
#define PID_CAT 0x01	/* Conditional Access Table */
#define PID_NIT 0x10	/* Network Information Table */
#define PID_SDT 0x11	/* Service Description Table */
#define PID_EIT 0x12	/* Event Information Table */
#define PID_RST 0x13	/* Running Status Table */
#define PID_TDT 0x14	/* Time Date Table */
#define PID_TOT 0x14	/* Time Offset Table */
#define PID_ST	0x14	/* Stuffung Table */
/* 0x15 - 0x1F */	/* Reserved for future use */

/* Table Identifier */

#define TID_PAT 0x00	/* Program Association Section */
#define TID_CAT 0x01	/* Conditional Access Section */
#define TID_PMT 0x02	/* Conditional Access Section */
/* 0x03 - 0x3F */	/* Reserved for future use */
#define TID_NIT_ACT 0x40	/* Network Information Section - actual */
#define TID_NIT_OTH 0x41	/* Network Information Section - other */
#define TID_SDT_ACT 0x42	/* Service Description Section - actual */
#define TID_SDT_OTH 0x46	/* Service Description Section - other */
#define TID_TDT 0x70	/* Time Date Section */
#define TID_TOT 0x73	/* Time Offset Section */

#define TID_BAT 0x01	/* Bouquet Association Section */
#define TID_BAT 0x01	/* Bouquet Association Section */

#define TID_EIT 0x12	/* Event Information Section */
#define TID_RST 0x13	/* Running Status Section */
#define TID_ST	0x14	/* Stuffung Section */
/* 0xFF */		/* Reserved for future use */


struct saa7146_modes_constants {
	unsigned char  v_offset;
	unsigned short v_field;
	unsigned short v_calc;
	
	unsigned char  h_offset;
	unsigned short h_pixels;
	unsigned short h_calc;
	
	unsigned short v_max_out;
	unsigned short h_max_out;
};


struct saa7146_modes_constants
 modes_constants[] = {
	{ V_OFFSET_PAL,		V_FIELD_PAL,	V_ACTIVE_LINES_PAL,
	  H_OFFSET_PAL,		H_PIXELS_PAL,	H_PIXELS_PAL+1,
	  V_ACTIVE_LINES_PAL,	1024 },	/* PAL values */
	{ V_OFFSET_NTSC,	V_FIELD_NTSC,	V_ACTIVE_LINES_NTSC,
	  H_OFFSET_NTSC,	H_PIXELS_NTSC,  H_PIXELS_NTSC+1,
	  V_ACTIVE_LINES_NTSC,	1024 },	/* NTSC values */
	{ 0,0,0,0,0,0,0,0 }, /* secam values */
	{ 0,0,0,0,0,0,0,0 } /* dummy values */
};

/* -----------------------------------------------------------------------------------------
   helper functions for the calculation of the horizontal- and vertical scaling	registers,
   clip-format-register etc ...
   these functions take pointers to the (most-likely read-out original-values) and manipulate
   them according to the requested new scaling parameters.
   ----------------------------------------------------------------------------------------- */

/* hps_coeff used for CXY and CXUV; scale 1/1 -> scale 1/64 */
struct {
	unsigned short hps_coeff;
	unsigned short weight_sum;
} hps_h_coeff_tab [] = { 
	{0x00,   2}, {0x02,   4}, {0x00,   4}, {0x06,   8}, {0x02,   8}, {0x08,   8}, {0x00,   8}, {0x1E,  16},
	{0x0E,   8}, {0x26,   8}, {0x06,   8}, {0x42,   8}, {0x02,   8}, {0x80,   8}, {0x00,   8}, {0xFE,  16},
	{0xFE,   8}, {0x7E,   8}, {0x7E,   8}, {0x3E,   8}, {0x3E,   8}, {0x1E,   8}, {0x1E,   8}, {0x0E,   8},
	{0x0E,   8}, {0x06,   8}, {0x06,   8}, {0x02,   8}, {0x02,   8}, {0x00,   8}, {0x00,   8}, {0xFE,  16},
	{0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8},
	{0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8}, {0xFE,   8},
	{0xFE,   8}, {0x7E,   8}, {0x7E,   8}, {0x3E,   8}, {0x3E,   8}, {0x1E,   8}, {0x1E,   8}, {0x0E,   8},
	{0x0E,   8}, {0x06,   8}, {0x06,   8}, {0x02,   8}, {0x02,   8}, {0x00,   8}, {0x00,   8}, {0xFE,  16}
};

/* table of attenuation values for horizontal scaling */
unsigned char h_attenuation[] = { 1, 2, 4, 8, 2, 4, 8, 16, 0};

struct {
	unsigned short hps_coeff;
	unsigned short weight_sum;
} hps_v_coeff_tab [] = { 
 {0x0100,   2},  {0x0102,   4},  {0x0300,   4},  {0x0106,   8},  {0x0502,   8},  {0x0708,   8},  {0x0F00,   8},  {0x011E,  16}, 
 {0x110E,  16},  {0x1926,  16},  {0x3906,  16},  {0x3D42,  16},  {0x7D02,  16},  {0x7F80,  16},  {0xFF00,  16},  {0x01FE,  32}, 
 {0x01FE,  32},  {0x817E,  32},  {0x817E,  32},  {0xC13E,  32},  {0xC13E,  32},  {0xE11E,  32},  {0xE11E,  32},  {0xF10E,  32}, 
 {0xF10E,  32},  {0xF906,  32},  {0xF906,  32},  {0xFD02,  32},  {0xFD02,  32},  {0xFF00,  32},  {0xFF00,  32},  {0x01FE,  64}, 
 {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64}, 
 {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64},  {0x01FE,  64}, 
 {0x01FE,  64},  {0x817E,  64},  {0x817E,  64},  {0xC13E,  64},  {0xC13E,  64},  {0xE11E,  64},  {0xE11E,  64},  {0xF10E,  64}, 
 {0xF10E,  64},  {0xF906,  64},  {0xF906,  64},  {0xFD02,  64},  {0xFD02,  64},  {0xFF00,  64},  {0xFF00,  64},  {0x01FE, 128} };

/* table of attenuation values for vertical scaling */
unsigned short v_attenuation[] = { 2, 4, 8, 16, 32, 64, 128, 256, 0};

struct frontend {
	int type;              /* type of frontend (tv tuner, dvb tuner/decoder, etc. */
#define FRONT_TV   0
#define FRONT_DVBS 1
#define FRONT_DVBC 2
#define FRONT_DVBT 3

	/* Sat line control */
    int power;             /* LNB power 0=off/pass through, 1=on */
	int volt;              /* 14/18V (V=0/H=1) */
	int ttk;               /* 22KHz */
	int diseqc;            /* Diseqc input select */
	unsigned int freq;            /* offset frequency (from local oscillator) in Hz */
    int AFC;
	unsigned int srate;           /* Symbol rate in Hz */
	int qam;               /* QAM mode for cable decoder, sat is always QPSK */
	int fec;               /* Forward Error Correction */
	unsigned short video_pid;        
	unsigned short audio_pid;
    unsigned short tt_pid;          /* Teletext PID */

	/* status information */
	int fsync;             /* frequency sync (from tuner) */
	int sync;              /* sync from decoder */

#define DVB_SYNC_SIGNAL        1
#define DVB_SYNC_CARRIER       2
#define DVB_SYNC_VITERBI       4
#define DVB_SYNC_FSYNC         8
#define DVB_SYNC_FRONT        16

	int afc;               /* frequency offset in Hz */
	unsigned short agc;             /* gain */
	unsigned short nest;            /* noise estimation */
    unsigned short vber;            /* viterbi bit error rate */

	int flags;
#define FRONT_TP_CHANGED  1 
#define FRONT_FREQ_CHANGED 2
#define FRONT_RATE_CHANGED 4
};

struct frontend dvb_front; 



int saa_interlace=1;
int saa_mode=0; // test
int saa_grab_height;
int saa_grab_port;
int saa_grab_width;
int saa_grab_format;



extern int ColourFormat;
extern BOOL Flip; 
extern int emstartx;
extern int emstarty;
extern int emsizex;
extern int emsizey;
extern int CurrentX;
extern int CurrentY;
extern int SurfacePitch;
extern int Offset_for_WindowOut;
extern int OverlayPitch;



struct	saa7146_video_dma {
	unsigned int base_odd;
	unsigned int base_even;
	unsigned int prot_addr;
	int pitch;
	unsigned int base_page;
	unsigned int num_line_byte;
};

struct DVBTunertype 
{
	char *name;
	unsigned char Vendor;
	unsigned char Type;
  
	/* all frequencies in units of Hz */
	unsigned long min;     /* minimum frequency */  
	unsigned long max;     /* maximum frequency */
	unsigned long res;     /* frequency resolution in Hz */
	unsigned long step;    /* stepsize in Hz (units of setfrequency ioctl) */
	unsigned long IFPCoff; /* frequency offset */
	unsigned long thresh1; /* frequency Range for UHF,VHF-L, VHF_H */   
	unsigned long thresh2;  
	unsigned char VHF_L;   
	unsigned char VHF_H;
	unsigned char UHF;
	unsigned char config; 
	unsigned char I2C;      /* most probable I2C address */
	unsigned char mode; /* mode change value (tested PHILIPS_SECAM only) */
	         /* 0x01 -> ??? no change ??? */
	         /* 0x02 -> PAL BDGHI / SECAM L */
	         /* 0x04 -> ??? PAL others / SECAM others ??? */
};

int DVBTuner=0;
int SaveTuner;

struct DVBTunertype DVBTuners[3] = {
        {"SP5659", 0x04, 0x5,
	         100000000UL, 2700000000UL, 125000, 1, 479500000,
	         0xffffffffUL, 0xffffffffUL, 0x30, 0x30, 0x30, 0x95, 0xc2},
        {"SPXXXX", 0x4, 0x6,
	          40000000UL, 870000000UL, 62500, 1, 36125000,
	         174000000UL, 454000000UL, 0xa1, 0x92, 0x34, 0x8e, 0xc2},
};

#define TUNER_POR       0x80
#define TUNER_FL        0x40
#define TUNER_MODE      0x38
#define TUNER_AFC       0x07


struct saa7146_video_dma vdma1;
	   
extern int NextFrame;
extern HANDLE Decode_Event;

int odswin=0;

#define MAXPROGS 4096


typedef struct TProgramm
{
	char Name[20];
    unsigned long freq;
    char Typ;
	unsigned int srate;         
	int qam;               
	int fec;   
	int norm;
	unsigned short video_pid;        
	unsigned short audio_pid;
    unsigned short tt_pid;          /* Teletext PID */
    BOOL  Tuner_Auto;
    int power;             /* LNB power 0=off/pass through, 1=on */
	int volt;              /* 14/18V (V=0/H=1) */
    int afc;
	int ttk;               /* 22KHz */
	int diseqc;            /* Diseqc input select */
	unsigned short PMT;
	unsigned char   BW;
    unsigned short  PCR_pid;
	unsigned short  PMC;
	unsigned char   TVType; //  == 00 PAL ; 11 == NTSC    
	unsigned char   ServiceTyp;   
};

extern struct TProgramm Programm[MAXPROGS+1];

extern unsigned int InitialDVBBrightness;
extern unsigned int InitialDVBContrast;
extern unsigned int InitialDVBColor;
extern unsigned int InitialDVBVolumeLinks;
extern unsigned int InitialDVBVolumeRechts;

unsigned int rps_bcs_ctrl[2] = { 0,0};
unsigned int rps_clip_format[2] = { 0,0 };

typedef struct OTLNB {
	     BOOL Power;
		 BOOL Switch22khz;
         unsigned int LofLow;
         unsigned int LofHigh;
		 unsigned int SwitchFreq;
};

struct TLNB {
	   BOOL Diseq;
	   struct OTLNB Anschluss[4];
} ;

extern struct TLNB LNB;

extern BOOL DOSIZE;

struct TTransponder {
	    BOOL Tuner_Auto;
		int ttk;
        int power;
		int diseqc;
        unsigned int freq;
        int volt;
        int qam;
        unsigned int srate;
        int fec;
    	int sync;              /* sync from decoder */
    	int afc;               /* frequency offset in Hz */
	    unsigned short agc;             /* gain */
	    unsigned short nest;            /* noise estimation */
        unsigned short vber;            /* viterbi bit error rate */
	};

struct TTransponder Transponder;

struct bitfilter {
        unsigned short pid;
        unsigned short data[16];
        unsigned short mode;
        unsigned short handle;
        unsigned short flags;
};

#define MAXFILTER 64

struct TFilter {
	       unsigned short pid;
		   unsigned char *Buffer;
		   int BufferIndex;
		   unsigned short DVB_Handle;

};
struct TFilter Filter[MAXFILTER];
int LastFilter;

/*
typedef struct {
	unsigned char table_id				:8;
	u_char section_length_hi		:4;
	u_char 					:2;
	u_char dummy				:1;	// has to be 0
	u_char section_syntax_indicator		:1;
	u_char section_length_lo		:8;
	u_char transport_stream_id_hi		:8;
	u_char transport_stream_id_lo		:8;

	u_char current_next_indicator		:1;
	u_char version_number			:5;
	u_char 					:2;
	u_char section_number			:8;
	u_char last_section_number		:8;
} pat_t;

#define PAT_PROG_LEN 4

typedef struct {
	u_char program_number_hi		:8;
	u_char program_number_lo		:8;

	u_char network_pid_hi			:5;
	u_char 					:3;

	u_char network_pid_lo			:8; 
} pat_prog_t;
*/
/*
PAT Big
typedef struct {
	unsigned char table_id:8;
	u_char section_syntax_indicator		:1;
	u_char dummy				:1;	// has to be 0
	u_char 					:2;
	u_char section_length_hi		:4;

	u_char section_length_lo		:8;

	u_char transport_stream_id_hi		:8;
	u_char transport_stream_id_lo		:8;

	u_char 					:2;
	u_char version_number			:5;
	u_char current_next_indicator		:1;
	u_char section_number			:8;
	u_char last_section_number		:8;
} pat_t;

#define PAT_PROG_LEN 4

typedef struct {
	u_char program_number_hi		:8;
	u_char program_number_lo		:8;

	u_char 					:3;
	u_char network_pid_hi			:5;

	u_char network_pid_lo			:8; 
} pat_prog_t;
*/

