/*******************************************************************
****                                                            ****
****    MODULNAME       : MultiDec                              ****
****    AUTOR           : Espresso                              ****
****                                                            ****
********************************************************************/
#include <windows.h>       /* required for all Windows applications */
#include <commdlg.h>
#include <stdio.h>
#include <memory.h>
#include <time.h>
#include <process.h>       /* for _beginthread                      */
#include <stdlib.h>        /* atoi                                  */
#include <io.h>         
#include <mmsystem.h>
#include <fcntl.h>
#include <commctrl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ddraw.h>
#include <math.h>
#include <mmsystem.h>
#include "resource.h"
#include "windrvr.h"
#include "MultiDec.h"     

static LPBYTE dst;
static LPBYTE src;
static int nFrame;

static char Text[128];

void Write_Log(LPSTR Text);

static int i;

static long Offset;
static DWORD   dwLastCount = 0;

extern void Start_Thread();
extern void Stop_Thread();


HWND VThWnd;

int PriorClassId;
int ThreadClassId=1;


clock_t Clockstart, Clockfinish;
double  duration;

SYSTEM_INFO SysInfo;

UINT                 WTVBPP;       
DWORD                dwDIB                   = 0;
HGLOBAL              hDIB                    = NULL;
BITMAPINFO          *pDIB                    = NULL;


BOOL CShowCursor=TRUE;


BOOL Load_INI(LPSTR Name);
BOOL Write_INI(LPSTR Name);
void Init_More();
void More_Even( int pp );
void More_Odd();
int G_Wert(int Wert1,int Wert2);

void fill(SHORT *pDest, DWORD bytes);

void  SetMenuAnalog();
void  SetMenuDigital();

void Init_Kernel_Memory( void );


//Aus Nagra.c
extern BOOL LeseKeyDatei(HWND hWnd);
extern void Setup_Coutry_Menu(HMENU Menu);
extern BOOL Init_Nagra_Decoding( int Lines );
extern void Free_Nagra_Decoding(void);
extern int FindePalPlusZeile(short *pLine,int  *nPALplusData);
extern void FindYUVLineOrder(short **pLinesAddress ,int *pSortLines,  int  *nPALplusZeile,int  *nPALplusData);
extern void FindYUVSecondLineOrder(short **pLinesAddress ,int *pSortLines);
extern void Init_HQTabelle();
extern BOOL GetMatrix(int BlackWert,int evenodd);
// Fantasio
extern void FilterBlueLines(DWORD **pLinesAddress, int *pSortLines, BOOL bEven);

// Aus MixerDev.c

extern void Enumerate_Sound_SubSystem(void);
extern void Mixer_Get_Volume(int *Links, int *Rechts);
extern void Mixer_Set_Volume(int Links, int Rechts);
extern void Get_Volume_Param(void);
extern void Mixer_Set_Defaults( void );
extern void Mixer_Mute(void);
extern void Mixer_UnMute(void);
extern void Exit_Mixer( void );



// HC-Optionen
void Init_HCYUV2RGBTabelle(BOOL  RGB15);
void  HCZeileAusgeben(DWORD *pQuelle,DWORD *pZiel,int Count);
void  HCZeileAusgeben_2(DWORD *pQuelle,DWORD *pZiel,int Pitch,int Count);
void  HCZeileAusgeben_3(DWORD *pQuelle,DWORD *pZiel,int Pitch,int Count);
void  HCZeileAusgeben_4(DWORD *pQuelle,DWORD *pZiel,int Pitch,int Count);

void Clear_Status();


// Aus Vcrypt.c
extern BOOL Find_Cut_Points_VC(short **pLinesAddressEven,short *RealOffset, int Burst);
extern void VC_UVColor(short *pQuelle,short *pZiel,short *pColorFaktor, int Cut);
extern int Get_Decoder_Key(short **pLinesAddressEven);
void Init_VC_HQTabelle();
extern void __fastcall VCHQAusgebenRGB16( void );
extern void __fastcall VCHQAusgebenRGB15( void );
extern void __fastcall VCHQAusgebenYUV2( void );
extern void __fastcall HQAusgebenRGB16( void );
extern void __fastcall HQAusgebenRGB16DVB( void );
extern void __fastcall HQAusgebenRGB15( void );
extern void __fastcall HQAusgebenRGB15DVB( void );
extern void __fastcall HQAusgebenYUV2( void );
extern void __fastcall HQAusgebenYUV2DVB( void );
extern void __fastcall HQFillRGB( void );
extern void __fastcall HQFillYUV2( void );

extern void Init_VC(void);
extern Free_VC_Decoding(void);
extern int decodePicture(int lines);


void Set_Mode_Digital( void );
void Set_Mode_Analog( void );

// Aus BT848.c 
extern void Wait_DStatus();
extern void Get_Thread_Status();
extern void InterCast_Init();
extern void InterCast_Exit();
extern BOOL Init_BT_Kernel_Memory( void );

extern BOOL Init_Memory();

extern BOOL SetGeoSize(int wWidth, int wHeight);
extern BOOL SetAudioSource(int nChannel);
extern BOOL SetVideoSource(int nInput);
extern BOOL Tuner_Scan();
extern BOOL SetColourFormat(int nColourFormat);
extern void Load_Country_Settings();
extern void Load_Country_Specific_Settings(int LPos);
extern BOOL Init_Tuner(int TunerNr );
extern void Set_Capture(int nState);

extern BOOL APIENTRY ChipSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY IFormSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY PLLSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY TunerSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY TunerDigiSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY CardSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY LowSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern BOOL APIENTRY MixerSetupProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY DetectSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY ToggleSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);

extern void Work_VideoDat(unsigned char *Buffer);

BOOL APIENTRY ResSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
extern void Start_VBI();
extern void Stop_VBI();
extern BOOL Init_TV_Karte(HWND hWnd);
extern BOOL InitTV( HWND hwnd , BOOL Fullscreen, int x , int y );
extern BOOL Init_Audio(BYTE DRead,BYTE DWrite );
extern BOOL ExitTV( void );
extern BOOL Init_BT_HardWare(HWND hWnd);
extern BOOL VideoPresent();
extern BOOL Alloc_DMA(DWORD dwSize, WD_DMA *dma,int Option );
extern BOOL Alloc_Display_DMA(DWORD dwSize, int NR);
extern void Free_DMA( WD_DMA *dma );
extern void Free_Display_DMA( int NR );
extern void Free_Surface_DMA( void );

extern BOOL Tuner_SetFrequency(int TunerTyp, int wFrequency);
extern BOOL SetBrightness(char bBrightness);
extern BOOL SetHue(char bHue);
extern BOOL SetContrast(int wContrast);
extern BOOL SetSaturationU(int wData);
extern BOOL SetSaturationV(int wData);
extern void SetColor(int Croma);

extern void MSP_SetMode(int type);
extern void MSP_SetStereo(int MajorMode, int MinorMode, int mode);
extern void MSP_Set_MajorMinor_Mode(int MajorMode,int MinorMode  );
extern void MSP_Print_Mode( );
extern void MSPWatch_Mode();



extern BOOL Audio_SetBalance(char nBalance);
extern BOOL Audio_SetBass(char nBass);
extern BOOL Audio_SetTreble(char nTreble);
extern BOOL Audio_SetLoudness(BYTE nLoudness);
extern BOOL Audio_SetSpatial(char nSpatial);
extern BOOL Audio_SetVolume(int nVolume);
extern BOOL Audio_SetSuperBass(BOOL bSuperBass);
extern BOOL Audio_SetEqualizer1(char nLevel);
extern BOOL Audio_SetEqualizer2(char nLevel);
extern BOOL Audio_SetEqualizer3(char nLevel);
extern BOOL Audio_SetEqualizer4(char nLevel);
extern BOOL Audio_SetEqualizer5(char nLevel);

extern void Destroy_Overlay();
extern BOOL OverlayUpdate(int x,int y,LPRECT pDestRect,DWORD  dwFlags,BOOL ColorKey);
extern void  Black_Overlay();
extern BOOL CreateOverlay(int x,int y);

BOOL Check_Even( void );
BOOL Check_Odd( void );

extern unsigned short Swab16(unsigned char *dat);



void RGBOutThread( );
void RGBOutThreadHalf( );
void YUVOutThread( );
void YUVOutThreadHalf( );

void NagraYUVHalfOutThread( );
void NagraYUVOutThread( );

 
void VCYUVHalfOutThread( ); 
void VCDecoderYUVHalfOutThread(  ); 

// Aus VT.C
void VT_ChannelChange();
VOID APIENTRY HandleFocusState(HWND hDlg,LPDRAWITEMSTRUCT lpdis);
VOID APIENTRY DrawEntireItem(HWND hDlg,LPDRAWITEMSTRUCT lpdis,INT Typ);


void Write_Programm_List();
void Load_Programm_List();
void Init_Screen_Struct();
void Restore_Mode();
void Save_Mode();



BOOL APIENTRY ProgrammListe(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY ProgrammEdit(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY DigiImport(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VideoTextProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VideoTextUnterTitelProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY SplashProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VCSetupProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY NagraSetupProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY TransponderSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY SRateSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VideoSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VideoSettingDigiProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY ICSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VDSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY CryptModeProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VTInfoProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VPSInfoProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY ICInfoProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VDInfoProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY VDInfoProcRaw(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY PDCProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY AudioSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY AudioDigiSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY AudioSettingProc1(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY ColorSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY SecamSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY AboutProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY NagraKeySetProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL APIENTRY LNBSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);


// DVB
BOOL Init_DVB_Memory(void);


/****************************************************************************

    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop

****************************************************************************/

 int APIENTRY WinMain(
    HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPSTR lpCmdLine,
    int nCmdShow
    )
{
    WNDCLASS        wc;
 	HINSTANCE       statusbar;
    MSG             msg;
    HGLOBAL hGlobal;
    HWND Load;
    int i;

	hInst=hInstance;
 emsizex=754;
 emsizey=521;
 emstartx=44;
 emstarty=82;

Load=FindWindow((LPCTSTR)"Espresso",(LPCTSTR)"Multi-Decoder");
if ( Load != NULL ) {
      SetFocus(Load);
      SetActiveWindow(Load);
	  SetForegroundWindow(Load);
      return FALSE;
     }  
SplashWnd=CreateDialog(hInst,"SPLASHBOX",NULL,SplashProc);
SetWindowPos(SplashWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);

// Default Inits //
Current_Mode=0;
CardType=0;
Capture_Video=TRUE;
Capture_VBI=TRUE;
Decode_AutoDetect=FALSE;
ColourFormat=3;
VideoSource=1;
AudioSource=4;
TunerType=0;
OPKEY[0].Name[0]=0x00;
OPKEY[1].Name[0]=0x00;
OPKEY[2].Name[0]=0x00;
OPKEY[3].Name[0]=0x00;
strcpy(OPKEY[0].Name,"KEY.TXT");
strcpy(OPKEY[0].Extension,"idx");
ActiveKey=0;
strcpy(OPKEY[1].Name,"KEY_C+.TXT");
strcpy(OPKEY[1].Extension,"ic+");

TVTYPE=0;
Flip=1;
OutDib=TRUE;
WindowStyle=0;
InitialHue=0x00;
InitialBrightness=0x00;
InitialContrast=0xd8;
InitialSaturationU=0xfe;
InitialSaturationV=0xb4;
InitialVolume=1000;
InitialSpecial=0;
InitialLoudness=0;
InitialBass=0;
InitialTreble=0;
MasterTestzeilen=16;
ManuellAudio[0]=0;ManuellAudio[1]=0;ManuellAudio[2]=0;ManuellAudio[3]=0;
ManuellAudio[4]=0;ManuellAudio[5]=0;ManuellAudio[6]=0;ManuellAudio[7]=0;



LNB.Diseq=FALSE;
LNB.Anschluss[0].LofLow=9750;
LNB.Anschluss[0].LofHigh=10600;
LNB.Anschluss[0].SwitchFreq=11700;
LNB.Anschluss[0].Power=TRUE;
LNB.Anschluss[0].Switch22khz=TRUE;

LNB.Anschluss[1].LofLow=9750;
LNB.Anschluss[1].LofHigh=10600;
LNB.Anschluss[1].SwitchFreq=11700;
LNB.Anschluss[1].Power=TRUE;
LNB.Anschluss[1].Switch22khz=TRUE;
LNB.Anschluss[2].LofLow=9750;
LNB.Anschluss[2].LofHigh=10600;
LNB.Anschluss[2].SwitchFreq=11700;
LNB.Anschluss[2].Power=TRUE;
LNB.Anschluss[2].Switch22khz=TRUE;
LNB.Anschluss[3].LofLow=9750;
LNB.Anschluss[3].LofHigh=10600;
LNB.Anschluss[3].SwitchFreq=11700;
LNB.Anschluss[3].Power=TRUE;
LNB.Anschluss[3].Switch22khz=TRUE;

strcpy(VDat.RawName,"VD-RAW.Dat");

TZ[0]=16;
TZ[1]=24;
TZ[2]=32;
TZ[3]=40;
TZ[4]=48;

for ( i = 0 ; i < 64 ; i++ ) MixerLoad[i].MixerAccess.SoundSystem = -1;

VTColourTable[0]=0;     //Schwarz
VTColourTable[1]=31744; //Rot
VTColourTable[2]=992;     //Grun
VTColourTable[3]=32736;  //Gelb
VTColourTable[4]=31;     //Blau
VTColourTable[5]=15375;     // Unsichtbar
VTColourTable[6]=15871;       // HellBlau
VTColourTable[7]=32767;     // Weis 
VTColourTable[8]=32767;       // Eigentich Transparent
GetCurrentDirectory(255,CurrentDir);
i=GetCurrentDirectory(sizeof(IC_BASE_DIR),IC_BASE_DIR);
strcat(IC_BASE_DIR,"\\I_Cast");
i=(int)CreateDirectory(IC_BASE_DIR,NULL);
i=GetCurrentDirectory(sizeof(VD_DIR),VD_DIR);
strcat(VD_DIR,"\\VideoDat");
i=(int)CreateDirectory(VD_DIR,NULL);

Load_INI("MultiDec.ini");

 if ( emsizex < 37 ) {
	  emsizex=450;
	  emstartx=10;
 }
 if ( emsizey < 37 ) {
	 emsizey=350;
	 emstarty=10;
 }
 //if ( emstartx < 0 ) emstartx=10;
 //if ( emstarty < 0 ) emstarty=10;
 if ( emstartx > GetSystemMetrics(SM_CXSCREEN) ) emstartx=10;
 if ( emstarty > GetSystemMetrics(SM_CYSCREEN) ) emstarty=10;


    wc.style = 0;//CS_OWNDC;
    wc.lpfnWndProc = (WNDPROC) MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(LONG);
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, "Espresso");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = CreateSolidBrush(0);  
//    wc.lpszMenuName =  "DECODEMENU";
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = "Espresso";

      if (!RegisterClass (&wc)) {
            return FALSE;
        }
  if ( Current_Mode == 0 ) {
	hMenu=LoadMenu(hInstance,"ANALOGMENU");
  } else {
	hMenu=LoadMenu(hInstance,"DIGITALMENU");
  }
    hWnd = CreateWindow(
        "Espresso",
        "Multi-Decoder",
        WS_OVERLAPPEDWINDOW,
        emstartx,
        emstarty,
        emsizex,
        emsizey,
        NULL,
        NULL,
        hInstance,
        NULL
    );

   
	if (!hWnd)
        return (FALSE);
        

   statusbar=hInst;
   if (!InitStatusBar (statusbar)) {
            return FALSE;
        }
  

    if (CreateStatusBar (hWnd, statusbar, ID_STATUSBAR)) {
        hwndTextField   = AddStatusField (statusbar, ID_TEXTFIELD, 110,0, FALSE);
        hwndAudioField   = AddStatusField (statusbar, ID_AUDIOFIELD, 110,0, FALSE);
		hwndPalField = AddStatusField (statusbar, ID_CODEFIELD, 110,0, FALSE);
        hwndKeyField   = AddStatusField (statusbar, ID_KENNUNGFFIELD, 90,50, FALSE);
        hwndFPSField   = AddStatusField (statusbar, ID_FPSFIELD, 45, 45, TRUE);
    } else {
        return FALSE;
    }						  
	  AdjustStatusBar(hWnd);
      rectscreen.bottom -= 8;

if ( Display_Status_Bar == FALSE ) {
 CheckMenuItem( GetMenu(hWnd), IDM_STATUSBAR, MF_UNCHECKED );
 ShowWindow(Status_Bar,SW_HIDE);
} else
  CheckMenuItem( GetMenu(hWnd), IDM_STATUSBAR, MF_CHECKED );

hGlobal=LoadResource(hInst,FindResource(hInst,"VTCHARLARGE",RT_BITMAP));
VTCharSetLarge=(BITMAPINFO*)LockResource(hGlobal);
hGlobal=LoadResource(hInst,FindResource(hInst,"VTCHARSMALL",RT_BITMAP));
VTCharSetSmall=(BITMAPINFO*)LockResource(hGlobal);


	  ShowWindow(hWnd,nCmdShow);
      PostMessage( hWnd, WM_SIZE, SIZENORMAL,MAKELONG( emsizex,emsizey ) );
 if ( Current_Mode == 0) {
	if (!(hAccel = LoadAccelerators (hInstance, "ANALOGACCEL")))
          {
          
               (void) MessageBox( GetFocus(), "Analog-Accel nicht geladen ", "Error", MB_OK);
          };

 } else  if ( Current_Mode == 1) {
	if (!(hAccel = LoadAccelerators (hInstance, "DIGITALACCEL")))
          {
          
               (void) MessageBox( GetFocus(), "Digital-Accel nicht geladen ", "Error", MB_OK);
          };
 };
	
    while (GetMessage(&msg, NULL, 0, 0)) {						   
     if( !TranslateAccelerator(hWnd, hAccel, &msg) ) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
	}
}
	 return (msg.wParam);

}




/****************************************************************************

    FUNCTION: MainWndProc(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages

    MESSAGES:

        WM_COMMAND    - application menu (About dialog box)
        WM_CREATE     - create window and objects
        WM_PAINT      - update window, draw objects
        WM_DESTROY    - destroy window

    COMMENTS:

        Handles to the objects you will use are obtained when the WM_CREATE
        message is received, and deleted when the WM_DESTROY message is
        received.  The actual drawing is done whenever a WM_PAINT message is
        received.

****************************************************************************/
LONG APIENTRY MainWndProc(
    HWND hWnd,
    UINT message,
    UINT wParam,
    LONG lParam)

{
char Text[128]; 
char Text1[128];    

int i,j,k;
BOOL SBTOK;

    switch (message) {

	 case WM_COMMAND:
         switch( LOWORD( wParam ))
                     {

         case IDM_SYNC_IRQ:
                  if ( Sync_Irq == FALSE ) {
                         Sync_Irq=TRUE;
			        	 CheckMenuItem( GetMenu(hWnd), IDM_SYNC_IRQ, MF_CHECKED );
				  } else {
                         Sync_Irq=FALSE;
				         CheckMenuItem( GetMenu(hWnd), IDM_SYNC_IRQ, MF_UNCHECKED );
				  }
			      break;
		 
		 case IDM_SRATES:
			              Save_Mode();
						  DialogBox(hInst,"SRATES",hWnd,SRateSettingProc);
                          Restore_Mode();
						  break;
		 case IDM_TPSCAN:
			              Save_Mode();
						  DialogBox(hInst,"TRANSPONDER",hWnd,TransponderSettingProc);
                          Restore_Mode();
						  break;
			 

		 case IDM_KEEP_LOADED:
             if ( Keep_DVB_Loaded == FALSE ) {
                 Keep_DVB_Loaded=TRUE;
				 CheckMenuItem( GetMenu(hWnd), IDM_KEEP_LOADED, MF_CHECKED );
			 } else {
                 Keep_DVB_Loaded=FALSE;
				 CheckMenuItem( GetMenu(hWnd), IDM_KEEP_LOADED, MF_UNCHECKED );
			 }
			 break;


         case IDM_SWAPMODE:
			 if (( Current_Mode == 0 ) && ( Has_DVB == TRUE )) {
                 Set_Mode_Digital();
			 } else if (( Current_Mode == 1 ) && ( Has_BT == TRUE )) {
                 Set_Mode_Analog();
			 };
			 break;
		 case IDM_WRITE_FRAME:
			    DoWriteFrame=TRUE;
				break;


        case IDM_DEKODERSOUND:
			if ( useSound == FALSE ) {
		        useSound=TRUE;
				CheckMenuItem( GetMenu(hWnd), IDM_DEKODERSOUND, MF_CHECKED );
                SoundCapture_Open();
                SoundCapture_Play() ;
                sprintf(Text,"Audio Dekoder - An ");
                if(Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			} else {
		        useSound=FALSE;
				CheckMenuItem( GetMenu(hWnd), IDM_DEKODERSOUND, MF_UNCHECKED );
                SoundCapture_Close();
                SoundCapture_Stop();
                sprintf(Text,"Audio Dekoder - Aus ");
                if(Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			}
            break;

// Fantasio
		case IDM_NOBLUELINES:
			if ( bFilterBlueLines == FALSE ) {
				bFilterBlueLines = TRUE;
				CheckMenuItem( GetMenu(hWnd), IDM_NOBLUELINES, MF_CHECKED );
				sprintf(Text,"BlauFilter an (Filtre Secam Lignes violettes Activ)");
			} else {
				bFilterBlueLines = FALSE;
				CheckMenuItem( GetMenu(hWnd), IDM_NOBLUELINES, MF_UNCHECKED );
				sprintf(Text,"Blaufilter aus (Filtre Secam Lignes violettes Dsactiv)");
			}
            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			break;

		case IDM_UPLUS:
			if (++iUFilterThresholdPCent >=100)
				iUFilterThresholdPCent=100;
			sprintf(Text,"Threshold U Filter %d %%",iUFilterThresholdPCent);
            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			break;
		case IDM_UMINUS:
			if (--iUFilterThresholdPCent <=1)
				iUFilterThresholdPCent=1;
			sprintf(Text,"Threshold U Filter %d %%",iUFilterThresholdPCent);
            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			break;
		case IDM_VPLUS:
			if (++iVFilterThresholdPCent >=100)
				iVFilterThresholdPCent=100;
			sprintf(Text,"Threshold V Filter %d %%",iVFilterThresholdPCent);
            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			break;
		case IDM_VMINUS:
			if (--iVFilterThresholdPCent <=1)
				iVFilterThresholdPCent=1;
			sprintf(Text,"Threshold V Filter %d %%",iVFilterThresholdPCent);
            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			break;

        case IDM_CLOSE_VT:
			  	for ( i = 0; i < MAXVTDIALOG; i++ ) {
					if ( VTDialog[i].Dialog != NULL ) SendMessage(VTDialog[i].Dialog,WM_COMMAND,IDCANCEL,0);
				};
				SetFocus(hWnd);
				break;
		
		
		
		case IDM_VT_PAGE_MINUS:
			  	for ( i = 0; i < MAXVTDIALOG; i++ ) {
					if ( VTDialog[i].Dialog != NULL ) {
           				j=Get_Dialog_Slot(VTDialog[i].Dialog);
                        if ( VTDialog[j].Page > 100 ) {
							 SetDlgItemInt(VTDialog[j].Dialog,IDC_EDIT1,VTDialog[j].Page-1 ,FALSE);
						     VTDialog[j].PageChange = TRUE;
						}
					};
				};
						return(TRUE);
                     
		case IDM_VT_PAGE_PLUS:
			  	for ( i = 0; i < MAXVTDIALOG; i++ ) {
					if ( VTDialog[i].Dialog != NULL ) {
           				j=Get_Dialog_Slot(VTDialog[i].Dialog);
                        if ( VTDialog[j].Page < 899 ) {
							 SetDlgItemInt(VTDialog[j].Dialog,IDC_EDIT1,VTDialog[j].Page+1 ,FALSE);
						     VTDialog[j].PageChange = TRUE;
						}
					};
				};
					  return(TRUE);


		case IDM_VT_PAGE_UP:
			  	for ( i = 0; i < MAXVTDIALOG; i++ ) {
					if ( VTDialog[i].Dialog != NULL ) {
           				j=Get_Dialog_Slot(VTDialog[i].Dialog);
						k=VTDialog[j].SubPage;
						if ( VTFrame[VTDialog[j].FramePos].SubCount == 0 ) return(TRUE);
                        k--;
						if ( k < 0 ) i=VTFrame[VTDialog[j].FramePos].SubCount-1;
						  while (( k>= 0 ) && ( VTFrame[VTDialog[j].FramePos].SubPage[k].Fill == FALSE )) k--;
                      if ( k >= 0 ) VTDialog[j].SubPage=k;
					  SetDlgItemInt(VTDialog[j].Dialog,IDC_EDIT1,VTDialog[j].Page ,FALSE);
					};
				};
					  return(TRUE);


       

		case IDM_VT_PAGE_DOWN:
			  	for ( i = 0; i < MAXVTDIALOG; i++ ) {
					if ( VTDialog[i].Dialog != NULL ) {
           				j=Get_Dialog_Slot(VTDialog[i].Dialog);
						k=VTDialog[j].SubPage;
						if ( VTFrame[VTDialog[j].FramePos].SubCount == 0 ) return(TRUE);
                        k++;
						if ( k >= VTFrame[VTDialog[j].FramePos].SubCount ) k=0;
					    while (( k < VTFrame[VTDialog[j].FramePos].SubCount) && ( VTFrame[VTDialog[j].FramePos].SubPage[k].Fill == FALSE )) k++;
                      if ( k < VTFrame[VTDialog[j].FramePos].SubCount ) VTDialog[j].SubPage=k;
					  SetDlgItemInt(VTDialog[j].Dialog,IDC_EDIT1,VTDialog[j].Page ,FALSE);
					};
				};
				return(TRUE);

         case IDM_CHANNELPLUS:
			 if ( USETUNER == FALSE ) break;
                 Clear_Status();
			 	 if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetAudioSource(4);
			     if (( Has_DVB == TRUE ) && ( Current_Mode == 1 )) DVB_SetVolume((unsigned char)0, (unsigned char)0);

				 i=CurrentProgramm+1;
			CurrentProgramm=-1;
			while ( i < MAXPROGS ) {
                if (( Programm[i].freq != 0  ) && (ValidModes(Programm[i].Typ) == TRUE  )) {
					CurrentProgramm=i;
                    break;
				}
				i++;
			};

			if ( CurrentProgramm == -1 ) {
			i=0;
			while ( i < MAXPROGS ) {
                if (( Programm[i].freq != 0  ) && (ValidModes(Programm[i].Typ) == TRUE  )) {
					CurrentProgramm=i;
					break;
				}
				i++;
			} 
			};
           
			if ( CurrentProgramm >= 0 ) {
				if (( Current_Mode == 0 ) && ( Programm[CurrentProgramm].Typ == 'D' )) Set_Mode_Digital();
				 else if (( Current_Mode == 1 ) && ( Programm[CurrentProgramm].Typ == 'A' )) Set_Mode_Analog();

				 if ( Programm[CurrentProgramm].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(Programm[CurrentProgramm].freq*1000,16,1000000));
				  else Set_DVB_Channel(CurrentProgramm);

				 
				 if ( Display_Status_Bar == TRUE ) {
                   	   sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
	                   SetWindowText (hwndKeyField,Text);
					}
				VT_ChannelChange();
			}
            	if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetAudioSource(AudioSource);
                if (( Has_DVB == TRUE ) && ( Current_Mode == 1 )) DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
				break;

         case IDM_CHANNELMINUS:
			 if ( USETUNER == FALSE ) break;
                 Clear_Status();
			 	 if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetAudioSource(4);
			     if (( Has_DVB == TRUE ) && ( Current_Mode == 1 )) DVB_SetVolume((unsigned char)0, (unsigned char)0);
				 i=CurrentProgramm-1;
			CurrentProgramm=-1;
			while ( i >= 0) {
                if (( Programm[i].freq != 0  ) && (ValidModes(Programm[i].Typ) == TRUE  )) {
					CurrentProgramm=i;
                    break;
				}
				i--;
			};

			if ( CurrentProgramm == -1 ) {
			i=MAXPROGS-1;
			while ( i >= 0 ) {
                if (( Programm[i].freq != 0  ) && (ValidModes(Programm[i].Typ) == TRUE  )) {
					CurrentProgramm=i;
					break;
				}
				i--;
			} 
			};

			if ( CurrentProgramm >= 0 ) {

				if (( Current_Mode == 0 ) && ( Programm[CurrentProgramm].Typ == 'D' )) Set_Mode_Digital();
				 else if (( Current_Mode == 1 ) && ( Programm[CurrentProgramm].Typ == 'A' )) Set_Mode_Analog();

				 if ( Programm[CurrentProgramm].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(Programm[CurrentProgramm].freq*1000,16,1000000));
				  else Set_DVB_Channel(CurrentProgramm);

				  if ( Display_Status_Bar == TRUE ) {
                   	   sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
	                   SetWindowText (hwndKeyField,Text);
					}
             VT_ChannelChange();
			}
            	if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetAudioSource(AudioSource);
                if (( Has_DVB == TRUE ) && ( Current_Mode == 1 )) DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
				break;


         case IDM_LOCK :    if ( MoreLinesLock==TRUE ) {
								MoreLinesLock=FALSE;
          			            Clear_Status();
								sprintf(Text,"Stabilisierung reset");
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
							}  else {
          				    sprintf(Text,"Stabilisierung wird gelock");
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
							MoreLinesLock=TRUE;
							}
			                break;


         case IDM_MOVIEBOOST_169:
			                 Stop_Thread();
							 MovieBoost=37;
							 AutoMovieBoostEnable=FALSE;
          				    sprintf(Text,"MovieBoost ist %d (16:9)",MovieBoost);
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);

							 Start_Thread();
							 break;

         case IDM_MOVIEBOOST_KEINER:
			                 Stop_Thread();
							 MovieBoost=0;
							 AutoMovieBoostEnable=FALSE;
							 sprintf(Text,"MovieBoost ist aus");
    	    		         if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                             Start_Thread();
							 break;

         case IDM_MOVIEBOOST_MINUS:
			                 Stop_Thread();
                             if ( MovieBoost < 90 ) MovieBoost++;
          				    sprintf(Text,"MovieBoost ist %d",MovieBoost);
							 AutoMovieBoostEnable=FALSE;
							if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                             Start_Thread();
							 break;

         case IDM_MOVIEBOOST_PLUS:
			                 Stop_Thread();
                             if ( MovieBoost > 0 ) MovieBoost--;
          				    sprintf(Text,"MovieBoost ist %d",MovieBoost);
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
							 AutoMovieBoostEnable=FALSE;
                             Start_Thread();
							 break;
         case IDM_AUTOSCALE:
			           
			                 Stop_Thread();
                		     MovieScale=G_Wert(MatrixLinesEven,MatrixLinesOdd);
							 if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) Init_Screen_Struct();
          				     sprintf(Text,"Y-Strech ist %d ",MovieScale);
    	    		         if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                             Start_Thread();
							 break;



         case IDM_SCALE_169:
			                 Stop_Thread();
							 MovieScale=37;
							 if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) Init_Screen_Struct();
          				     sprintf(Text,"Y-Strech ist %d (16:9)",MovieScale);
    	    		         if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                             Start_Thread();
							 break;

         case IDM_SCALE_KEINER:
			                 Stop_Thread();
							 MovieScale=0;
							 if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) Init_Screen_Struct();
          				     sprintf(Text,"Y-Strech ist aus");
    	    		         if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);

                             Start_Thread();
							 break;

         case IDM_SCALE_MINUS:
			                 Stop_Thread();
                             if ( MovieScale < 90 ) MovieScale++;
							 if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) Init_Screen_Struct();
          				    sprintf(Text,"Y-Strech ist %d",MovieScale);
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                             Start_Thread();
							 break;

         case IDM_SCALE_PLUS:
			                 Stop_Thread();
                             if ( MovieScale > 0 ) MovieScale--;
							 if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) Init_Screen_Struct();
          				    sprintf(Text,"Y-Strech ist %d",MovieScale);
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);

                             Start_Thread();
							 break;

         case IDM_RESET:     
			                 if ( Current_Mode == 0 ) Reset_BT_HardWare(hWnd);
							 else if ( Current_Mode == 1 ) DVB_Reset();
							 break;

         case IDM_TOGGLE_MENU:
			 if ( Show_Menu == TRUE ) {
 							 Stop_Thread();
							 Set_Capture(4);
			                 Show_Menu=FALSE;
							 Display_Status_Bar=FALSE;
							 ShowWindow(Status_Bar,SW_HIDE);
					         KillTimer(hWnd, 1);

							 WStyle=GetWindowLong(hWnd,GWL_STYLE);
							 if ( Toggle_WithOut_Frame == TRUE ) SetWindowLong(hWnd,GWL_STYLE,WS_VISIBLE); 
                             else  SetWindowLong(hWnd,GWL_STYLE,WS_VISIBLE|WS_THICKFRAME);
							 SetMenu(hWnd,NULL);
                             Init_Screen_Struct();
                             Set_Capture(5);
							 if ( WindowStyle == 2 ) memset(lpSurface,0x00,800*600*2);
 							 if ( WindowStyle == 1 ) memset(lpSurface,0x00,640*480*2);
 							 if ( WindowStyle == 3 ) memset(lpSurface,0x00,Res_X*Res_Y*2);
							 return(TRUE);
						 };

 							 Stop_Thread();
							 Set_Capture(4);
			                 Show_Menu=TRUE;
							 Display_Status_Bar=TRUE;
							 ShowWindow(Status_Bar,SW_SHOW);
							 SetTimer (hWnd, 1, 2500, NULL);
                             SetWindowLong(hWnd,GWL_STYLE,WStyle); 
							 SetMenu(hWnd,hMenu);
                             Init_Screen_Struct();
                             Set_Capture(5);
							 return(TRUE);

						 break;

         case IDM_KEYSET:
			              Save_Mode();
						  DialogBox(hInst,"NAGRAKEYSET",hWnd,NagraKeySetProc);
                          Restore_Mode();
						  break;

         case IDM_ABOUT:
			              Save_Mode();
						  DialogBox(hInst,"ABOUT",hWnd,AboutProc);
                          Restore_Mode();
						  break;
		 
         case IDM_NAGRA_SETUP:
			              Save_Mode();
						  DialogBox(hInst,"NAGRASETUP",hWnd,NagraSetupProc);
                          Restore_Mode();
						  break;
         
		case IDM_FullFields:
			 if (DecodeNagra==TRUE){
				 if(NagraFullField==FALSE) NagraFullField=TRUE; else NagraFullField=FALSE; 
				 if ( NagraFullField == TRUE )  sprintf(Text,"Beide Halbbilder");
                      else sprintf(Text,"Ein Halbbild");
   	    		 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 
			 DecodeNagra=FALSE;
			 SendMessage(hWnd,WM_COMMAND,IDM_DECODING_NAGRA1,0);
			 MoreLinesLock=FALSE;
			 } else {
                           Stop_Thread();
						   Set_Capture(4);
						   if ( HalfTVMode == FALSE ) {
						    CheckMenuItem( GetMenu(hWnd), IDM_HALFMODE, MF_CHECKED );
                            HalfTVMode=TRUE;
                            Init_Screen_Struct();
 			                Set_Capture(5);
          				    sprintf(Text,"Ein Halbbild");
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);

							break;
						   } 
						    CheckMenuItem( GetMenu(hWnd), IDM_HALFMODE, MF_UNCHECKED );
                            HalfTVMode=FALSE;
                            Init_Screen_Struct();
 			                Set_Capture(5);
          				    sprintf(Text,"Beide Halbbilder");
   	    		            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);

							break;
			 }
		    break;


		 case IDM_DECODING_NAGRA1:
 		   	    Stop_Thread();
          		Set_Capture(4);
				 if ( DecodeNagra == FALSE ) {
          			   if (LeseKeyDatei(hWnd) == FALSE ) {
  		         	       Set_Capture(5);
				           return(FALSE);
					   }
				  
				  CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );

					if ( OutDib == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_CHECKED );
    				else if ( ModeOverlay == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_CHECKED );
				 else CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_CHECKED ); 


					   ModeRAWOverlay=FALSE;
     				   ModeRAWSurface=FALSE;
    				 if ( TVTYPE != 5 ) S_TVTYPE=TVTYPE;
					  S_ColourFormat=ColourFormat;
					 CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_UNCHECKED );
					 if (TVTYPE==0) TVTYPE=5;
			         CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
			         CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
			         ColourFormat=4;
                     SetColourFormat(ColourFormat);
					 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
 			         DecodeVCrypt=FALSE; 
				     DecodeNagra=TRUE;
 				     DecodeDecoderVCrypt=FALSE;
				
					 if ( !Init_Nagra_Decoding(MasterTestzeilen) ) {
 			         DecodeVCrypt=FALSE; 
				     DecodeNagra=FALSE;
 				     DecodeDecoderVCrypt=FALSE;
                     };

		             Init_Screen_Struct();
               };
                 Set_Capture(5);


			  break;




         case IDM_BRIGHTNESSPLUS:

			 if ( Current_Mode == 0 ) {
 	             if ( InitialBrightness < 128 ) i=InitialBrightness;
              			else i=-(256-InitialBrightness);

                 if (( i > -127 ) && ( i < 127 )) i++;
                 if ( i < 0 ) InitialBrightness=256+i;
				    else InitialBrightness=i;
				 SetBrightness(InitialBrightness);
			 } else if ( Current_Mode == 1 ){
				 if ( InitialDVBBrightness < 255 ) InitialDVBBrightness++;
				 i=InitialDVBBrightness;
				 set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);

			 }
                 sprintf(Text,"Helligkeit %d",i);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                 break;

         case IDM_BRIGHTNESSMINUS:

			 if ( Current_Mode == 0 ) {
 	             if ( InitialBrightness < 128 ) i=InitialBrightness;
              			else i=-(256-InitialBrightness);
                 if (( i > -127 ) && ( i < 127 )) i--;
                 if ( i < 0 ) InitialBrightness=256+i;
				    else InitialBrightness=i;
				 SetBrightness(InitialBrightness);
			 } else if ( Current_Mode == 1 ){
				 if ( InitialDVBBrightness > 0 ) InitialDVBBrightness--;
				 i=InitialDVBBrightness;
				 set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
			 }
				 sprintf(Text,"Helligkeit %d",i);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
                 break;

         case IDM_COLORPLUS:
			 if ( Current_Mode == 0 ){
				 if (( InitialSaturationU < 255 ) && (InitialSaturationV < 255 )) {
				 InitialSaturationU++;
				 InitialSaturationV++;
                 sprintf(Text,"Farbe U %d V %d",InitialSaturationU,InitialSaturationV);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 SetSaturationU(InitialSaturationU);
                 SetSaturationV(InitialSaturationV);
				 }
			 } else if ( Current_Mode == 1 ){
				 if ( InitialDVBColor < 127  ) InitialDVBColor++;
                 sprintf(Text,"Farbe %d",InitialDVBColor);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
			 }

                 break;
         
         case IDM_COLORMINUS:
			 if ( Current_Mode == 0 ){
			 if (( InitialSaturationU > 0 ) && (InitialSaturationV > 0 )) {
				 InitialSaturationU--;
				 InitialSaturationV--;
                 sprintf(Text,"Farbe U %d V %d",InitialSaturationU,InitialSaturationV);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 SetSaturationU(InitialSaturationU);
                 SetSaturationV(InitialSaturationV);
				 }
			 } else if ( Current_Mode == 1 ){
				 if ( InitialDVBColor > 0 ) InitialDVBColor--;
                 sprintf(Text,"Farbe %d",InitialDVBColor);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
			 }
			 break;

         case IDM_KONTRASTPLUS:
			 if ( Current_Mode == 0 ){
			    if ( InitialContrast < 256 ) InitialContrast++;
 		     	 SetContrast(InitialContrast);    
                 sprintf(Text,"Kontrast %d",InitialContrast);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			 } else if ( Current_Mode == 1 ){
				 if ( InitialDVBContrast < 127) InitialDVBContrast++;
                 sprintf(Text,"Kontrast %d",InitialDVBContrast);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
			 }

                 break;
         
         case IDM_KONTRASTMINUS:
			 if ( Current_Mode == 0 ){
       			 if ( InitialContrast > 0 ) InitialContrast--;
 		     	 SetContrast(InitialContrast);    
                 sprintf(Text,"Kontrast %d",InitialContrast);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			 } else if ( Current_Mode == 1 ){
				 if ( InitialDVBContrast > 0) InitialDVBContrast--;
                 sprintf(Text,"Kontrast %d",InitialDVBContrast);
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
			 }

                 break;

  		 case IDM_MUTE:
			 if ( System_In_Mute == FALSE ) {
                  System_In_Mute = TRUE ;
			     if ( USE_MIXER == FALSE  ) {
					 if ( Current_Mode == 0 ) {
					           SetAudioSource(4);
					           sprintf(Text,"Mute auf BT");
					 } else if ( Current_Mode == 1 ) {
                               DVB_SetVolume((unsigned char)0x00, (unsigned char)0x00);
					           sprintf(Text,"Mute auf DVB");
					 }
				 };
			     if ( USE_MIXER == TRUE ) {
                    Mixer_Mute();
					sprintf(Text,"Mute auf Mixer");
				 }
			 } else {
                  System_In_Mute = FALSE ;
			     if ( USE_MIXER == FALSE  ) {
					 if ( Current_Mode == 0 ) {
					        SetAudioSource(AudioSource);
					        sprintf(Text,"UnMute auf BT");
					 } else if ( Current_Mode == 1 ) {
                               DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
					           sprintf(Text,"UnMute auf DVB");
					 }
				 };
			     if ( USE_MIXER == TRUE ) {
                    Mixer_UnMute();
					sprintf(Text,"UnMute auf Mixer");
				 }

			 }
            if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
            break;

         case IDM_L_BALANCE:
				  if ( USE_MIXER == FALSE  ) {
					 if ( Current_Mode == 0 ) {
					if ( InitialBalance > -127 ) InitialBalance--;
					Audio_SetBalance(InitialBalance); // -127 - +128
					sprintf(Text,"BT-Balance %d",InitialBalance);
					 } else if ( Current_Mode == 1 ) { 
							 if (( InitialDVBVolumeLinks < 127) && ( InitialDVBVolumeRechts > 0 )) {
								 InitialDVBVolumeLinks++;
								 InitialDVBVolumeRechts--;
							 }
						 DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
						 sprintf(Text,"DVB-Balance L %d R %d",InitialDVBVolumeLinks,InitialDVBVolumeRechts);
				  };
				}
                 if ( USE_MIXER == TRUE ) {
				     if ( MIXER_LINKER_KANAL+MixerVolumeStep <= MixerVolumeMax ) MIXER_LINKER_KANAL+=MixerVolumeStep;
				     if ( MIXER_RECHTER_KANAL-MixerVolumeStep >= 0 ) MIXER_RECHTER_KANAL-=MixerVolumeStep;
				     Mixer_Set_Volume(MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
					 sprintf(Text,"Balance L %d R %d",MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
				 }
				 
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 break;

         case IDM_R_BALANCE:
				  if ( USE_MIXER == FALSE  ) {
					if ( Current_Mode == 0 ) { 
					if ( InitialBalance < 128 ) InitialBalance++;
					Audio_SetBalance(InitialBalance); // -127 - +128
					sprintf(Text,"BT-Balance %d",InitialBalance);
					 } else if ( Current_Mode == 1 ) { 
							 if (( InitialDVBVolumeLinks > 0 ) && ( InitialDVBVolumeRechts < 127 )) {
								 InitialDVBVolumeLinks--;
								 InitialDVBVolumeRechts++;
							 }
						 DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
						 sprintf(Text,"DVB-Balance L %d R %d",InitialDVBVolumeLinks,InitialDVBVolumeRechts);
				  };
				  }
                 if ( USE_MIXER == TRUE ) {
				     if ( MIXER_LINKER_KANAL-MixerVolumeStep >= 0 ) MIXER_LINKER_KANAL-=MixerVolumeStep;
					 if ( MIXER_RECHTER_KANAL+MixerVolumeStep <= MixerVolumeMax ) MIXER_RECHTER_KANAL+=MixerVolumeStep;
					 Mixer_Set_Volume(MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
					 sprintf(Text,"Balance L %d R %d",MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
				 }
				 
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 break;

  		 case IDM_VOLUMEPLUS:
			     if ( USE_MIXER == FALSE  ) {
				if ( Current_Mode == 0 ) { 
			     if ( InitialVolume < 980 ) InitialVolume+=20;
				 Audio_SetVolume(InitialVolume);
                 sprintf(Text,"BT-Volume %d",InitialVolume);
					 } else if ( Current_Mode == 1 ) { 
							 if (( InitialDVBVolumeLinks < 127 ) && ( InitialDVBVolumeRechts < 127 )) {
								 InitialDVBVolumeLinks++;
								 InitialDVBVolumeRechts++;
							 }
						 DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
						 sprintf(Text,"DVB-Volume L %d R %d",InitialDVBVolumeLinks,InitialDVBVolumeRechts);
				  };

				};
                 if ( USE_MIXER == TRUE ) {
                     i=((MixerVolumeMax/MixerVolumeStep)/100)*MixerVolumeStep;
                     if (( i+MIXER_LINKER_KANAL > MixerVolumeMax ) || ( i+MIXER_RECHTER_KANAL > MixerVolumeMax )) i=MixerVolumeStep;
					 if ( MIXER_LINKER_KANAL+i <= MixerVolumeMax ) MIXER_LINKER_KANAL+=i;
				     if ( MIXER_RECHTER_KANAL+i <= MixerVolumeMax ) MIXER_RECHTER_KANAL+=i;
				     Mixer_Set_Volume(MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
					 sprintf(Text,"Volume L %d R %d",MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
				 };

   	    		 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 break;
  		 case IDM_VOLUMEMINUS:
				  if ( USE_MIXER == FALSE  ) {
				if ( Current_Mode == 0 ) { 
					 if ( InitialVolume > 20 ) InitialVolume-=20;
					Audio_SetVolume(InitialVolume);
					sprintf(Text,"BT-Volume %d",InitialVolume);
					 } else if ( Current_Mode == 1 ) { 
							 if (( InitialDVBVolumeLinks > 0 ) && ( InitialDVBVolumeRechts > 0)) {
								 InitialDVBVolumeLinks--;
								 InitialDVBVolumeRechts--;
							 }
						 DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
						 sprintf(Text,"DVB-Volume L %d R %d",InitialDVBVolumeLinks,InitialDVBVolumeRechts);
				  };

				  }
                 if ( USE_MIXER == TRUE ) {
                     i=((MixerVolumeMax/MixerVolumeStep)/100)*MixerVolumeStep;
                     if (( MIXER_LINKER_KANAL-i < 0) || ( MIXER_RECHTER_KANAL-i < 0)) i=MixerVolumeStep;
					 if ( MIXER_LINKER_KANAL-i >= 0 ) MIXER_LINKER_KANAL-=i;
				     if ( MIXER_RECHTER_KANAL-i >= 0 ) MIXER_RECHTER_KANAL-=i;
				     Mixer_Set_Volume(MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
					 sprintf(Text,"Volume L %d R %d",MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
                    
				 }
					 
					 
				 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 break;

      case IDM_TOGGLECURSOR:
		    CShowCursor=!CShowCursor;
		    i=ShowCursor(CShowCursor);
		  break;
		 

	  case IDM_KEY0:
		      Stop_Thread();
		      i=ActiveKey;
			  ActiveKey=0;
              sprintf(Text,"KeySet %s",OPKEY[ActiveKey].Name);
   	    	  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			  if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
				  ActiveKey=i;
			  };
              Start_Thread();
			  break; 
	  case IDM_KEY1:
		      Stop_Thread();
		      i=ActiveKey;
			  ActiveKey=1;
              sprintf(Text,"KeySet %s",OPKEY[ActiveKey].Name);
   	    	  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			  if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
				  ActiveKey=i;
			  };
              Start_Thread();
			  break; 
	  case IDM_KEY2:
		      Stop_Thread();
		      i=ActiveKey;
			  ActiveKey=2;
              sprintf(Text,"KeySet %s",OPKEY[ActiveKey].Name);
   	    	  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			  if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
				  ActiveKey=i;
			  };
              Start_Thread();
			  break; 
	  case IDM_KEY3:
		      Stop_Thread();
		      i=ActiveKey;
			  ActiveKey=3;
              sprintf(Text,"KeySet %s",OPKEY[ActiveKey].Name);
   	    	  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
			  if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
				  ActiveKey=i;
			  };
              Start_Thread();
			  break; 

		 case IDM_MORETZ:
 		   if (DecodeNagra==TRUE) {	 
			   Stop_Thread();
			   for ( i = 0; i < 5 ; i++ ) {
				   if( MasterTestzeilen < TZ[i]) {
					   MasterTestzeilen=TZ[i];
					   break;
			   };
               };
                 sprintf(Text,"Testzeilen auf  %d",MasterTestzeilen);
   	    		 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
					 SendMessage(hWnd,WM_COMMAND,IDM_DECODING_OFF,0);
					 break;
				 };

			  if ( MatrixModeEven == TRUE )  {
          	               GetMatrix(MatrixLinesEven-1,0);
			  }
      		  if ( MatrixModeOdd == TRUE )  {
          	               GetMatrix(MatrixLinesOdd-1,1);
			  }

				 Start_Thread();
		   }

		   break;

		 case IDM_LESSTZ:
 		   if (DecodeNagra==TRUE) {	 
			   Stop_Thread();
			   for ( i = 4; i >= 0 ; i-- ) {
				   if( MasterTestzeilen > TZ[i]) {
					   MasterTestzeilen=TZ[i];
					   break;
			   };
               };
                 sprintf(Text,"Testzeilen auf  %d",MasterTestzeilen);
   	    		 if ( Display_Status_Bar == TRUE ) SetWindowText (hwndTextField,Text);
				 if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
					 SendMessage(hWnd,WM_COMMAND,IDM_DECODING_OFF,0);
					 break;
				 };
      		  if ( MatrixModeEven == TRUE )  {
          	               GetMatrix(MatrixLinesEven-1,0);
			  }
      		  if ( MatrixModeOdd == TRUE )  {
          	               GetMatrix(MatrixLinesOdd-1,1);
			  }

			  Start_Thread();
		   }
		   break;


		 case IDM_DECODING_VIDEOCRYPTSETUP:
			            Save_Mode();
		                DialogBox(hInst,"VIDEOCRYPTSETUP",hWnd,VCSetupProc);
						Restore_Mode();
                        break;

		 case IDM_CHROMA_KEYING:
                        Chroma_Key=!Chroma_Key;
			            break;

						
		 case IDM_DECODING_VIDEOCRYPT:
		   	    Stop_Thread();
        		Set_Capture(4);
                MoreLinesLock=FALSE;

				if ( DecodeVCrypt == FALSE ) {
				 DecodeVCrypt=TRUE; 
			     DecodeNagra=FALSE;
				 DecodeDecoderVCrypt=FALSE;
				if ( TVTYPE != 5 ) S_TVTYPE=TVTYPE;
				 TVTYPE=5;
				 S_ColourFormat=ColourFormat;
				 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
/*						   if ( ALLWAYS_TOP == FALSE ) {
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,728,576,SWP_NOMOVE|SWP_NOCOPYBITS);
						   } else {
								 SetWindowPos(hWnd,HWND_TOPMOST,10,10,728,576,SWP_NOMOVE|SWP_NOCOPYBITS);

						   }
*/
				 ColourFormat=4;
                 SetColourFormat(ColourFormat);
				 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
				 DecodeVCrypt=TRUE; 
			     DecodeNagra=FALSE;
				 DecodeDecoderVCrypt=FALSE;
                 Init_Screen_Struct();;
              };

                 Set_Capture(5);
                 break;
			 
		 case IDM_DECODER_MODE:
		   	    Stop_Thread();
        		Set_Capture(4);
                MoreLinesLock=FALSE;

			   if ( DecodeDecoderVCrypt == FALSE ) {
				 DecodeVCrypt=FALSE; 
			     DecodeNagra=FALSE;
				 DecodeDecoderVCrypt=TRUE;
 			   if ( TVTYPE != 5 ) S_TVTYPE=TVTYPE;
				 TVTYPE=5;

				 S_ColourFormat=ColourFormat;
				 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
/*						   if ( ALLWAYS_TOP == FALSE ) {
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,728,576,SWP_NOMOVE|SWP_NOCOPYBITS);
						   } else {
								 SetWindowPos(hWnd,HWND_TOPMOST,10,10,728,576,SWP_NOMOVE|SWP_NOCOPYBITS);

						   }
*/
				 ColourFormat=4;
                 SetColourFormat(ColourFormat);
				 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
                 Init_Screen_Struct();
              };

                 Set_Capture(5);
                 break;

				 

		 case IDM_DECODING_OFF:
 		   	     Stop_Thread();
                 Set_Capture(4);
				 DecodeVCrypt=FALSE; 
			     DecodeNagra=FALSE;
				 MoreLinesLock=FALSE;
				 DecodeDecoderVCrypt=FALSE;
				 CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_UNCHECKED );
				 TVTYPE=S_TVTYPE;
			     CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
			     CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
			     ColourFormat=S_ColourFormat;
                 SetColourFormat(ColourFormat);
				 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
                 Init_Screen_Struct();
				 Free_Nagra_Decoding();
                 SendMessage(hWnd,WM_COMMAND,OldMode,0);
				 break;

         case IDM_KARTE0:
		 case IDM_KARTE1:
         case IDM_KARTE2:
         case IDM_KARTE3:
         case IDM_KARTE4:
         case IDM_KARTE5:
         case IDM_KARTE6:
			 if ( Current_Mode == 0 ) {
  			   CheckMenuItem( GetMenu(hWnd), CardType+1080, MF_UNCHECKED );
			   CardType=wParam-1080;
			   CheckMenuItem( GetMenu(hWnd), CardType+1080, MF_CHECKED );
			 } else  if ( Current_Mode == 1 ) {
  			   CheckMenuItem( GetMenu(hWnd), DVBType+1080, MF_UNCHECKED );
			   DVBType=wParam-1080;
			   CheckMenuItem( GetMenu(hWnd), DVBType+1080, MF_CHECKED );
			 }
			   break;
         case IDM_MANUELL_CARD:
			               Save_Mode();
 			               DialogBox(hInst,"CARDTYPE",hWnd,(DLGPROC)CardSettingProc);
						   Restore_Mode();
						   break;

      
		 
		 case IDM_ENDE:
				PostMessage(hWnd,WM_DESTROY,wParam,lParam);
			   break;

    
		 
		 case IDM_MSPMODE_3:
		 case IDM_MSPMODE_2:
		 case IDM_MSPMODE_4:
		 case IDM_MSPMODE_5:
		 case IDM_MSPMODE_6:
		 	    MSP_SetMode( wParam-1600);
				break;
		 
		 case IDM_MAJOR_CARRIER_0:
		 case IDM_MAJOR_CARRIER_1:
		 case IDM_MAJOR_CARRIER_2:
		 case IDM_MAJOR_CARRIER_3:
                    MSP_Set_MajorMinor_Mode(wParam-1610,MSPMinorMode);
                    break;
		 
		 case IDM_MINOR_CARRIER_0:
		 case IDM_MINOR_CARRIER_1:
		 case IDM_MINOR_CARRIER_2:
		 case IDM_MINOR_CARRIER_3:
		 case IDM_MINOR_CARRIER_4:
		 case IDM_MINOR_CARRIER_5:
		 case IDM_MINOR_CARRIER_6:
		 case IDM_MINOR_CARRIER_7:
                    MSP_Set_MajorMinor_Mode(MSPMajorMode,wParam-1620  );
                    break;


		 case IDM_MSPSTEREO_1:
		 case IDM_MSPSTEREO_2:
		 case IDM_MSPSTEREO_3:
		 case IDM_MSPSTEREO_4:
			        MSP_SetStereo(MSPMajorMode, MSPMinorMode,wParam-1630);
					break;



         case IDM_AUTOSTEREO:
			 if ( AutoStereoSelect == FALSE ) {
				  AutoStereoSelect=TRUE;
			      CheckMenuItem( GetMenu(hWnd), IDM_AUTOSTEREO, MF_CHECKED );

			 } else {
	               AutoStereoSelect=FALSE;
				   CheckMenuItem( GetMenu(hWnd), IDM_AUTOSTEREO, MF_UNCHECKED );
			 }
		 
		 case IDM_AUDIO_0:
         case IDM_AUDIO_1:
         case IDM_AUDIO_2:
         case IDM_AUDIO_3:
         case IDM_AUDIO_4:
         case IDM_AUDIO_5:

    		   CheckMenuItem( GetMenu(hWnd), AudioSource+1110, MF_UNCHECKED );
			   AudioSource=wParam-1110;
			   Set_Capture(4);
			   SetAudioSource(AudioSource);
			   Set_Capture(5);
			   CheckMenuItem( GetMenu(hWnd), AudioSource+1110, MF_CHECKED );
			   break;


		 case IDM_EXTERN1: 
		 case IDM_EXTERN2: 
		 case IDM_EXTERN3: 
		     CheckMenuItem( GetMenu(hWnd), VideoSource+1089, MF_UNCHECKED );
			   VideoSource=wParam-1089;
               Set_Capture(4);
			   SetVideoSource(VideoSource);
               sprintf(Text,"Extern %d",VideoSource);
   			   if ( Display_Status_Bar == TRUE ) SetWindowText (hwndKeyField,Text);
			   Set_Capture(5);
			   CheckMenuItem( GetMenu(hWnd), VideoSource+1089, MF_CHECKED );
			   break;

		 case IDM_VIDEO:
			          if ( Capture_Video == FALSE ) {
						   Capture_Video = TRUE ;
						   Set_Capture(0);
						   CheckMenuItem( GetMenu(hWnd), IDM_VIDEO, MF_CHECKED );
					  } else {
						   Set_Capture(1);
						   Capture_Video = FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_VIDEO, MF_UNCHECKED );
					  }
					  break;
	
         case IDM_HWINFO :
			               Save_Mode();
			               DialogBox(hInst,"HWINFO",hWnd,(DLGPROC)ChipSettingProc);
						   Restore_Mode();
						   break;

         case IDM_PLL:
			               Save_Mode();
			               DialogBox(hInst,"PLLINFO",hWnd,(DLGPROC)PLLSettingProc);
						   Restore_Mode();
						   break;

         
		 case IDM_IFORM :
			               Save_Mode();
			               DialogBox(hInst,"IFORMINFO",hWnd,(DLGPROC)IFormSettingProc);
						   Restore_Mode();
						   break;

         case IDM_DONT_TOUCH: 
			 if ( USETUNER == TRUE ) {
			                      	 USETUNER=FALSE;
                    				 CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH, MF_CHECKED );
							 }  else {
									 USETUNER=TRUE;
									 CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH, MF_UNCHECKED );
							 }
                           break;
         
		 case IDM_DONT_TOUCH_CARD: 
			 if ( USECARD == TRUE ) {
			                      	 USECARD=FALSE;
                    				 CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH_CARD, MF_CHECKED );
							 }  else {
									 USECARD=TRUE;
									 CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH_CARD, MF_UNCHECKED );
							 }
                           break;


         case IDM_MANUELL_TUNER:

			               Save_Mode();
			              if ( Current_Mode == 0 ) DialogBox(hInst,"TUNERSETTINGS",hWnd,(DLGPROC)TunerSettingProc);
						   else  if ( Current_Mode == 1 ) DialogBox(hInst,"TUNERSETTINGSDIGI",hWnd,(DLGPROC)TunerDigiSettingProc);
						   Restore_Mode();
						   break;

         case IDM_VBI_VT:
			              if (VBI_Flags&VBI_VT) {
				           VBI_Flags-=VBI_VT;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VT, MF_UNCHECKED );
   	   					   EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_GRAYED);
						   EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXTSMALL,MF_GRAYED);
						   EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXT,MF_GRAYED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_VT_RESET,MF_GRAYED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_UNTERTITEL,MF_GRAYED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_PDC_OUT,MF_GRAYED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_GRAYED);

                           break;
						  };
				           VBI_Flags+=VBI_VT;
                 		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VT, MF_CHECKED );
	   					   EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXTSMALL,MF_ENABLED);
						   EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXT,MF_ENABLED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_VT_RESET,MF_ENABLED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_UNTERTITEL,MF_ENABLED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_PDC_OUT,MF_ENABLED);
		                   EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_ENABLED);
                           break;

		 case IDM_VBI_VD:
			              if (VBI_Flags&VBI_VD) {
							  if ( BeforeVD != 7 ) {
                           Set_Capture(4);
                           Sleep(30);
						   VBI_Flags-=VBI_VD;
                		   VideoDat_Exit();
						   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VD, MF_UNCHECKED );
                           VBI_lpf=16;
						   MakeVBITable(VBI_lpf);
                           MakeVBITable2(VBI_lpf);
	                       MakeVBITable3(VBI_lpf);
	                       MakeVBITable4(VBI_lpf);
	                       MakeVBITable5(VBI_lpf);
			               CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_UNCHECKED );
						   TVTYPE=BeforeVD;
					       S_TVTYPE=0;
			               CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_VD_OUT,MF_GRAYED);
                           Init_Screen_Struct();
   	        		       Set_Capture(5);
						   break;
							  };
						   VBI_Flags-=VBI_VD;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VD, MF_UNCHECKED );
                           EnableMenuItem(GetMenu(hWnd),IDM_VD_OUT,MF_GRAYED);
						   break;
						  };


                           BeforeVD=TVTYPE;
						   if ( TVTYPE != 7 ) {
                           Set_Capture(4);
                           Sleep(30);
						   VideoDat_Init();
						   VBI_Flags+=VBI_VD;        // 
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VD, MF_CHECKED );
                           VBI_lpf=19;
						   MakeVBITable(VBI_lpf);
                           MakeVBITable2(VBI_lpf);
	                       MakeVBITable3(VBI_lpf);
	                       MakeVBITable4(VBI_lpf);
	                       MakeVBITable5(VBI_lpf);
			               CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_UNCHECKED );
						   TVTYPE=7;
					       S_TVTYPE=0;
			               CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_VD_OUT,MF_ENABLED);
                           Init_Screen_Struct();
   	        		       Set_Capture(5);
						   break;
					 };
                          VideoDat_Init();	
						   VBI_Flags+=VBI_VD;         
                		   
							CheckMenuItem( GetMenu(hWnd), IDM_VBI_VD, MF_CHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_VD_OUT,MF_ENABLED);
						   break;

		 case IDM_VBI_VPS:
			              if (VBI_Flags&VBI_VPS) {
				           VBI_Flags-=VBI_VPS;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VPS, MF_UNCHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_VPS_OUT,MF_GRAYED);
                           break;
						  };
				           VBI_Flags+=VBI_VPS;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VPS, MF_CHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_VPS_OUT,MF_ENABLED);
                           break;

         case IDM_VBI_VC:
			              if (VBI_Flags&VBI_VC) {
				           VBI_Flags-=VBI_VC;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VC, MF_UNCHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_CRYPTSTATUS,MF_GRAYED);
						   break;
						  };
				           VBI_Flags+=VBI_VC;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VC, MF_CHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_CRYPTSTATUS,MF_ENABLED);
                           break;

         
		 
		 case IDM_VBI_IC:
			              if (VBI_Flags&VBI_IC) {
				           VBI_Flags-=VBI_IC;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_IC, MF_UNCHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_IC_OUT,MF_GRAYED);
                           break;
						  };
				           VBI_Flags+=VBI_IC;
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_IC, MF_CHECKED );
						   EnableMenuItem(GetMenu(hWnd),IDM_IC_OUT,MF_ENABLED);

                           break;

		 case IDM_UNTERTITEL:
			              Save_Mode();
						  VThWnd=CreateDialog(hInst,"VIDEOTEXTUNTERTITEL",NULL,VideoTextUnterTitelProc);
		                  if (( ALLWAYS_TOP==TRUE) || (WindowStyle != 0 )) SetWindowPos(VThWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
						  break;

         case IDM_VIDEODAT_SETUP:
			              Save_Mode();
						  DialogBox(hInst,"VDSETUP",hWnd,VDSettingProc);
						  Restore_Mode();
                          break;

         case IDM_INTERCAST_SETUP:
			              Save_Mode();
						  DialogBox(hInst,"ICSETUP",hWnd,ICSettingProc);
						  Restore_Mode();
                          break;

         case IDM_AUTODECODE_SETTUNG:
			              Save_Mode();
						  DialogBox(hInst,"AUTODECODESETTING",hWnd,DetectSettingProc);
						  Restore_Mode();
                          break;

         case IDM_TOGGLE_SETTUNGS:
			              Save_Mode();
						  DialogBox(hInst,"TOGGLESETTING",hWnd,ToggleSettingProc);
						  Restore_Mode();
                          break;

		 case IDM_CALL_VIDEOTEXTSMALL:
		            	  VTLarge=FALSE;
						  Save_Mode();
						  VThWnd=CreateDialog(hInst,"VIDEOTEXTSMALL",NULL,VideoTextProc);
		                  if (( ALLWAYS_TOP==TRUE) || (WindowStyle != 0 )) SetWindowPos(VThWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
						  break;

		 
		 case IDM_CALL_VIDEOTEXT:
		            	  VTLarge=TRUE;
						  Save_Mode();
						  VThWnd=CreateDialog(hInst,"VIDEOTEXT",NULL,VideoTextProc);
		                  if (( ALLWAYS_TOP==TRUE) || (WindowStyle != 0 ))  SetWindowPos(VThWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
						  break;
		 case IDM_VT_RESET:
                          VT_ChannelChange();
                          break;

         case IDM_SECAM_THRESHOLD:
			              Save_Mode();
						  DialogBox(hInst,"SECAMTHRESHOLD",hWnd,SecamSettingProc);
						  Restore_Mode();
                          break;

         case IDM_LNB:
			             
			              Save_Mode();
						  DialogBox(hInst,"LNBSETTING",hWnd,LNBSettingProc);
						  Restore_Mode();
                          break;

         case IDM_AUDIOSETTINGS:
			             
			              Save_Mode();
						  if ( Current_Mode == 0 ) DialogBox(hInst,"AUDIOEINSTELLUNGEN",hWnd,AudioSettingProc);
						    else if ( Current_Mode == 1 ) DialogBox(hInst,"AUDIOEINSTELLUNGENDIGI",hWnd,AudioDigiSettingProc);
						  Restore_Mode();
                          break;

         case IDM_AUDIOSETTINGS1:
			              Save_Mode();
						  DialogBox(hInst,"AUDIOEINSTELLUNGEN1",hWnd,AudioSettingProc1);
						  Restore_Mode();
                          break;

         case IDM_VIDEOSETTINGS:
			              Save_Mode();
						  if ( Current_Mode == 0 ) DialogBox(hInst,"VIDEOEINSTELLUNGEN",hWnd,VideoSettingProc);
						  else  if ( Current_Mode == 1 ) DialogBox(hInst,"VIDEOEINSTELLUNGENDIGI",hWnd,VideoSettingDigiProc);
                          Restore_Mode();
						  break;

         case IDM_CRYPTSTATUS:
			              Save_Mode();
						  DialogBox(hInst,"CRYPTSTATUS",hWnd,CryptModeProc);
                          Restore_Mode();
						  break;

         case IDM_PDC_OUT:
			              Save_Mode();
						  DialogBox(hInst,"PDCSTATUS",hWnd,PDCProc);
                          Restore_Mode();
						  break;

         case IDM_VPS_OUT:
			              Save_Mode();
						  DialogBox(hInst,"VPSSTATUS",hWnd,VPSInfoProc);
                          Restore_Mode();
						  break;
         case IDM_IC_OUT:
			              Save_Mode();
						  DialogBox(hInst,"ICSTATUS",hWnd,ICInfoProc);
                          Restore_Mode();
						  break;

         case IDM_VD_OUT:
			              Save_Mode();
						  if ( VD_RAW==TRUE ) DialogBox(hInst,"VDSTATUSRAW",hWnd,VDInfoProcRaw);
						  else DialogBox(hInst,"VDSTATUS",hWnd,VDInfoProc);

                          Restore_Mode();
						  break;

         case IDM_VT_OUT:
			              Save_Mode();
						  DialogBox(hInst,"VTSTATUS",hWnd,VTInfoProc);
                          Restore_Mode();
						  break;

						  
		 case IDM_AUTOMB:
			 if (Auto_MovieBoost == FALSE ) {
				Auto_MovieBoost = TRUE;
				CheckMenuItem( GetMenu(hWnd), IDM_AUTOMB, MF_CHECKED );
			 } else {
				Auto_MovieBoost = FALSE;
				CheckMenuItem( GetMenu(hWnd), IDM_AUTOMB, MF_UNCHECKED );
			 }
			 break;


         case IDM_AUTODETECT:
			          if ( Decode_AutoDetect == FALSE ) {
								Decode_AutoDetect = TRUE ;
						        CheckMenuItem( GetMenu(hWnd), IDM_AUTODETECT, MF_CHECKED );
					  } else {
						        Decode_AutoDetect = FALSE;
								CheckMenuItem( GetMenu(hWnd), IDM_AUTODETECT, MF_UNCHECKED );
					  }
					  break;

		 case IDM_VBI:
			          if ( Capture_VBI == FALSE ) {
							  Start_VBI();
                              Set_Capture(2);
						        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VT,MF_ENABLED);
                                EnableMenuItem(GetMenu(hWnd),IDM_VBI_IC,MF_ENABLED);
                                if (VBI_Flags&VBI_IC) {
                                   EnableMenuItem(GetMenu(hWnd),IDM_IC_OUT,MF_ENABLED);
								}
		                        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VC,MF_ENABLED);
                                if (VBI_Flags&VBI_VC) {
                                   EnableMenuItem(GetMenu(hWnd),IDM_CRYPTSTATUS,MF_ENABLED);
								}

								EnableMenuItem(GetMenu(hWnd),IDM_VBI_VPS,MF_ENABLED);
                                if (VBI_Flags&VBI_VPS) {
                                   EnableMenuItem(GetMenu(hWnd),IDM_VPS_OUT,MF_ENABLED);
								}

								EnableMenuItem(GetMenu(hWnd),IDM_VBI_VD,MF_ENABLED);

								if (VBI_Flags&VBI_VT) {
               					    EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXTSMALL,MF_ENABLED);
		                            EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXT,MF_ENABLED);
		                            EnableMenuItem(GetMenu(hWnd),IDM_VT_RESET,MF_ENABLED);
		                            EnableMenuItem(GetMenu(hWnd),IDM_UNTERTITEL,MF_ENABLED);
		                            EnableMenuItem(GetMenu(hWnd),IDM_PDC_OUT,MF_ENABLED);
		                            EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_ENABLED);
								}

								EnableMenuItem(GetMenu(hWnd),IDM_AUTODETECT,MF_ENABLED);
								Capture_VBI = TRUE ;
						        CheckMenuItem( GetMenu(hWnd), IDM_VBI, MF_CHECKED );
					  } else {
     						   Capture_VBI = FALSE;
						   Stop_Thread();
							   Stop_VBI();
						        Set_Capture(4);
						        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VT,MF_GRAYED);
                                EnableMenuItem(GetMenu(hWnd),IDM_VBI_IC,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VC,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VPS,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VD,MF_GRAYED);
								EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXTSMALL,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXT,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_VT_RESET,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_AUTODETECT,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_CRYPTSTATUS,MF_GRAYED);
						   	    CheckMenuItem( GetMenu(hWnd), IDM_VBI, MF_UNCHECKED );
  			                    EnableMenuItem(GetMenu(hWnd),IDM_UNTERTITEL,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_PDC_OUT,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_IC_OUT,MF_GRAYED);
		                        EnableMenuItem(GetMenu(hWnd),IDM_VPS_OUT,MF_GRAYED);

                                Set_Capture(3);

					  }
					  break;

		 case IDM_CAPTURE_PAUSE:
			          if ( Capture_Pause == FALSE ) {
						   Capture_Pause = TRUE ;
						   Set_Capture(4);
						   CheckMenuItem( GetMenu(hWnd), IDM_CAPTURE_PAUSE, MF_CHECKED );
					  } else {
						   Set_Capture(5);
						   Capture_Pause = FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_CAPTURE_PAUSE, MF_UNCHECKED );
					  }
					  break;

         case IDM_RAW_SURFACE:
			 if (( WTVBPP != 15  ) && ( WTVBPP != 16 ) ) {
                             MessageBox(hWnd,"Kein 16-Bit (15-Bit) HiColor eingestellt","Multi-Decode",MB_ICONSTOP|MB_OK);
						     return(TRUE);
						}
                           OldMode=IDM_RAW_SURFACE;
						   Stop_Thread();
						   Set_Capture(4);
							   if ( WTVBPP == 15 ) {
			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
								   ColourFormat=3;
                                   S_ColourFormat= ColourFormat;

			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
								   SetColourFormat(ColourFormat);
							   }
							   if ( WTVBPP == 16 ) {
			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
								   ColourFormat=2;
                                   S_ColourFormat= ColourFormat;
								   CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
								   SetColourFormat(ColourFormat);
							   }
                           Flip=0;
						   ModeRAWOverlay=FALSE;
						   ModeRAWSurface=TRUE;
						   CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;

         case IDM_RAW_OVERLAY:
                           if ( !Can_Overlay ) break;
                           OldMode=IDM_RAW_OVERLAY;
						   Stop_Thread();
						   Set_Capture(4);
	   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
						   ColourFormat=4;
	   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
						   SetColourFormat(ColourFormat);
                           Flip=0;
						   ModeRAWOverlay=TRUE;
						   ModeRAWSurface=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_CHECKED );
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;


		 case IDM_OVERLAY:
                           if ( !Can_Overlay ) break;
						   Set_Capture(4);
	   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
						   ColourFormat=4;
	   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
                           OldMode=IDM_OVERLAY;
						   ModeOverlay=TRUE;
						   ModeRAWSurface=FALSE;
						   ModeRAWOverlay=FALSE;
						   Stop_Thread();
                           Flip=0;
						   OutDib=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;


		 case IDM_INTERN_SURFACE:
			 if (( WTVBPP != 15  ) && ( WTVBPP != 16 ) ) {
                             MessageBox(hWnd,"Kein 16-Bit (15-Bit) HiColor eingestellt","Multi-Decode",MB_ICONSTOP|MB_OK);
						     return(TRUE);
						}
                           OldMode=IDM_INTERN_SURFACE;
						   Stop_Thread();
						   Set_Capture(4);
						   if (( ColourFormat == 2 ) || ( ColourFormat == 3 )) {
							   if ( WTVBPP == 15 ) {
			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
								   ColourFormat=3;
								   S_ColourFormat= ColourFormat;
			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
								   SetColourFormat(ColourFormat);
							   }
							   if ( WTVBPP == 16 ) {
			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
								   ColourFormat=2;
                                   S_ColourFormat= ColourFormat;
								   CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
								   SetColourFormat(ColourFormat);
							   }
						   }
                           Flip=0;
						   ModeOverlay=FALSE;
						   ModeRAWSurface=FALSE;
						   ModeRAWOverlay=FALSE;
						   OutDib=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;



		 case IDM_DIB:
			               OldMode=IDM_DIB;
                           Stop_Thread();
					       Sleep(10); 
						   Set_Capture(4);
						   if ( ColourFormat == 2 ) {
			   		               CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
								   ColourFormat=3;
                                   S_ColourFormat= ColourFormat;
								   CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
								   SetColourFormat(ColourFormat);
						   }
						   Flip=1;
						   OutDib=TRUE;
						   ModeOverlay=FALSE;
						   ModeRAWSurface=FALSE;
						   ModeRAWOverlay=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;

         case IDM_DX_OV_STRECH:
                           Stop_Thread();
						   Set_Capture(4);
						  if ( USE_DX_OV_STRECH == TRUE ) {
						   USE_DX_OV_STRECH=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_DX_OV_STRECH, MF_UNCHECKED );
						  } else {
						   USE_DX_OV_STRECH=TRUE;
						   CheckMenuItem( GetMenu(hWnd), IDM_DX_OV_STRECH, MF_CHECKED );
						  }
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;

         case IDM_COLORMIXER:
			              Save_Mode();
						  DialogBox(hInst,"FARBMIXER",hWnd,ColorSettingProc);
						  Restore_Mode();
                          break;


         case  IDM_AUDIO_MIXER:
			              Save_Mode();
						  DialogBox(hInst,"MIXERSETUP",hWnd,MixerSetupProc);
						  Restore_Mode();
                          break;


         case IDM_COLORMIX:
                           Stop_Thread();
						   Set_Capture(4);
						   if ( ColorMix == FALSE ) {
						    CheckMenuItem( GetMenu(hWnd), IDM_COLORMIX, MF_CHECKED );
                            ColorMix=TRUE;
                            Init_Screen_Struct();
 			                Set_Capture(5);
							   break;
						   } 
						    CheckMenuItem( GetMenu(hWnd), IDM_COLORMIX, MF_UNCHECKED );
                            ColorMix=FALSE;
                            Init_Screen_Struct();
 			                Set_Capture(5);
							break;

         case IDM_HALFMODE:
                           Stop_Thread();
						   Set_Capture(4);
						   if ( HalfTVMode == FALSE ) {
						    CheckMenuItem( GetMenu(hWnd), IDM_HALFMODE, MF_CHECKED );
                            HalfTVMode=TRUE;
                            Init_Screen_Struct();
 			                Set_Capture(5);
							   break;
						   } 
						    CheckMenuItem( GetMenu(hWnd), IDM_HALFMODE, MF_UNCHECKED );
                            HalfTVMode=FALSE;
                            Init_Screen_Struct();
 			                Set_Capture(5);
							break;

		 case IDM_DX_AUSTAST:
                           Stop_Thread();
						   Set_Capture(4);
						  if ( WAIT_DX_VBI == TRUE ) {
						   WAIT_DX_VBI=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_DX_AUSTAST, MF_UNCHECKED );
						  } else {
						   WAIT_DX_VBI=TRUE;
						   CheckMenuItem( GetMenu(hWnd), IDM_DX_AUSTAST, MF_CHECKED );
						  }
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;

		 case IDM_DX_LOCK:
                           Stop_Thread();
						   Set_Capture(4);
						  if ( USE_DX_LOCK == TRUE ) {
						   USE_DX_LOCK=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_DX_LOCK, MF_UNCHECKED );
						  } else {
						   USE_DX_LOCK=TRUE;
						   CheckMenuItem( GetMenu(hWnd), IDM_DX_LOCK, MF_CHECKED );
						  }
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;
						   
		 
		 
		 case IDM_STATUSBAR:
			             if ( Display_Status_Bar == TRUE ) {
							Stop_Thread();
							 
			               	  Display_Status_Bar=FALSE;
               		   	      Stop_Thread();
							  KillTimer(hWnd, 1);
							  
							  CheckMenuItem( GetMenu(hWnd), IDM_STATUSBAR, MF_UNCHECKED );
							  Set_Capture(4);
							  ShowWindow(Status_Bar,SW_HIDE);
							  Init_Screen_Struct();
        		              Set_Capture(5);
                              break;
						 };
                              Display_Status_Bar=TRUE;
               		   	      Stop_Thread();
        		              SetTimer (hWnd, 1, 2000, NULL);
							  CheckMenuItem( GetMenu(hWnd), IDM_STATUSBAR, MF_CHECKED );
							  Set_Capture(4);
							  ShowWindow(Status_Bar,SW_SHOW);
							  Init_Screen_Struct();
        		              Set_Capture(5);

							  break;
		 case IDM_ON_TOP:
						   Stop_Thread();
			               Set_Capture(4);
			               WStyle=GetWindowLong(hWnd,GWL_EXSTYLE);
						   if ( ALLWAYS_TOP ) {
							     WStyle=WStyle^8;
								 i=SetWindowLong(hWnd,GWL_EXSTYLE,WStyle);
								 ALLWAYS_TOP = FALSE ;
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
                                 CheckMenuItem( GetMenu(hWnd), IDM_ON_TOP, MF_UNCHECKED );
						   } else {
							     WStyle=WStyle|8;
								 i=SetWindowLong(hWnd,GWL_EXSTYLE,WStyle);
						         ALLWAYS_TOP = TRUE ;
                                 CheckMenuItem( GetMenu(hWnd), IDM_ON_TOP, MF_CHECKED );
								 SetWindowPos(hWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);

						   }
                           Init_Screen_Struct();
			               Set_Capture(5);
						   
			              break;

         case IDM_FENSTER: 
						   Stop_Thread();
			               Set_Capture(4);
						   if ( InitTV(hWnd,FALSE,CurrentX,CurrentY) == TRUE ) {
						   if ( ALLWAYS_TOP==FALSE ) {
							     WStyle=WStyle^8;
								 i=SetWindowLong(hWnd,GWL_EXSTYLE,WStyle);
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
						   } else {
							     WStyle=WStyle|8;
								 i=SetWindowLong(hWnd,GWL_EXSTYLE,WStyle);
                                 CheckMenuItem( GetMenu(hWnd), IDM_ON_TOP, MF_CHECKED );
						   }

						   WindowStyle=0;
						   CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );

						   } else  	MessageBox(hWnd,"Fehler beim Einstellen vom Bildschirmodus","Multi-Decode",MB_ICONSTOP|MB_OK);
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;

         case IDM_FENSTER768x576: 
						   Stop_Thread();
			               Set_Capture(4);
						   i=768;
						   j=576;
                           if ( Show_Menu == FALSE ) {
							                    i+=2*GetSystemMetrics(SM_CXSIZEFRAME);
												j+=GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYMENUSIZE)+(2*GetSystemMetrics(SM_CYSIZEFRAME))+2;
                                    			if ( Display_Status_Bar == TRUE ) j+=21;

						   };
						   if ( InitTV(hWnd,FALSE,CurrentX,CurrentY) == TRUE ) {
						   if ( ALLWAYS_TOP==FALSE ) {
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,i,j,SWP_NOMOVE|SWP_NOCOPYBITS);
						   } else {
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,i,j,SWP_NOMOVE|SWP_NOCOPYBITS);
						   }

						   WindowStyle=0;
						   CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );

						   } else  	MessageBox(hWnd,"Fehler beim Einstellen vom Bildschirmodus","Multi-Decode",MB_ICONSTOP|MB_OK);
                           Init_Screen_Struct();
			               Set_Capture(5);
						   break;

		 case IDM_640x480:
			               Stop_Thread();
			               Set_Capture(4);
						   SBTOK=BTOK;
						   BTOK=FALSE;
						   if (  InitTV(hWnd,TRUE,640,480) == TRUE ) {
                           MoveWindow(hWnd,0,0,640,480,TRUE);
						   WindowStyle=1;
						   CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );

                           } else {
							   	 InitTV(hWnd,FALSE,640,480);
                                 MoveWindow(hWnd,0,0,640,480,TRUE);
							     MessageBox(hWnd,"Fehler beim Einstellen vom Bildschirmodus","Multi-Decode",MB_ICONSTOP|MB_OK);
						   }
						   BTOK=SBTOK;
                           Init_Screen_Struct();
						   Set_Capture(5);
						   break;
	 
		 case IDM_800x600:

			               Stop_Thread();
						   Sleep(10);
			               Set_Capture(4);
						   SBTOK=BTOK;
						   BTOK=FALSE;
						   if (  InitTV(hWnd,TRUE,800,600) == TRUE ) {
                           MoveWindow(hWnd,0,0,800,600,TRUE); 
						   WindowStyle=2;
						   CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );
                           } else {
						      InitTV(hWnd,FALSE,640,480);
							  MoveWindow(hWnd,0,0,640,480,TRUE);
						   };
						   BTOK=SBTOK;
						   Init_Screen_Struct();
						   Set_Capture(5);
						   break;
		 case IDM_OWN_RES:
			               if (( Res_X==0 ) || ( Res_Y==0 )) return(TRUE);
			               Stop_Thread();
						   Sleep(10);
			               Set_Capture(4);
						   SBTOK=BTOK;
						   BTOK=FALSE;
						   if (  InitTV(hWnd,TRUE,Res_X,Res_Y) == TRUE ) {
                           MoveWindow(hWnd,0,0,Res_X,Res_Y,TRUE);
						   WindowStyle=3;
						   CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						   CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_CHECKED );

                           } else {
						      InitTV(hWnd,FALSE,640,480);
							  MoveWindow(hWnd,0,0,640,480,TRUE);
						   };
						   BTOK=SBTOK;
						   Init_Screen_Struct();
						   Set_Capture(5);
						   
						   break;

         case  IDM_LOW :
			               Save_Mode();
 			               DialogBox(hInst,"LOWVALUE",hWnd,(DLGPROC)LowSettingProc);
						   Restore_Mode();
						   break;

         case  IDM_SETUP_OWN_RES :
						   Save_Mode();
 			               DialogBox(hInst,"RESTYPE",hWnd,(DLGPROC)ResSettingProc);
						   Restore_Mode();
						   break;


         case IDM_COUNTRYSELECT_0:
         case IDM_COUNTRYSELECT_1:
         case IDM_COUNTRYSELECT_2:
         case IDM_COUNTRYSELECT_3:
         case IDM_COUNTRYSELECT_4:
         case IDM_COUNTRYSELECT_5:
         case IDM_COUNTRYSELECT_6:
         case IDM_COUNTRYSELECT_7:
         case IDM_COUNTRYSELECT_8:
         case IDM_COUNTRYSELECT_9:
         case IDM_COUNTRYSELECT_10:
         case IDM_COUNTRYSELECT_11:
         case IDM_COUNTRYSELECT_12:
         case IDM_COUNTRYSELECT_13:
         case IDM_COUNTRYSELECT_14:
         case IDM_COUNTRYSELECT_15:
         case IDM_COUNTRYSELECT_16:
         case IDM_COUNTRYSELECT_17:
         case IDM_COUNTRYSELECT_18:
         case IDM_COUNTRYSELECT_19:
         case IDM_COUNTRYSELECT_20:
         case IDM_COUNTRYSELECT_21:
         case IDM_COUNTRYSELECT_22:
         case IDM_COUNTRYSELECT_23:
         case IDM_COUNTRYSELECT_24:
         case IDM_COUNTRYSELECT_25:
         case IDM_COUNTRYSELECT_26:
         case IDM_COUNTRYSELECT_27:
         case IDM_COUNTRYSELECT_28:
         case IDM_COUNTRYSELECT_29:
         case IDM_COUNTRYSELECT_30:
         case IDM_COUNTRYSELECT_31:
         case IDM_COUNTRYSELECT_32:
         case IDM_COUNTRYSELECT_33:
         case IDM_COUNTRYSELECT_34:
						   CheckMenuItem( GetMenu(hWnd), CountryCode+5000, MF_UNCHECKED );
			               CountryCode=wParam-5000;
						   CheckMenuItem( GetMenu(hWnd), CountryCode+5000, MF_CHECKED );
                           Load_Country_Specific_Settings(CountryCode);
						   break;

         case IDM_CHANNEL_SEARCH:
                           Tuner_Scan(FALSE);
						   Write_Programm_List();
						   break;
         case IDM_FREQ_SEARCH:
                           Tuner_Scan(TRUE);
						   Write_Programm_List();
						   break;

         case IDM_DIGIIMPORT:
			               Save_Mode();
					       DialogBox(hInst,"DIGIIMPORT",hWnd,(DLGPROC)DigiImport);
						   Restore_Mode();
						   break;


         case IDM_KANAL_LISTE:
			               Save_Mode();
					       DialogBox(hInst,"KANALLISTE",hWnd,(DLGPROC)ProgrammListe);
						   Restore_Mode();
						   break;


         case IDM_TREADPRIOR_0:
		 case IDM_TREADPRIOR_1:
         case IDM_TREADPRIOR_2:
         case IDM_TREADPRIOR_3:
		 case IDM_TREADPRIOR_4:
						   CheckMenuItem( GetMenu(hWnd), ThreadClassId+1150, MF_UNCHECKED );
			               ThreadClassId=wParam-1150;
						   CheckMenuItem( GetMenu(hWnd), ThreadClassId+1150, MF_CHECKED );
						   Set_Capture(4);
                           Sleep(100);
						   Set_Capture(5);
						   break;


         case IDM_PRIORCLASS_0:
		 case IDM_PRIORCLASS_1:
         case IDM_PRIORCLASS_2:
						   CheckMenuItem( GetMenu(hWnd), PriorClassId+1160, MF_UNCHECKED );
			               PriorClassId=wParam-1160;
						   CheckMenuItem( GetMenu(hWnd), PriorClassId+1160, MF_CHECKED );
						   strcpy(Text, "Kann Prioritt nicht ndern");
						   if ( PriorClassId == 0 ) { 
                     	   if ( SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS) == TRUE	) strcpy(Text, "Normale Prioritt");
                           } else if ( PriorClassId == 1 ) { 
                     	   if ( SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS) == TRUE	) strcpy(Text, "Hohe Prioritt");
						   } else {
                     	   if ( SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS) == TRUE ) strcpy(Text, "RealTime Prioritt");
						   }
						   SetWindowText(hwndTextField,Text);
						   break;

		 case IDM_TUNER_4: 
			   CheckMenuItem( GetMenu(hWnd), TunerType+1100, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_EXTERN1, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_EXTERN2, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_EXTERN3, MF_UNCHECKED );
			   TunerType=wParam-1100;
			   CheckMenuItem( GetMenu(hWnd), TunerType+1100, MF_CHECKED );
			   Set_Capture(4);
			   VideoSource=0;
			   SetVideoSource(VideoSource);
			   Set_Capture(5);
              break;		       
		 
		 case IDM_TUNER_0: 
		 case IDM_TUNER_1: 
		 case IDM_TUNER_2: 
		 case IDM_TUNER_3: 
		 case IDM_TUNER_5: 
		 case IDM_TUNER_6:
		 case IDM_TUNER_7:
		 case IDM_TUNER_8:
                
			 if ( Current_Mode == 0 ) {
			   CheckMenuItem( GetMenu(hWnd), TunerType+1100, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_EXTERN1, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_EXTERN2, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_EXTERN3, MF_UNCHECKED );
			   
			   VideoSource=0;
			   TunerType=wParam-1100;
			   Set_Capture(4);
               Init_Tuner(TunerType);
			   SetVideoSource(VideoSource);
	      		 i=0;
               sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
			  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndKeyField,Text);

			   Set_Capture(5);

			   CheckMenuItem( GetMenu(hWnd), TunerType+1100, MF_CHECKED );
			 } else if ( Current_Mode == 1 ) {
				 CheckMenuItem( GetMenu(hWnd), DVBTuner+1100, MF_UNCHECKED );
				 DVBTuner=wParam-1100;
				 CheckMenuItem( GetMenu(hWnd), DVBTuner+1100, MF_CHECKED );
                 sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
    			  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndKeyField,Text);
			 }
				 break;

		 case IDM_TYPEFORMAT_0:
		 case IDM_TYPEFORMAT_1:
		 case IDM_TYPEFORMAT_2:
		 case IDM_TYPEFORMAT_3:
		 case IDM_TYPEFORMAT_4:
		 case IDM_TYPEFORMAT_5:
		 case IDM_TYPEFORMAT_6:
         case IDM_TYPEFORMAT_7:
					 CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_UNCHECKED );

					 if (( TVTYPE == 7 ) && (wParam-1120 != 7 )) {
						   Set_Capture(4);
						   VBI_Flags-=VBI_VD;        // STOP VD
                           Sleep(30);
                		   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VD, MF_UNCHECKED );
                           VBI_lpf=16;
						   MakeVBITable(VBI_lpf);
                           MakeVBITable2(VBI_lpf);
	                       MakeVBITable3(VBI_lpf);
	                       MakeVBITable4(VBI_lpf);
	                       MakeVBITable5(VBI_lpf);
						   TVTYPE=wParam-1120;
					       S_TVTYPE=TVTYPE;
			               CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
                           Init_Screen_Struct();
   	        		       Set_Capture(5);
						   break;
					 };

					 if (( TVTYPE != 7 ) && (wParam-1120 == 7 )) {
						   Set_Capture(4);
                           Sleep(30);
                           VBI_lpf=19;
						   MakeVBITable(VBI_lpf);
                           MakeVBITable2(VBI_lpf);
	                       MakeVBITable3(VBI_lpf);
	                       MakeVBITable4(VBI_lpf);
	                       MakeVBITable5(VBI_lpf);
						   TVTYPE=wParam-1120;
					       S_TVTYPE=TVTYPE;
			               CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
                           Init_Screen_Struct();
   	        		       Set_Capture(5);
						   break;
					 };

					 TVTYPE=wParam-1120;
					 S_TVTYPE=TVTYPE;
			         CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
					 Set_Capture(4);
                     Init_Screen_Struct();
   			         Set_Capture(5);
                     break; 

		 case IDM_COLORFORMAT_0:
		 case IDM_COLORFORMAT_1:
		 case IDM_COLORFORMAT_2:
		 case IDM_COLORFORMAT_3:
		 case IDM_COLORFORMAT_4:
		 case IDM_COLORFORMAT_5:
		 case IDM_COLORFORMAT_6:
		 case IDM_COLORFORMAT_7:
		 case IDM_COLORFORMAT_8:
		 case IDM_COLORFORMAT_9:
		 case IDM_COLORFORMAT_10:
		             CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_UNCHECKED );
			         ColourFormat=wParam-1130;
					 Set_Capture(4);
                     SetColourFormat(ColourFormat);
					 S_ColourFormat= ColourFormat;
					 Set_Capture(5);
					 CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
                     break; 


			 break ;
            }
			 break ;

        case WM_CREATE:
			          

			                  GetSystemInfo(&SysInfo);
			                  My_Heap=HeapCreate(0,SysInfo.dwPageSize,0);
			                  SetDlgItemText(SplashWnd,IDC_TEXT1,"Tabellenaufbau");
			                  SetDlgItemText(SplashWnd,IDC_TEXT2,"");
			                  SetDlgItemText(SplashWnd,IDC_TEXT3,"");
			                  SetDlgItemText(SplashWnd,IDC_TEXT4,"");
			                  SetDlgItemText(SplashWnd,IDC_TEXT5,"");
                              SetMenu(hWnd,hMenu);
							  Sleep(100);
                              SetDlgItemText(SplashWnd,IDC_TEXT2,"InterCast");
							  VTtoAscii[20]=0x34;
             		          for (i=0; i < 12; i++ ) UTPages[i]=0;
							  InterCast_Init();
							  Sleep(100);
                              SetDlgItemText(SplashWnd,IDC_TEXT3,"VideoText");
                             for ( i=0; i < 800 ; i++ ) {
               					 VTFrame[i].SubPage=NULL;
                                 VTFrame[i].SubCount=0;
							  };

							  VT_ChannelChange();
							  
							  for ( i = 0; i < MAXVTDIALOG; i++ ) VTDialog[i].Dialog=NULL;
                           
							  Load_Programm_List();
							  Load_Country_Settings();
                              VTScreen[0]=NULL;
							  // DIB-Bitmap VideoText erzeugen


						  
						   Setup_Coutry_Menu(GetMenu(hWnd));
                           Sleep(100);
                           SetDlgItemText(SplashWnd,IDC_TEXT4,"HQ-Farbe");
						   Init_HQTabelle();
						   Init_VC_HQTabelle();
                           

						   CheckMenuItem( GetMenu(hWnd), ThreadClassId+1150, MF_CHECKED );
						   CheckMenuItem( GetMenu(hWnd), PriorClassId+1160, MF_CHECKED );
					

                           if ( USE_MIXER == TRUE ) {
						      Sleep(100);
							  SetDlgItemText(SplashWnd,IDC_TEXT1,"Sound-System");
  						      SetDlgItemText(SplashWnd,IDC_TEXT2,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT3,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT4,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT5,"");
                             
							  Enumerate_Sound_SubSystem();
                              if ( SoundSystem.DeviceAnzahl == 0 ) {
								    SetDlgItemText(SplashWnd,TEXT3,"Kein Soundsystem gefunden");
							  } else {
								  if ( SoundSystem.DeviceAnzahl >= 1 ) SetDlgItemText(SplashWnd,TEXT3,SoundSystem.MixerDev[0].szPname);
								  if ( SoundSystem.DeviceAnzahl >= 2 ) SetDlgItemText(SplashWnd,TEXT4,SoundSystem.MixerDev[1].szPname);
								  if ( SoundSystem.DeviceAnzahl >= 3 ) SetDlgItemText(SplashWnd,TEXT5,SoundSystem.MixerDev[2].szPname);
								  Sleep(100);   
								  SetDlgItemText(SplashWnd,IDC_TEXT3,"");
								  SetDlgItemText(SplashWnd,IDC_TEXT4,"");
							      SetDlgItemText(SplashWnd,IDC_TEXT5,"");

							    if ( Volume.SoundSystem >= 0 ) sprintf(Text,"%s",SoundSystem.MixerDev[Volume.SoundSystem].szPname);
									 else if ( Mute.SoundSystem >= 0 ) sprintf(Text,"%s",SoundSystem.MixerDev[Mute.SoundSystem].szPname);
									   else sprintf(Text,"%s",SoundSystem.MixerDev[0].szPname);
                                 SetDlgItemText(SplashWnd,IDC_TEXT2,Text);
								
								if ( Volume.SoundSystem >= 0 ) sprintf(Text,"Volume -> %s",SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[Volume.Destination].MixerConnections[Volume.Connection].szName);
								 else sprintf(Text,"Volume nicht gesetzt");
								 SetDlgItemText(SplashWnd,IDC_TEXT3,Text);

								 if ( Mute.SoundSystem >= 0 ) sprintf(Text,"%s -> %s  %s",SoundSystem.To_Lines[Mute.SoundSystem].To_Connection[Mute.Destination].MixerConnections[Mute.Connection].szName,SoundSystem.To_Lines[Mute.SoundSystem].MixerLine[Mute.Destination].szName,SoundSystem.To_Lines[Mute.SoundSystem].To_Connection[Mute.Destination].To_Control[Mute.Connection].MixerControl[Mute.Control].szName);
								   else sprintf(Text,"Mute nicht gesetzt");
								   SetDlgItemText(SplashWnd,IDC_TEXT4,Text);



							   if ( MIXER_LINKER_KANAL == -1 ) Mixer_Get_Volume(&MIXER_LINKER_KANAL,&MIXER_RECHTER_KANAL);
     						  Mixer_Set_Defaults();
							  Get_Volume_Param();
							  Mixer_Set_Volume(MIXER_LINKER_KANAL,MIXER_RECHTER_KANAL);
							  };
						   }; 
  							  SetDlgItemText(SplashWnd,IDC_TEXT1,"Systemanalyse");
							  SetDlgItemText(SplashWnd,IDC_TEXT2,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT3,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT4,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT5,"");

							  Sleep(100);
							  sprintf(Text,"Prozessor %d ",SysInfo.dwProcessorType);
							  SetDlgItemText(SplashWnd,IDC_TEXT2,Text);
							  sprintf(Text,"Anzahl %d ",SysInfo.dwNumberOfProcessors);
							  SetDlgItemText(SplashWnd,IDC_TEXT3,Text);

                              if ( SysInfo.dwNumberOfProcessors > 1 ) {
								  if ( AusgabeProzessor == 0 ) {
									  if ( SysInfo.dwNumberOfProcessors == 2 ) {
                                        MainProzessor=0;
										IrqProzessor=0;
										VBIProzessor=0;
                                        AusgabeProzessor=1;
									  }
									  if ( SysInfo.dwNumberOfProcessors == 3 ) {
                                        MainProzessor=0;
										IrqProzessor=0;
										VBIProzessor=1;
                                        AusgabeProzessor=2;
									  }
									  if ( SysInfo.dwNumberOfProcessors > 3 ) {
                                        MainProzessor=0;
										IrqProzessor=1;
										VBIProzessor=2;
                                        AusgabeProzessor=3;
									  }

								  }

							  SetDlgItemText(SplashWnd,IDC_TEXT1,"Multi-Prozessor");
							  sprintf(Text,"Main-CPU %d ",MainProzessor);
							  SetDlgItemText(SplashWnd,IDC_TEXT2,Text);
							  sprintf(Text,"IRQ-CPU %d ",IrqProzessor);
							  SetDlgItemText(SplashWnd,IDC_TEXT3,Text);
							  sprintf(Text,"VBI-CPU %d ",VBIProzessor);
							  SetDlgItemText(SplashWnd,IDC_TEXT4,Text);
							  sprintf(Text,"DECODE-CPU %d ",AusgabeProzessor);
							  SetDlgItemText(SplashWnd,IDC_TEXT5,Text);
							  Sleep(100);
							  }

                              ProzessorMask=1<<(MainProzessor);
							  i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         
						  
							  SetDlgItemText(SplashWnd,IDC_TEXT1,"Hardwareanalyse");
							  SetDlgItemText(SplashWnd,IDC_TEXT2,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT3,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT4,"");
							  SetDlgItemText(SplashWnd,IDC_TEXT5,"");
							  Sleep(200);

				if ( WindowStyle == 0 ) {
							 CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_CHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );

							 InitTV(hWnd,FALSE,768,576);
				  } else if  ( WindowStyle == 1 ) {
							 CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_CHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );

							 InitTV(hWnd,TRUE,640,480);
				  } else if	( WindowStyle == 2 ) {
							 CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_CHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );
							 InitTV(hWnd,TRUE,800,600);
				  } else if	( WindowStyle == 3 ) {
							 CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						     CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_CHECKED );
				    		 if (  InitTV(hWnd,TRUE,Res_X,Res_Y) == FALSE) {
						        WindowStyle=0;
							    CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_CHECKED );
						        CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
						        CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
						        CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );
						        InitTV(hWnd,FALSE,640,480);
								MoveWindow(hWnd,0,0,640,480,TRUE);
						   };
				  };

				  
				  if ( WTVBPP == 0 ) EnableMenuItem(GetMenu(hWnd),IDM_INTERN_SURFACE,MF_GRAYED);
                   if ( Can_Overlay) {
					   EnableMenuItem(GetMenu(hWnd),IDM_OVERLAY,MF_ENABLED);
				       EnableMenuItem(GetMenu(hWnd),IDM_RAW_OVERLAY,MF_ENABLED);
					   if ( Can_Overlay_Strech == FALSE ) EnableMenuItem(GetMenu(hWnd),IDM_DX_OV_STRECH,MF_GRAYED);
					     else EnableMenuItem(GetMenu(hWnd),IDM_DX_OV_STRECH,MF_ENABLED);
				   } else {
					   EnableMenuItem(GetMenu(hWnd),IDM_OVERLAY,MF_GRAYED);
					   EnableMenuItem(GetMenu(hWnd),IDM_DX_OV_STRECH,MF_GRAYED);
				       EnableMenuItem(GetMenu(hWnd),IDM_RAW_OVERLAY,MF_GRAYED);
				   }
			       if ( bFilterBlueLines == TRUE )CheckMenuItem( GetMenu(hWnd), IDM_NOBLUELINES, MF_CHECKED );
				   if ( USE_DX_OV_STRECH == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_DX_OV_STRECH, MF_CHECKED );
				   if ( WAIT_DX_VBI == TRUE )  CheckMenuItem( GetMenu(hWnd), IDM_DX_AUSTAST, MF_CHECKED );
				   if ( USE_DX_LOCK == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_DX_LOCK, MF_CHECKED );
				   if ( ColorMix == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_COLORMIX, MF_CHECKED ); 
				   if ( HalfTVMode == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_HALFMODE, MF_CHECKED ); 
				   if ( Decode_AutoDetect == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_AUTODETECT, MF_CHECKED ); 
                   if (VBI_Flags&VBI_VT) {
					   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VT, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXTSMALL,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXT,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_VT_RESET,MF_ENABLED);
 	                    EnableMenuItem(GetMenu(hWnd),IDM_UNTERTITEL,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_PDC_OUT,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_ENABLED);
					   }
				   }
				   if (VBI_Flags&VBI_IC) {
					    CheckMenuItem( GetMenu(hWnd), IDM_VBI_IC, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_IC_OUT,MF_ENABLED);
				   }
                   }
						
				  if (VBI_Flags&VBI_VC) {
					   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VC, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_CRYPTSTATUS,MF_ENABLED);
				   }
                   }
				  if (VBI_Flags&VBI_VPS) {
					  CheckMenuItem( GetMenu(hWnd), IDM_VBI_VPS, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_VPS_OUT,MF_ENABLED);
				   }
                  }				   
					  
				   if ( Auto_MovieBoost == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_AUTOMB, MF_CHECKED ); 

				  if ( USECARD == FALSE ) CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH_CARD, MF_CHECKED ); 

     			 if ( USETUNER == FALSE ) {
                     TunerType=4;
					 VideoSource=0;
					 CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH, MF_CHECKED );
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_0,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_1,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_2,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_3,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_5,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_6,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_7,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_8,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNELPLUS,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNELMINUS,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNEL_SEARCH,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_FREQ_SEARCH,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNEL_SEARCH,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_MANUELL_TUNER,MF_GRAYED);
				 };
				  
				  Load_Country_Specific_Settings(CountryCode);
				  CheckMenuItem( GetMenu(hWnd), CountryCode+5000, MF_CHECKED );
				  CheckMenuItem( GetMenu(hWnd), CardType+1080, MF_CHECKED );
                  CheckMenuItem( GetMenu(hWnd), AudioSource+1110, MF_CHECKED );
				  S_TVTYPE=TVTYPE;
				  CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
				  S_ColourFormat= ColourFormat;
				  CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
                  if ( VideoSource > 0 ) CheckMenuItem( GetMenu(hWnd), VideoSource+1089, MF_CHECKED );
				  else {
					  CheckMenuItem( GetMenu(hWnd), TunerType+1100, MF_CHECKED );
				  }
				  CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
				  CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );



				  OldMode=IDM_DIB;
                  if ( ModeRAWSurface==TRUE ) {
                           Flip=0;
                           OldMode=IDM_RAW_SURFACE;
						   ModeOverlay=FALSE;
						   ModeRAWSurface=TRUE;
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_CHECKED );
						   OutDib=FALSE;
                  } else if ( ModeRAWOverlay==TRUE ) {
                           Flip=0;
                           OldMode=IDM_RAW_OVERLAY;
						   ModeRAWOverlay=TRUE;
						   ModeRAWSurface=FALSE;
						   CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_CHECKED );
						   OutDib=FALSE;
				  } else if ( OutDib==TRUE ) {
						   Flip=1;
						   CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_CHECKED );
    				} else if ( ModeOverlay == TRUE ) {
 					        OldMode=IDM_OVERLAY;
					        Flip=0;
						    CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_CHECKED );
				  } else {
 					        OldMode=IDM_INTERN_SURFACE;
						   Flip=0;
						    CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_CHECKED );
					  }

				 SetTimer (hWnd, 10, 5000, NULL);

				  PostMessage(hWnd,INIT_BT,0,0);
		break;


	  case INIT_BT:

		  MSPStatus[0]=0x00;
          HardWareFound=0;
          CurrentProgramm=InitialProg;
		  
		  if ( Init_TV_Karte(hWnd) == TRUE ) HardWareFound++;
		  if ( Init_DVB_Karte(hWnd) == TRUE ) HardWareFound++;

		  Init_Kernel_Memory();

		  if ( Has_BT == TRUE ) {
			 if ( Init_Memory() == FALSE ) {

                 for ( i=0; i < 800 ; i++ ) {
					 if ( VTFrame[i].SubPage != NULL  ) free(VTFrame[i].SubPage);
					 VTFrame[i].SubPage=NULL;
                     VTFrame[i].SubCount=0;
				 };
                
                InterCast_Exit();
				Exit_Mixer();

				Free_DMA(&Risc_dma); 
				Free_DMA(&Vbi_dma[0]);
				Free_DMA(&Vbi_dma[1]);
				Free_DMA(&Vbi_dma[2]);
				Free_DMA(&Vbi_dma[3]);
				Free_DMA(&Vbi_dma[4]);

				Free_Display_DMA(0);
				Free_Display_DMA(1);
				Free_Display_DMA(2);
				Free_Display_DMA(3);
				Free_Display_DMA(4);

				Free_DMA(&Burst_dma[0]);
				Free_DMA(&Burst_dma[1]);
				Free_DMA(&Burst_dma[2]);
				Free_DMA(&Burst_dma[3]);
				Free_DMA(&Burst_dma[4]);
				Free_Surface_DMA();
				BT_Close();
				Has_BT=FALSE;
				HardWareFound=0;
			 };
			 };

					 WStyle=GetWindowLong(hWnd,GWL_EXSTYLE);
					 if ( ALLWAYS_TOP == FALSE ) {
							     WStyle=WStyle^8;
								 i=SetWindowLong(hWnd,GWL_EXSTYLE,WStyle);
								 SetWindowPos(hWnd,HWND_NOTOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
                                 CheckMenuItem( GetMenu(hWnd), IDM_ON_TOP, MF_UNCHECKED );
						   } else {
							     WStyle=WStyle|8;
								 i=SetWindowLong(hWnd,GWL_EXSTYLE,WStyle);
                                 CheckMenuItem( GetMenu(hWnd), IDM_ON_TOP, MF_CHECKED );
								 SetWindowPos(hWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
						   }

                    		 dwDIB = sizeof(pDIB->bmiHeader);
							  hDIB = GlobalAlloc(GMEM_ZEROINIT | GMEM_MOVEABLE, dwDIB);
						      if(hDIB == NULL) {
									MessageBox(hWnd,"Couldn't GlobalAlloc DIB-Screen Memory","Multi-Decode",MB_ICONSTOP|MB_OK);
								return(FALSE);
								}

							  pDIB = (BITMAPINFO*)GlobalLock(hDIB);
							  if(pDIB == NULL)
									{
									MessageBox(hWnd,"Couldn't Lock DIB-Screen  Memory","Multi-Decode",MB_ICONSTOP|MB_OK);
									GlobalFree(hDIB);
									hDIB = NULL;
									return(FALSE);
				}	

		  if ( Has_BT == TRUE ) {							  
			 Init_BT_HardWare(hWnd);
			 sprintf(TunerStatus,"Kein Device am I2C-Bus");
			 if ( USETUNER == TRUE) {
			 sprintf(Text,"Kein Tuner");
    		 if ( Init_Tuner(TunerType) == TRUE ) {
			                  sprintf(Text,"Tuner OK");

			                  
			 }
			 SetDlgItemText(SplashWnd,IDC_TEXT4,Text);

             } else {
        		sprintf(TunerStatus,"Tuner soll nicht initialsiert werden");
				sprintf(Text,"Tuner deakt.");
      			SetDlgItemText(SplashWnd,IDC_TEXT4,Text);
			 }

			 if ( MSPStatus[0] == 0x00 ) {
			 sprintf(MSPStatus,"Kein Device am I2C-Bus");
			 sprintf(Text,"Kein MSP-Device");
			 if (  Init_Audio(0x80,0x81) == TRUE ) {
			                  sprintf(Text,"MSP-Device OK");
							  sprintf(MSPStatus,"MSP-Device I2C-Bus I/O 0x80/0x81");
			 } 
			 } else {
				 sprintf(Text,"MSP-Device OK");
			 }
			 SetDlgItemText(SplashWnd,IDC_TEXT5,Text);

             if ( Has_MSP == TRUE ) {
				   SetTimer(hWnd,8,10000,NULL);
			 if ( AutoStereoSelect == TRUE ) {
			      CheckMenuItem( GetMenu(hWnd), IDM_AUTOSTEREO, MF_CHECKED );
			 };
             };
             
			 if ( VideoSource == 1 ) sprintf(Text,"Extern 1");
			  else if ( VideoSource == 2 ) sprintf(Text,"Extern 2");
       			  else if ( VideoSource == 3 ) sprintf(Text,"Extern 3");
			  else {
			if (( CurrentProgramm >=0 ) && ( CurrentProgramm < MAXPROGS ))
                    sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
			  }; 

			  if ( Display_Status_Bar == TRUE ) SetWindowText (hwndKeyField,Text);
		  };


          if ( Has_DVB == TRUE ) {
			  SetDlgItemText(SplashWnd,IDC_TEXT1,"DVB-Hardware");
			  SetDlgItemText(SplashWnd,IDC_TEXT2,DVBTyp);
			  SetDlgItemText(SplashWnd,IDC_TEXT3,"");
			  SetDlgItemText(SplashWnd,IDC_TEXT4,"");
			  SetDlgItemText(SplashWnd,IDC_TEXT5,"");

			  if ( Has_DVB==TRUE ) {
			  if ( Init_DVB_HardWare() == TRUE ) {
			  GetDlgItemText(SplashWnd,IDC_TEXT2,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT1,Text1);
			  GetDlgItemText(SplashWnd,IDC_TEXT3,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT2,Text1);
			  GetDlgItemText(SplashWnd,IDC_TEXT4,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT3,Text1);
			  GetDlgItemText(SplashWnd,IDC_TEXT5,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT4,Text1);
              SetDlgItemText(SplashWnd,IDC_TEXT5,"DVB OK");
			  } else {
			  GetDlgItemText(SplashWnd,IDC_TEXT2,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT1,Text1);
			  GetDlgItemText(SplashWnd,IDC_TEXT3,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT2,Text1);
			  GetDlgItemText(SplashWnd,IDC_TEXT4,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT3,Text1);
			  GetDlgItemText(SplashWnd,IDC_TEXT5,Text1,64);
			  SetDlgItemText(SplashWnd,IDC_TEXT4,Text1);
              SetDlgItemText(SplashWnd,IDC_TEXT5,"DVB FAIL");
              Sleep(1000);
			  Has_DVB=FALSE;
			  HardWareFound--;
			  }
		  };
		  };
		  

		  if ( HardWareFound == 0 ) {
			  SetDlgItemText(SplashWnd,IDC_TEXT1,"");
			  SetDlgItemText(SplashWnd,IDC_TEXT2,"Keine");
			  SetDlgItemText(SplashWnd,IDC_TEXT3,"passende");
			  SetDlgItemText(SplashWnd,IDC_TEXT4,"Hardware");
			  SetDlgItemText(SplashWnd,IDC_TEXT5,"");
			  ExitTV();
			  Sleep(5000);
			  ExitThread(9);

		  }

		  
		if (!Alloc_Surface_DMA()) {
        MessageBox(hWnd,"Surface Memory knnen fr DMA nicht gelockt werden !! Surface deaktiviert !!","Multi-Decode",MB_ICONSTOP|MB_OK);
		ModeOverlay=FALSE;
		ModeRAWSurface=FALSE;
		CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_CHECKED );
	    OutDib=TRUE;
		Flip=1;
		WTVBPP = 0;
		CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_CHECKED );
		EnableMenuItem(GetMenu(hWnd),IDM_INTERN_SURFACE,MF_GRAYED);
		EnableMenuItem(GetMenu(hWnd),IDM_RAW_SURFACE,MF_GRAYED);

		}

          if ( Show_Menu == FALSE ) {
				     Show_Menu=TRUE;
					 SendMessage(hWnd,WM_COMMAND,IDM_TOGGLE_MENU,0);
			}		


		if (( Current_Mode == 1 ) && ( Has_DVB == FALSE )) Current_Mode=0;
		if (( Current_Mode == 0 ) && ( Has_BT == FALSE )) Current_Mode=1;

		if ( CurrentProgramm >= 0 ) {
				if ((Programm[CurrentProgramm].Typ == 'A' ) && ( Has_BT == TRUE )) Tuner_SetFrequency(TunerType,MulDiv(Programm[CurrentProgramm].freq*1000,16,1000000));
				    else if ((Programm[CurrentProgramm].Typ == 'D' ) && ( Has_DVB == TRUE )) Set_DVB_Channel(CurrentProgramm);
		};


		if (( Current_Mode == 1 ) && ( Has_DVB == TRUE )) {

			     CreateOSDWindow( 3, 0, 300, 180);
                 MoveWindowAbs(3,220,100);
                 SetFont( 3, 1, 1, 0);
                 WriteText( 3, 96, 60, "MultiDec");
				 SetFont( 3, 3, 7, 4);
				 WriteText( 3, 110, 100, "DVB");
				 SetTimer(hWnd,203,5000,NULL);
                 Stop_Thread();
                 DestroyMenu(hMenu);
				 hMenu=LoadMenu(hInst,"DIGITALMENU");
                 if ( Show_Menu == TRUE ) SetMenu(hWnd,hMenu);
				 DestroyAcceleratorTable(hAccel);
				 hAccel = LoadAccelerators (hInst, "DIGITALACCEL");
			     SetMenuDigital();
   				 DOSIZE=TRUE;
				 // Digital  // 2 Screens-Buffer
              	for ( i=0; i < 2 ; i++ ) {
                   pDisplay[i]=DVB_Display_dma[i]->pUserAddr;
				}
                 Init_Screen_Struct();
				 Run_DVB_Irq(TRUE);
				 Set_Capture(5);
		} else if (( Current_Mode == 0 ) && ( Has_BT == TRUE )) {
                 Stop_Thread();
                 DestroyMenu(hMenu);
				 hMenu=LoadMenu(hInst,"ANALOGMENU");
                 if ( Show_Menu == TRUE ) SetMenu(hWnd,hMenu);
				 DestroyAcceleratorTable(hAccel);
				 hAccel = LoadAccelerators (hInst, "ANALOGACCEL");
			     SetMenuAnalog();
				 DOSIZE=TRUE;
				 for ( i=0; i < 5 ; i++ ) {
                       pDisplay[i]=Display_dma[i]->pUserAddr;
					}

                 Init_Screen_Struct();
				 Run_BT_Irq(TRUE);
				 Set_Capture(5);
			     Sleep(100);
             	 SetAudioSource(AudioSource);

			 };		
		

		SetTimer (hWnd, 1, 2500, NULL);
			

		   return(TRUE);
 	  case WM_LBUTTONUP:
             
		  if ( MoveXDist == -1 ) {
               PostMessage(hWnd,WM_COMMAND,IDM_TOGGLE_MENU,0);
		  }
		     MoveXDist=-1;
			 MoveYDist=-1;

			 break;

      case WM_MOUSEMOVE:
                  if ( wParam == MK_LBUTTON ) 
			  {

				  if (( MoveXDist==-1 ) && ( MoveYDist==-1)) { 
  				      GetWindowRect(hWnd,&rectscreen);
					  MoveXDist = LOWORD(lParam);  // horizontal position of cursor 
                      MoveYDist = HIWORD(lParam);  
					  emsizex=rectscreen.right-rectscreen.left;
					  emsizey=rectscreen.bottom-rectscreen.top;

				  } else {
                		 	
					     MoveWindow(hWnd,rectscreen.left-(MoveXDist-LOWORD(lParam)),rectscreen.top-(MoveYDist-HIWORD(lParam)),emsizex,emsizey,TRUE);
					  }
              }
			  break;

		  
      case WM_MENUSELECT:

		  if ( HIWORD(wParam) == 0xffff ) {
			               Restore_Mode();
		                   break; 
		  }

		  if ( HIWORD(wParam) & MF_POPUP  ) {
			               Save_Mode();
		  }
		  break;

	  case WM_RBUTTONUP:
		    CShowCursor=!CShowCursor;
		    i=ShowCursor(CShowCursor);
			break;

	  case WM_TIMER:
          if ( wParam >= 200 ) {
			   KillTimer(hWnd,wParam);
			   DestroyOSDWindow(wParam-200);
               return(TRUE);
		  };
               
	  
		  if (( Has_BT == TRUE ) && ( Current_Mode==0 )) {
		  ResetIrq++;
	      if (( Capture_VBI == FALSE ) && (( ModeRAWSurface == TRUE ) || ( ModeRAWOverlay == TRUE ))) ResetIrq=0;
		  if (( ResetIrq > 4 ) && (( Capture_Video == TRUE ) || (Capture_VBI == TRUE ))) {

			  Reset_BT_HardWare();
			  ResetIrq=0;
		  } 

		  if ( wParam == 8 ) {
              if ( Display_Status_Bar == TRUE ) MSP_Print_Mode();
			  if ( AutoStereoSelect == TRUE ) MSPWatch_Mode();
              return(TRUE);
		  }
		  } else ResetIrq=0;

		  if  ( wParam == 10 ) {
			  if ( DecodeNagra == FALSE) {
		            if (( AutoMovieBoostEnable==TRUE ) && ( MovieBoost != 0 )) {
            		MoreLinesLock=FALSE;
					Stop_Thread();
		            MovieBoost = 0;
		            AutoMovieBoostEnable=FALSE;
		            Start_Thread();
					}
			  } else {
	      if (Auto_MovieBoost==TRUE) {
			  i=G_Wert(MatrixLinesEven,MatrixLinesOdd);
			  if ((i > 6 ) && ( MovieBoost != i) && (MoreLinesLock == TRUE )) {

			       Stop_Thread();
				   MovieBoost=i;
                   AutoMovieBoostEnable=TRUE;
				   Start_Thread();
					}
				};
			  };
          };

		  if ( wParam == 1 ) {
		if (( Has_BT == TRUE ) && ( Current_Mode==0 )) {	 
		  if (!VideoPresent() ) {
			     SetWindowText(hwndTextField," Kein Videosignal gefunden");
				 return(TRUE);
		  };
		};
		if (( Has_DVB == TRUE ) && ( Current_Mode==1 )) {	 
		  if (!DVBVideoPresent() ) {
			     SetWindowText(hwndTextField," Kein DigitalSignal gefunden");
				 return(TRUE);
		  } else {
			     SetWindowText(hwndTextField,Programm[CurrentProgramm].Name);
		  }
		    sprintf(Text,"V-Pid %04x  A-Pid %04x",Programm[CurrentProgramm].video_pid,Programm[CurrentProgramm].audio_pid);
          	SetWindowText(hwndPalField,Text);
		};

		if ( Current_Mode == 0 ) {
		      Text[0]=0x00;
			  if ( Packet30.Identifier[0] != 0x00 ) {
                   sprintf(Text,"%s ",Packet30.Identifier);
				   Packet30.Identifier[0]=0x00;
			  } else if ( VPS_lastname[0] != 0x00 ) {
				  sprintf(Text,"%s ",VPS_lastname);
				  VPS_lastname[0] = 0x00; 
			  }

			  strcpy(Text1,Text);

			  if ( DecodeNagra == TRUE ) {

			  if ( NagraFullField == TRUE) {
					strcat(Text," FF ");
					
			  }else {
					strcat(Text," HF ");

			  };
			  
			  sprintf(Text1,"%s %dTZ",Text,MasterTestzeilen);
			  }
			  
			if ( System_In_Mute == TRUE ) sprintf(Text1,"Volume Mute");
				SetWindowText(hwndTextField,Text1);
                Text[0]=0x00;
                PalFormat=( nPALplusData & FORMAT_MASK );

                switch(PalFormat)
				{
                case FORMAT_14_9:
					          strcpy(Text,"PalPlus 14:9");
                              break;

                 case FORMAT_16_9:
					          strcpy(Text,"PalPlus 16:9");
							  break;
				 case FORMAT_4_3:
 					          strcpy(Text,"PalPlus 4:3");
                              break;
				}

				if ( DecodeNagra == FALSE ) {
			if ( Decode_AutoDetect == TRUE ) {
				    strcat(Text," Dek. automatisch ");
			  }else {
					strcat(Text," Dek. manuell ");

			  };
               if ( HalfTVMode == TRUE ) strcat(Text," Halbbild");
				}
   
    

	if ( DecodeDecoderVCrypt == TRUE ) {
  	    if ( MoreLinesLock == FALSE ) strcat(Text," VC-Decoder AutoSync");
          else strcat(Text," VC-Decoder Irq-Lock");
	}

	
	if ( DecodeNagra == TRUE ) {
		     if ( FirstWidthEven == TESTPIXEL ) {
		        if (Line0BlackEven) strcat(Text,"E0");
			 } else {
			   if (Line0BlackEven) {
				  sprintf(Text1,"+HE(%d)",FirstWidthEven);
                  strcat(Text,Text1);
			   }
			 }
		  if ( MatrixModeEven == TRUE )  {
			 sprintf(Text1,"+ME %d",MatrixLinesEven);
			 strcat(Text,Text1);
		  } else { 
		     if (Line1BlackEven) strcat(Text,"+E1");
 		     if (Line285BlackEven) strcat(Text,"+E285");
		     if (Line286BlackEven) strcat(Text,"+E286");
		  }

		  if ( FirstWidthOdd == TESTPIXEL ) {
		     if (Line0BlackOdd) strcat(Text,"+O0");
		  } else {
			 if (Line0BlackOdd) {
				sprintf(Text1,"+HO(%d)",FirstWidthOdd);
                strcat(Text,Text1);
			 }
		  };
	      if ( MatrixModeOdd == TRUE )  {
			 sprintf(Text1,"+MO %d",MatrixLinesOdd);
			 strcat(Text,Text1);
		  } else {
			 if (Line1BlackOdd) strcat(Text,"+O1");
			 if (Line285BlackOdd) strcat(Text,"+O285");
			 if (Line286BlackOdd) strcat(Text,"+O286");
		  }
	 

		  if ( MoreLinesLock == FALSE ) {
			 if ( NagraFullField == TRUE ) sprintf(Text1,"(Stab) (%d/%d)",FirstWidthEven,FirstWidthOdd);
             else sprintf(Text1,"(Stab) (%d)",FirstWidthEven);
			 strcat(Text,Text1);
		  } else strcat(Text,"  (Lock)");
	};

	SetWindowText(hwndPalField,Text);
};


if ( Current_Mode == 1 ) {
// Wei nich nicht was !!!

			  }


	return(TRUE);
		  };

		  if ( wParam == 99 ) {
			  KillTimer(hWnd,99);
              i=atoi(ChannelString);
			  ChannelString[0]=0x00;
			  i=i-1;
			   if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetAudioSource(4);
			   if (( Has_DVB == TRUE ) && ( Current_Mode == 1 )) DVB_SetVolume((unsigned char)0, (unsigned char)0);
			   
			   if (( i >= 0 ) && ( i < MAXPROGS ))  {

                if (( Programm[i].freq != 0  ) && (ValidModes(Programm[i].Typ) == TRUE  )) {
			               CurrentProgramm=i;
						if (( Current_Mode == 0 ) && ( Programm[CurrentProgramm].Typ == 'D' )) Set_Mode_Digital();
				           else if (( Current_Mode == 1 ) && ( Programm[CurrentProgramm].Typ == 'A' )) Set_Mode_Analog();
                      
						   if (Programm[CurrentProgramm].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(Programm[CurrentProgramm].freq*1000,16,1000000));
				               else Set_DVB_Channel(CurrentProgramm);
				 if ( Display_Status_Bar == TRUE ) {
                   	   sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
	                   SetWindowText (hwndKeyField,Text);
					}
	
				}
				   
				   
				   VT_ChannelChange();
				   Sleep(20);
                   if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetAudioSource(AudioSource);
			        if (( Has_DVB == TRUE ) && ( Current_Mode == 1 )) DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
			   }



		  };
			return(TRUE);

        case WM_SYSCOMMAND:  //            Verhindern vom ScreenSaver 
                 switch(wParam&0xFFF0)
				 {
				case SC_SCREENSAVE:
				case SC_MONITORPOWER:
				return 0;
				break;
				}

        case WM_SIZE:
        case WM_MOVE:

			 GetClientRect(hWnd, &rectscreen);
             ClientToScreen(hWnd, (POINT*)&rectscreen.left);
             ClientToScreen(hWnd, (POINT*)&rectscreen.right);
             
			 if ( (LastRect.top != rectscreen.top ) ||
                  (LastRect.bottom != rectscreen.bottom ) ||
				  (LastRect.left != rectscreen.left ) ||
				  (LastRect.right != rectscreen.right ))  {
            
              AdjustStatusBar (hWnd);
			  if ( DOSIZE == TRUE ) {

				  Stop_Thread();
				  if ( CurrentCapture != 0 ) {
				  Set_Capture(4);
                  Init_Screen_Struct();
				  Set_Capture(5);
			  } else  Init_Screen_Struct();
  			 LastRect.top=rectscreen.top;
			 LastRect.bottom=rectscreen.bottom;
			 LastRect.left=rectscreen.left;
			 LastRect.right=rectscreen.right;
			  };
			  };			  

			 break;

		case WM_CHAR:
			if ( ((char) wParam  >= '0' ) && ((char) wParam  <= '9' )) {
				      sprintf(Text,"%c",wParam);
				      strcat(ChannelString, Text); 
					  if ( strlen(ChannelString) >= 4 ) SetTimer(hWnd,99,100,NULL);
                      SetTimer(hWnd,99,1000,NULL);
			}

			    break;

		case WM_QUERYENDSESSION:
        case WM_DESTROY:
			    
			    Stop_Thread();
				Write_INI("Multidec.ini");
                
				if ( Has_BT == TRUE ) {
        		Stop_VBI();
				SetAudioSource(4);
	            Set_Capture(4);
				};

				Sleep(100);
  				Free_Nagra_Decoding();
				Exit_Mixer();
				InterCast_Exit();
                VideoDat_Exit();

                 for ( i=0; i < 800 ; i++ ) {
					 if ( VTFrame[i].SubPage != NULL  ) free(VTFrame[i].SubPage);
					 VTFrame[i].SubPage=NULL;
                     VTFrame[i].SubCount=0;
				 };
				Free_DMA(&Risc_dma); 
				Free_DMA(&Vbi_dma[0]);
				Free_DMA(&Vbi_dma[1]);
				Free_DMA(&Vbi_dma[2]);
				Free_DMA(&Vbi_dma[3]);
				Free_DMA(&Vbi_dma[4]);

				Free_Display_DMA(0);
				Free_Display_DMA(1);
				Free_Display_DMA(2);
				Free_Display_DMA(3);
				Free_Display_DMA(4);

				Free_DMA(&Burst_dma[0]);
				Free_DMA(&Burst_dma[1]);
				Free_DMA(&Burst_dma[2]);
				Free_DMA(&Burst_dma[3]);
				Free_DMA(&Burst_dma[4]);
				Free_Surface_DMA();
				  Free_SAA7146_DMA(&debi_mem_dma);
	              Free_DVB_Display_DMA(0);
	              Free_DVB_Display_DMA(1);
				  Free_SAA7146_DMA(&rps0_mem_dma);

				if ( pDecode != NULL ) {
 				    free(pDecode);
					pDecode=NULL;
			 };                     
                if(hDIB != NULL)
				{
                     GlobalUnlock(hDIB);
                     GlobalFree(hDIB);
                     hDIB = NULL;
                     pDIB = NULL;
         }

            for ( i = 0; i < MAXVTDIALOG ; i++ ) {				  
	        free(VTScreen[i]);
            };

			ExitTV();
            
            PostQuitMessage(0);
            return(TRUE);

	}

return(DefWindowProc(hWnd,message,wParam,lParam));
}


void RGBOutThread( void  ) 
{

int   DP;
int   MBoost;
DOUBLE YStep,YSum;   
int i,j;
int nZeileZiel;
int CurrentFrame;
DDSURFACEDESC	ddsd;
HRESULT		    ddrval;


ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         


if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

ddsd.dwSize=sizeof( ddsd );

dwLastCount=GetTickCount();
nFrame=0;
for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < CurrentY ; i+=2 ) {
       pLinesAddressOdd[(j*CLEARLINES)+(i/2)] = (short *)pDisplay[j]+(i*CurrentX)+CurrentX;
       pLinesAddressEven[(j*CLEARLINES)+(i/2)] = (short *)pDisplay[j]+(i*CurrentX);
}
}


MBoost=(int)(((double)MovieBoost/288)*CurrentY/2);

YStep=(double)MaxY/(CurrentY-(MovieScale*4));
YSum=0.0;
ShowY=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
    LinesOutEven[nZeileZiel]=0;
    LinesOutOdd[nZeileZiel]=0;
}

for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};

	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutOdd[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=1;
      else LinesOutOdd[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=2;
      else LinesOutOdd[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=3;
      else LinesOutOdd[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=4;
      else LinesOutOdd[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};
};


if ( OutDib == TRUE ) {
DP=DibPitch/2;
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];

};



for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;

	for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

	if ( LinesOutEven[nZeileZiel] > 0 ) {
		if ( LinesOutEven[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*3),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
	}

	if ( LinesOutOdd[nZeileZiel] > 0 ) {
		if ( LinesOutOdd[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutOdd[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutOdd[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*2),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*2),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*3),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
   }
}	

	SetDIBitsToDevice( DIB_Hdc,
                      0,
                      0,
                      pDIB->bmiHeader.biWidth,
                      pDIB->bmiHeader.biHeight,
                      0,
                      0,
                      0,
                      pDIB->bmiHeader.biHeight,
                      pDecode,
                      pDIB,
                      DIB_RGB_COLORS
                    );

if ( Display_Status_Bar == TRUE ) {
      if(dwLastCount+960 <= GetTickCount())
      {
	   sprintf(Text,"%d FPS",nFrame);
	   SetWindowText (hwndFPSField,Text);
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
}
}
}

DP=SurfacePitch/2;
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];
};

if ( WTVBPP==16) {


for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    if ( WAIT_DX_VBI ) ddrval=IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(lpDDSurface, NULL, &ddsd, DDLOCK_WAIT, NULL);
   		 for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

		if ( LinesOutEven[nZeileZiel] > 0 ) {
		if ( LinesOutEven[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*3),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
	}

	if ( LinesOutOdd[nZeileZiel] > 0 ) {
		if ( LinesOutOdd[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutOdd[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutOdd[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*2),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*2),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*3),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
   }
}

		 if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(lpDDSurface,  ddsd.lpSurface);

	if ( Display_Status_Bar == TRUE ) {
       if(dwLastCount+960 <= GetTickCount()) {

		  sprintf(Text,"%d FPS",nFrame);
	      SetWindowText (hwndFPSField,Text);
	      nFrame=0;
          dwLastCount = GetTickCount();
	  }
	}
}
}

for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    if ( WAIT_DX_VBI ) ddrval=IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(lpDDSurface, NULL, &ddsd, DDLOCK_WAIT, NULL);
   		 for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

			 
	if ( LinesOutEven[nZeileZiel] > 0 ) {
		if ( LinesOutEven[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*3),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
	}

	if ( LinesOutOdd[nZeileZiel] > 0 ) {
		if ( LinesOutOdd[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutOdd[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutOdd[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*2),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressOdd[nZeileZiel],pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*2),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressOdd[nZeileZiel]+DP*3),pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
   }

}	
		 if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(lpDDSurface,  ddsd.lpSurface);

	if ( Display_Status_Bar == TRUE  ) {
       if(dwLastCount+960 <= GetTickCount()) {
		  sprintf(Text,"%d FPS",nFrame);
	      SetWindowText (hwndFPSField,Text);
	      nFrame=0;
          dwLastCount = GetTickCount();
	  }
	}
}

}


void RGBOutThreadHalf( void  ) 
{


int   DP;
int   MBoost;
DOUBLE YStep,YSum;   
int i,j;
int nZeileZiel;
int CurrentFrame;
DDSURFACEDESC	ddsd;
HRESULT		    ddrval;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         


if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

ddsd.dwSize=sizeof( ddsd );

dwLastCount=GetTickCount();
nFrame=0;
for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < 288 ; i++) {
       pLinesAddressEven[(j*CLEARLINES)+i] = (short *)pDisplay[j]+(i*CurrentX);
}
}


MBoost=(int)(((double)MovieBoost/288)*CurrentY/2);

YStep=(double)MaxY/((CurrentY/2)-(MovieScale*2));
YSum=0.0;
ShowY=0;
for ( nZeileZiel=0; nZeileZiel < 288; nZeileZiel++ ) LinesOutEven[nZeileZiel]=0;
 

for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};
};


if ( OutDib == TRUE ) {
DP=DibPitch/2;
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
};



for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;

	for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

	if ( LinesOutEven[nZeileZiel] > 0 ) {
		if ( LinesOutEven[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*3),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
	}

}	

	SetDIBitsToDevice( DIB_Hdc,
                      0,
                      0,
                      pDIB->bmiHeader.biWidth,
                      pDIB->bmiHeader.biHeight,
                      0,
                      0,
                      0,
                      pDIB->bmiHeader.biHeight,
                      pDecode,
                      pDIB,
                      DIB_RGB_COLORS
                    );

if ( Display_Status_Bar == TRUE ) {
      if(dwLastCount+960 <= GetTickCount())
      {
	   sprintf(Text,"%d FPS",nFrame);
	   SetWindowText (hwndFPSField,Text);
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
}
}
}

DP=SurfacePitch/2;
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
};

if ( WTVBPP==16) {


for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    if ( WAIT_DX_VBI ) ddrval=IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(lpDDSurface, NULL, &ddsd, DDLOCK_WAIT, NULL);
   		 for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

		if ( LinesOutEven[nZeileZiel] > 0 ) {
		if ( LinesOutEven[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*3),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
	}

}

		 if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(lpDDSurface,  ddsd.lpSurface);

	if ( Display_Status_Bar == TRUE  ) {
       if(dwLastCount+960 <= GetTickCount()) {
		  sprintf(Text,"%d FPS",nFrame);
	      SetWindowText (hwndFPSField,Text);
	      nFrame=0;
          dwLastCount = GetTickCount();
	  }
	}
}
}

for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    if ( WAIT_DX_VBI ) ddrval=IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(lpDDSurface, NULL, &ddsd, DDLOCK_WAIT, NULL);
   		 for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

			 
	if ( LinesOutEven[nZeileZiel] > 0 ) {
		if ( LinesOutEven[nZeileZiel] == 1 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 2 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else if ( LinesOutEven[nZeileZiel] == 3 ) {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		} else {
			memcpy(pLinesDstAddressEven[nZeileZiel],pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*2),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
			memcpy((pLinesDstAddressEven[nZeileZiel]+DP*3),pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], CurrentX*2);
		}
	}

}	
		 if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(lpDDSurface,  ddsd.lpSurface);

	if ( Display_Status_Bar == TRUE ) {
       if(dwLastCount+960 <= GetTickCount()) {
		  sprintf(Text,"%d FPS",nFrame);
	      SetWindowText (hwndFPSField,Text);
	      nFrame=0;
          dwLastCount = GetTickCount();
	  }
	}
}

}



void YUVOutThread() 
{
char Text[128];
LPDIRECTDRAWSURFACE *lpDDOut;
int   MBoost;
DOUBLE YStep,YSum;   
int i,j;
int nZeileZiel;
int CurrentFrame;
DDSURFACEDESC	ddsd;
HRESULT		    ddrval;
short *pQuelle;
FARPROC Call_Ausgabe;
FARPROC Call_Fill;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         

if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

if ( ColorMix == TRUE ) {
if ( OutDib == TRUE ) {
	Init_HCYUV2RGBTabelle(TRUE);
} else {
	if ( WTVBPP==16) Init_HCYUV2RGBTabelle(FALSE);
else Init_HCYUV2RGBTabelle(TRUE); 
}
};
	   
ddsd.dwSize=sizeof( ddsd );

dwLastCount=GetTickCount();
nFrame=0;
for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < CurrentY ; i+=2 ) {
       pLinesAddressOdd[(j*CLEARLINES)+(i/2)] = (short *)pDisplay[j]+(i*CurrentX)+CurrentX;
       pLinesAddressEven[(j*CLEARLINES)+(i/2)] = (short *)pDisplay[j]+(i*CurrentX);
}
}

MBoost=(int)(((double)MovieBoost/CLEARLINES)*CurrentY/2);
YStep=(double)MaxY/(CurrentY-(MovieScale*4));
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
    LinesOutEven[nZeileZiel]=0;
    LinesOutOdd[nZeileZiel]=0;
};

YSum=0.0;
ShowY=0;
for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};

	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutOdd[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=1;
      else LinesOutOdd[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=2;
      else LinesOutOdd[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=3;
      else LinesOutOdd[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutOdd[nZeileZiel]=4;
      else LinesOutOdd[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};


};
ColFaktor = &HQTabelle[312*4*4];

if ( OutDib == TRUE ) {
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];

};
CurrentPitch=DibPitch;
lpDDOut=&lpDDOverlay;
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB15DVB);
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;

} else if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( lpDDOverlay != NULL ))  {
ColorMix=FALSE;

	Black_Overlay();
	if (( Can_Overlay_Strech ) && ( USE_DX_OV_STRECH )) {
		for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
				if ( LinesOutEven[nZeileZiel] > 0 ) LinesOutEven[nZeileZiel]=1; 
				  else if ( LinesOutEven[nZeileZiel] < 0 ) LinesOutEven[nZeileZiel]=-1; 
		        if ( LinesOutOdd[nZeileZiel] > 0 ) LinesOutOdd[nZeileZiel]=1;
				   else if ( LinesOutOdd[nZeileZiel] < 0 ) LinesOutOdd[nZeileZiel]=-1;
        }
	}


j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];
}

CurrentPitch=OverlayPitch;
lpDDOut=&lpDDOverlay;

if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenYUV2);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenYUV2DVB);
Call_Fill=(FARPROC)(HQFillYUV2);
BytesOut=CurrentX*2;
} else {
for ( i=0; i < MaxY; i++ ) fill( (unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(i*(SurfacePitch/2)),CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];
};
CurrentPitch=SurfacePitch;
lpDDOut=&lpDDSurface;
if ( WTVBPP == 16 )  {
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB16);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB16DVB);
} else {
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB15DVB);
	}
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;
};

for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    FindePalPlusZeile(pLinesAddressEven[CurrentFrame*CLEARLINES],&nPALplusData);
    if ( OutDib == FALSE ) {
	 if ( WAIT_DX_VBI ) IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
     if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(*lpDDOut, NULL, &ddsd, DDLOCK_WAIT, NULL);
	};

	for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

 if ( ColorMix==TRUE ) {
	if ( LinesOutEven[nZeileZiel] == 1 ) HCZeileAusgeben((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentX);
      else if ( LinesOutEven[nZeileZiel] == 2 ) HCZeileAusgeben_2((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentPitch, CurrentX);
      else if ( LinesOutEven[nZeileZiel] == 3 ) HCZeileAusgeben_3((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentPitch, CurrentX);
	  else if ( LinesOutEven[nZeileZiel] == 4 ) HCZeileAusgeben_4((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentPitch, CurrentX);
 	if ( LinesOutOdd[nZeileZiel] == 1 ) HCZeileAusgeben((DWORD*)pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressOdd[nZeileZiel],CurrentX);
      else if ( LinesOutOdd[nZeileZiel] == 2 ) HCZeileAusgeben_2((DWORD*)pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressOdd[nZeileZiel],CurrentPitch,CurrentX);
      else if ( LinesOutOdd[nZeileZiel] == 3 ) HCZeileAusgeben_3((DWORD*)pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressOdd[nZeileZiel],CurrentPitch,CurrentX);
 	  else if ( LinesOutOdd[nZeileZiel] == 4 ) HCZeileAusgeben_4((DWORD*)pLinesAddressOdd[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressOdd[nZeileZiel],CurrentPitch, CurrentX);
		} else {
            LinesAnzahl=LinesOutEven[nZeileZiel];
            if ( LinesAnzahl == 0 ) {
 		    pQuelle=pLinesAddressEven[(CurrentFrame*CLEARLINES)+nZeileZiel];
            _asm {
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Fill
					call ebx
				};
			} else if (( LinesAnzahl >= 1 ) && ( LinesAnzahl < 5 )) {
		    pQuelle=pLinesAddressEven[(CurrentFrame*CLEARLINES)+nZeileZiel];
            TmpPtr=ZeilenPuffer;;
            ScreenPtr=pLinesDstAddressEven[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;
            _asm
				{
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Ausgabe
					call ebx
				};
			};
		
            LinesAnzahl=LinesOutOdd[nZeileZiel];
            if ( LinesAnzahl == 0 ) {
 		    pQuelle=pLinesAddressOdd[(CurrentFrame*CLEARLINES)+nZeileZiel];
            _asm {
					mov edi,dword ptr [HQLinebufferOddPtr];
					mov edx,pQuelle
					mov ebx,Call_Fill
					call ebx
				};
			} else if (( LinesAnzahl >= 1 ) && ( LinesAnzahl < 5 )) {
		    pQuelle=pLinesAddressOdd[(CurrentFrame*CLEARLINES)+nZeileZiel];
            TmpPtr=ZeilenPuffer;;
            ScreenPtr=pLinesDstAddressOdd[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;
            _asm
				{
					mov edi,dword ptr [HQLinebufferOddPtr];
					mov edx,pQuelle
					mov ebx,Call_Ausgabe
					call ebx
				};	
			};		

	};
	}
	if ( OutDib == FALSE ) {
		if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(*lpDDOut,  ddsd.lpSurface);
	} else SetDIBitsToDevice( DIB_Hdc,0,0,pDIB->bmiHeader.biWidth,ShowY,0,0,0,ShowY,pDecode,pDIB,DIB_RGB_COLORS);


	if ( Display_Status_Bar == TRUE  ) {
      if(dwLastCount+960 <= GetTickCount())
      {
		  sprintf(Text,"%d FPS",nFrame);
	   SetWindowText (hwndFPSField,Text);
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
	}
	}
};





void YUVOutThreadHalf() 
{
char Text[128];
LPDIRECTDRAWSURFACE *lpDDOut;
int   MBoost;
DOUBLE YStep,YSum;   
int i,j;
int nZeileZiel;
int CurrentFrame;
DDSURFACEDESC	ddsd;
HRESULT		    ddrval;
short *pQuelle;
FARPROC Call_Ausgabe;
FARPROC Call_Fill;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         

if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

if ( ColorMix == TRUE ) {
if ( OutDib == TRUE ) {
	Init_HCYUV2RGBTabelle(TRUE);
} else {
	if ( WTVBPP==16) Init_HCYUV2RGBTabelle(FALSE);
else Init_HCYUV2RGBTabelle(TRUE); 
}
};
	   
ddsd.dwSize=sizeof( ddsd );

dwLastCount=GetTickCount();
nFrame=0;

for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < 288; i++) {
       pLinesAddressEven[(j*CLEARLINES)+i] = (short *)pDisplay[j]+(i*CurrentX);
}
}

MBoost=(int)(((double)MovieBoost/CLEARLINES)*CurrentY/2);
YStep=(double)MaxY/(CurrentY/2-(MovieScale*2));
for ( nZeileZiel=0; nZeileZiel < 288; nZeileZiel++ )  LinesOutEven[nZeileZiel]=0;

YSum=0.0;
ShowY=0;
for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MBoost ) && ( nZeileZiel < CurrentY/2-MBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};


};


ColFaktor = &HQTabelle[312*4*4];

if ( OutDib == TRUE ) {
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
};

CurrentPitch=DibPitch;
lpDDOut=&lpDDOverlay;
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB16);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB16DVB);
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;

} else if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( lpDDOverlay != NULL ))  {
ColorMix=FALSE;
	Black_Overlay();
	if (( Can_Overlay_Strech ) && ( USE_DX_OV_STRECH )) {
		for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
				if ( LinesOutEven[nZeileZiel] > 0 ) LinesOutEven[nZeileZiel]=1; 
				  else if ( LinesOutEven[nZeileZiel] < 0 ) LinesOutEven[nZeileZiel]=-1; 
        }
	}
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
}
CurrentPitch=OverlayPitch;
lpDDOut=&lpDDOverlay;
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenYUV2);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenYUV2DVB);
Call_Fill=(FARPROC)(HQFillYUV2);
BytesOut=CurrentX*2;
} else {

for ( i=0; i < MaxY; i++ ) fill( (unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(i*(SurfacePitch/2)),CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
};
CurrentPitch=SurfacePitch;
lpDDOut=&lpDDSurface;
if ( WTVBPP == 16 ) {
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB16);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB16DVB);
} else {  
if ( Current_Mode == 0 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
else if ( Current_Mode == 1 ) Call_Ausgabe=(FARPROC)(HQAusgebenRGB15DVB);
}
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;
};

for (;;) {
    nFrame++;
	Get_Thread_Status();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    FindePalPlusZeile(pLinesAddressEven[CurrentFrame*CLEARLINES],&nPALplusData);
    if ( OutDib == FALSE ) {
	 if ( WAIT_DX_VBI ) IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
     if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(*lpDDOut, NULL, &ddsd, DDLOCK_WAIT, NULL);
	};

	for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {

 if ( ColorMix==TRUE ) {
	if ( LinesOutEven[nZeileZiel] == 1 ) HCZeileAusgeben((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentX);
      else if ( LinesOutEven[nZeileZiel] == 2 ) HCZeileAusgeben_2((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentPitch, CurrentX);
      else if ( LinesOutEven[nZeileZiel] == 3 ) HCZeileAusgeben_3((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentPitch, CurrentX);
	  else if ( LinesOutEven[nZeileZiel] == 4 ) HCZeileAusgeben_4((DWORD*)pLinesAddressEven[CurrentFrame*CLEARLINES+nZeileZiel], (DWORD*)pLinesDstAddressEven[nZeileZiel],CurrentPitch, CurrentX);
		} else {
            LinesAnzahl=LinesOutEven[nZeileZiel];
            if ( LinesAnzahl == 0 ) {
 		    pQuelle=pLinesAddressEven[(CurrentFrame*CLEARLINES)+nZeileZiel];
            _asm {
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Fill
					call ebx
				};
			} else if (( LinesAnzahl >= 1 ) && ( LinesAnzahl < 5 )) {
		    pQuelle=pLinesAddressEven[(CurrentFrame*CLEARLINES)+nZeileZiel];
            TmpPtr=ZeilenPuffer;;
            ScreenPtr=pLinesDstAddressEven[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;
            _asm
				{
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Ausgabe
					call ebx
				};
			};
		};		
	}
	if ( OutDib == FALSE ) {
		if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(*lpDDOut,  ddsd.lpSurface);
	} else SetDIBitsToDevice( DIB_Hdc,0,0,pDIB->bmiHeader.biWidth,ShowY,0,0,0,ShowY,pDecode,pDIB,DIB_RGB_COLORS);

	if ( Display_Status_Bar == TRUE  ) {
      if(dwLastCount+960 <= GetTickCount())
      {
		  sprintf(Text,"%d FPS",nFrame);
	   SetWindowText (hwndFPSField,Text);
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
	}
	}
};


void NagraYUVHalfOutThread(  ) 
{
    FILE *sFile;
    char Fname[50];

	LPDIRECTDRAWSURFACE *lpDDOut;
	int nZeileZiel   ;     
    int nZielInvers  ; 	
    int nZeileQuelle ; 	
    int nQuelleInvers; 	
    int Burst;
    DOUBLE YStep,YSum;   
	unsigned int i,j;
	DDSURFACEDESC	ddsd;
	HRESULT		    ddrval;
	short *pQuelle;
	FARPROC Call_Ausgabe;
	FARPROC Call_Fill;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         

if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);


ddsd.dwSize=sizeof( ddsd );

nPixelSchritt = CurrentX/TESTPIXEL/2;
fill(HQLinebufferEven,1480*4);
Init_More();

dwLastCount=GetTickCount();
nFrame=0;

for ( i = 0; i < ZEILENZAHL; i++) {
    BlackSet[i]=FALSE;
}


for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < CurrentY ; i+=2 ) {
    pLinesAddressEven[(j*ZEILENZAHL)+(i/2)] = (short *)pDisplay[j]+((i/2)*CurrentX);
}
}


YStep=(double)MaxY/(ZEILENZAHL-1-(MovieScale*2));
YSum=0.0;
ShowY=0;

for ( nZeileZiel=0; nZeileZiel < ZEILENZAHL; nZeileZiel++ ) {
    LinesOutEven[nZeileZiel]=0;
};

for ( nZeileZiel=1+MovieScale; nZeileZiel < ZEILENZAHL-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};
};


if ( OutDib == TRUE ) {
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=ShowY;
for ( nZeileZiel=1+MovieScale; nZeileZiel < ZEILENZAHL-MovieScale; nZeileZiel++ ) {
if (LinesOutEven[nZeileZiel] > 0 )  j-=LinesOutEven[nZeileZiel];
 else j+=LinesOutEven[nZeileZiel];
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
};

CurrentPitch=DibPitch;
lpDDOut=&lpDDOverlay;
Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;

} else if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( lpDDOverlay != NULL ))  {
ColorMix=FALSE;
	Black_Overlay();
	if (( Can_Overlay_Strech ) && ( USE_DX_OV_STRECH )) {
		for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
				if ( LinesOutEven[nZeileZiel] > 0 ) LinesOutEven[nZeileZiel]=1; 
				  else if ( LinesOutEven[nZeileZiel] < 0 ) LinesOutEven[nZeileZiel]=-1; 
        }
	}
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
}
CurrentPitch=OverlayPitch;
lpDDOut=&lpDDOverlay;
Call_Ausgabe=(FARPROC)(HQAusgebenYUV2);
Call_Fill=(FARPROC)(HQFillYUV2);
BytesOut=CurrentX*2;
} else {

for ( i=0; i < MaxY; i++ ) fill( (unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(i*(SurfacePitch/2)),CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
};
CurrentPitch=SurfacePitch;
lpDDOut=&lpDDSurface;
if ( WTVBPP == 16 )    Call_Ausgabe=(FARPROC) (HQAusgebenRGB16);
else  Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;
};

for (;;)  {
    nFrame++;
	Wait_DStatus();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    Burst=( pBurstLine[CurrentFrame][3] < 128)?0:1;   //Pal Burst Position 

	if ( DoWriteFrame == TRUE ) {
   
		sprintf(Fname,"TestPic.%d",WriteIndex);
		sFile = fopen(Fname, "wb");
        if(sFile != NULL) {
			WriteIndex++;
			fwrite(&Burst, sizeof(unsigned int), 1, sFile);
			fwrite(&CurrentX, sizeof(unsigned int), 1, sFile);
            for ( i = 0; i < ZEILENZAHL; i++ ) fwrite(pLinesAddressEven[(CurrentFrame*ZEILENZAHL)+i], sizeof(unsigned char), 2*CurrentX, sFile);
           fclose(sFile);
		}
	DoWriteFrame=FALSE;
	};
	
	FindYUVLineOrder(&pLinesAddressEven[CurrentFrame*ZEILENZAHL], &pSortLinesEven[0],&nPALplusZeile,&nPALplusData);
	if (bFilterBlueLines) {
				FilterBlueLines((DWORD**)(&pLinesAddressEven[CurrentFrame*ZEILENZAHL]), &pSortLinesEven[0],TRUE);
	}
    
	if ((!MoreLinesLock) && ( FirstWidthOdd > 0)) More_Even(nPALplusZeile);

    if ( OutDib == FALSE ) {
	 if ( WAIT_DX_VBI ) IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
     if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(*lpDDOut, NULL, &ddsd, DDLOCK_WAIT, NULL);
	};
   
    for ( nZeileZiel=1+MovieScale; nZeileZiel < ZEILENZAHL-MovieScale; nZeileZiel++ ) {
		if ( TVTYPE == 2 ) ColFaktor = &NullTable[0];
		else {
	nZeileQuelle  = pSortLinesEven[nZeileZiel];
    nZielInvers   = nZeileZiel & 1;
		nQuelleInvers = nZeileQuelle & 1;
	if ( nZeileQuelle < 32 ) { 
  		  nQuelleInvers ^= 1;
          nZeileQuelle-=25;
		  };
 		if(Burst == 0 )
            {
               nQuelleInvers ^= 1;
               nZielInvers   ^= 1;
            }
	nZeileQuelle -= nZeileZiel;
	ColFaktor = &HQTabelle[((nZeileQuelle+312)*4+nQuelleInvers+nZielInvers*2)*4];
	};

     LinesAnzahl=LinesOutEven[nZeileZiel];
            if ( LinesAnzahl == 0 ) {
 		    pQuelle=pLinesAddressEven[(CurrentFrame*ZEILENZAHL)+pSortLinesEven[nZeileZiel]];
            _asm {
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Fill
					call ebx
			};
			} else if (( LinesAnzahl >= 1 ) && ( LinesAnzahl < 5 )) {
		    pQuelle=pLinesAddressEven[(CurrentFrame*ZEILENZAHL)+pSortLinesEven[nZeileZiel]];
            TmpPtr=ZeilenPuffer;
            ScreenPtr=pLinesDstAddressEven[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;
            _asm
				{
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Ausgabe
					call ebx
				};
			};
   }

	if ( OutDib == FALSE ) {
		if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(*lpDDOut,  ddsd.lpSurface);
	} else SetDIBitsToDevice( DIB_Hdc,0,0,pDIB->bmiHeader.biWidth,ShowY,0,0,0,ShowY,pDecode,pDIB,DIB_RGB_COLORS);

      if(dwLastCount+960 <= GetTickCount())
      {
		  if (MoreLinesLock==FALSE) {
 					if ( MatrixModeEven == TRUE ) MoreLinesLock=TRUE;
					if ( AutoLockCount < 10 ) AutoLockCount++;
					 else MoreLinesLock=TRUE;
					 if ( MoreLinesLock == TRUE ) {
                           if (( Line1BlackEven == FALSE ) && 
							   ( Line285BlackEven == FALSE ) && 
							   ( Line286BlackEven == FALSE ) && 
							   ( MatrixModeEven == FALSE )) UntilEven=1;
					 }
		  } else {
					 if (Check_Even() == FALSE ) Clear_Status();
				}

if ( Display_Status_Bar == TRUE ) {
		  sprintf(Text,"%d FPS",nFrame);
	      SetWindowText (hwndFPSField,Text);
	}
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
}
};




void NagraYUVOutThread(  ) 
{
    LPDIRECTDRAWSURFACE *lpDDOut;
	int nZeileZiel   ;     
    int nZielInvers  ; 	
    int nZeileQuelle ; 	
    int nQuelleInvers; 	
    int Burst;
    DOUBLE YStep,YSum;   
	unsigned int i,j;
	DDSURFACEDESC	ddsd;
	HRESULT		    ddrval;
	short *pQuelle;
	FARPROC Call_Ausgabe;
	FARPROC Call_Fill;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         


if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

ddsd.dwSize=sizeof( ddsd );


nPixelSchritt = CurrentX/TESTPIXEL/2;
fill(HQLinebufferEven,1480*4);
fill(HQLinebufferOdd,1480*4);
Init_More();

for ( i = 0; i < ZEILENZAHL; BlackSet[i++]=FALSE ) ;


dwLastCount=GetTickCount();
nFrame=0;
for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < CurrentY ; i+=2 ) {
       pLinesAddressOdd[(j*ZEILENZAHL)+(i/2)] = (short *)pDisplay[j]+(i*CurrentX)+CurrentX;
       pLinesAddressEven[(j*ZEILENZAHL)+(i/2)] = (short *)pDisplay[j]+(i*CurrentX);
}
}




YStep=(double)MaxY/((ZEILENZAHL-1-MovieScale*2)*2);
for ( nZeileZiel=0; nZeileZiel < ZEILENZAHL; nZeileZiel++ ) {
    LinesOutEven[nZeileZiel]=0;
    LinesOutOdd[nZeileZiel]=0;
};

YSum=0.0;
ShowY=0;
for ( nZeileZiel=MovieScale+1; nZeileZiel < ZEILENZAHL-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
}  else if ( YSum < 3 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};


	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutOdd[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutOdd[nZeileZiel]=1;
      else LinesOutOdd[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutOdd[nZeileZiel]=2;
      else LinesOutOdd[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutOdd[nZeileZiel]=3;
      else LinesOutOdd[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutOdd[nZeileZiel]=4;
      else LinesOutOdd[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
}; 
};

if ( OutDib == TRUE ) {
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=ShowY;
for ( nZeileZiel=1; nZeileZiel < ZEILENZAHL; nZeileZiel++ ) {
if (LinesOutEven[nZeileZiel] > 0 )  j-=LinesOutEven[nZeileZiel];
 else j+=LinesOutEven[nZeileZiel];
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
if (LinesOutOdd[nZeileZiel] > 0 )  j-=LinesOutOdd[nZeileZiel];
 else j+=LinesOutOdd[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
};

CurrentPitch=DibPitch;
lpDDOut=&lpDDOverlay;
Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;

} else if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( lpDDOverlay != NULL ))  {
ColorMix=FALSE;

	Black_Overlay();
	if (( Can_Overlay_Strech ) && ( USE_DX_OV_STRECH )) {
		for ( nZeileZiel=MovieScale; nZeileZiel < CurrentY/2-MovieScale; nZeileZiel++ ) {
				if ( LinesOutEven[nZeileZiel] > 0 ) LinesOutEven[nZeileZiel]=1; 
				  else if ( LinesOutEven[nZeileZiel] < 0 ) LinesOutEven[nZeileZiel]=-1; 
		        if ( LinesOutOdd[nZeileZiel] > 0 ) LinesOutOdd[nZeileZiel]=1;
				   else if ( LinesOutOdd[nZeileZiel] < 0 ) LinesOutOdd[nZeileZiel]=-1;
        }
	}


j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];
}

CurrentPitch=OverlayPitch;
lpDDOut=&lpDDOverlay;
Call_Ausgabe=(FARPROC)(HQAusgebenYUV2);
Call_Fill=(FARPROC)(HQFillYUV2);
BytesOut=CurrentX*2;
} else {
for ( i=0; i < MaxY; i++ ) fill( (unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(i*(SurfacePitch/2)),CurrentX);
j=0;
for ( nZeileZiel=0; nZeileZiel < CurrentY/2; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
pLinesDstAddressOdd[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutOdd[nZeileZiel] > 0 )  j+=LinesOutOdd[nZeileZiel];
 else j-=LinesOutOdd[nZeileZiel];
};
CurrentPitch=SurfacePitch;
lpDDOut=&lpDDSurface;
if ( WTVBPP == 16 )    Call_Ausgabe=(FARPROC) (HQAusgebenRGB16);
else  Call_Ausgabe=(FARPROC)(HQAusgebenRGB15);
Call_Fill=(FARPROC)(HQFillRGB);
BytesOut=CurrentX*2;
};



for (;;)  {
    nFrame+=2;
	Wait_DStatus();
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    Burst=( pBurstLine[CurrentFrame][3] < 128)?0:1;   //Pal Burst Position 

	FindYUVLineOrder(&pLinesAddressEven[CurrentFrame*ZEILENZAHL], &pSortLinesEven[0],&nPALplusZeile,&nPALplusData);
    
	if ((!MoreLinesLock) && ( FirstWidthOdd > 0)) More_Even(nPALplusZeile);
	FindYUVSecondLineOrder(&pLinesAddressOdd[CurrentFrame*ZEILENZAHL], &pSortLinesOdd[0]);

	if (bFilterBlueLines) {
			  FilterBlueLines((DWORD**)(&pLinesAddressEven[CurrentFrame*ZEILENZAHL]), &pSortLinesEven[0],TRUE);
			  FilterBlueLines((DWORD**)(&pLinesAddressOdd[CurrentFrame*ZEILENZAHL]), &pSortLinesOdd[0],FALSE);
			}

	if ((!MoreLinesLock) && ( FirstWidthOdd > 0)) More_Odd();

    
    if ( OutDib == FALSE ) {
	 if ( WAIT_DX_VBI ) IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
     if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(*lpDDOut, NULL, &ddsd, DDLOCK_WAIT, NULL);
	};
   
    for ( nZeileZiel=1+MovieScale; nZeileZiel < ZEILENZAHL-MovieScale; nZeileZiel++ ) {
		if ( TVTYPE == 2 ) ColFaktor = &NullTable[0];
		else {
	nZielInvers   = nZeileZiel & 1;
	nZeileQuelle  = pSortLinesEven[nZeileZiel];
	nQuelleInvers = nZeileQuelle & 1;
	if ( nZeileQuelle < 32 ) { 
  		  nQuelleInvers ^= 1;
          nZeileQuelle-=25;
		  };
    nZeileQuelle -= nZeileZiel;
    if(Burst == 0 )
            {
               nQuelleInvers ^= 1;
               nZielInvers   ^= 1;
            }
	ColFaktor = &HQTabelle[((nZeileQuelle+312)*4+nQuelleInvers+nZielInvers*2)*4];
	};

     LinesAnzahl=LinesOutEven[nZeileZiel];
            if ( LinesAnzahl == 0 ) {
 		    pQuelle=pLinesAddressEven[(CurrentFrame*ZEILENZAHL)+pSortLinesEven[nZeileZiel]];
            _asm {
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Fill
                    call ebx
			};
			} else if (( LinesAnzahl >= 1 ) && ( LinesAnzahl < 5 )) {
		    
				
				
				
		pQuelle=pLinesAddressEven[(CurrentFrame*ZEILENZAHL)+pSortLinesEven[nZeileZiel]];
            TmpPtr=ZeilenPuffer;;
            ScreenPtr=pLinesDstAddressEven[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;

            
			
			_asm
				{
					mov edi,dword ptr [HQLinebufferEvenPtr];
					mov edx,pQuelle
					mov ebx,Call_Ausgabe
					call ebx
				};
	
  };


if ( TVTYPE == 2 ) ColFaktor = &NullTable[0];
    else {
	nZeileQuelle  = pSortLinesOdd[nZeileZiel];
    nQuelleInvers = nZeileQuelle & 1;
	if ( nZeileQuelle < 32 ) nZeileQuelle-=26;
    nZeileQuelle -= nZeileZiel;
    if(Burst == 1 )  nQuelleInvers ^= 1;
    nZielInvers   ^= 1;
	ColFaktor = &HQTabelle[((nZeileQuelle+312)*4+nQuelleInvers+nZielInvers*2)*4];
	};

	LinesAnzahl=LinesOutOdd[nZeileZiel];
            if ( LinesAnzahl == 0 ) {
 		    pQuelle=pLinesAddressOdd[(CurrentFrame*ZEILENZAHL)+pSortLinesOdd[nZeileZiel]];
            _asm {
					mov edi,dword ptr [HQLinebufferOddPtr];
					mov edx,pQuelle
					mov ebx,Call_Fill
                    call ebx
			};
			} else if (( LinesAnzahl >= 1 ) && ( LinesAnzahl < 5 )) {

			pQuelle=pLinesAddressOdd[(CurrentFrame*ZEILENZAHL)+pSortLinesOdd[nZeileZiel]];
            TmpPtr=ZeilenPuffer;;
            ScreenPtr=pLinesDstAddressOdd[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;
            _asm
				{
					mov edi,dword ptr [HQLinebufferOddPtr];
					mov edx,pQuelle
					mov ebx,Call_Ausgabe
					call ebx
				};
         };
   }

	if ( OutDib == FALSE ) {
		if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(*lpDDOut,  ddsd.lpSurface);
	} else SetDIBitsToDevice( DIB_Hdc,0,0,pDIB->bmiHeader.biWidth,ShowY,0,0,0,ShowY,pDecode,pDIB,DIB_RGB_COLORS);

      if(dwLastCount+960 <= GetTickCount())
      {
			if (MoreLinesLock==FALSE) {
					if (( MatrixModeOdd == TRUE ) && ( MatrixModeEven == TRUE )) MoreLinesLock=TRUE;
					if ( AutoLockCount < 10 ) AutoLockCount++;
					 else MoreLinesLock=TRUE;
 					 if ( MoreLinesLock == TRUE ) {
                           if (( Line1BlackEven == FALSE ) && 
							   ( Line285BlackEven == FALSE ) && 
							   ( Line286BlackEven == FALSE ) && 
							   ( MatrixModeEven == FALSE )) UntilEven=1;
                           if (( Line1BlackOdd == FALSE ) && 
							   ( Line285BlackOdd == FALSE ) && 
							   ( Line286BlackOdd == FALSE ) && 
							   ( MatrixModeOdd == FALSE )) UntilOdd=1;
					 }

			} else {
					 if (Check_Odd() == FALSE ) Clear_Status();
		 }

		if ( Display_Status_Bar == TRUE ) {
		  sprintf(Text,"%d FPS",nFrame);
	      SetWindowText (hwndFPSField,Text);
	}
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
}
}



void Init_More()
{

if ( MoreLinesLock == FALSE ) {
AutoLockCount=0;
UntilEven=0;
UntilOdd=0;
BlackEven=-1;
BlackOdd=-1;
MoreLinesLock=FALSE;  
FirstWidthEven=TESTPIXEL;
FirstWidthOdd=TESTPIXEL;
FirstWidthEvenCount=0;
FirstWidthOddCount=0;

Line286BlackEven=FALSE;
Line286BlackOdd=FALSE;
Line1BlackEven=FALSE;
Line1BlackOdd=FALSE;
B1e=0;
B286e=0;
B1o=0;
B286o=0;
MatrixCountEven=0;
MatrixModeEven=FALSE;
MatrixLinesEven=0;
MatrixCountOdd=0;
MatrixModeOdd=FALSE;
MatrixLinesOdd=0;

}

};




BOOL Check_Even( void )
{
int m=0;

if (( Line0BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[0]])) return(FALSE);
if (( Line1BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[1]])) return(FALSE);
if (( Line285BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[285]])) return(FALSE);
if (( Line286BlackEven == TRUE ) && (!BlackSet[pSortLinesEven[286]])) return(FALSE);
 
if ( MatrixModeEven == TRUE ) {
for ( i=0 ; i < 68 ; i++ ) {
	if ( BlackSet[pSortLinesEven[i]]==TRUE ) m++;
}
if ( m < MatrixLinesEven ) return(FALSE);
}
return(TRUE);
};

BOOL Check_Odd( void )
{
int m=0;

if (( Line0BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[0]])) return(FALSE);
if (( Line1BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[1]])) return(FALSE);
if (( Line285BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[285]])) return(FALSE);
if (( Line286BlackOdd == TRUE ) && (!BlackSet[pSortLinesOdd[286]])) return(FALSE);
 
if ( MatrixModeOdd == TRUE ) {
for ( i=0 ; i < 68 ; i++ ) {
	if ( BlackSet[pSortLinesOdd[i]]==TRUE ) m++;
}
if ( m < MatrixLinesOdd ) return(FALSE);
}
return(TRUE);
};


void More_Even( int pp )
{
int i;
int m=0;
int j;

    if ( BlackSet[pSortLinesEven[0]] ) {
		if ( B0e < 100 ) B0e++;
		else Line0BlackEven=TRUE;
		FirstWidthEvenCount=0;
	} else {
		B0e=0;
		if (( Line0BlackEven==TRUE ) &&
		   ( FirstWidthEven<TESTPIXEL)) FirstWidthEven++;
        FirstWidthEvenCount++;
        Line0BlackEven=FALSE;
	}

    if ( BlackSet[pSortLinesEven[1]] ) {
		if ( B1e < 100 ) B1e++;
		else Line1BlackEven=TRUE;
	} else {
		B1e=0;
        Line1BlackEven=FALSE;
	}

    if ( BlackSet[pSortLinesEven[286]] ) {
		if ( B286e < 100 ) B286e++;
		else Line286BlackEven=TRUE;
	} else {
		B286e=0;
        Line286BlackEven=FALSE;
	}

    if ( BlackSet[pSortLinesEven[285]] ) {
		if ( B285e < 100 ) B285e++;
		else Line285BlackEven=TRUE;
	} else {
		B285e=0;
        Line285BlackEven=FALSE;
	}
	
if (( FirstWidthEvenCount > 100 ) &&
    ( FirstWidthEven >3 )) {
	FirstWidthEvenCount=80;
	if (( MatrixModeEven == FALSE ) &&
    ( Line0BlackEven == FALSE ) &&
    ( Line1BlackEven == FALSE )) {
		AutoLockCount=0;
		FirstWidthEven--;
	};
}

if ( pp >= 0 ) BlackSet[pp]=TRUE;
	

for ( i=0 ; i < 68 ; i++ ) {
	if ( BlackSet[pSortLinesEven[i]]==TRUE ) m++;
}

j=m;
for ( i=68 ; i < 287 ; i++ ) {
	if ( BlackSet[pSortLinesEven[i]]==TRUE ) j++;
}

if ( j != BlackEven ) {
		AutoLockCount=0;
		BlackEven = j;
}; 

if (( m < 6 ) || ( m > 66 )) {
	                      MatrixModeEven=FALSE;
	                      MatrixCountEven=0;
						  MatrixLinesEven=0;
                      	return;
	}

if ( MatrixCountEven == 0 ) {
	   MatrixLinesEven=m;
	   MatrixCountEven++; 
} else {
   if ( m==MatrixLinesEven )
   { 
	   if ( MatrixCountEven < 100 ) MatrixCountEven++; 
   } else MatrixCountEven-=10;
	 
	if ( MatrixCountEven < 0 ) {
		                  MatrixCountEven=0;
						  MatrixModeEven=FALSE;
						  MatrixLinesEven=0;
						  return;
						}
 
	if ( MatrixCountEven > 80) {
                 if ( MatrixModeEven == FALSE ) {
					   MatrixModeEven=TRUE;
                       GetMatrix(MatrixLinesEven-1,0);
				   }
	}
}
}

void More_Odd()
{
int m=0;
int i;
int j;

    if ( BlackSet[pSortLinesOdd[0]] ) {
		if ( B0o < 100 ) B0o++;
		else Line0BlackOdd=TRUE;
		FirstWidthOddCount=0;

	} else {
		B0o=0;
		if (( Line0BlackOdd==TRUE ) &&
		   ( FirstWidthOdd<TESTPIXEL)) FirstWidthOdd++;
		FirstWidthOddCount++;
        Line0BlackOdd=FALSE;
	}


    if ( BlackSet[pSortLinesOdd[1]] ) {
		if ( B1o < 100 ) B1o++;
		else Line1BlackOdd=TRUE;
	} else {
		B1o=0;
        Line1BlackOdd=FALSE;
	}
    if ( BlackSet[pSortLinesOdd[286]] ) {
		if ( B286o < 100 ) B286o++;
		else Line286BlackOdd=TRUE;
	} else {
		B286o=0;
        Line286BlackOdd=FALSE;
	}
    if ( BlackSet[pSortLinesOdd[285]] ) {
		if ( B285o < 100 ) B285o++;
		else Line285BlackOdd=TRUE;
	} else {
		B285o=0;
        Line285BlackOdd=FALSE;
	}


if (( FirstWidthOddCount > 100 ) &&
    ( FirstWidthOdd > 3 )) {
	FirstWidthOddCount=75;
	if (( MatrixModeOdd == FALSE ) &&
    ( Line0BlackOdd == FALSE ) &&
    ( Line1BlackOdd == FALSE )) {
		FirstWidthOdd--;
		AutoLockCount=0;
	};
}



for ( i=0 ; i < 68 ; i++ ) {
	if ( BlackSet[pSortLinesOdd[i]]==TRUE ) m++;
}

j=m;
for ( i=68 ; i < 287 ; i++ ) {
	if ( BlackSet[pSortLinesOdd[i]]==TRUE ) j++;
}

if ( j != BlackOdd ) {
		AutoLockCount=0;
		BlackOdd = j;
}; 


if (( m < 6 ) || ( m > 66 )) {
	                      MatrixCountOdd=0;
						  MatrixLinesOdd=0;
	                      return;
}
if ( MatrixCountOdd == 0 ) {
	   MatrixLinesOdd=m;
	   MatrixCountOdd++; 
} else {
	if ( m==MatrixLinesOdd ) {
	if ( MatrixCountOdd < 100 ) MatrixCountOdd++; 
	} else MatrixCountOdd-=10;
	 
	if ( MatrixCountOdd < 0 ) {
		                  MatrixCountOdd=0;
						  MatrixModeOdd=FALSE;
						  MatrixLinesOdd=0;
						  return;
						}
 
	if ( MatrixCountOdd > 60 ) {
                   if ( MatrixModeOdd == FALSE ) {
					   MatrixModeOdd=TRUE;
                       GetMatrix(MatrixLinesOdd-1,1);
				   }
	}
}


}



void VCYUVHalfOutThread(  ) 
{

	#define VCCLEARLINES 287

    int nFrame=0;

	LPDIRECTDRAWSURFACE *lpDDOut;
	FARPROC Call_Ausgabe;

    int CurrentFrame;
	int nZeileZiel   ;     
    DOUBLE YStep,YSum;   
	unsigned int i,j;
    int OutX;
	int VCCut;
	int Burst;
	short *pQuelle;

	DDSURFACEDESC	ddsd;
    HRESULT		    ddrval;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         

if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

OutX=710;
if ( MaxX < OutX ) OutX=MaxX;
Set_BT_Decrypt_Mode();

ddsd.dwSize=sizeof( ddsd );


YStep=(double)MaxY/(VCCLEARLINES-2-(MovieScale*2));
YSum=0.0;
ShowY=0;

for ( nZeileZiel=0; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
    LinesOutEven[nZeileZiel]=0;
};

for ( nZeileZiel=2+MovieScale; nZeileZiel < VCCLEARLINES-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < VCCLEARLINES-MovieBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < VCCLEARLINES-MovieBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < VCCLEARLINES-MovieBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < VCCLEARLINES-MovieBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};
};

dwLastCount=GetTickCount();
nFrame=0;
for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < VCCLEARLINES ; i++ ) {
    pLinesAddressEven[(j*VCCLEARLINES)+i] = (short *)pDisplay[j]+(i*CurrentX)+VCLmargin;
}
}




if ( OutDib == TRUE ) {
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=ShowY;
for ( nZeileZiel=1; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
if (LinesOutEven[nZeileZiel] > 0 )  j-=LinesOutEven[nZeileZiel];
 else j+=LinesOutEven[nZeileZiel];
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
};
CurrentPitch=DibPitch;
 Call_Ausgabe=(FARPROC) (VCHQAusgebenRGB15);
} else if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( lpDDOverlay != NULL ))  {
Black_Overlay();
j=0;
	if (( Can_Overlay_Strech ) && ( USE_DX_OV_STRECH )) {
            for ( nZeileZiel=1+MovieScale; nZeileZiel < VCCLEARLINES-MovieScale; nZeileZiel++ ) {
			if ( LinesOutEven[nZeileZiel] > 0 ) LinesOutEven[nZeileZiel] = 1;
			  else if ( LinesOutEven[nZeileZiel] < 0 ) LinesOutEven[nZeileZiel] = -1;
        }
	}

j=0;
for ( nZeileZiel=1; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
} 
CurrentPitch=OverlayPitch;
lpDDOut=&lpDDOverlay;
Call_Ausgabe=(FARPROC)VCHQAusgebenYUV2;
} else { 
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(i*(SurfacePitch/2)),OutX);
j=0;
for ( nZeileZiel=1; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
}
CurrentPitch=SurfacePitch;
lpDDOut=&lpDDSurface;
if ( WTVBPP == 16 )    Call_Ausgabe=(FARPROC) (VCHQAusgebenRGB16);
else  Call_Ausgabe=(FARPROC)(VCHQAusgebenRGB15);
};

BytesOut=OutX*2;

VCFirstLine=2;
while (( LinesOutEven[VCFirstLine] < 1 ) || ( LinesOutEven[VCFirstLine] > 5 )) VCFirstLine++;

for ( i=0; i < 5; i++ ) {
for ( nZeileZiel=VCFirstLine; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
	if (( LinesOutEven[VCFirstLine] < 1 ) || ( LinesOutEven[VCFirstLine] > 5 )) {
			pLinesAddressEven[(i*VCCLEARLINES)+nZeileZiel]=NULL;
            };
		};
}

VCTotalLines=0;
for ( nZeileZiel=VCFirstLine; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
	if (pLinesAddressEven[nZeileZiel] != NULL ) VCTotalLines++;
	}

VCTotalLines-=4;


for (;;) {
    nFrame++;
	Wait_DStatus();
	if (!VideoPresent ) continue;
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
    Burst=( pBurstLine[CurrentFrame][3] < 128)?0:1;   //Pal Burst Position 

	if (Find_Cut_Points_VC(&pLinesAddressEven[(CurrentFrame*VCCLEARLINES)],RealOffset,Burst)) {

	// Gute Dekodierung
	}

    if ( OutDib == FALSE ) {
	if ( WAIT_DX_VBI ) (void)IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(*lpDDOut, NULL, &ddsd, DDLOCK_WAIT, NULL);
	};
	for ( nZeileZiel=VCFirstLine; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
        LinesAnzahl=LinesOutEven[nZeileZiel];
		if (( LinesAnzahl > 0 ) && ( LinesAnzahl < 5 ) ) {
			VCCut=RealOffset[nZeileZiel];
			if ( Chroma_Key == TRUE ) {
		if (((nZeileZiel+Burst)&1) == 1 ) ColFaktor=&VCHQTabelleBurst[VCCut*8];
		 else ColFaktor=&VCHQTabelleNoBurst[VCCut*8];
			} else ColFaktor=&VCHQTabelleBurst[710*8];
        
            pQuelle=pLinesAddressEven[(CurrentFrame*VCCLEARLINES)+nZeileZiel];
            TmpPtr=ZeilenPuffer;
            ScreenPtr=pLinesDstAddressEven[nZeileZiel];
            
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;
_asm
   {
	  mov esi,dword ptr [HQLinebufferEvenPtr];
	  mov eax,VCCut
	  shl eax,1
      add eax,2    
	  mov edx,pQuelle
      mov ebx,Call_Ausgabe
	  call ebx
	};	
	};  // Ende Anzahl Lines
	};

  if ( OutDib == TRUE ) {
  SetDIBitsToDevice( DIB_Hdc,
                      0,
                      0,
                      pDIB->bmiHeader.biWidth,
                      ShowY,
                      0,
                      0,
                      0,
                      ShowY,
                      pDecode,
                      pDIB,
                      DIB_RGB_COLORS
                    );
  } else {
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(*lpDDOut,  ddsd.lpSurface);
  };

if ( Display_Status_Bar == TRUE ) {
      if(dwLastCount+960 <= GetTickCount())
      {
	   sprintf(Text,"%d FPS",nFrame);
	   SetWindowText (hwndFPSField,Text);
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
}
}
}



void VCDecoderYUVHalfOutThread(  ) 
{
	LPDIRECTDRAWSURFACE *lpDDOut;
	FARPROC Call_Ausgabe;
    int nFrame=0;
	short *pQuelle;
    int CurrentFrame;
	int nZeileZiel   ;     
    DOUBLE YStep,YSum;   
	int Burst;
	unsigned int i,j;
    int VCCut;
	int VCIrq;
	int OutX;
    int Key=-1;
    int LastKey=-1;



	DDSURFACEDESC	ddsd;
    HRESULT		    ddrval;

ProzessorMask=1<<(AusgabeProzessor);
i=SetThreadAffinityMask (GetCurrentThread(),ProzessorMask);         

if ( ThreadClassId == 0 )  SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_BELOW_NORMAL);
 else if ( ThreadClassId == 1 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_NORMAL);
   else if ( ThreadClassId == 2 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_ABOVE_NORMAL);
     else if ( ThreadClassId == 3 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
       else if ( ThreadClassId == 4 ) SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_TIME_CRITICAL);

VCIRQSync=FALSE;
ddsd.dwSize=sizeof( ddsd );
Set_BT_Decrypt_Mode();

OutX=710;
if ( MaxX < OutX ) OutX=MaxX;


YStep=(double)MaxY/(ZEILENZAHL-(MovieScale*2));
YSum=0.0;
ShowY=0;

for ( nZeileZiel=0; nZeileZiel < ZEILENZAHL; nZeileZiel++ ) {
    LinesOutEven[nZeileZiel]=0;
};

for ( nZeileZiel=1+MovieScale; nZeileZiel < ZEILENZAHL-MovieScale; nZeileZiel++ ) {
	YSum=YSum+YStep;
if ( YSum < 1 ) {
	LinesOutEven[nZeileZiel]=0;
} else if ( YSum < 2 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=1;
      else LinesOutEven[nZeileZiel]=-1;
	YSum-=1;
	ShowY+=1;
} else if ( YSum < 3 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=2;
      else LinesOutEven[nZeileZiel]=-2;

    YSum-=2;
	ShowY+=2;
} else if ( YSum < 4 ) {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=3;
      else LinesOutEven[nZeileZiel]=-3;

    YSum-=3;
	ShowY+=3;
} else {
	if (( nZeileZiel > MovieBoost ) && ( nZeileZiel < ZEILENZAHL-MovieBoost )) LinesOutEven[nZeileZiel]=4;
      else LinesOutEven[nZeileZiel]=-4;
    YSum-=4;
	ShowY+=4;
};
};



dwLastCount=GetTickCount();
nFrame=0;
for ( j= 0 ; j < 5 ; j++ ) {
for ( i = 0; i < ZEILENZAHL ; i++ ) {
    pLinesAddressEven[(j*ZEILENZAHL)+i] = (short *)pDisplay[j]+(i*CurrentX)+10;
}
}



if ( OutDib == TRUE ) {
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)&pDecode[i*DibPitch/2],CurrentX);
j=ShowY;
for ( nZeileZiel=1; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
if (LinesOutEven[nZeileZiel] > 0 )  j-=LinesOutEven[nZeileZiel];
 else j+=LinesOutEven[nZeileZiel];
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)&pDecode[j*DibPitch/2];
};
CurrentPitch=DibPitch;
Call_Ausgabe=(FARPROC)VCHQAusgebenRGB15;
} else if (( ModeOverlay == TRUE ) && ( Can_Overlay ) && ( lpDDOverlay != NULL ))  {
Black_Overlay();
j=0;
	if (( Can_Overlay_Strech ) && ( USE_DX_OV_STRECH )) {
            for ( nZeileZiel=1+MovieScale; nZeileZiel < VCCLEARLINES-MovieScale; nZeileZiel++ ) {
			if ( LinesOutEven[nZeileZiel] > 0 ) LinesOutEven[nZeileZiel] = 1;
			  else if ( LinesOutEven[nZeileZiel] < 0 ) LinesOutEven[nZeileZiel] = -1;
        }
	}

j=0;
for ( nZeileZiel=1; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpOverlay+(j*(OverlayPitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
} 
CurrentPitch=OverlayPitch;
lpDDOut=&lpDDOverlay;
Call_Ausgabe=(FARPROC)VCHQAusgebenYUV2;
} else { 
for ( i=0; i < MaxY; i++ ) fill((unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(i*(SurfacePitch/2)),OutX);
j=0;
for ( nZeileZiel=1; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {
pLinesDstAddressEven[nZeileZiel]=(unsigned short*)lpSurface+(Offset_for_WindowOut/2)+(j*(SurfacePitch/2));
if (LinesOutEven[nZeileZiel] > 0 )  j+=LinesOutEven[nZeileZiel];
 else j-=LinesOutEven[nZeileZiel];
}
CurrentPitch=SurfacePitch;
lpDDOut=&lpDDSurface;
if ( WTVBPP == 16 )    Call_Ausgabe=(FARPROC) (VCHQAusgebenRGB16);
else  Call_Ausgabe=(FARPROC)(VCHQAusgebenRGB15);
};

BytesOut=OutX*2;



for (;;) {
    nFrame++;
	if (( MoreLinesLock == FALSE ) && (( nFrame==6 ) || ( nFrame==12 ) || ( nFrame==18 ))) VCIRQSync=FALSE;
	Wait_DStatus();
	if (!VideoPresent ) continue;
	CurrentFrame=NextFrame-1;
	if ( CurrentFrame < 0 ) CurrentFrame=4;
	VCIrq=CurrentIrq;
    Burst=( pBurstLine[CurrentFrame][3] < 128)?0:1;   //Pal Burst Position 

	if ( VCIRQSync == FALSE ) {
    Key=Get_Decoder_Key(&pLinesAddressEven[(CurrentFrame*ZEILENZAHL)]);
	if ( Key == LastKey+1 ) {
		 VCIRQSync=TRUE;
		 CurrentIrq=Key;
	} ;
    VCIrq=Key;
	LastKey=Key;
	};
    if ( OutDib == FALSE ) {
	if ( WAIT_DX_VBI ) (void)IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN, NULL);
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Lock(*lpDDOut, NULL, &ddsd, DDLOCK_WAIT, NULL);
	};

	for ( nZeileZiel=2; nZeileZiel < VCCLEARLINES; nZeileZiel++ ) {

        LinesAnzahl=LinesOutEven[nZeileZiel];
		if (( LinesAnzahl > 0 ) && ( LinesAnzahl < 5 ) ) {
			VCCut=cp_odd[VCIrq][nZeileZiel-2];
			if ( Chroma_Key == TRUE ) {
		if (((nZeileZiel+Burst)&1) == 1 ) ColFaktor=&VCHQTabelleBurst[VCCut*8];
		 else ColFaktor=&VCHQTabelleNoBurst[VCCut*8];
			};
        
            pQuelle=pLinesAddressEven[(CurrentFrame*VCCLEARLINES)+nZeileZiel];
            TmpPtr=ZeilenPuffer;;
            ScreenPtr=pLinesDstAddressEven[nZeileZiel];
			if ( LinesAnzahl == 1 ) TmpPtr=ScreenPtr;

 _asm
   {
	  mov esi,dword ptr [HQLinebufferEvenPtr];
      mov eax,VCCut
	  shl eax,1
      add eax,2    
	  mov edx,pQuelle
      mov ebx,Call_Ausgabe
	  call ebx
	};	
		};

	};
  if ( OutDib == TRUE ) {
  SetDIBitsToDevice( DIB_Hdc,
                      0,
                      0,
                      pDIB->bmiHeader.biWidth,
                      ShowY,
                      0,
                      0,
                      0,
                      ShowY,
                      pDecode,
                      pDIB,
                      DIB_RGB_COLORS
                    );
  } else {
    if ( USE_DX_LOCK ) ddrval=IDirectDrawSurface_Unlock(*lpDDOut,  ddsd.lpSurface);
  };

if ( Display_Status_Bar == TRUE ) {
      if(dwLastCount+960 <= GetTickCount())
      {
	   sprintf(Text,"%d FPS",nFrame);
	   SetWindowText (hwndFPSField,Text);
	   nFrame=0;
       dwLastCount = GetTickCount();
	  }
}
}
}


BOOL APIENTRY ProgrammListe(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
	int i,j,k,p;
	char zeile[140];
	char zeile1[140];
    struct TProgramm save;
	LOGFONT Mfont = {9,0,0,0,0,0,0,0,0,0,0,0,0,"Fixedsys"};   
    HFONT currFont;


    switch (message) {
        case WM_INITDIALOG:
            currFont = CreateFontIndirect(&Mfont);
			SendMessage(GetDlgItem(hDlg,IDC_LIST1),
                     WM_SETFONT,
                     (WPARAM)currFont,
                     TRUE);

             EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
             EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),FALSE);


		case RESET_LIST:
            SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_RESETCONTENT,0,0);
            
            j=1;
            i=0;
			p=-1;
			while ( i < MAXPROGS ) {
                if ( Programm[i].freq != 0 ) {
					if ( Programm[i].Typ == 'A' ) {
                 sprintf(zeile," %04d. %- 21s  %10.3f  (Analog) ",j,Programm[i].Name,(float)Programm[i].freq/1000);
                    } else {
               sprintf(zeile," %04d. %- 21s  %10.3f V %4d A %4d",j,Programm[i].Name,(float)Programm[i].freq/1000,Programm[i].video_pid,Programm[i].audio_pid);
					}
				 k=SendMessage(GetDlgItem(hDlg,
                                      IDC_LIST1),
                           LB_ADDSTRING,
                           0,
                           (LPARAM)zeile);
			       if (( message == (UINT)RESET_LIST ) &&
					   ( i == (int)wParam ) &&
					   ( wParam != 0 )) {
					    p=k;
				   };
				   j++;
			
				} ;
				 i++;
				};
            if ( p >= 0 ) {
				            SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_SETCURSEL,p,0);
				  if ( p > 0 ) EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),TRUE);
				    else EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
			      if ( p+1 < SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_GETCOUNT,0,0)) EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),TRUE);
                    else EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),FALSE);
			};			
							return(TRUE);

 

        case WM_COMMAND:

         if ( (HWND)lParam==GetDlgItem(hDlg,IDC_LIST1) ){

			 if (HIWORD(wParam)==LBN_SELCHANGE){
				  i=SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_GETCURSEL,0,0);
				  if ( i > 0 ) EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),TRUE);
				    else EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
			      if ( i+1 < SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_GETCOUNT,0,0)) EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),TRUE);
                    else EnableWindow(GetDlgItem(hDlg,IDC_BUTTON2),FALSE);

				if (( i >= 0 ) && ( i < MAXPROGS )) {
                if (ValidModes(Programm[i].Typ) == TRUE  ) {
			               CurrentProgramm=i;
						if (( Current_Mode == 0 ) && ( Programm[CurrentProgramm].Typ == 'D' )) Set_Mode_Digital();
				           else if (( Current_Mode == 1 ) && ( Programm[CurrentProgramm].Typ == 'A' )) Set_Mode_Analog();
                      
				 if ( Display_Status_Bar == TRUE ) {
                   	   sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
	                   SetWindowText (hwndKeyField,Text);
					}

						   if (Programm[CurrentProgramm].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(Programm[CurrentProgramm].freq*1000,16,1000000));
				               else Set_DVB_Channel(CurrentProgramm);
					}
				};
			 };

			 if (HIWORD(wParam)==LBN_DBLCLK) {
               		 i=SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_GETCURSEL,0,0);
					 EditProgramm=i;
                     if (( i >= 0 ) && ( i < MAXPROGS )) {
				 if ( Display_Status_Bar == TRUE ) {
                   	   sprintf(Text,"%04d. %s ",CurrentProgramm+1,Programm[CurrentProgramm].Name);
	                   SetWindowText (hwndKeyField,Text);
					}
					  
					  DialogBox(hInst,"PROGRAMM",hWnd,(DLGPROC)ProgrammEdit);
                      SetFocus(hDlg);
				     SendMessage(hDlg,RESET_LIST,CurrentProgramm,0);
             }
		 }
		 }

		 if (LOWORD(wParam) == IDC_BUTTON2 ) {
            i=SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_GETCURSEL,0,0);
			if ( i+1 < MAXPROGS ) {
               if ( Programm[i+1].freq != 0 ) {
                       memcpy(&save,&Programm[i],sizeof(struct TProgramm));
                       memcpy(&Programm[i],&Programm[i+1],sizeof(struct TProgramm));
                       memcpy(&Programm[i+1],&save,sizeof(struct TProgramm));
                       SendMessage(hDlg,RESET_LIST,i+1,0);
         			   Write_Programm_List();
					}
				 }
		 };
		 
		 if (LOWORD(wParam) == IDC_BUTTON1 ) {
            i=SendMessage(GetDlgItem(hDlg,IDC_LIST1),LB_GETCURSEL,0,0);
			if ( i>= 1  ) {
                       memcpy(&save,&Programm[i],sizeof(struct TProgramm));
                       memcpy(&Programm[i],&Programm[i-1],sizeof(struct TProgramm));
                       memcpy(&Programm[i-1],&save,sizeof(struct TProgramm));
         			   Write_Programm_List();
					   SendMessage(hDlg,RESET_LIST,i-1,0);
				 }
			 }

		 if (LOWORD(wParam) == IDM_NEU ) {
            i=0;
			while ( i < MAXPROGS ) {
                if ( Programm[i].freq == 0 ) {
                    CurrentProgramm=i;
					i=MAXPROGS;
                };
             i++;
			}
               Programm[CurrentProgramm].freq=0;
			   Programm[CurrentProgramm].Name[0]=0x00;
			   Programm[CurrentProgramm].Typ='A';
			   // ggf Mehr
EditProgramm=CurrentProgramm;
			   DialogBox(hInst,"PROGRAMM",hWnd,(DLGPROC)ProgrammEdit);
               SetFocus(hDlg);
			   SendMessage(hDlg,RESET_LIST,CurrentProgramm,0);
		 };
		 
		 
		 if (LOWORD(wParam) == IDOK
                || LOWORD(wParam) == IDCANCEL) {
			EndDialog(hDlg,TRUE);
				 }

			 break;
    }
    return (FALSE);
        UNREFERENCED_PARAMETER(lParam);
}




BOOL APIENTRY ProgrammEdit(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
	char zeile[140];
    unsigned long freq;
	float ffreq;


	switch (message) {
        case WM_INITDIALOG:
            SetDlgItemInt(hDlg,IDC_PRGNR,EditProgramm+1,FALSE);
            SetDlgItemText(hDlg,IDC_EDIT1,Programm[EditProgramm].Name);
 
			SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_RESETCONTENT, 0, 0);
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 0, (LPARAM)(LPSTR)"Reserviert");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 1, (LPARAM)(LPSTR)"Digital TV");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 2, (LPARAM)(LPSTR)"Digital Radio");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 3, (LPARAM)(LPSTR)"NVOD ref.");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 4, (LPARAM)(LPSTR)"NVOD TimeShft");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 5, (LPARAM)(LPSTR)"PAL Coded");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 6, (LPARAM)(LPSTR)"SECAM Coded");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 7, (LPARAM)(LPSTR)"D/D2-Coded");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 8, (LPARAM)(LPSTR)"FM-Radio");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 9, (LPARAM)(LPSTR)"Text");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 10, (LPARAM)(LPSTR)"Anwendung");
        	SendMessage (GetDlgItem(hDlg,IDC_COMBO1), CB_INSERTSTRING, 11, (LPARAM)(LPSTR)"Anwendung");

			if ( Programm[EditProgramm].Typ != 'D' ) {
				         SetDlgItemText(hDlg,FREQTEXT,"Mhz");
				       CheckDlgButton(hDlg, IDC_RADIO1, TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_CHECK1),FALSE);
					    EnableWindow(GetDlgItem(hDlg,IDC_RADIO3),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO4),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO5),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO6),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO7),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO8),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO9),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO10),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO11),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO12),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO13),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO14),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO15),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO16),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO17),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO18),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO19),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO20),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO21),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT8),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT9),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT10),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT11),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT12),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO22),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO23),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO24),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO25),FALSE);

			} else {
				         SetDlgItemText(hDlg,FREQTEXT,"Ghz");
				        CheckDlgButton(hDlg, IDC_RADIO2, TRUE);

   						if ( Programm[EditProgramm].Tuner_Auto == TRUE) CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
						   else CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
						if ( Programm[EditProgramm].power == 1 ) CheckDlgButton(hDlg, IDC_RADIO5, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO6, TRUE);
						if ( Programm[EditProgramm].ttk == 1 ) CheckDlgButton(hDlg, IDC_RADIO22, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO23, TRUE);
						if ( Programm[EditProgramm].afc == 1 ) CheckDlgButton(hDlg, IDC_RADIO24, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO25, TRUE);

						   
						if ( Programm[EditProgramm].diseqc == 0 ) CheckDlgButton(hDlg, IDC_RADIO7, TRUE);
                        else if ( Programm[EditProgramm].diseqc == 1 ) CheckDlgButton(hDlg, IDC_RADIO8, TRUE);
                        else if ( Programm[EditProgramm].diseqc == 2 ) CheckDlgButton(hDlg, IDC_RADIO9, TRUE);
                        else if ( Programm[EditProgramm].diseqc == 3 ) CheckDlgButton(hDlg, IDC_RADIO10, TRUE);

						if ( Programm[EditProgramm].volt == 1 ) CheckDlgButton(hDlg, IDC_RADIO20, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO21, TRUE);



                        if ( Programm[EditProgramm].fec == 0 ) CheckDlgButton(hDlg, IDC_RADIO11, TRUE);
                        else if ( Programm[EditProgramm].fec == 1 ) CheckDlgButton(hDlg, IDC_RADIO12, TRUE);
                        else if ( Programm[EditProgramm].fec == 2 ) CheckDlgButton(hDlg, IDC_RADIO13, TRUE);
                        else if ( Programm[EditProgramm].fec == 3 ) CheckDlgButton(hDlg, IDC_RADIO14, TRUE);
                        else if ( Programm[EditProgramm].fec == 4 ) CheckDlgButton(hDlg, IDC_RADIO15, TRUE);
                        else if ( Programm[EditProgramm].fec == 5 ) CheckDlgButton(hDlg, IDC_RADIO16, TRUE);
                        else if ( Programm[EditProgramm].fec == 6 ) CheckDlgButton(hDlg, IDC_RADIO17, TRUE);
                        else if ( Programm[EditProgramm].fec == 7 ) CheckDlgButton(hDlg, IDC_RADIO18, TRUE);
                        else if ( Programm[EditProgramm].fec == 8 ) CheckDlgButton(hDlg, IDC_RADIO19, TRUE);

                        if ( Programm[EditProgramm].TVType == 0 ) CheckDlgButton(hDlg, IDC_RADIO3, TRUE);
                        else if ( Programm[EditProgramm].TVType == 3 ) CheckDlgButton(hDlg, IDC_RADIO4, TRUE);

						SetDlgItemInt(hDlg,IDC_EDIT6,Programm[EditProgramm].srate,FALSE);
						SetDlgItemInt(hDlg,IDC_EDIT7,Programm[EditProgramm].video_pid,FALSE);
						SetDlgItemInt(hDlg,IDC_EDIT8,Programm[EditProgramm].audio_pid,FALSE);
						SetDlgItemInt(hDlg,IDC_EDIT9,Programm[EditProgramm].PMT,FALSE);
						SetDlgItemInt(hDlg,IDC_EDIT10,Programm[EditProgramm].tt_pid,FALSE);
						SetDlgItemInt(hDlg,IDC_EDIT11,Programm[EditProgramm].PCR_pid,FALSE);
						SetDlgItemInt(hDlg,IDC_EDIT12,Programm[EditProgramm].PMC,FALSE);
                        SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_SETCURSEL,Programm[EditProgramm].ServiceTyp,0);
			};


			sprintf(zeile,"%10.3f",(float)Programm[EditProgramm].freq/1000);
            SetDlgItemText(hDlg,IDC_EDIT2,zeile);
            return(TRUE);

        case WM_COMMAND:
              if ( ((HWND)lParam==GetDlgItem(hDlg,IDC_RADIO1)) ||
				   ((HWND)lParam==GetDlgItem(hDlg,IDC_RADIO2)) ) {
				  if ( IsDlgButtonChecked(hDlg, IDC_RADIO1)) {
				        SetDlgItemText(hDlg,FREQTEXT,"Mhz");
                        EnableWindow(GetDlgItem(hDlg,IDC_CHECK1),FALSE);
					    EnableWindow(GetDlgItem(hDlg,IDC_RADIO3),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO4),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO5),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO6),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO7),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO8),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO9),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO10),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO11),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO12),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO13),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO14),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO15),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO16),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO17),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO18),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO19),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO20),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO21),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO22),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO23),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO24),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO25),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT8),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT9),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT10),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT11),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT12),FALSE);
                        EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),FALSE);

				  } else {
				        SetDlgItemText(hDlg,FREQTEXT,"Ghz");
                        EnableWindow(GetDlgItem(hDlg,IDC_CHECK1),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_RADIO3),TRUE);

                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO4),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO5),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO6),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO7),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO8),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO9),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO10),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO11),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO12),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO13),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO14),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO15),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO16),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO17),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO18),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO19),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO20),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO21),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO22),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO23),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO24),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_RADIO25),TRUE);

                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT6),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT7),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT8),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT9),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT10),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT11),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_EDIT12),TRUE);
                        EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),TRUE);

				  }
			  }
			
			if (LOWORD(wParam) == IDOK ) {
             GetDlgItemText(hDlg,IDC_EDIT1,Programm[EditProgramm].Name,sizeof(Programm[EditProgramm].Name));
             GetDlgItemText(hDlg,IDC_EDIT2,zeile,sizeof(zeile));
			 ffreq=(float)atof(zeile);
			 freq=(unsigned	long)(ffreq*1000);
			 Programm[EditProgramm].freq=freq;
              if ( IsDlgButtonChecked(hDlg, IDC_RADIO1)) {
				  Programm[EditProgramm].Typ ='A';
              } else {
                  Programm[EditProgramm].Typ ='D';
				  
                   Programm[EditProgramm].Tuner_Auto=!IsDlgButtonChecked(hDlg, IDC_CHECK1);
				   Programm[EditProgramm].power= IsDlgButtonChecked(hDlg, IDC_RADIO5);
				   Programm[EditProgramm].ttk= IsDlgButtonChecked(hDlg, IDC_RADIO22);
				   Programm[EditProgramm].afc=IsDlgButtonChecked(hDlg,IDC_RADIO24);

				  if ( IsDlgButtonChecked(hDlg, IDC_RADIO7)) Programm[EditProgramm].diseqc = 0;
                    else if ( IsDlgButtonChecked(hDlg, IDC_RADIO8)) Programm[EditProgramm].diseqc = 1;
                     else if ( IsDlgButtonChecked(hDlg, IDC_RADIO9)) Programm[EditProgramm].diseqc = 2;
                      else if ( IsDlgButtonChecked(hDlg, IDC_RADIO10)) Programm[EditProgramm].diseqc = 3;
                      Programm[EditProgramm].volt= IsDlgButtonChecked(hDlg, IDC_RADIO20);


                        if ( IsDlgButtonChecked(hDlg, IDC_RADIO11)) Programm[EditProgramm].fec = 0;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO12)) Programm[EditProgramm].fec = 1;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO13)) Programm[EditProgramm].fec = 2;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO14)) Programm[EditProgramm].fec = 3;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO15)) Programm[EditProgramm].fec = 4;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO16)) Programm[EditProgramm].fec = 5;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO17)) Programm[EditProgramm].fec = 6;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO18)) Programm[EditProgramm].fec = 7;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO19)) Programm[EditProgramm].fec = 8;


                        if ( IsDlgButtonChecked(hDlg, IDC_RADIO3)) Programm[EditProgramm].TVType = 0;
						else Programm[EditProgramm].TVType = 3 ;

						Programm[EditProgramm].afc=GetDlgItemInt(hDlg,IDC_RADIO24,NULL,FALSE);
						Programm[EditProgramm].srate=GetDlgItemInt(hDlg,IDC_EDIT6,NULL,FALSE);
						Programm[EditProgramm].video_pid=GetDlgItemInt(hDlg,IDC_EDIT7,NULL,FALSE);
						Programm[EditProgramm].audio_pid=GetDlgItemInt(hDlg,IDC_EDIT8,NULL,FALSE);
						Programm[EditProgramm].PMT=GetDlgItemInt(hDlg,IDC_EDIT9,NULL,FALSE);
						Programm[EditProgramm].tt_pid=GetDlgItemInt(hDlg,IDC_EDIT10,NULL,FALSE);
						Programm[EditProgramm].PCR_pid=GetDlgItemInt(hDlg,IDC_EDIT11,NULL,FALSE);
						Programm[EditProgramm].PMC=GetDlgItemInt(hDlg,IDC_EDIT12,NULL,FALSE);
                        Programm[EditProgramm].ServiceTyp=SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);


			  }



			 Write_Programm_List();
			 EndDialog(hDlg,TRUE);
			}

			if (LOWORD(wParam) == IDTEST ) {

             GetDlgItemText(hDlg,IDC_EDIT1,Programm[EditProgramm].Name,sizeof(Programm[EditProgramm].Name));
             GetDlgItemText(hDlg,IDC_EDIT2,zeile,sizeof(zeile));
			 ffreq=(float)atof(zeile);
			 freq=(unsigned	long)(ffreq*1000);
			 Programm[MAXPROGS].freq=freq;
              if ( IsDlgButtonChecked(hDlg, IDC_RADIO1)) {
				  Programm[MAXPROGS].Typ ='A';
              } else {
                  Programm[MAXPROGS].Typ ='D';
                   Programm[MAXPROGS].Tuner_Auto=IsDlgButtonChecked(hDlg, IDC_CHECK1);
				   Programm[MAXPROGS].power= IsDlgButtonChecked(hDlg, IDC_RADIO5);
				   Programm[MAXPROGS].ttk= IsDlgButtonChecked(hDlg, IDC_RADIO22);
				   Programm[MAXPROGS].afc= IsDlgButtonChecked(hDlg, IDC_RADIO24);

				   if ( IsDlgButtonChecked(hDlg, IDC_RADIO7)) Programm[MAXPROGS].diseqc = 0;
                    else if ( IsDlgButtonChecked(hDlg, IDC_RADIO8)) Programm[MAXPROGS].diseqc = 1;
                     else if ( IsDlgButtonChecked(hDlg, IDC_RADIO9)) Programm[MAXPROGS].diseqc = 2;
                      else if ( IsDlgButtonChecked(hDlg, IDC_RADIO10)) Programm[MAXPROGS].diseqc = 3;
                      Programm[MAXPROGS].volt= IsDlgButtonChecked(hDlg, IDC_RADIO20);


                        if ( IsDlgButtonChecked(hDlg, IDC_RADIO11)) Programm[MAXPROGS].fec = 0;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO12)) Programm[MAXPROGS].fec = 1;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO13)) Programm[MAXPROGS].fec = 2;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO14)) Programm[MAXPROGS].fec = 3;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO15)) Programm[MAXPROGS].fec = 4;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO16)) Programm[MAXPROGS].fec = 5;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO17)) Programm[MAXPROGS].fec = 6;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO18)) Programm[MAXPROGS].fec = 7;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO19)) Programm[MAXPROGS].fec = 8;


                        if ( IsDlgButtonChecked(hDlg, IDC_RADIO3)) Programm[MAXPROGS].TVType = 0;
						else Programm[MAXPROGS].TVType = 3 ;

						Programm[MAXPROGS].srate=GetDlgItemInt(hDlg,IDC_EDIT6,NULL,FALSE);
						Programm[MAXPROGS].video_pid=GetDlgItemInt(hDlg,IDC_EDIT7,NULL,FALSE);
						Programm[MAXPROGS].audio_pid=GetDlgItemInt(hDlg,IDC_EDIT8,NULL,FALSE);
						Programm[MAXPROGS].PMT=GetDlgItemInt(hDlg,IDC_EDIT9,NULL,FALSE);
						Programm[MAXPROGS].tt_pid=GetDlgItemInt(hDlg,IDC_EDIT10,NULL,FALSE);
						Programm[MAXPROGS].PCR_pid=GetDlgItemInt(hDlg,IDC_EDIT11,NULL,FALSE);
						Programm[MAXPROGS].PMC=GetDlgItemInt(hDlg,IDC_EDIT12,NULL,FALSE);
                        Programm[MAXPROGS].ServiceTyp=SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);
			  }

                if (ValidModes(Programm[MAXPROGS].Typ) == TRUE  ) {
						if (( Current_Mode == 0 ) && ( Programm[MAXPROGS].Typ == 'D' )) Set_Mode_Digital();
				           else if (( Current_Mode == 1 ) && ( Programm[MAXPROGS].Typ == 'A' )) Set_Mode_Analog();
                      
						   if (Programm[MAXPROGS].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(Programm[MAXPROGS].freq*1000,16,1000000));
				               else Set_DVB_Channel(MAXPROGS);
					} else {
					if ( Programm[MAXPROGS].Typ == 'D' ) MessageBox(hDlg,"Digitale Programme knnen Mangels Hardware nicht angezeigt werden","Multi-Dec",MB_ICONSTOP|MB_OK);
						 else if ( Programm[MAXPROGS].Typ == 'A' ) MessageBox(hDlg,"Analoge Programme knnen Mangels Hardware nicht angezeigt werden","Multi-Dec",MB_ICONSTOP|MB_OK);
					}


			}


			if (LOWORD(wParam) == IDB_FPLUS ) {
             GetDlgItemText(hDlg,IDC_EDIT2,zeile,sizeof(zeile));
			 ffreq=(float)atof(zeile);
             ffreq=ffreq+(float)0.25;
             freq=(unsigned	long)(ffreq*1000);
			 
		 if ( ValidModes(Programm[EditProgramm].Typ) == TRUE ) {
			if ( Programm[EditProgramm].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(freq*1000,16,1000000));
			else {

				Set_TV_Freq((unsigned __int64)freq*1000); 
                Sleep(5);
				DVB_Reset(); 
			 };
		 }			 
			 sprintf(zeile,"%10.3f",(float)ffreq);
             SetDlgItemText(hDlg,IDC_EDIT2,zeile);
			};


			if (LOWORD(wParam) == IDB_FMINUS ) {
             GetDlgItemText(hDlg,IDC_EDIT2,zeile,sizeof(zeile));
			 ffreq=(float)atof(zeile);
             ffreq=ffreq-(float)0.25;
             freq=(unsigned	long)(ffreq*1000);
		 if ( ValidModes(Programm[EditProgramm].Typ) == TRUE ) {
			 if ( Programm[EditProgramm].Typ == 'A' ) Tuner_SetFrequency(TunerType,MulDiv(freq*1000,16,1000000));
			else {
                Set_TV_Freq((unsigned __int64)freq*1000); 
                Sleep(5);
				DVB_Reset(); 
             }
			 };

             sprintf(zeile,"%10.3f",(float)ffreq);
             SetDlgItemText(hDlg,IDC_EDIT2,zeile);
			};

               if ( LOWORD(wParam) == IDDEL) {
                  Programm[EditProgramm].freq=0;
                  Programm[EditProgramm].Name[0]=0x00;
        		  i=EditProgramm;
                  while ( i < MAXPROGS-1 ) {
				  memcpy(&Programm[i],&Programm[i+1],sizeof(struct TProgramm));
				  i++;
				  };
                  Programm[i].freq = 0;
                  Programm[i].Name[0] = 0;

				  Write_Programm_List();
				  EndDialog(hDlg,TRUE);

			   }


               if ( LOWORD(wParam) == IDCANCEL) {
			EndDialog(hDlg,TRUE);
				 }

			 break;
    }
    return (FALSE);
        UNREFERENCED_PARAMETER(lParam);
}


BOOL APIENTRY TransponderSettingProc(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
	char zeile[140];
    unsigned long freq;
	float ffreq;


	switch (message) {
        case WM_INITDIALOG:
			
                        Transponder.fec=Programm[CurrentProgramm].fec;
                        Transponder.diseqc=Programm[CurrentProgramm].diseqc;
                        Transponder.freq=Programm[CurrentProgramm].freq;
                        Transponder.power=Programm[CurrentProgramm].power;
                        Transponder.qam=Programm[CurrentProgramm].qam;
                        Transponder.srate=Programm[CurrentProgramm].srate;
                        Transponder.ttk=Programm[CurrentProgramm].ttk;
                        Transponder.Tuner_Auto=Programm[CurrentProgramm].Tuner_Auto;
                        Transponder.volt=Programm[CurrentProgramm].volt;

   						if ( Transponder.Tuner_Auto == TRUE) CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
						   else CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
						if ( Transponder.power == 1 ) CheckDlgButton(hDlg, IDC_RADIO5, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO6, TRUE);
						if ( Transponder.ttk == 1 ) CheckDlgButton(hDlg, IDC_RADIO22, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO23, TRUE);
						   
						if ( Transponder.diseqc == 0 ) CheckDlgButton(hDlg, IDC_RADIO7, TRUE);
                        else if ( Transponder.diseqc == 1 ) CheckDlgButton(hDlg, IDC_RADIO8, TRUE);
                        else if ( Transponder.diseqc == 2 ) CheckDlgButton(hDlg, IDC_RADIO9, TRUE);
                        else if ( Transponder.diseqc == 3 ) CheckDlgButton(hDlg, IDC_RADIO10, TRUE);

						if ( Transponder.volt == 1 ) CheckDlgButton(hDlg, IDC_RADIO20, TRUE);
						   else CheckDlgButton(hDlg, IDC_RADIO21, TRUE);



                        if ( Transponder.fec == 0 ) CheckDlgButton(hDlg, IDC_RADIO11, TRUE);
                        else if ( Transponder.fec == 1 ) CheckDlgButton(hDlg, IDC_RADIO12, TRUE);
                        else if ( Transponder.fec == 2 ) CheckDlgButton(hDlg, IDC_RADIO13, TRUE);
                        else if ( Transponder.fec == 3 ) CheckDlgButton(hDlg, IDC_RADIO14, TRUE);
                        else if ( Transponder.fec == 4 ) CheckDlgButton(hDlg, IDC_RADIO15, TRUE);
                        else if ( Transponder.fec == 5 ) CheckDlgButton(hDlg, IDC_RADIO16, TRUE);
                        else if ( Transponder.fec == 6 ) CheckDlgButton(hDlg, IDC_RADIO17, TRUE);
                        else if ( Transponder.fec == 7 ) CheckDlgButton(hDlg, IDC_RADIO18, TRUE);
                        else if ( Transponder.fec == 8 ) CheckDlgButton(hDlg, IDC_RADIO19, TRUE);
						SetDlgItemInt(hDlg,IDC_EDIT6,Transponder.srate,FALSE);
			sprintf(zeile,"%10.3f",(float)Transponder.freq/1000);
            SetDlgItemText(hDlg,IDC_EDIT2,zeile);
            return(TRUE);

        case WM_COMMAND:
			

			if (LOWORD(wParam) == IDTEST ) {

             GetDlgItemText(hDlg,IDC_EDIT2,zeile,sizeof(zeile));
			 ffreq=(float)atof(zeile);
			 freq=(unsigned	long)(ffreq*1000);
			 Transponder.freq=freq;

			 Transponder.Tuner_Auto=IsDlgButtonChecked(hDlg, IDC_CHECK1);
			 Transponder.power= IsDlgButtonChecked(hDlg, IDC_RADIO5);
			 Transponder.ttk= IsDlgButtonChecked(hDlg, IDC_RADIO22);

				   if ( IsDlgButtonChecked(hDlg, IDC_RADIO7)) Transponder.diseqc = 0;
                    else if ( IsDlgButtonChecked(hDlg, IDC_RADIO8)) Transponder.diseqc = 1;
                     else if ( IsDlgButtonChecked(hDlg, IDC_RADIO9)) Transponder.diseqc = 2;
                      else if ( IsDlgButtonChecked(hDlg, IDC_RADIO10)) Transponder.diseqc = 3;
                      Transponder.volt= IsDlgButtonChecked(hDlg, IDC_RADIO20);


                        if ( IsDlgButtonChecked(hDlg, IDC_RADIO11)) Transponder.fec = 0;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO12)) Transponder.fec = 1;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO13)) Transponder.fec = 2;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO14)) Transponder.fec = 3;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO15)) Transponder.fec = 4;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO16)) Transponder.fec = 5;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO17)) Transponder.fec = 6;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO18)) Transponder.fec = 7;
						else if ( IsDlgButtonChecked(hDlg, IDC_RADIO19)) Transponder.fec = 8;
  					    Transponder.srate=GetDlgItemInt(hDlg,IDC_EDIT6,NULL,FALSE);
                        if ( Transponder.srate != 0 ) {
						(void)Set_Transponder(&Transponder);
						} else {
							Set_Transponder(&Transponder);
							for ( i = 0 ; i < 10 ; i++ ) {
                                if ( SRates[i] != 0 ) SetDlgItemInt(hDlg,IDC_EDIT6,SRates[i],FALSE);
								if ( Set_Transponder_SRate(&Transponder,SRates[i]) == TRUE ) break;
								}
						}


                   if ( Transponder.sync&1 ) SetDlgItemText(hDlg,ID_SIGNAL,"Signal");
				          else SetDlgItemText(hDlg,ID_SIGNAL,"      ");
                   if ( Transponder.sync&2 ) SetDlgItemText(hDlg,ID_CARRIER,"Carrier");
				          else SetDlgItemText(hDlg,ID_CARRIER,"      ");
                   if ( Transponder.sync&3 ) SetDlgItemText(hDlg,ID_VITERBI,"Viterbi");
				          else SetDlgItemText(hDlg,ID_VITERBI,"      ");
                   if ( Transponder.sync&4 ) SetDlgItemText(hDlg,ID_FSYNC,"FSync");
				          else SetDlgItemText(hDlg,ID_FSYNC,"      ");
                   if ( Transponder.sync&5 ) SetDlgItemText(hDlg,ID_FRONT,"FrontSync");
				          else SetDlgItemText(hDlg,ID_FRONT,"      ");
                   if ( Transponder.sync&6 ) SetDlgItemText(hDlg,ID_BIT6,"Bit 6");
				          else SetDlgItemText(hDlg,ID_BIT6,"      ");
                   if ( Transponder.sync&7 ) SetDlgItemText(hDlg,ID_BIT7,"Bit 7");
				          else SetDlgItemText(hDlg,ID_BIT7,"      ");
                   if ( Transponder.sync&8 ) SetDlgItemText(hDlg,ID_BIT8,"Bit 8");
				          else SetDlgItemText(hDlg,ID_BIT8,"      ");
                  SetDlgItemInt(hDlg,ID_NEST,Transponder.nest,FALSE);

				  Get_Pat();
			}

               if ( LOWORD(wParam) == IDOK) {
			EndDialog(hDlg,TRUE);
				 }

               if ( LOWORD(wParam) == IDCANCEL) {
			EndDialog(hDlg,TRUE);
				 }

			 break;
    }
    return (FALSE);
        UNREFERENCED_PARAMETER(lParam);
}




BOOL APIENTRY DigiImport(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
    OPENFILENAME OpenFileName;
    CHAR         szDirName[256]   = "";
    CHAR         szFile[256]      = "\0";
    CHAR         szFileTitle[256];
    CHAR szFilter[] = "DVB-Datei (*.dvb)\0*.dvb\0\0";

struct DVBImport
{
	unsigned char Buffer1[6];
	unsigned short PMT;
	unsigned short Freq;
	unsigned short Symb;
    unsigned char   FEC;
	unsigned char   BW;
	unsigned char   POL;
	unsigned char   Diseq; // Bit 0/1  SpecOff == 4 SpecOn == 8 SpecAuto == 0
	unsigned short  Video_pid;
    unsigned short  Audio_pid;
    unsigned short  PCR_pid;
    unsigned short  Filler1;
	unsigned short  PMC;
	unsigned char   TVType; //  == 00 PAL ; 11 == NTSC    
	unsigned char   ServiceTyp;   
	unsigned short  Text_pid;
    unsigned short  Filler2;
    unsigned char   Name[20];
	unsigned char   Buffer[12];
};

struct DVBImport Import;

	int i,j,k,l;
    int fd;
	char CurrentDir[255];
	char Datei[255];
	char Text[255];

GetCurrentDirectory(sizeof(CurrentDir),CurrentDir);

    switch (message) {
        case WM_INITDIALOG:
             break;

        case WM_COMMAND:

		 if (LOWORD(wParam) == IDC_BUTTON1 ) {
                                             strcpy(szFilter,"DVB-Datei (*.dvb)\0*.dvb\0");
						               		 OpenFileName.lStructSize       = sizeof(OPENFILENAME);
											 OpenFileName.hwndOwner         = hDlg;
                                             OpenFileName.hInstance         = (HANDLE) hInst;
                                             OpenFileName.lpstrFilter       = szFilter;
                                             OpenFileName.lpstrCustomFilter = (LPSTR) NULL;
                                             OpenFileName.nMaxCustFilter    = 0L;
                                             OpenFileName.nFilterIndex      = 0L;
                                             OpenFileName.lpstrFile         = szFile;
                                             OpenFileName.nMaxFile          = sizeof(szFile);
                                             OpenFileName.lpstrFileTitle    = szFileTitle;
                                             OpenFileName.nMaxFileTitle     = sizeof(szFileTitle);
                                             OpenFileName.lpstrInitialDir   = (LPCTSTR)CurrentDir;
                                             OpenFileName.lpstrTitle        = "DVB-Dateien importieren";
                                             OpenFileName.nFileOffset       = 0;
                                             OpenFileName.nFileExtension    = 0;
                                             OpenFileName.lpstrDefExt       = (LPCTSTR)"*.dvb";
                                             OpenFileName.lCustData         = 0;
                                             OpenFileName.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST |
                                                                  OFN_HIDEREADONLY | OFN_NONETWORKBUTTON;

											  
 										     if (!GetOpenFileName(&OpenFileName)) return(FALSE);
											 SetDlgItemText(hDlg,IDC_EDIT1,OpenFileName.lpstrFile);
											 SetCurrentDirectory(CurrentDir);
		 };
		 

		 
		 
		 if (LOWORD(wParam) == IDOK ) {

		    GetDlgItemText(hDlg,IDC_EDIT1,Datei,sizeof(Datei));

            if ((fd=open(Datei,_O_RDONLY | _O_BINARY )) != -1 ) {

			 if ( IsDlgButtonChecked(hDlg, IDC_CHECK1)) {
				 i=0;
		         k=0;
				 while ( i < MAXPROGS ) {
					 if ( Programm[i].Typ == 'D' ) {
				         k++;
						 sprintf(Text,"Lsche %d    ",k);
						 SetDlgItemText(hDlg,IDC_TEXT,Text);
						 j=i;
						 while ( j < MAXPROGS-1 ) {
				             memcpy(&Programm[j],&Programm[j+1],sizeof(struct TProgramm));
				             j++;
							};
                        Programm[j].freq = 0;
                        Programm[j].Name[0] = 0;

					 } else i++;
				 };
			 };

k=0;

			 while ( sizeof(struct DVBImport) == read(fd,&Import,sizeof(struct DVBImport)) ) {
              
				 if ( Import.Freq != 0 ) {
				 i=0;
				 while ( i < MAXPROGS ) {
					 if (( Programm[i].freq == 0 ) && (Programm[i].Name[0]==0x00 )) break;
                     i++;
			 }
				 if ( i>= MAXPROGS ) {
					 				MessageBox(hDlg,"Alle Speicherpltze voll","Multi-Dec",MB_ICONSTOP|MB_OK);
									close(fd);
                         			EndDialog(hDlg,TRUE);
				 };
					
				 k++;
				sprintf(Text,"Importiert %d    ",k);
				SetDlgItemText(hDlg,IDC_TEXT,Text);
				 j=0;
				 l=0;
				 while ( j < strlen(Import.Name) ) {
					 if (( Import.Name[j] >= 0x20 ) && ( Import.Name[j] < 0x86 )) Programm[i].Name[l++]=Import.Name[j];
				     Programm[i].Name[l]=0x00;
					 j++;
				 };
				 Programm[i].Name[19]=0x00;
				Programm[i].Tuner_Auto=TRUE;
				Programm[i].Typ='D';
                Programm[i].PMT = Swab16(&Import.PMT);
                Programm[i].freq =  Swab16(&Import.Freq) * 1000  ;
                Programm[i].srate =  Swab16(&Import.Symb)  ;
				
				if ( Import.FEC == 1 ) Programm[i].fec=8;         // 1/1
				else if ( Import.FEC == 2 ) Programm[i].fec=0;    // 1/2
				else if ( Import.FEC == 3 ) Programm[i].fec=1;    // 2/3
				else if ( Import.FEC == 4 ) Programm[i].fec=2;    // 3/4
				else if ( Import.FEC == 5 ) Programm[i].fec=3;    // ????
				else if ( Import.FEC == 6 ) Programm[i].fec=4;    // 5/6
				else if ( Import.FEC == 7 ) Programm[i].fec=5;    // 7/8
				else if ( Import.FEC == 0 ) Programm[i].fec=8;    // AUTO
                Programm[i].volt = !Import.POL  ;
                Programm[i].diseqc = Import.Diseq & 3 ;
                Programm[i].video_pid =  Swab16(&Import.Video_pid);
                Programm[i].audio_pid =  Swab16(&Import.Audio_pid);
                Programm[i].PCR_pid =  Swab16(&Import.PCR_pid) ;
                Programm[i].PMC =  Swab16(&Import.PMC ) ;
                Programm[i].TVType = Import.TVType & 3  ;
                Programm[i].tt_pid =  Swab16(&Import.Text_pid);
				Programm[i].ServiceTyp = Import.ServiceTyp;
			 }
			 };
			} else {
				MessageBox(hDlg," Datei nicht gefunden ","Multi-Dec",MB_ICONSTOP|MB_OK);
                break;
			};

            Write_Programm_List();  
			EndDialog(hDlg,TRUE);

		 }
		 if (LOWORD(wParam) == IDCANCEL ) {
			EndDialog(hDlg,TRUE);
		 }


			 break;
    }
    return (FALSE);
        UNREFERENCED_PARAMETER(lParam);
}


BOOL APIENTRY SRateSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i,j;
   
	switch (message) {
        case WM_INITDIALOG:
			SetDlgItemInt(hDlg,IDC_EDIT1,SRates[0],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT2,SRates[1],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT3,SRates[2],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT4,SRates[3],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT5,SRates[4],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT6,SRates[5],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT7,SRates[6],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT8,SRates[7],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT9,SRates[8],FALSE);
			SetDlgItemInt(hDlg,IDC_EDIT10,SRates[9],FALSE);
			break;


  case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
				 SRates[0]=GetDlgItemInt(hDlg,IDC_EDIT1,NULL,FALSE);
				 SRates[1]=GetDlgItemInt(hDlg,IDC_EDIT2,NULL,FALSE);
				 SRates[2]=GetDlgItemInt(hDlg,IDC_EDIT3,NULL,FALSE);
				 SRates[3]=GetDlgItemInt(hDlg,IDC_EDIT4,NULL,FALSE);
				 SRates[4]=GetDlgItemInt(hDlg,IDC_EDIT5,NULL,FALSE);
				 SRates[5]=GetDlgItemInt(hDlg,IDC_EDIT6,NULL,FALSE);
				 SRates[6]=GetDlgItemInt(hDlg,IDC_EDIT7,NULL,FALSE);
				 SRates[7]=GetDlgItemInt(hDlg,IDC_EDIT8,NULL,FALSE);
				 SRates[8]=GetDlgItemInt(hDlg,IDC_EDIT9,NULL,FALSE);
				 SRates[9]=GetDlgItemInt(hDlg,IDC_EDIT10,NULL,FALSE);
				EndDialog(hDlg,TRUE);
			}


			if (LOWORD(wParam) == IDCANCEL ) {
				EndDialog(hDlg,TRUE);
			}

			 break;
    }

return(FALSE);
}




BOOL APIENTRY VideoSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i,j;
   
	switch (message) {
        case WM_INITDIALOG:
            
            TBrightness=InitialBrightness;
			TContrast=InitialContrast;
			THue=InitialHue;
            TSaturationU=InitialSaturationU;
            TSaturationV=InitialSaturationV;
            if ( TBrightness < 128 ) i=TBrightness;
			else i=-(256-TBrightness);
			SetDlgItemInt(hDlg,IDC_D1,i,TRUE);
			SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
            if ( THue < 128 ) i=THue;
			else i=-(256-THue);
			SetDlgItemInt(hDlg,IDC_D3,i,TRUE);
			LastSaturation = (TSaturationU+TSaturationV)/2; 
			SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
			SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
			SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);

            if ( TBrightness < 128 ) i=TBrightness;
			else i=-(256-TBrightness);
			y=(int)(157-((double)i/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,FALSE);
			
			y=(int)(235-((double)TContrast/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,FALSE);

            if ( THue < 128 ) i=THue;
			else i=-(256-THue);
			y=(int)(157-((double)i/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,FALSE);

			y=(int)(235-((double)LastSaturation/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,FALSE);

			y=(int)(235-((double)TSaturationU/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-4,22,8,FALSE);

			y=(int)(235-((double)TSaturationV/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S6),410,y-4,22,8,FALSE);


			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 70) && ( y <= 240 )) {
					if (( x >= 33) && ( x <= 55 )) {
            			i=(int)((double)(y-155)/160*255);
                        if ( i < -127) i=-127;
						 else if ( i > 127 ) i=127;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-2,22,8,TRUE);
						  TBrightness=i;
                          if ( TBrightness < 128 ) i=TBrightness;
			                 else i=-(256-TBrightness);
						  SetDlgItemInt(hDlg,IDC_D1,i,TRUE);
				          SetBrightness(TBrightness);
					}
					if (( x >= 109) && ( x <= 131 )) {
            			i=(int)((double)(y-235)/160*255);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-2,22,8,TRUE);
						  TContrast=i;
						  SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
                          SetContrast(TContrast);
					}


					if (( x >= 183) && ( x <= 205 )) {
            			i=(int)((double)(y-155)/160*255);
                        if ( i < -127) i=-127;
						 else if ( i > 127 ) i=127;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-2,22,8,TRUE);
						  THue=i;
			              if ( THue < 128 ) i=THue;
                 			else i=-(256-THue);
						  SetDlgItemInt(hDlg,IDC_D3,i,TRUE);
					      SetHue(THue);
					}
					if (( x >= 258) && ( x <= 280 )) {
            			i=(int)((double)(y-235)/160*255);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						  j=i-LastSaturation;

						if (( j+TSaturationV <= 255) && 
							( j+TSaturationU <= 255 ) && 
							( j+TSaturationV >= 0 ) &&
							( j+TSaturationU >= 0 )) {
                		  
						  MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-2,22,8,TRUE);
						  TSaturationU+=j;
						  y=(int)(235-((double)TSaturationU/256*160));
 						  MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-2,22,8,TRUE);
						  TSaturationV+=j;
						  y=(int)(235-((double)TSaturationV/256*160));
						  MoveWindow(GetDlgItem(hDlg,IDC_S6),410,y-2,22,8,TRUE);
                		  LastSaturation = (TSaturationU+TSaturationV)/2; 
						  SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
						  SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);
						  SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
						  SetSaturationU(TSaturationU);
						  SetSaturationV(TSaturationV);
						}
						}
					if (( x >= 334 ) && ( x <= 356 )) {
            			i=(int)((double)(y-235)/160*255);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-2,22,8,TRUE);
						  TSaturationU=i;
                		  LastSaturation = (TSaturationU+TSaturationV)/2; 
						  SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
						  y=(int)(235-((double)LastSaturation/256*160));
			              MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,TRUE);

						  SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
						  SetSaturationU(TSaturationU);
					}
					if (( x >= 410 ) && ( x <= 432 )) {
            			i=(int)((double)(y-235)/160*255);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S6),410,y-2,22,8,TRUE);
						  TSaturationV=i;
                		  LastSaturation = (TSaturationU+TSaturationV)/2; 
						  SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
						  y=(int)(235-((double)LastSaturation/256*160));
			              MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,TRUE);

						  SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);
						  SetSaturationV(TSaturationV);
					}


                }
			}
           return(FALSE);
        case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
                    InitialBrightness=TBrightness;
					InitialContrast=TContrast;
					InitialHue=THue;
                    InitialSaturationU=TSaturationU;
                    InitialSaturationV=TSaturationV;
 			    	EndDialog(hDlg,TRUE);
			}


			if (LOWORD(wParam) == IDCANCEL ) {
	            SetBrightness(InitialBrightness);
				SetContrast(InitialContrast);
				SetHue(InitialHue);
				SetSaturationU(InitialSaturationU);
				SetSaturationV(InitialSaturationV);
				
				EndDialog(hDlg,TRUE);
			}

               if ( LOWORD(wParam) == IDDEFAULT) {
				 THue=0x00;
				 TBrightness=0x00;			   
				 TContrast=0xd8;	
				 TSaturationU=0xfe;			   
				 TSaturationV=0xb4;			   
	             SetBrightness(TBrightness);
				 SetContrast(TContrast);
				 SetHue(THue);
				 SetSaturationU(TSaturationU);
				 SetSaturationV(TSaturationV);
	             if ( TBrightness < 128 ) i=TBrightness;
             			else i=-(256-TBrightness);
     			 SetDlgItemInt(hDlg,IDC_D1,i,TRUE);
				 SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
	             if ( THue < 128 ) i=THue;
             			else i=-(256-THue);
				 SetDlgItemInt(hDlg,IDC_D3,i,TRUE);
 			     SetDlgItemInt(hDlg,IDC_D4,((TSaturationU+TSaturationV)/2),FALSE);
				 SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
				 SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);
				 y=(int)(157-((double)TBrightness/256*160));
				 MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,TRUE);
				 y=(int)(235-((double)TContrast/256*160));
				 MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);
				 y=(int)(157-((double)THue/256*160));
				 MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,TRUE);
			     y=(int)(235-((double)((TSaturationU+TSaturationV)/2)/256*160));
			     MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,TRUE);
				 y=(int)(235-((double)TSaturationU/256*160));
				 MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-4,22,8,TRUE);
				 y=(int)(235-((double)TSaturationV/256*160));
				 MoveWindow(GetDlgItem(hDlg,IDC_S6),410,y-4,22,8,TRUE);
                 break;
			   
			 }

			 break;
    }

return(FALSE);
}


BOOL APIENTRY VideoSettingDigiProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i,j;
   
	switch (message) {
        case WM_INITDIALOG:
            
            TBrightness=InitialDVBBrightness;
			TContrast=InitialDVBContrast;
			TColor=InitialDVBColor;
			SetDlgItemInt(hDlg,IDC_D1,TBrightness,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
			SetDlgItemInt(hDlg,IDC_D3,TColor,FALSE);
			y=(int)(235-((double)TBrightness/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,FALSE);
			
			y=(int)(235-((double)TContrast/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,FALSE);

			y=(int)(235-((double)TColor/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,FALSE);
			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 70) && ( y <= 240 )) {
					if (( x >= 33) && ( x <= 55 )) {
            			i=(int)((double)(y-235)/160*255);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-2,22,8,TRUE);
						  TBrightness=i;
						  SetDlgItemInt(hDlg,IDC_D1,i,TRUE);
				          set_picture_prop(TBrightness,TContrast,TColor);
					}
					if (( x >= 109) && ( x <= 131 )) {
            			i=(int)((double)(y-235)/160*127);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 127 ) i=127;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-2,22,8,TRUE);
						  TContrast=i;
						  SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
				          set_picture_prop(TBrightness,TContrast,TColor);
					}


					if (( x >= 183) && ( x <= 205 )) {
            			i=(int)((double)(y-235)/160*127);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 127) i=127;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-2,22,8,TRUE);
						  TColor=i;
						  SetDlgItemInt(hDlg,IDC_D3,TColor,TRUE);
				          set_picture_prop(TBrightness,TContrast,TColor);
					}


                }
			}
           return(FALSE);
        case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
                    InitialDVBBrightness=TBrightness;
					InitialDVBContrast=TContrast;
					InitialDVBColor=TColor;
 			    	EndDialog(hDlg,TRUE);
			}


			if (LOWORD(wParam) == IDCANCEL ) {
				          set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
				EndDialog(hDlg,TRUE);
			}

               if ( LOWORD(wParam) == IDDEFAULT) {
				 TBrightness=0x80;
				 TContrast=0x40;			   
				 TColor=0x40;	
	             set_picture_prop(InitialDVBBrightness,InitialDVBContrast,InitialDVBColor);
			SetDlgItemInt(hDlg,IDC_D1,TBrightness,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
			SetDlgItemInt(hDlg,IDC_D3,TColor,FALSE);
			y=(int)(235-((double)TBrightness/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,TRUE);
			
			y=(int)(235-((double)TContrast/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);

			y=(int)(235-((double)TColor/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,TRUE);
			break;
		 }

			 break;
    }

return(FALSE);
}




BOOL APIENTRY AudioSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i;
   
	switch (message) {
        case WM_INITDIALOG:
            if ( Has_MSP == FALSE ) {
                MessageBox(hWnd,"Kein MSP-Audio-Device gefunden","Multi-Decode",MB_ICONSTOP|MB_OK);
                EndDialog(hDlg,0);
			}

            TVolume=InitialVolume;
			TSpecial=InitialSpecial;
			TLoudness=InitialLoudness;
            TBass=InitialBass;
            TTreble=InitialTreble;
            TBalance=InitialBalance;
			TSuperBass=InitialSuperBass;


			SetDlgItemInt(hDlg,IDC_D1,TVolume,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,TSpecial,TRUE);
			SetDlgItemInt(hDlg,IDC_D3,TLoudness,TRUE);
			SetDlgItemInt(hDlg,IDC_D4,TBass,TRUE);
			SetDlgItemInt(hDlg,IDC_D5,TTreble,TRUE);
			SetDlgItemInt(hDlg,IDC_D6,TBalance,TRUE);

            CheckDlgButton(hDlg, IDC_CHECK1, TSuperBass);

			y=(int)(235-((double)(TVolume+1)/1000*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,FALSE);

			y=(int)(157-((double)(TSpecial+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,FALSE);

			y=(int)(235-((TLoudness+1)/68*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,FALSE);

			y=(int)(157-((double)(TBass+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,FALSE);

			y=(int)(157-((double)(TTreble+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-4,22,8,FALSE);

			x=(int)(279-((double)(TBalance+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S6),x-4,271,8,22,FALSE);


			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 70) && ( y <= 240 )) {
					if (( x >= 33) && ( x <= 55 )) {
            			i=(int)((double)(y-235)/160*1000);
                        i=-i;
						if ( i < 0 ) i=0;
						 else if ( i > 1000 ) i=1000;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-2,22,8,TRUE);
						  InitialVolume=i;
						  SetDlgItemInt(hDlg,IDC_D1,InitialVolume,FALSE);
				          Audio_SetVolume(InitialVolume);
					}
					if (( x >= 109) && ( x <= 131 )) {
            			i=(int)((double)(y-155)/160*255);
                        if ( i < -127) i=-127;
						 else if ( i > 128 ) i=128;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-2,22,8,TRUE);
						  InitialSpecial=i;
						  SetDlgItemInt(hDlg,IDC_D2,InitialSpecial,TRUE);
                          Audio_SetSpatial(InitialSpecial); 
					}


					if (( x >= 183) && ( x <= 205 )) {
            			i=(int)((double)(y-235)/160*68);
                        i=-i;
						if ( i < 0 ) i=0;
						 else if ( i > 68 ) i=68;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-2,22,8,TRUE);
						  InitialLoudness=i;
						  SetDlgItemInt(hDlg,IDC_D3,InitialLoudness,FALSE);
			              Audio_SetLoudness(InitialLoudness);
					}
					if (( x >= 258) && ( x <= 280 )) {
            			i=(int)((double)(y-155)/160*255);
						  i=-i;
                        if ( i < -96) i=-96;
						 else if ( i > 127 ) i=127;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-2,22,8,TRUE);
						  InitialBass=i;
						  SetDlgItemInt(hDlg,IDC_D4,InitialBass,TRUE);
				          Audio_SetBass(InitialBass);
					}
					if (( x >= 334 ) && ( x <= 356 )) {
            			i=(int)((double)(y-155)/160*255);
						 i=-i;
                        if ( i < -96) i=-96;
						 else if ( i > 127 ) i=127;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-2,22,8,TRUE);
						  InitialTreble=i;
						  SetDlgItemInt(hDlg,IDC_D5,InitialTreble,TRUE);
					      Audio_SetTreble(InitialTreble);
					}


                }
				if (( y >= 271 ) && ( y <= 293 ) && ( x >= 195 ) && ( x <= 360 )) {

					i=(int)((double)(x-277)/160*255);
						 i=-i;
                        if ( i < -127) i=-127;
						 else if ( i > 127 ) i=127;
						  InitialBalance=i;
						  SetDlgItemInt(hDlg,IDC_D6,InitialBalance,TRUE);
             			x=(int)(279-((double)(InitialBalance+1)/256*160));
			            MoveWindow(GetDlgItem(hDlg,IDC_S6),x-4,271,8,22,TRUE);
						Audio_SetBalance(InitialBalance); // -127 - +128

				}
			
			}
           return(FALSE);
        case WM_COMMAND:
             if ( (HWND)lParam==GetDlgItem(hDlg,IDC_CHECK1) ) Audio_SetSuperBass(IsDlgButtonChecked(hDlg, IDC_CHECK1));
         			
			if (LOWORD(wParam) == IDOK ) {

					SetAudioSource(4);
     	            Audio_SetSuperBass(IsDlgButtonChecked(hDlg, IDC_CHECK1));
					Audio_SetVolume(InitialVolume);
	    			Audio_SetSpatial(InitialSpecial); 
		    		Audio_SetLoudness(InitialLoudness);
			    	Audio_SetBass(InitialBass);
				    Audio_SetTreble(InitialTreble);
				    Audio_SetBalance(InitialBalance); 
                   
                    SetAudioSource(AudioSource);
					EndDialog(hDlg,TRUE);
			}


			if (LOWORD(wParam) == IDCANCEL ) {
				SetAudioSource(4);
   	            Audio_SetSuperBass(TSuperBass);
				Audio_SetVolume(TVolume);
				Audio_SetSpatial(TSpecial); 
				Audio_SetLoudness(TLoudness);
				Audio_SetBass(TBass);
				Audio_SetTreble(TTreble);
				Audio_SetBalance(TBalance); 
                SetAudioSource(AudioSource);
				EndDialog(hDlg,TRUE);
			}



               if ( LOWORD(wParam) == IDDEFAULT) {

				TVolume=1000;
				TBalance=0x00;
				TSpecial=0x00;
				TLoudness=0x00;
				TBass=0x00;
				TTreble=0x00;
                CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
				SetAudioSource(4);
 			    Audio_SetSuperBass(FALSE);
	            Audio_SetVolume(TVolume);
				Audio_SetSpatial(TSpecial); 
				Audio_SetLoudness(TLoudness);
				Audio_SetBass(TBass);
				Audio_SetTreble(TTreble);
				Audio_SetBalance(TBalance); 
				
			SetDlgItemInt(hDlg,IDC_D1,TVolume,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,TSpecial,TRUE);
			SetDlgItemInt(hDlg,IDC_D3,TLoudness,TRUE);
			SetDlgItemInt(hDlg,IDC_D4,TBass,TRUE);
			SetDlgItemInt(hDlg,IDC_D5,TTreble,TRUE);
			SetDlgItemInt(hDlg,IDC_D6,TBalance,TRUE);
            SetAudioSource(AudioSource);

			y=(int)(235-((double)(TVolume+1)/1000*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,TRUE);

			y=(int)(157-((double)(TSpecial+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);

			y=(int)(235-((TLoudness+1)/68*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,TRUE);

			y=(int)(157-((double)(TBass+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,TRUE);

			y=(int)(157-((double)(TTreble+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-4,22,8,TRUE);

			x=(int)(279-((double)(TBalance+1)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S6),x-4,271,8,22,TRUE);

			break;
			   
			 }

			 break;
    }

return(FALSE);
}


BOOL APIENTRY AudioDigiSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i,j;
   
	switch (message) {
        case WM_INITDIALOG:
            TVolumeLinks=InitialDVBVolumeLinks;
			TVolumeRechts=InitialDVBVolumeRechts;
            TVolume=(InitialDVBVolumeLinks+InitialDVBVolumeRechts)/2;

			SetDlgItemInt(hDlg,IDC_D1,TVolumeLinks,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,TVolume,FALSE);
			SetDlgItemInt(hDlg,IDC_D3,TVolumeRechts,FALSE);

			y=(int)(235-((double)TVolumeLinks/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,FALSE);

			y=(int)(235-((double)TVolume/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,FALSE);

			y=(int)(235-((double)TVolumeRechts/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,FALSE);
			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 70) && ( y <= 240 )) {
					if (( x >= 33) && ( x <= 55 )) {
            			i=(int)((double)(y-235)/160*127);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 127 ) i=127;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-2,22,8,TRUE);
						  TVolumeLinks=i;
						  SetDlgItemInt(hDlg,IDC_D1,i,TRUE);
                		  TVolume = (TVolumeLinks+TVolumeRechts)/2; 
						  SetDlgItemInt(hDlg,IDC_D2,TVolume,FALSE);
						  y=(int)(235-((double)TVolume/256*160));
			              MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);
						  DVB_SetVolume((unsigned char)TVolumeLinks, (unsigned char)TVolumeRechts);
					}
					if (( x >= 109) && ( x <= 131 )) {
            			i=(int)((double)(y-235)/160*127);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 127 ) i=127;
						  j=i-TVolume;

						if (( j+TVolumeLinks <= 127) && 
							( j+TVolumeRechts <= 127 ) && 
							( j+TVolumeLinks >= 0 ) &&
							( j+TVolumeRechts >= 0 )) {
                		  
 			              MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);

						  TVolumeLinks+=j;
						  y=(int)(235-((double)TVolumeLinks/128*160));
                		  MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-2,22,8,TRUE);
						  
						  TVolumeRechts+=j;
						  y=(int)(235-((double)TVolumeRechts/128*160));
              			  MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-2,22,8,TRUE);

                		  TVolume = (TVolumeLinks+TVolumeRechts)/2; 
			              SetDlgItemInt(hDlg,IDC_D1,TVolumeLinks,FALSE);
			              SetDlgItemInt(hDlg,IDC_D2,TVolume,FALSE);
			              SetDlgItemInt(hDlg,IDC_D3,TVolumeRechts,FALSE);
				          DVB_SetVolume((unsigned char)TVolumeLinks, (unsigned char)TVolumeRechts);
						}
					}


					if (( x >= 183) && ( x <= 205 )) {
            			i=(int)((double)(y-235)/160*127);
						i=-i;
                        if ( i < 0) i=0;
						 else if ( i > 127 ) i=127;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-2,22,8,TRUE);
						  TVolumeRechts=i;
						  SetDlgItemInt(hDlg,IDC_D3,i,TRUE);
                		  TVolume = (TVolumeLinks+TVolumeRechts)/2; 
						  SetDlgItemInt(hDlg,IDC_D2,TVolume,FALSE);
						  y=(int)(235-((double)TVolume/128*160));
			              MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);
						  DVB_SetVolume((unsigned char)TVolumeLinks, (unsigned char)TVolumeRechts);
					}
                }
			
			}
           return(FALSE);
        case WM_COMMAND:
         			
			if (LOWORD(wParam) == IDOK ) {
                   InitialDVBVolumeRechts=TVolumeRechts;
                   InitialDVBVolumeLinks=TVolumeLinks;
				   EndDialog(hDlg,TRUE);
			}

			if (LOWORD(wParam) == IDCANCEL ) {
				 DVB_SetVolume((unsigned char)InitialDVBVolumeLinks, (unsigned char)InitialDVBVolumeRechts);
				EndDialog(hDlg,TRUE);
			}



               if ( LOWORD(wParam) == IDDEFAULT) {

				TVolumeRechts=0x45;
				TVolumeLinks=0x45;
				DVB_SetVolume((unsigned char)TVolumeLinks, (unsigned char)TVolumeRechts);
				
			SetDlgItemInt(hDlg,IDC_D1,TVolumeLinks,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,TVolume,FALSE);
			SetDlgItemInt(hDlg,IDC_D3,TVolumeRechts,FALSE);

			y=(int)(235-((double)TVolumeLinks/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,TRUE);

			y=(int)(235-((double)TVolume/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);

			y=(int)(235-((double)TVolumeRechts/128*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,TRUE);

			break;
			   
			 }

			 break;
    }

return(FALSE);
}



BOOL APIENTRY LNBSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i,j;
   
	switch (message) {
        case WM_INITDIALOG:

			CheckDlgButton(hDlg, IDC_CHECK1, LNB.Diseq);

			SetDlgItemInt(hDlg,IDC_LOF_LOW1,LNB.Anschluss[0].LofLow,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_SWITCH1,LNB.Anschluss[0].SwitchFreq,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_HIGH1,LNB.Anschluss[0].LofHigh,FALSE);
			CheckDlgButton(hDlg, IDC_LNBPOWER1, LNB.Anschluss[0].Power);
			CheckDlgButton(hDlg, IDC_LNBSWITSH22KHZ1, LNB.Anschluss[0].Switch22khz);

			SetDlgItemInt(hDlg,IDC_LOF_LOW2,LNB.Anschluss[1].LofLow,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_SWITCH2,LNB.Anschluss[1].SwitchFreq,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_HIGH2,LNB.Anschluss[1].LofHigh,FALSE);
			CheckDlgButton(hDlg, IDC_LNBPOWER2, LNB.Anschluss[1].Power);
			CheckDlgButton(hDlg, IDC_LNBSWITSH22KHZ2, LNB.Anschluss[1].Switch22khz);

			SetDlgItemInt(hDlg,IDC_LOF_LOW3,LNB.Anschluss[2].LofLow,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_SWITCH3,LNB.Anschluss[2].SwitchFreq,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_HIGH3,LNB.Anschluss[2].LofHigh,FALSE);
			CheckDlgButton(hDlg, IDC_LNBPOWER3, LNB.Anschluss[2].Power);
			CheckDlgButton(hDlg, IDC_LNBSWITSH22KHZ3, LNB.Anschluss[2].Switch22khz);

			SetDlgItemInt(hDlg,IDC_LOF_LOW4,LNB.Anschluss[3].LofLow,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_SWITCH4,LNB.Anschluss[3].SwitchFreq,FALSE);
			SetDlgItemInt(hDlg,IDC_LOF_HIGH4,LNB.Anschluss[3].LofHigh,FALSE);
			CheckDlgButton(hDlg, IDC_LNBPOWER4, LNB.Anschluss[3].Power);
			CheckDlgButton(hDlg, IDC_LNBSWITSH22KHZ4, LNB.Anschluss[3].Switch22khz);
			break;

        case WM_COMMAND:
         			
			if (LOWORD(wParam) == IDOK ) {
  			  LNB.Diseq=IsDlgButtonChecked(hDlg, IDC_CHECK1);
              
			  LNB.Anschluss[0].LofLow=GetDlgItemInt(hDlg,IDC_LOF_LOW1,NULL,FALSE);
			  LNB.Anschluss[0].SwitchFreq=GetDlgItemInt(hDlg,IDC_LOF_SWITCH1,NULL,FALSE);
			  LNB.Anschluss[0].LofHigh=GetDlgItemInt(hDlg,IDC_LOF_HIGH1,NULL,FALSE);
			  LNB.Anschluss[0].Power=IsDlgButtonChecked(hDlg, IDC_LNBPOWER1 );
			  LNB.Anschluss[0].Switch22khz=IsDlgButtonChecked(hDlg, IDC_LNBSWITSH22KHZ1 );

			  LNB.Anschluss[1].LofLow=GetDlgItemInt(hDlg,IDC_LOF_LOW2,NULL,FALSE);
			  LNB.Anschluss[1].SwitchFreq=GetDlgItemInt(hDlg,IDC_LOF_SWITCH2,NULL,FALSE);
			  LNB.Anschluss[1].LofHigh=GetDlgItemInt(hDlg,IDC_LOF_HIGH2,NULL,FALSE);
			  LNB.Anschluss[1].Power=IsDlgButtonChecked(hDlg, IDC_LNBPOWER2 );
			  LNB.Anschluss[1].Switch22khz=IsDlgButtonChecked(hDlg, IDC_LNBSWITSH22KHZ2 );

			  LNB.Anschluss[2].LofLow=GetDlgItemInt(hDlg,IDC_LOF_LOW3,NULL,FALSE);
			  LNB.Anschluss[2].SwitchFreq=GetDlgItemInt(hDlg,IDC_LOF_SWITCH3,NULL,FALSE);
			  LNB.Anschluss[2].LofHigh=GetDlgItemInt(hDlg,IDC_LOF_HIGH3,NULL,FALSE);
			  LNB.Anschluss[2].Power=IsDlgButtonChecked(hDlg, IDC_LNBPOWER3 );
			  LNB.Anschluss[2].Switch22khz=IsDlgButtonChecked(hDlg, IDC_LNBSWITSH22KHZ3 );


  			  LNB.Anschluss[3].LofLow=GetDlgItemInt(hDlg,IDC_LOF_LOW4,NULL,FALSE);
			  LNB.Anschluss[3].SwitchFreq=GetDlgItemInt(hDlg,IDC_LOF_SWITCH4,NULL,FALSE);
			  LNB.Anschluss[3].LofHigh=GetDlgItemInt(hDlg,IDC_LOF_HIGH4,NULL,FALSE);
			  LNB.Anschluss[3].Power=IsDlgButtonChecked(hDlg, IDC_LNBPOWER4 );
			  LNB.Anschluss[3].Switch22khz=IsDlgButtonChecked(hDlg, IDC_LNBSWITSH22KHZ4 );
			  
			  EndDialog(hDlg,TRUE);
			}

			if (LOWORD(wParam) == IDCANCEL ) {
				EndDialog(hDlg,TRUE);
			}




			 break;
    }

return(FALSE);
}




BOOL APIENTRY SecamSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i;
   
	switch (message) {
        case WM_INITDIALOG:

            TUFilter=iUFilterThresholdPCent;
			TVFilter=iVFilterThresholdPCent;

			SetDlgItemInt(hDlg,IDC_D1,iUFilterThresholdPCent,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,iVFilterThresholdPCent,FALSE);

			y=(int)(235-((double)(TUFilter+1)/100*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),63,y-4,22,8,FALSE);

			y=(int)(235-((double)(TVFilter+1)/100*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),138,y-4,22,8,FALSE);
			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 70) && ( y <= 240 )) {
					if (( x >= 63) && ( x <= 85 )) {
            			i=(int)((double)(y-235)/160*100);
                        i=-i;
						if ( i < 0 ) i=1;
						 else if ( i > 100 ) i=100;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),63,y-2,22,8,TRUE);
						  iUFilterThresholdPCent=i;
						  SetDlgItemInt(hDlg,IDC_D1,iUFilterThresholdPCent,FALSE);
					}
					if (( x >= 139) && ( x <= 160 )) {
            			i=(int)((double)(y-235)/160*100);
                        i=-i;
						if ( i < 0 ) i=1;
						 else if ( i > 100 ) i=100;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S2),138,y-2,22,8,TRUE);
						  iVFilterThresholdPCent=i;
						  SetDlgItemInt(hDlg,IDC_D2,iVFilterThresholdPCent,FALSE);
					}
				}              

			
			}
           return(FALSE);
        case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
					EndDialog(hDlg,TRUE);
			}


 			if (LOWORD(wParam) == IDCANCEL ) {
				   iUFilterThresholdPCent=TUFilter;
			       iVFilterThresholdPCent=TVFilter;
				   EndDialog(hDlg,TRUE);
			}



               if ( LOWORD(wParam) == IDDEFAULT) {

				   iUFilterThresholdPCent=70;
			       iVFilterThresholdPCent=70;
				
			SetDlgItemInt(hDlg,IDC_D1,iUFilterThresholdPCent,FALSE);
			SetDlgItemInt(hDlg,IDC_D2,iVFilterThresholdPCent,FALSE);
			y=(int)(235-((double)(iUFilterThresholdPCent+1)/100*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),63,y-4,22,8,TRUE);
			y=(int)(235-((double)(iVFilterThresholdPCent+1)/100*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),138,y-4,22,8,TRUE);
			break;
			   
			 }

			 break;
    }

return(FALSE);
}



BOOL APIENTRY AudioSettingProc1
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i;
   
	switch (message) {
        case WM_INITDIALOG:
            if ( Has_MSP == FALSE ) {
                MessageBox(hWnd,"Kein MSP-Audio-Device gefunden","Multi-Decode",MB_ICONSTOP|MB_OK);
                EndDialog(hDlg,0);
			}

            TEqualizer1=InitialEqualizer1;
			TEqualizer2=InitialEqualizer2;
			TEqualizer3=InitialEqualizer3;
            TEqualizer4=InitialEqualizer4;
            TEqualizer5=InitialEqualizer5;

			SetDlgItemInt(hDlg,IDC_D1,TEqualizer1,TRUE);
			SetDlgItemInt(hDlg,IDC_D2,TEqualizer2,TRUE);
			SetDlgItemInt(hDlg,IDC_D3,TEqualizer3,TRUE);
			SetDlgItemInt(hDlg,IDC_D4,TEqualizer4,TRUE);
			SetDlgItemInt(hDlg,IDC_D5,TEqualizer5,TRUE);

			y=(int)(157-((double)(TEqualizer1)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,FALSE);

			y=(int)(157-((double)(TEqualizer2)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,FALSE);

			y=(int)(157-((double)(TEqualizer3)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,FALSE);

			y=(int)(157-((double)(TEqualizer4)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,FALSE);

			y=(int)(157-((double)(TEqualizer5)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-4,22,8,FALSE);
			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 70) && ( y <= 240 )) {
					if (( x >= 33) && ( x <= 55 )) {
            			i=(int)((double)(y-155)/210*192);
                        if ( i < -69) i=-69;
						 else if ( i > 69 ) i=69;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-2,22,8,TRUE);
						  InitialEqualizer1=i;
						  SetDlgItemInt(hDlg,IDC_D1,InitialEqualizer1,TRUE);
                          Audio_SetEqualizer1(InitialEqualizer1);
					}
					if (( x >= 109) && ( x <= 131 )) {
            			i=(int)((double)(y-155)/210*192);
                        if ( i < -69) i=-69;
						 else if ( i > 69 ) i=69;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-2,22,8,TRUE);
						  InitialEqualizer2=i;
						  SetDlgItemInt(hDlg,IDC_D2,InitialEqualizer2,TRUE);
                          Audio_SetEqualizer2(InitialEqualizer2);
					}
					if (( x >= 183) && ( x <= 205 )) {
            			i=(int)((double)(y-155)/210*192);
                        if ( i < -69) i=-69;
						 else if ( i > 69 ) i=69;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-2,22,8,TRUE);
						  InitialEqualizer3=i;
						  SetDlgItemInt(hDlg,IDC_D3,InitialEqualizer3,TRUE);
			              Audio_SetEqualizer3(InitialEqualizer3);
					}
					if (( x >= 258) && ( x <= 280 )) {
            			i=(int)((double)(y-155)/210*192);
                        if ( i < -69) i=-69;
						 else if ( i > 69 ) i=69;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-2,22,8,TRUE);
						  InitialEqualizer4=i;
						  SetDlgItemInt(hDlg,IDC_D4,InitialEqualizer4,TRUE);
			              Audio_SetEqualizer4(InitialEqualizer4);
					}
					if (( x >= 334 ) && ( x <= 356 )) {
            			i=(int)((double)(y-155)/210*192);
                        if ( i < -69) i=-69;
						 else if ( i > 69 ) i=69;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-2,22,8,TRUE);
						  InitialEqualizer5=i;
						  SetDlgItemInt(hDlg,IDC_D5,InitialEqualizer5,TRUE);
			              Audio_SetEqualizer5(InitialEqualizer5);
					}
                }
			
			}
           return(FALSE);
        case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
					SetAudioSource(4);
     	            Audio_SetEqualizer1(InitialEqualizer1);
     	            Audio_SetEqualizer2(InitialEqualizer2);
     	            Audio_SetEqualizer3(InitialEqualizer3);
     	            Audio_SetEqualizer4(InitialEqualizer4);
					Audio_SetEqualizer5(InitialEqualizer5);
                    SetAudioSource(AudioSource);
					EndDialog(hDlg,TRUE);
			}


			if (LOWORD(wParam) == IDCANCEL ) {
					SetAudioSource(4);
     	            Audio_SetEqualizer1(TEqualizer1);
     	            Audio_SetEqualizer2(TEqualizer2);
     	            Audio_SetEqualizer3(TEqualizer3);
     	            Audio_SetEqualizer4(TEqualizer4);
					Audio_SetEqualizer5(TEqualizer5);
                    SetAudioSource(AudioSource);
  				    EndDialog(hDlg,TRUE);
			}



               if ( LOWORD(wParam) == IDDEFAULT) {

            TEqualizer1=0x00;
			TEqualizer2=0x00;
			TEqualizer3=0x00;
            TEqualizer4=0x00;
            TEqualizer5=0x00;
			SetAudioSource(4);
     	    Audio_SetEqualizer1(0);
     	    Audio_SetEqualizer2(0);
     	    Audio_SetEqualizer3(0);
     	    Audio_SetEqualizer4(0);
			Audio_SetEqualizer5(0);
            SetAudioSource(AudioSource);
			SetDlgItemInt(hDlg,IDC_D1,TEqualizer1,TRUE);
			SetDlgItemInt(hDlg,IDC_D2,TEqualizer2,TRUE);
			SetDlgItemInt(hDlg,IDC_D3,TEqualizer3,TRUE);
			SetDlgItemInt(hDlg,IDC_D4,TEqualizer4,TRUE);
			SetDlgItemInt(hDlg,IDC_D5,TEqualizer5,TRUE);

			y=(int)(157-((double)(TEqualizer1)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),33,y-4,22,8,TRUE);

			y=(int)(157-((double)(TEqualizer2)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),109,y-4,22,8,TRUE);

			y=(int)(157-((double)(TEqualizer3)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),183,y-4,22,8,TRUE);

			y=(int)(157-((double)(TEqualizer4)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),258,y-4,22,8,TRUE);

			y=(int)(157-((double)(TEqualizer5)/192*210));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),334,y-4,22,8,TRUE);
			break;
			   
			 }

			 break;
    }

return(FALSE);
}



BOOL APIENTRY ResSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int i,j;
int Boot_Up_Loop=0;

	switch (message) {
        case WM_INITDIALOG:
			   Stop_Thread();
			   Sleep(10);
			   Set_Capture(4);
			   OutDib=TRUE;
			   InitTV(hWnd,FALSE,640,480);
			   MoveWindow(hWnd,0,0,640,480,TRUE);
			   Init_Screen_Struct();
			   emstartx=Res_X;
               emstarty=Res_Y;
			   Set_Capture(5);
			   SetDlgItemInt(hDlg,IDC_RESX,Res_X,FALSE);
               SetDlgItemInt(hDlg,IDC_RESY,Res_Y,FALSE);
            break;
		case WM_TIMER:
            if (LOWORD(wParam) == 2 ) {
			   KillTimer(hDlg,2);
			   Stop_Thread();
			   Sleep(10);
			   Set_Capture(4);
			   InitTV(hWnd,FALSE,640,480);
			   MoveWindow(hWnd,0,0,640,480,TRUE);
               ShowWindow(hDlg,SW_SHOW);
			   EnableWindow(GetDlgItem(hDlg,IDOK),FALSE);
			   Init_Screen_Struct();
			   Set_Capture(5);
               if  ( MessageBox(hDlg,"War es in Ordnung ?? ","Multi-Dekoder",MB_ICONQUESTION | MB_YESNO ) == IDYES ) EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
			}
           break;

		case WM_COMMAND:

			if (LOWORD(wParam) == IDC_BUTTON1 ) {
               i=GetDlgItemInt(hDlg,IDC_RESX,NULL,FALSE);
               j=GetDlgItemInt(hDlg,IDC_RESY,NULL,FALSE);
			   Stop_Thread();
			   Sleep(10);
			   Set_Capture(4);
			   if (  InitTV(hWnd,TRUE,i,j) == FALSE ) {
				   i=0;
 			       InitTV(hWnd,FALSE,640,480);
			       MoveWindow(hWnd,0,0,640,480,TRUE);
			   }
			   Init_Screen_Struct();
			   Set_Capture(5);
			   if ( i != 0 ) {
               ShowWindow(hDlg,SW_HIDE);
			   SetTimer(hDlg,2,10000,NULL);
			}
			}


			if (LOWORD(wParam) == IDOK ) {

			   Res_X=GetDlgItemInt(hDlg,IDC_RESX,NULL,FALSE);
               Res_Y=GetDlgItemInt(hDlg,IDC_RESY,NULL,FALSE);
			   Stop_Thread();
			   Sleep(10);
			   Set_Capture(4);
			   if (  InitTV(hWnd,TRUE,Res_X,Res_Y) == FALSE ) {
			         InitTV(hWnd,FALSE,640,480);
 			         MoveWindow(hWnd,0,0,640,480,TRUE);
			         Init_Screen_Struct();
			         Set_Capture(5);
			   } else {
               WindowStyle=3;
			   CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
			   CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_CHECKED );

			   Init_Screen_Struct();
			   Set_Capture(5);
			   EndDialog(hDlg,TRUE);
			   }
			}
			
			if (LOWORD(wParam) == IDCANCEL ) {
               Res_X=emstartx;
               Res_Y=emstarty;
               EndDialog(hDlg,TRUE);
			}

			break;
    }

return(FALSE);
}


void Write_Programm_List()
{
	int i,j;
	int fd;

	if ((fd=open("Programm.ids" ,_O_WRONLY | _O_TRUNC | _O_CREAT | _O_BINARY , _S_IWRITE | _S_IREAD)) == -1 ) {
		 MessageBox(hWnd,"Kann Programmdatei <programm.ids> nicht schreiben","Multi-Decode",MB_ICONSTOP|MB_OK);
		 return;
	};

i=0;
while ( i < MAXPROGS ) {
	if ( Programm[i].Name[0] != 0x00 ) {
		j=write(fd,&Programm[i],sizeof(struct TProgramm));
	};
	i++;
};
close(fd);
};

void Load_Programm_List()
{
typedef struct TProgrammalt
{
	char Name[64];
    unsigned long freq;
};
struct TProgrammalt Programmalt;


	
	int i,j,k;
	int fd;
i=0;
while ( i < MAXPROGS ) {
Programm[i].Name[0]=0x00;
Programm[i].freq=0L;
i++;
};

if ((fd=open("Programm.idx" ,_O_RDONLY | _O_BINARY )) != -1 ) {

i=0;
k=0;
while ( i < 100 ) {
	Programmalt.Name[0] = 0x00; 
	j=read(fd,&Programmalt,sizeof(Programmalt));
    if (( j == sizeof(Programmalt)) && (Programmalt.Name[0] != 0x00 )) {
	strcpy(&Programm[k].Name[0],&Programmalt.Name[0]);
    Programm[k].freq=Programmalt.freq/1000;
    Programm[k].Typ = 'A';
	if ( Programm[k].freq == InitialFreq/1000 ) {
                       InitialProg=k;
			};

	k++;
	} 
i++;
};
close(fd);
remove("Programm.idx");
Write_Programm_List();
};

i=0;
if ((fd=open("Programm.ids" ,_O_RDONLY | _O_BINARY )) == -1 ) return;
while ( i < MAXPROGS ) {
	read(fd,&Programm[i],sizeof(Programm[i]));
	i++;
};
close(fd);
}


BOOL APIENTRY SplashProc(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG: 
//			ShowWindow(hDlg,SW_SHOW);
			InvalidateRect(hDlg,NULL,TRUE); 
			SetTimer(hDlg,2,10000,NULL);
            return(TRUE);
 
        case WM_TIMER:

			if ( wParam == 2 ) {
                 EndDialog(hDlg,0);
			}

			
			
return(FALSE);

    }
    return (FALSE);
UNREFERENCED_PARAMETER(lParam);
}


BOOL Load_INI(LPSTR Name)
{

 FILE* iniFile;
 char zeile[100];
 char buffer[20];
 char *Pos;
 char *SemmelPos;
 unsigned int j;
 int B=0;
 

 if ((iniFile=fopen(Name,"r")) == NULL )  {
				 return(FALSE);
			   }

 VBI_Flags=0;

 while ( fgets(zeile,sizeof(zeile),iniFile) != NULL ) 
   {

    SemmelPos=strstr(zeile,";");
	if ( SemmelPos==NULL )	 SemmelPos=strstr(zeile,"\n");
    

    if (((Pos=strstr(zeile,"WINDOWSTARTX=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 emstartx=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"WINDOWSTARTY=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 emstarty=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"WINDOWSIZEX=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 emsizex=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"WINDOWSIZEY=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 emsizey=atoi(buffer);
		 }

    else if (((Pos=strstr(zeile,"WINDOWSTYLE=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 WindowStyle=atoi(buffer);
		 }
	else if (((Pos=strstr(zeile,"RESX=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+5;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Res_X=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"RESY=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+5;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Res_Y=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"TOPMOST=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 ALLWAYS_TOP=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 ALLWAYS_TOP=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"PROCESSPRIORITY=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+16;	   
             j=0;              
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 PriorClassId=atoi(buffer);
	}						   
    else if (((Pos=strstr(zeile,"THREADPRIORITY=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ThreadClassId=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"WINDOWPROZESSOR=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+16;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MainProzessor=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"IRQPROZESSOR=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 IrqProzessor=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"VBIPROZESSOR=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VBIProzessor=atoi(buffer);
		 }
    else if (((Pos=strstr(zeile,"DECODEPROZESSOR=")) != 0)  && ( SemmelPos > Pos )) {
			 Pos=Pos+16;
             j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 AusgabeProzessor=atoi(buffer);
		 }
	else if (((Pos=strstr(zeile,"STATUSBAR=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 Display_Status_Bar=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Display_Status_Bar=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"DIBMODE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 OutDib=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 OutDib=TRUE;
			 }

	}

    else if (((Pos=strstr(zeile,"OVERLAYMODE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 ModeOverlay=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 ModeOverlay=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"RAWSURFACE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 ModeRAWSurface=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 ModeRAWSurface=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"RAWOVERLAY=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 ModeRAWOverlay=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 ModeRAWOverlay=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"SYNC_IRQ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 Sync_Irq=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Sync_Irq=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"TVSCREEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 Show_Menu=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Show_Menu=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"TVSCREENNOFRAME=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+16;
			 Toggle_WithOut_Frame=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Toggle_WithOut_Frame=TRUE;
			 }

	}

    else if (((Pos=strstr(zeile,"HALBBILDMODUS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 HalfTVMode=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 HalfTVMode=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"COLORMIX=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 ColorMix=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 ColorMix=TRUE;
			 }

	}


else if (((Pos=strstr(zeile,"MOVIESCALING=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MovieScale=atoi(buffer);

	}

    else if (((Pos=strstr(zeile,"NAGRATESTZEILEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MasterTestzeilen=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"NAGRATESTZEILEN1=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TZ[0]=atoi(buffer);
	} 
	else if (((Pos=strstr(zeile,"NAGRATESTZEILEN2=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TZ[1]=atoi(buffer);
	}                
	else if (((Pos=strstr(zeile,"NAGRATESTZEILEN3=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TZ[2]=atoi(buffer);
	}                
	else if (((Pos=strstr(zeile,"NAGRATESTZEILEN4=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TZ[3]=atoi(buffer);
	}                
	else if (((Pos=strstr(zeile,"NAGRATESTZEILEN5=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TZ[4]=atoi(buffer);
	}                
    else if (((Pos=strstr(zeile,"NAGRAFULL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 NagraFullField=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 NagraFullField=TRUE;
			 }

	}
    else if (((Pos=strstr(zeile,"AUTO-DETECT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 Decode_AutoDetect=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Decode_AutoDetect=TRUE;
			 }

	}  
	else if (((Pos=strstr(zeile,"KEYNAME0=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 OPKEY[0].Name[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[0].Name[j]=*Pos;
			 j++;
			 OPKEY[0].Name[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYNAME1=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 OPKEY[1].Name[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[1].Name[j]=*Pos;
			 j++;
			 OPKEY[1].Name[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYNAME2=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 OPKEY[2].Name[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[2].Name[j]=*Pos;
			 j++;
			 OPKEY[2].Name[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYNAME3=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 OPKEY[3].Name[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[3].Name[j]=*Pos;
			 j++;
			 OPKEY[3].Name[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYEXTENSION0=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 OPKEY[0].Extension[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[0].Extension[j]=*Pos;
			 j++;
			 OPKEY[0].Extension[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYEXTENSION1=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 OPKEY[1].Extension[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[1].Extension[j]=*Pos;
			 j++;
			 OPKEY[1].Extension[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYEXTENSION2=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 OPKEY[2].Extension[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[2].Extension[j]=*Pos;
			 j++;
			 OPKEY[2].Extension[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"KEYEXTENSION3=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 OPKEY[3].Extension[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OPKEY[3].Extension[j]=*Pos;
			 j++;
			 OPKEY[3].Extension[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"AKTIVERKEY=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ActiveKey=atoi(buffer);
	}                
	else if (((Pos=strstr(zeile,"AUTO-DETECT-NAGRA=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+18;
			 AutoDetect_Nagra=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 AutoDetect_Nagra=TRUE;
			 }

	} else if (((Pos=strstr(zeile,"AUTO-DETECT-VC=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 AutoDetect_VC=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 AutoDetect_VC=TRUE;
			 }

	} else if (((Pos=strstr(zeile,"VBI_VT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+7;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
                VBI_Flags+=VBI_VT;
			 }
	} else if (((Pos=strstr(zeile,"VBI_VC=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+7;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
                VBI_Flags+=VBI_VC;
			 }
	}                            
    else if (((Pos=strstr(zeile,"VBI_IC=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+7;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
                VBI_Flags+=VBI_IC;
			 }
	}
	else if (((Pos=strstr(zeile,"IC_BASE_DIR=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 IC_BASE_DIR[j]=0x00;
			 while ( Pos < SemmelPos) {
			 IC_BASE_DIR[j]=*Pos;
			 j++;
			 IC_BASE_DIR[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"VD_BASE_DIR=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 VD_DIR[j]=0x00;
			 while ( Pos < SemmelPos) {
			 VD_DIR[j]=*Pos;
			 j++;
			 VD_DIR[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"VD_FILENAME=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 VDat.RawName[j]=0x00;
			 while ( Pos < SemmelPos) {
			 VDat.RawName[j]=*Pos;
			 j++;
			 VDat.RawName[j]=0x00;
			 Pos++;
			 }
	}                
	else if (((Pos=strstr(zeile,"VD_RAWFILE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 VD_RAW=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 VD_RAW=TRUE;
			 }
	}                
    else if (((Pos=strstr(zeile,"VBI_VPS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
                VBI_Flags+=VBI_VPS;
			 }
	}                            
	else if (((Pos=strstr(zeile,"AUTO-MOVIEBOOST=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+16;
			 Auto_MovieBoost=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Auto_MovieBoost=TRUE;
			 }

	}            
    else if (((Pos=strstr(zeile,"SCHWARZ-SCHWELLE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialLow=atoi(buffer);
	} else if (((Pos=strstr(zeile,"VCCHROMAKEY=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 Chroma_Key=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Chroma_Key=TRUE;
			 }
	}  else if (((Pos=strstr(zeile,"NTDRIVERNAME=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 j=0;
			 OrgDriverName[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OrgDriverName[j]=*Pos;
			 j++;
			 OrgDriverName[j]=0x00;
			 Pos++;
			 }
	}  else if (((Pos=strstr(zeile,"NTDVBDRIVERNAME=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+16;
			 j=0;
			 OrgDVBDriverName[j]=0x00;
			 while ( Pos < SemmelPos) {
			 OrgDriverName[j]=*Pos;
			 j++;
			 OrgDVBDriverName[j]=0x00;
			 Pos++;
			 }
	}  else if (((Pos=strstr(zeile,"VIDEOKARTE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 CardType=atoi(buffer);
	}                            
    else if (((Pos=strstr(zeile,"VIDEOSOURCE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VideoSource=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"AUDIOSOURCE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 AudioSource=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"TUNERTYP=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TunerType=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"TVTYP=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+6;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 TVTYPE=atoi(buffer);
			 if ( TVTYPE == 5 ) TVTYPE=0;
	}
    else if (((Pos=strstr(zeile,"FREQUENZ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialFreq=atol(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848-HUE-REGISTER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+19;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialHue=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848-CONTRAST-REGISTER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+24;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialContrast=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848-BRIGHTNESS-REGISTER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+26;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialBrightness=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848-SATURATION_U-REGISTER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+28;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialSaturationU=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848-SATURATION_V-REGISTER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+28;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialSaturationV=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848-IFORM-REGISTER=")) != 0 ) && ( SemmelPos > Pos )) {
             InitialIFORM=0;
		     Pos=Pos+21;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialIFORM=atoi(buffer);
	}

    else if (((Pos=strstr(zeile,"TUNER_THRESH1=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].thresh1=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"TUNER_THRESH2=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].thresh2=atoi(buffer);
	}

    else if (((Pos=strstr(zeile,"TUNER_VHF_L=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].VHF_L=atoi(buffer);
	}

    else if (((Pos=strstr(zeile,"TUNER_VHF_H=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].VHF_H=atoi(buffer);
	}

    else if (((Pos=strstr(zeile,"TUNER_UHF=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+10;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].UHF=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"TUNER_CONFIG=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].config=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"TUNER_I2C=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+10;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].I2C=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"TUNER_IFPCOFF=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 Tuners[8].IFPCoff=atoi(buffer);
	}

    else if (((Pos=strstr(zeile,"BT848_GPIO_OUT_EN=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+18;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[0]=atoi(buffer);
	}                            
    else if (((Pos=strstr(zeile,"BT848_GPIO_REG_INP=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+19;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[7]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848_GPIO_DATA_TUNER=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+22;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[1]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848_GPIO_DATA_RADIO=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+22;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[2]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848_GPIO_DATA_EXTERN=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+23;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[3]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848_GPIO_DATA_INTERN=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+23;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[4]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848_GPIO_DATA_AUS=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+20;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[5]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"BT848_GPIO_DATA_AN=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+19;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ManuellAudio[6]=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"BT848-PLL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 INIT_PLL=0;
			 j=0;
			 buffer[j]=0x00;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 INIT_PLL=1;
			 }
			 else if (( *Pos == 'F' ) ||  ( *Pos == 'f' )) {
				 INIT_PLL=0;
			 } else {
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 INIT_PLL=atoi(buffer);
			 };
	}
	else if (((Pos=strstr(zeile,"USE_OVERLAY_STRECHING=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+22;
			 USE_DX_OV_STRECH=TRUE;
			 if (( *Pos == 'F' ) ||  ( *Pos == 'f' )) {
				 USE_DX_OV_STRECH=FALSE;
			 }
	}
	else if (((Pos=strstr(zeile,"USE_DX_LOCK=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 USE_DX_LOCK=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 USE_DX_LOCK=TRUE;
			 }
	}
	else if (((Pos=strstr(zeile,"WAIT_DX_VBI=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 WAIT_DX_VBI=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 WAIT_DX_VBI=TRUE;
			 }
	}
	else if (((Pos=strstr(zeile,"TUNER_USE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 USETUNER=TRUE;
			 if (( *Pos == 'F' ) ||  ( *Pos == 'f' )) {
				 USETUNER=FALSE;
			 }
	}
	else if (((Pos=strstr(zeile,"CARD_USE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 USECARD=TRUE;
			 if (( *Pos == 'F' ) ||  ( *Pos == 'f' )) {
				 USECARD=FALSE;
			 }
	}
	else if (((Pos=strstr(zeile,"CAPTUREVIDEO=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 Capture_Video=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Capture_Video=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"CAPTUREVBI=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 Capture_VBI=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Capture_VBI=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"LASTMODE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 Current_Mode=0;
			 if (( *Pos == 'D' ) ||  ( *Pos == 'd' )) {
				 Current_Mode=1;
			 }

	}
	else if (((Pos=strstr(zeile,"LETZTES_PROGRAMM=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialProg=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-Karte=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+10;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBType=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-TYP=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuner=atoi(buffer);

	} else if (((Pos=strstr(zeile,"KEEPFIRMLOADED=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 Keep_DVB_Loaded=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 Keep_DVB_Loaded=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"FIRMVERSIONID=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 FirmID=atoi(buffer);
	} else if (((Pos=strstr(zeile,"SYMBOLRATE0=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[0]=atoi(buffer);
	} else if (((Pos=strstr(zeile,"SYMBOLRATE1=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[1]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE2=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[2]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE3=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[3]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE4=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[4]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE5=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[5]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE6=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[6]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE7=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[7]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE8=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[8]=atoi(buffer);

	} else if (((Pos=strstr(zeile,"SYMBOLRATE9=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 SRates[9]=atoi(buffer);
	} else if (((Pos=strstr(zeile,"DISEQC=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+7;
			 LNB.Diseq=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Diseq=TRUE;
			 }
	}	else if (((Pos=strstr(zeile,"LNB1_LOF_LOW=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[0].LofLow=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB1_LOF_HIGH=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[0].LofHigh=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB1_SWITCHFREQ=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[0].SwitchFreq=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"LNB1_POWER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 LNB.Anschluss[0].Power=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[0].Power=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"LNB1_SWITCH_22KHZ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+18;
			 LNB.Anschluss[0].Switch22khz=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[0].Switch22khz=TRUE;
			 }

	}	else if (((Pos=strstr(zeile,"LNB2_LOF_LOW=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[1].LofLow=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB1_LOF_HIGH=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[1].LofHigh=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB2_SWITCHFREQ=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[1].SwitchFreq=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"LNB2_POWER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 LNB.Anschluss[1].Power=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[1].Power=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"LNB2_SWITCH_22KHZ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+18;
			 LNB.Anschluss[1].Switch22khz=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[1].Switch22khz=TRUE;
			 }

	}	else if (((Pos=strstr(zeile,"LNB3_LOF_LOW=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[2].LofLow=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB3_LOF_HIGH=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[2].LofHigh=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB3_SWITCHFREQ=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[2].SwitchFreq=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"LNB3_POWER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 LNB.Anschluss[2].Power=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[2].Power=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"LNB3_SWITCH_22KHZ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+18;
			 LNB.Anschluss[2].Switch22khz=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[2].Switch22khz=TRUE;
			 }

	}	else if (((Pos=strstr(zeile,"LNB4_LOF_LOW=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[3].LofLow=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB4_LOF_HIGH=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[3].LofHigh=atoi(buffer);
	}	else if (((Pos=strstr(zeile,"LNB4_SWITCHFREQ=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 LNB.Anschluss[3].SwitchFreq=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"LNB4_POWER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 LNB.Anschluss[3].Power=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[3].Power=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"LNB4_SWITCH_22KHZ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+18;
			 LNB.Anschluss[3].Switch22khz=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 LNB.Anschluss[3].Switch22khz=TRUE;
			 }


	} else if (((Pos=strstr(zeile,"DVB-TUNER-MIN=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].min=atoi(buffer)*1000;
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-MAX=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].max=atoi(buffer)*1000;
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-RES=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].res=atoi(buffer)*1000;
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-STEP=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].step=atoi(buffer)*1000;
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-THRESH1=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+18;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].thresh1=atoi(buffer)*1000;
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-THRESH2=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+18;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].thresh2=atoi(buffer)*1000;
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-VHF_L=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].VHF_L=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-VHF_H=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].VHF_H=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-UHF=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].UHF=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-CONFIG=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].config=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-I2C=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].I2C=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-TUNER-IFPCOFF=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+18;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 DVBTuners[2].IFPCoff=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-CONTRAST=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialDVBContrast=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-BRIGHTNESS=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialDVBBrightness=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-COLOR=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+10;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialDVBColor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-VOLUME-LEFT=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+16;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialDVBVolumeLinks=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"DVB-VOLUME-RIGHT=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+17;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialDVBVolumeRechts=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"SAVESETTING=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 SaveSettings=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 SaveSettings=TRUE;
			 }

	}

	else if (((Pos=strstr(zeile,"LAENDERCODE=")) != 0 ) && ( SemmelPos > Pos )) {
		     Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 CountryCode=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"COLORFORMAT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 ColourFormat=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"INVERT-ROT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 InvertRot=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 InvertRot=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"INVERT-GRUEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 InvertGruen=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 InvertGruen=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"INVERT-BLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 InvertBlau=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 InvertBlau=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"OFF-ROT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 OffRot=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 OffRot=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"OFF-GRUEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 OffGruen=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 OffGruen=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"OFF-BLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 OffBlau=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 OffBlau=TRUE;
			 }

	}

	else if (((Pos=strstr(zeile,"COLORMIXMODE1=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 HCMode1=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 HCMode1=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"MIXSCHWELLE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCSchwelle=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXROT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+7;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCRotFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXGRUEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCGruenFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXBLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCBlauFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"COLORMIXMODE2=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 HCMode2=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 HCMode2=TRUE;
			 }

	}
	else if (((Pos=strstr(zeile,"MIXCUTSCHWELLE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXCUTLOROT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutLoRotFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXCUTLOGRUEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutLoGruenFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXCUTLOBLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutLoBlauFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXCUTHIROT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutHiRotFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXCUTHIGRUEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutHiGruenFaktor=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MIXCUTHIBLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 HCCutHiBlauFaktor=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-SCHWARZ=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[0]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-ROT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+7;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[1]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-GRUEN=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[2]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-GELB=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[3]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-BLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[4]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-HELLBLAU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[6]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-WEIS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[7]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-WEIS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[7]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-UNSICHTBAR=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[5]=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"VT-TRANSPARENT=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 VTColourTable[8]=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MSPMODE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+8;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MSPMode=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MSPMAJOR=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MSPMajorMode=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MSPMINOR=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MSPMinorMode=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MSPSTEREO=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MSPStereo=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"MSP-STEREO=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 AutoStereoSelect=TRUE;
			 if (( *Pos == 'F' ) ||  ( *Pos == 'f' )) {
				 AutoStereoSelect=FALSE;
			 }
	}
	else if (((Pos=strstr(zeile,"IC2_VOLUME=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialVolume=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_SPATIAL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialSpecial=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_LOUDNESS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+13;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialLoudness=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_BASS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+9;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialBass=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_TREBLE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialTreble=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_BALANCE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+12;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialBalance=atoi(buffer);
	}
	else if (((Pos=strstr(zeile,"I2C_SUPERBASS=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;           
			 InitialSuperBass=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 InitialSuperBass=TRUE;
			 }

	} 
    else if (((Pos=strstr(zeile,"IC2_EQUALIZER1=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialEqualizer1=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_EQUALIZER2=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialEqualizer2=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_EQUALIZER3=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialEqualizer3=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_EQUALIZER4=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialEqualizer4=atoi(buffer);
	}
    else if (((Pos=strstr(zeile,"IC2_EQUALIZER5=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+15;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 InitialEqualizer5=atoi(buffer);
	} else if (((Pos=strstr(zeile,"USE_MIXER=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;           
			 USE_MIXER=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 USE_MIXER=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"MIXER_VOLUME_LINKER_KANAL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+26;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MIXER_LINKER_KANAL=atoi(buffer);
	} else if (((Pos=strstr(zeile,"MIXER_VOLUME_RECHTER_KANAL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+27;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 MIXER_RECHTER_KANAL=atoi(buffer);
	} else if (((Pos=strstr(zeile,"MIXER_VOLUME_CONTROL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+21;
			   Volume.SoundSystem=-1;	 
			   Volume.Destination=0;	 
			   Volume.Connection=0;	 
			   Volume.Control=0;	 
			 j=sscanf(Pos,"%03d %03d %03d %03d",&Volume.SoundSystem,&Volume.Destination,&Volume.Connection,&Volume.Control );
             if ( j != 4 ) {
			   Volume.SoundSystem=-1;	 
			   Volume.Destination=0;	 
			   Volume.Connection=0;	 
			   Volume.Control=0;	 
			 };
	} else if (((Pos=strstr(zeile,"MIXER_MUTE_CONTROL=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+19;
			   Mute.SoundSystem=-1;	 
			   Mute.Destination=0;	 
			   Mute.Connection=0;	 
			   Mute.Control=0;	 
			 j=sscanf(Pos,"%03d %03d %03d %03d",&Mute.SoundSystem,&Mute.Destination,&Mute.Connection,&Mute.Control );
             if ( j != 4 ) {
			   Mute.SoundSystem=-1;	 
			   Mute.Destination=0;	 
			   Mute.Connection=0;	 
			   Mute.Control=0;	 
			 };
	// Fantasion
	}	else if (((Pos=strstr(zeile,"FILTREBLEU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 bFilterBlueLines=FALSE;
			 if (( *Pos == 'T' ) ||  ( *Pos == 't' )) {
				 bFilterBlueLines=TRUE;
			 }
	} else if (((Pos=strstr(zeile,"SEUILBLEU=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+10;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 iUFilterThresholdPCent=atoi(buffer);
	} else if (((Pos=strstr(zeile,"SEUILROUGE=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+11;
			 j=0;
			 buffer[j]=0x00;
			 while ( Pos < SemmelPos) {
			 if ( *Pos != 0x20 ) {
			 buffer[j]=*Pos;
			 j++;
			 buffer[j]=0x00;
			 }
			 Pos++;
			 }
			 iVFilterThresholdPCent=atoi(buffer);
	} else if (((Pos=strstr(zeile,"MIXER_BOOT_UP=")) != 0 ) && ( SemmelPos > Pos )) {
			 Pos=Pos+14;
               MixerLoad[B].MixerAccess.SoundSystem=-1;
			   MixerLoad[B].MixerAccess.Destination=0;
			   MixerLoad[B].MixerAccess.Connection=0;
			   MixerLoad[B].MixerAccess.Control=0;
			   MixerLoad[B].MixerValues.Kanal1=0;
			   MixerLoad[B].MixerValues.Kanal2=0;
			   MixerLoad[B].MixerValues.Kanal3=0;
			   MixerLoad[B].MixerValues.Kanal4=0;
               j=sscanf(Pos,"%03d %03d %03d %03d %d %d %d %d",&MixerLoad[B].MixerAccess.SoundSystem,&MixerLoad[B].MixerAccess.Destination,&MixerLoad[B].MixerAccess.Connection,&MixerLoad[B].MixerAccess.Control,&MixerLoad[B].MixerValues.Kanal1,&MixerLoad[B].MixerValues.Kanal2,&MixerLoad[B].MixerValues.Kanal3,&MixerLoad[B].MixerValues.Kanal4);
               B++;
			   if ( j != 8 ) {
               MixerLoad[B].MixerAccess.SoundSystem=-1;
			   MixerLoad[B].MixerAccess.Destination=0;
			   MixerLoad[B].MixerAccess.Connection=0;
			   MixerLoad[B].MixerAccess.Control=0;
			   MixerLoad[B].MixerValues.Kanal1=0;
			   MixerLoad[B].MixerValues.Kanal2=0;
			   MixerLoad[B].MixerValues.Kanal3=0;
			   MixerLoad[B].MixerValues.Kanal4=0;
			   B--;
			 };

			 } 
	
	}

  fclose(iniFile);

return(TRUE);
}


BOOL Write_INI(LPSTR Name)
{

 FILE* iniFile;
 RECT nowRect; 
 int i;
 
 if ((iniFile=fopen(Name,"w")) == NULL )  {
				 return(FALSE);
			   }

GetWindowRect(hWnd,&nowRect);


fprintf(iniFile,"; INI-Datei MultiDecoder 5.2\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; Benutzerdefinierbare Einstellungen \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; WINDOWSTARTX,WINDOWSTARTY            Position des Windows beim Starten (linke obere Ecke)\n");
fprintf(iniFile,"WINDOWSTARTX=%d						; X-Coordinate\n",nowRect.left);
fprintf(iniFile,"WINDOWSTARTY=%d						; Y-Coordinate\n",nowRect.top);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; WINDOWSIZEX,WINDOWSIZEY              Lnge und Hhe des Windows beim Starten \n");
fprintf(iniFile,"WINDOWSIZEX=%d							; X-Lnge\n",nowRect.right-nowRect.left);
fprintf(iniFile,"WINDOWSIZEY=%d							; Y-Lnge\n",nowRect.bottom-nowRect.top);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; WINDOWSTYLE                          Art der Ausgabe\n");
fprintf(iniFile,";                                               0 = Fenster\n");
fprintf(iniFile,";                                               1 = 640*480\n");
fprintf(iniFile,";                                               2 = 800*600\n");
fprintf(iniFile,";                                               3 = RESX*RESY\n");
fprintf(iniFile,"WINDOWSTYLE=%d;             \n",WindowStyle);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; Bei WINDOWSTYLE=3 kann eine eigene Vollbildauflsung hinterlegt werden z.B. 720 * 576\n");
fprintf(iniFile,"RESX=%d;             \n",Res_X);
fprintf(iniFile,"RESY=%d;             \n",Res_Y);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; TOPMOST                              Ausgabe Erfolgt immer im Vordergrund\n");
if ( ALLWAYS_TOP == TRUE ) fprintf(iniFile,"TOPMOST=TRUE;                   \n");
else fprintf(iniFile,"TOPMOST=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"PROCESSPRIORITY=%d;                    ;Process-Prioritt\n",PriorClassId);
fprintf(iniFile,";                                               0 = NORMAL_PRIORITY_CLASS\n");
fprintf(iniFile,";                                               1 = HIGH_PRIORITY_CLASS\n");
fprintf(iniFile,";                                               2 = REALTIME_PRIORITY_CLASS\n");
fprintf(iniFile,"THREADPRIORITY=%d;                    ;Thread-Proritt Decoding und Ausgabe\n",ThreadClassId);
fprintf(iniFile,";                                               0 = THREAD_PRIORITY_BELOW_NORMAL\n");
fprintf(iniFile,";                                               1 = THREAD_PRIORITY_NORMAL\n");
fprintf(iniFile,";                                               2 = THREAD_PRIORITY_ABOVE_NORMAL \n");
fprintf(iniFile,";                                               3 = THREAD_PRIORITY_HIGHEST\n");
fprintf(iniFile,";                                               4 = THREAD_PRIORITY_TIME_CRITICAL \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,";Bei Mehrprozessor-Systemen  koennen die Threads verteilt werden\n");
fprintf(iniFile,";2 Prozessorsystem vermutlich WINDOWPROZESSOR=0; IRQPROZESSOR=0; VBIPROZESSOR=0; DECODEPROZESSOR=1;\n");
fprintf(iniFile,";3 Prozessorsystem vermutlich WINDOWPROZESSOR=0; IRQPROZESSOR=0; VBIPROZESSOR=1; DECODEPROZESSOR=2;\n");
fprintf(iniFile,";>4 Prozessorsystem vermutlich WINDOWPROZESSOR=0; IRQPROZESSOR=1; VBIPROZESSOR=2; DECODEPROZESSOR=3;\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,";WINDOWPROZESSOR                                Message und Menhandling (Wenig Last)\n");
fprintf(iniFile,"WINDOWPROZESSOR=%d                              Nummer der CPU (0 bis Anzahl Prozessoren)\n",MainProzessor);
fprintf(iniFile,"; \n");
fprintf(iniFile,";IRQPROZESSOR                                   Wandelt den IRQ in ein Event (Wenig Last)\n");
fprintf(iniFile,"IRQPROZESSOR=%d                                 Nummer der CPU (0 bis Anzahl Prozessoren)\n",IrqProzessor);
fprintf(iniFile,"; \n");
fprintf(iniFile,";VBIPROZESSOR                                   VBI-Decording (Mittlere Last)\n");
fprintf(iniFile,"VBIPROZESSOR=%d                                 Nummer der CPU (0 bis Anzahl Prozessoren)\n",VBIProzessor);
fprintf(iniFile,"; \n");
fprintf(iniFile,";DECODEPROZESSOR                                Decording/Ausgabe (Maximale Last)\n");
fprintf(iniFile,"DECODEPROZESSOR=%d                              Nummer der CPU (0 bis Anzahl Prozessoren)\n",AusgabeProzessor);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; SYNC_IRQ                                      Ausgabe ber Karten-Interrupt syncronisieren\n");
if ( Sync_Irq == TRUE ) fprintf(iniFile,"SYNC_IRQ=TRUE;\n");
else fprintf(iniFile,"SYNC_IRQ=FALSE;\n");

fprintf(iniFile,"; DIBMODE                                       Ausgabe ber ein DIB \n");
if ( OutDib == TRUE ) fprintf(iniFile,"DIBMODE=TRUE;\n");
else fprintf(iniFile,"DIBMODE=FALSE;\n");
fprintf(iniFile,"; OVERLAYMODE                                   Ausgabe ber OVERLAY\n");
if ( ModeOverlay == TRUE ) fprintf(iniFile,"OVERLAYMODE=TRUE;                   \n");
else fprintf(iniFile,"OVERLAYMODE=FALSE;\n");
fprintf(iniFile,"; SURFACEMODE                                   Ausgabe ber SURFACE\n");
if (( ModeOverlay == FALSE ) && ( OutDib == FALSE )) fprintf(iniFile,"SURFACEMODE=TRUE;\n");
else fprintf(iniFile,"SURFACEMODE=FALSE;\n");
fprintf(iniFile,"; RAWSURFACE                                    Ausgabe in die Surface-RAW\n");
if ( ModeRAWSurface == TRUE ) fprintf(iniFile,"RAWSURFACE=TRUE;                   \n");
else fprintf(iniFile,"RAWSURFACE=FALSE;                   \n");
fprintf(iniFile,"; RAWSURFACE                            Ausgabe in die Overlay-RAW\n");
if ( ModeRAWOverlay == TRUE ) fprintf(iniFile,"RAWOVERLAY=TRUE;                   \n");
else fprintf(iniFile,"RAWOVERLAY=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; TVSCREEN                              Bildschirm mit Rahmen, Menu, etc\n");
if ( Show_Menu == TRUE ) fprintf(iniFile,"TVSCREEN=TRUE;                   \n");
else fprintf(iniFile,"TVSCREEN=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; TVSCREENNOFRAME                       Bildschirm im TV-Modus ohne Rahmen\n");
if ( Toggle_WithOut_Frame == TRUE ) fprintf(iniFile,"TVSCREENNOFRAME=TRUE;                   \n");
else fprintf(iniFile,"TVSCREENNOFRAME=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; STATUSBAR                            Status-Bar ausgeben\n");
if ( Display_Status_Bar == TRUE ) fprintf(iniFile,"STATUSBAR=TRUE;                   \n");
else fprintf(iniFile,"STATUSBAR=FALSE;                   \n");
fprintf(iniFile,"; HALBBILDMODUS                         Es wird nur ein Halbbild ausgegeben\n");
if ( HalfTVMode == TRUE ) fprintf(iniFile,"HALBBILDMODUS=TRUE;                   \n");
else fprintf(iniFile,"HALBBILDMODUS=FALSE;                   \n");
fprintf(iniFile,"; COLORMIX                              Farbmischer aktiviert\n");
if ( ColorMix == TRUE ) fprintf(iniFile,"COLORMIX=TRUE;                   \n");
else fprintf(iniFile,"COLORMIX=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; MovieScaling                          Anzahl der Zeilen \n");
fprintf(iniFile,"MOVIESCALING=%d;                \n",MovieScale);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** NagraVision Setup ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; NAGRATESTZEILEN                      Anzahl der Testzeilen fr die Nagra-Dekodierung\n");
fprintf(iniFile,"NAGRATESTZEILEN=%d;                \n",MasterTestzeilen);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; NAGRATESTZEILEN                      Testzeilen fr die nderung im Dekoderbetrieb(Die 1. sollte die Kleinste sein\n");
fprintf(iniFile,"NAGRATESTZEILEN1=%d;                \n",TZ[0]);
fprintf(iniFile,"NAGRATESTZEILEN2=%d;                \n",TZ[1]);
fprintf(iniFile,"NAGRATESTZEILEN3=%d;                \n",TZ[2]);
fprintf(iniFile,"NAGRATESTZEILEN4=%d;                \n",TZ[3]);
fprintf(iniFile,"NAGRATESTZEILEN5=%d;                \n",TZ[4]);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; NAGRAFULL                            Beide Halbbilder fr die Nagra-Dekodierung\n");
if ( NagraFullField == TRUE ) fprintf(iniFile,"NAGRAFULL=TRUE;                   \n");
else fprintf(iniFile,"NAGRAFULL=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; AUTO-MOVIEBOOST                      Anzahl der Schwarzen Zeilen werden automatisch erkannt\n");
if ( Auto_MovieBoost == TRUE ) fprintf(iniFile,"AUTO-MOVIEBOOST=TRUE;                   \n");
else fprintf(iniFile,"AUTO-MOVIEBOOST=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; SCHWARZ-SCHWELLE                     Schwellwert fr die Erkennung der schwarzen Zeilen\n");
fprintf(iniFile,"SCHWARZ-SCHWELLE=%d;                \n",InitialLow);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; Diverse KeyFiles abhandeln\n");
for ( i=0; i < 4 ; i++ ) {
fprintf(iniFile,"KEYNAME%d=%s;                \n",i,OPKEY[i].Name);
fprintf(iniFile,"KEYEXTENSION%d=%s;                \n",i,OPKEY[i].Extension);
};
fprintf(iniFile,"; \n");
fprintf(iniFile,"AKTIVERKEY=%d;                \n",ActiveKey);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** VideoCrypt Setup ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; VCCHROMAKEY                          FineShifting ber Farbdekodierung\n");
if ( Chroma_Key == TRUE ) fprintf(iniFile,"VCCHROMAKEY=TRUE;                   \n");
else fprintf(iniFile,"VCCHROMAKEY=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** Direct X Setup ****************************\n");
fprintf(iniFile,"; \n");
if ( WAIT_DX_VBI == TRUE ) {
fprintf(iniFile,"WAIT_DX_VBI=TRUE;                        Warten auf Graka vertikalte Austastlcke \n");
} else {
fprintf(iniFile,"WAIT_DX_VBI=FALSE;                       Nicht warten auf Graka vertikalte Austastlcke  \n");
}
if ( USE_DX_LOCK == TRUE ) {
fprintf(iniFile,"USE_DX_LOCK=TRUE;                        Direct X Locking verwenden\n");
} else {
fprintf(iniFile,"USE_DX_LOCK=FALSE;                       Direct X Locking nicht verwenden\n");
}
if ( USE_DX_OV_STRECH == TRUE ) {
fprintf(iniFile,"USE_OVERLAY_STRECHING=TRUE;                   Overlay-Hardware-Streching verwenden\n");
} else {
fprintf(iniFile,"USE_OVERLAY_STRECHING=FALSE;                  Overlay-Hardware-Streching nicht verwenden\n");
}
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** LASTMODE ****************************\n");
fprintf(iniFile,"; \n");
if ( Current_Mode == 0 ) {
fprintf(iniFile,"LASTMODE=ANALOG;                              War in Analog\n");
} else {
fprintf(iniFile,"LASTMODE=DIGITAL;                             War in Digital\n");
}
fprintf(iniFile,"; \n");
fprintf(iniFile,"; LETZTES_PROGRAMM                            Aktuellese Programm\n");
fprintf(iniFile,"LETZTES_PROGRAMM=%d;             \n",CurrentProgramm);
fprintf(iniFile,"; \n");
if ( SaveSettings == TRUE ) {
fprintf(iniFile,"SAVESETTING=TRUE;                        BT_Einstellungen fr Diagnose in Setting.BT sichern \n");
} else {
fprintf(iniFile,"SAVESETTING=FALSE;                       BT_Einstellungen fr Diagnose in Setting.BT sichern \n");
}
fprintf(iniFile,";                                        und auch die SAA7146 Settings in Setting.SAA\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; NTDRIVERNAME=                          Diese Variable mu bei NT gesetzt werden, wenn die Org. TV-Software installiert ist.\n");
fprintf(iniFile,";                                        Name des Gertes der org. Software. ( Bei meiner Hauppage ist es hcw848nt )\n");
fprintf(iniFile,";                                        Ist abzulesen in der Registry unter HKLM\\SYSTEM\\CurrentControlSet\\Services\\XXXXX \n");
fprintf(iniFile,";                                        Die Bezeichnung XXXXX ist einzutragen\n");
fprintf(iniFile,"NTDRIVERNAME=%s; \n",OrgDriverName);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; NTDVBDRIVERNAME=                       Diese Variable mu bei NT gesetzt werden, wenn die Org. TV-Software installiert ist.\n");
fprintf(iniFile,";                                        Name des Gertes der org. Software. \n");
fprintf(iniFile,";                                        Ist abzulesen in der Registry unter HKLM\\SYSTEM\\CurrentControlSet\\Services\\XXXXX \n");
fprintf(iniFile,";                                        Die Bezeichnung XXXXX ist einzutragen\n");
fprintf(iniFile,"NTDVBDRIVERNAME=%s; \n",OrgDVBDriverName);
fprintf(iniFile,"; \n");

fprintf(iniFile,"; ****************** SAA7146 Setup *************************\n");
fprintf(iniFile,"; \n");
if ( Has_DVB == TRUE ) {
fprintf(iniFile,"; DVB-Karte                                   Art der DVB-Karte\n");
fprintf(iniFile,";                                             0= DVB-S(at)\n");
fprintf(iniFile,";                                             1= DVB-C(able)\n");
fprintf(iniFile,"DVB-Karte=%d\n",DVBType);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; DVB-TUNER-TYP                             Art des VideoTuners der DVB-Karte\n");
fprintf(iniFile,";                                             0= SP5659 DVB-S(at)\n");
fprintf(iniFile,";                                             1= SPXXXX DVB-C(able)\n");
fprintf(iniFile,";                                             3= Eigene Definition\n");
fprintf(iniFile,"DVB-TUNER-TYP=%d  \n",DVBTuner);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; COLORFORMAT                            Farbformate DVB\n");
fprintf(iniFile,";                                           2=RGB16        \n");
fprintf(iniFile,";                                           3=RGB15        \n");
fprintf(iniFile,";                                           4=YUV2  (422)   \n");
fprintf(iniFile,"COLORFORMAT=%d;             \n",ColourFormat);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; KEEPFIRMLOADED                          Beim beenden von MultiDec wird die Firmware in der DVB-Karte gelassen\n");
fprintf(iniFile,";                                         Dadurch ist der nchste Start deutlich schneller\n");
if ( Keep_DVB_Loaded == TRUE ) {
fprintf(iniFile,"KEEPFIRMLOADED=TRUE;                      Firmware drinnen lassen\n");
} else {
fprintf(iniFile,"KEEPFIRMLOADED=FALSE;                     Firmware entfernen\n");
}
fprintf(iniFile,"; FIRMVERSIONID                           Wird fr den Vergleich mit KEEPFIRMLOADED bentigt\n");
fprintf(iniFile,";                                         Wird dezimal abgespeicher, ist in Hex die Firmwareversion\n");
fprintf(iniFile,"FIRMVERSIONID=%d;             \n",FirmID);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ************* zu bercksichtigende Symbolraten **************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"SYMBOLRATE0=%d;             \n",SRates[0]);
fprintf(iniFile,"SYMBOLRATE1=%d;             \n",SRates[1]);
fprintf(iniFile,"SYMBOLRATE2=%d;             \n",SRates[2]);
fprintf(iniFile,"SYMBOLRATE3=%d;             \n",SRates[3]);
fprintf(iniFile,"SYMBOLRATE4=%d;             \n",SRates[4]);
fprintf(iniFile,"SYMBOLRATE5=%d;             \n",SRates[5]);
fprintf(iniFile,"SYMBOLRATE6=%d;             \n",SRates[6]);
fprintf(iniFile,"SYMBOLRATE7=%d;             \n",SRates[7]);
fprintf(iniFile,"SYMBOLRATE8=%d;             \n",SRates[8]);
fprintf(iniFile,"SYMBOLRATE9=%d;             \n",SRates[9]);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ************************** LNBs ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; DISEQC                                      Anlage kann Diseqc");
if ( LNB.Diseq == TRUE ) {
fprintf(iniFile,"DISEQC=TRUE;                                  Kann es\n");
} else {
fprintf(iniFile,"DISEQC=FALSE;                                 Kann es nicht\n");
}
fprintf(iniFile,";                                             Einstellungen LNB 1\n");
fprintf(iniFile,"LNB1_LOF_LOW=%d;                              LNB 1 Lof LowBand\n",LNB.Anschluss[0].LofLow);
fprintf(iniFile,"LNB1_LOF_HIGH=%d;                             LNB 1 Lof HighBand \n",LNB.Anschluss[0].LofHigh);
fprintf(iniFile,"LNB1_SWITCHFREQ=%d;                           LNB 1 LowBand / HighBand Switchfrequens\n",LNB.Anschluss[0].SwitchFreq);
if ( LNB.Anschluss[0].Power == TRUE ) {
fprintf(iniFile,"LNB1_POWER=TRUE;                              LNB 1 Spannungsversorgung AN\n");
} else {
fprintf(iniFile,"LNB1_POWER=FALSE                              LNB 1 Spannungsversorgung AUS\n");
}
if ( LNB.Anschluss[0].Switch22khz == TRUE ) {
fprintf(iniFile,"LNB1_SWITCH_22KHZ=TRUE;                       LNB 1 Umschalten Band mit 22 KHZ AN\n");
} else {
fprintf(iniFile,"LNB1_SWITCH_22KHZ=FALSE                       LNB 1 Umschalten Band mit 22 KHZ AUS\n");
}
fprintf(iniFile,"; \n");


if ( LNB.Diseq == TRUE ) {
fprintf(iniFile,";                                             Einstellungen LNB 2\n");
fprintf(iniFile,"LNB2_LOF_LOW=%d;                              LNB 2 Lof LowBand\n",LNB.Anschluss[1].LofLow);
fprintf(iniFile,"LNB2_LOF_HIGH=%d;                             LNB 2 Lof HighBand \n",LNB.Anschluss[1].LofHigh);
fprintf(iniFile,"LNB2_SWITCHFREQ=%d;                           LNB 2 LowBand / HighBand Switchfrequens\n",LNB.Anschluss[1].SwitchFreq);
if ( LNB.Anschluss[1].Power == TRUE ) {
fprintf(iniFile,"LNB2_POWER=TRUE;                              LNB 2 Spannungsversorgung AN\n");
} else {
fprintf(iniFile,"LNB2_POWER=FALSE                              LNB 2 Spannungsversorgung AUS\n");
}
if ( LNB.Anschluss[1].Switch22khz == TRUE ) {
fprintf(iniFile,"LNB2_SWITCH_22KHZ=TRUE;                       LNB 2 Umschalten Band mit 22 KHZ AN\n");
} else {
fprintf(iniFile,"LNB2_SWITCH_22KHZ=FALSE                       LNB 2 Umschalten Band mit 22 KHZ AUS\n");
}
fprintf(iniFile,"; \n");

fprintf(iniFile,";                                             Einstellungen LNB 3\n");
fprintf(iniFile,"LNB3_LOF_LOW=%d;                              LNB 3 Lof LowBand\n",LNB.Anschluss[2].LofLow);
fprintf(iniFile,"LNB3_LOF_HIGH=%d;                             LNB 3 Lof HighBand \n",LNB.Anschluss[2].LofHigh);
fprintf(iniFile,"LNB3_SWITCHFREQ=%d;                           LNB 3 LowBand / HighBand Switchfrequens\n",LNB.Anschluss[2].SwitchFreq);
if ( LNB.Anschluss[2].Power == TRUE ) {
fprintf(iniFile,"LNB3_POWER=TRUE;                              LNB 3 Spannungsversorgung AN\n");
} else {
fprintf(iniFile,"LNB3_POWER=FALSE                              LNB 3 Spannungsversorgung AUS\n");
}
if ( LNB.Anschluss[2].Switch22khz == TRUE ) {
fprintf(iniFile,"LNB3_SWITCH_22KHZ=TRUE;                       LNB 3 Umschalten Band mit 22 KHZ AN\n");
} else {
fprintf(iniFile,"LNB3_SWITCH_22KHZ=FALSE                       LNB 3 Umschalten Band mit 22 KHZ AUS\n");
}
fprintf(iniFile,"; \n");

fprintf(iniFile,";                                             Einstellungen LNB 4\n");
fprintf(iniFile,"LNB4_LOF_LOW=%d;                              LNB 4 Lof LowBand\n",LNB.Anschluss[3].LofLow);
fprintf(iniFile,"LNB4_LOF_HIGH=%d;                             LNB 4 Lof HighBand \n",LNB.Anschluss[3].LofHigh);
fprintf(iniFile,"LNB4_SWITCHFREQ=%d;                           LNB 4 LowBand / HighBand Switchfrequens\n",LNB.Anschluss[3].SwitchFreq);
if ( LNB.Anschluss[3].Power == TRUE ) {
fprintf(iniFile,"LNB4_POWER=TRUE;                              LNB 4 Spannungsversorgung AN\n");
} else {
fprintf(iniFile,"LNB4_POWER=FALSE                              LNB 4 Spannungsversorgung AUS\n");
}
if ( LNB.Anschluss[3].Switch22khz == TRUE ) {
fprintf(iniFile,"LNB4_SWITCH_22KHZ=TRUE;                       LNB 4 Umschalten Band mit 22 KHZ AN\n");
} else {
fprintf(iniFile,"LNB4_SWITCH_22KHZ=FALSE                       LNB 4 Umschalten Band mit 22 KHZ AUS\n");
}
fprintf(iniFile,"; \n");
};
fprintf(iniFile,"; ****************** eigener DVBTuner *************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"DVB-TUNER-MIN=%d;                             Minimale Frequenz \n",DVBTuners[2].min/1000);
fprintf(iniFile,"DVB-TUNER-MAX=%d;                             Maximale Frequenz \n",DVBTuners[2].max/1000);
fprintf(iniFile,"DVB-TUNER-RES=%d;                             Frequenzauflsung\n",DVBTuners[2].res/1000);
fprintf(iniFile,"DVB-TUNER-STEP=%d;                            Frequensschritte\n",DVBTuners[2].step/1000);
fprintf(iniFile,"DVB-TUNER-THRESH1=%d;                         Schwellwert VHF_Low\n",DVBTuners[2].thresh1/1000);
fprintf(iniFile,"DVB-TUNER-THRESH2=%d;                         Schwellwert VHF_High\n",DVBTuners[2].thresh2/1000);
fprintf(iniFile,"DVB-TUNER-VHF_L=%d;                           Schaltwert  VHF_Low\n",DVBTuners[2].VHF_L);
fprintf(iniFile,"DVB-TUNER-VHF_H=%d;                           Schaltwert  VHF_High\n",DVBTuners[2].VHF_H);
fprintf(iniFile,"DVB-TUNER-UHF=%d;                             Schaltwert  UHF\n",DVBTuners[2].UHF);
fprintf(iniFile,"DVB-TUNER-CONFIG=%d;                          Konfigurationsparameter Tuner\n",DVBTuners[2].config);
fprintf(iniFile,"DVB-TUNER-I2C=%d;                             I2C - Bus - ID\n",DVBTuners[2].I2C);
fprintf(iniFile,"DVB-TUNER-IFPCOFF=%d;                         Frequenz-Offset\n",DVBTuners[2].IFPCoff);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** DVB Farbeinstellungen  *************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; DVB-CONTRAST                              Letzter Wert fr Kontrast\n");
fprintf(iniFile,"DVB-CONTRAST=%d;               \n",InitialDVBContrast);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; DVB-BRIGHTNESS                            Letzter Wert fr Helligkeit\n");
fprintf(iniFile,"DVB-BRIGHTNESS=%d;          \n",InitialDVBBrightness);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; DVB-COLOR                                 Letzter Wert fr Farbe \n");
fprintf(iniFile,"DVB-COLOR=%d;        \n",InitialDVBColor);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** DVB Audioeinstellungen  *************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; DVB-VOLUME-LEFT                           Lautstrke linker Kanal\n");
fprintf(iniFile,"DVB-VOLUME-LEFT=%d;        \n",InitialDVBVolumeLinks);
fprintf(iniFile,"; DVB-VOLUME-RIGHT                          Lautstrke rechter Kanal\n");
fprintf(iniFile,"DVB-VOLUME-RIGHT=%d;        \n",InitialDVBVolumeRechts);
} else {
fprintf(iniFile,";                  ********************************\n");
fprintf(iniFile,";                  **      KEINE DVB-Hardware   ***\n");
fprintf(iniFile,";                  **            gefunden       ***\n");
fprintf(iniFile,";                  ********************************\n");
}
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** BT8X8 Setup ****************************\n");
fprintf(iniFile,"; \n");
if ( Has_BT == TRUE ) {
fprintf(iniFile,"; VIDEOKARTE                           Typ der Videokarte\n");
fprintf(iniFile,";                                             0=Miro \n");
fprintf(iniFile,";                                             1=Hauppauge \n");
fprintf(iniFile,";                                             2=STB \n");
fprintf(iniFile,";                                             3=Intel\n");
fprintf(iniFile,";                                             4=Diamond DTV2000\n");
fprintf(iniFile,";                                             5=AVerMedia TVPhone \n");
fprintf(iniFile,";                                             6=Eigener Kartentyp\n");
fprintf(iniFile,"VIDEOKARTE=%d;             \n",CardType);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; VIDEOSOURCE                          Video-Eingang/Source\n");
fprintf(iniFile,";                                             0= Video_Tuner \n");
fprintf(iniFile,";                                             1= Video_Ext1 \n");
fprintf(iniFile,";                                             2= Video_Ext2 \n");
fprintf(iniFile,";                                             3= Video_Ext3 \n");
fprintf(iniFile,"VIDEOSOURCE=%d;             \n",VideoSource);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; AUDIOSOURCE                          Audio-Eingang/Source\n");
fprintf(iniFile,";                                             0= Tuner \n");
fprintf(iniFile,";                                             1= MSP-Baustein/Radio \n");
fprintf(iniFile,";                                             2= External \n");
fprintf(iniFile,";                                             3= Internal \n");
fprintf(iniFile,";                                             4= Aus \n");
fprintf(iniFile,"AUDIOSOURCE=%d;             \n",AudioSource);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; TUNERTYP                             Art des VideoTuners der Karte\n");
fprintf(iniFile,";                                             0= Temic Pal \n");
fprintf(iniFile,";                                             1= Philips Pal I \n");
fprintf(iniFile,";                                             2= Philips Ntsc \n");
fprintf(iniFile,";                                             3= Philips Secam \n");
fprintf(iniFile,";                                             4= Unbekannt \n");
fprintf(iniFile,";                                             5= Philips Pal \n");
fprintf(iniFile,";                                             6= Temic Ntsc \n");
fprintf(iniFile,";                                             7= Temic Pal I \n");
fprintf(iniFile,";                                             8= Tuner mit manuellen Parametern\n");
fprintf(iniFile,"TUNERTYP=%d;             \n",TunerType);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; TVTYP                                Art des TV-Signals\n");
fprintf(iniFile,";                                      ( Die Spezialformate werden nicht abgespeichert)\n");
fprintf(iniFile,";                                             0= PAL BDGHI \n");
fprintf(iniFile,";                                             1= NTSC \n");
fprintf(iniFile,";                                             2= SECAM \n");
fprintf(iniFile,";                                             3= PAL M\n");
fprintf(iniFile,";                                             4= PAL N\n");
if ( TVTYPE > 4 ) TVTYPE=0;
fprintf(iniFile,"TVTYP=%d;             \n",TVTYPE);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; COLORFORMAT                            Farbformat\n");
fprintf(iniFile,";                                           0=RGB32           ( nicht untersttzt )\n");
fprintf(iniFile,";                                           1=RGB24           ( nicht untersttzt )\n");
fprintf(iniFile,";                                           2=RGB16        \n");
fprintf(iniFile,";                                           3=RGB15        \n");
fprintf(iniFile,";                                           4=YUV2  (422)   \n");
fprintf(iniFile,";                                           5=BtYUV (411)     ( nicht untersttzt )\n");
fprintf(iniFile,";                                           6=Y8              ( nicht untersttzt )\n");
fprintf(iniFile,";                                           7=RGB8 (Dithered)  ( nicht untersttzt )\n");
fprintf(iniFile,";                                           8=YCrCb 422 Planar ( nicht untersttzt )\n");
fprintf(iniFile,";                                           9=YCrCb 411 Planar ( nicht untersttzt )\n");
fprintf(iniFile,"COLORFORMAT=%d;             \n",ColourFormat);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; BT848-PLL                      PLL Initialisieren \n");
fprintf(iniFile,";                                             0= Nicht verwenden \n");
fprintf(iniFile,";                                             1= PLL mit 28.63636 MHz Quarz\n");
fprintf(iniFile,";                                             2= PLL mit 35.46895 MHz Quarz\n");
fprintf(iniFile,"BT848-PLL=%d;                     \n",INIT_PLL);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** VBI-Daten Auswertung ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,";          Die Videodat-Einstellung wird nicht abgespeichert\n");
fprintf(iniFile,";          Mu bei der entsprechenden Sendung eingeschaltet werden\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; AUTO-DETECT                          Codierung automatisch erkennen\n");
if ( Decode_AutoDetect == TRUE ) fprintf(iniFile,"AUTO-DETECT=TRUE;                   \n");
else fprintf(iniFile,"AUTO-DETECT=FALSE;                   \n");
fprintf(iniFile,";                                      MTV machte es notwendig\n");
fprintf(iniFile,"; AUTO-DETECT-NAGRA                    Automatische Umschalten zur Systerdekodierung erlaubt\n");
if ( AutoDetect_Nagra == TRUE ) fprintf(iniFile,"AUTO-DETECT-NAGRA=TRUE;                   \n");
else fprintf(iniFile,"AUTO-DETECT-NAGRA=FALSE;                   \n");
fprintf(iniFile,"; AUTO-DETECT-VC                       Automatische Umschalten zur Videocryptdekodierung erlaubt\n");
if ( AutoDetect_VC == TRUE ) fprintf(iniFile,"AUTO-DETECT-VC=TRUE;                   \n");
else fprintf(iniFile,"AUTO-DETECT-VC=FALSE;                   \n");
fprintf(iniFile,"; VBI_VT                                   VideoText benutzen\n");
if (VBI_Flags&VBI_VT) fprintf(iniFile,"VBI_VT=TRUE;                   \n");
else fprintf(iniFile,"VBI_VT=FALSE;                   \n");
fprintf(iniFile,"; VBI_VPS                                  VPS-Daten auswerten\n");
if (VBI_Flags&VBI_VPS) fprintf(iniFile,"VBI_VPS=TRUE;                   \n");
else fprintf(iniFile,"VBI_VPS=FALSE;                   \n");
fprintf(iniFile,"; VBI_VD                                   InterCast auswerten\n");
if (VBI_Flags&VBI_IC) fprintf(iniFile,"VBI_IC=TRUE;                   \n");
else fprintf(iniFile,"VBI_IC=FALSE;                   \n");
fprintf(iniFile,"; VBI_VC                                   Nagra/Videocrypt I/II auswerten\n");
if (VBI_Flags&VBI_VC) fprintf(iniFile,"VBI_VC=TRUE;                   \n");
else fprintf(iniFile,"VBI_VC=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC_BASE_DIR                              Pfad fr Datenablage InterCast\n");
fprintf(iniFile,"IC_BASE_DIR=%s;                      \n",IC_BASE_DIR);
fprintf(iniFile,"; VD_BASE_DIR                              Pfad fr Datenablage VideoDat\n");
fprintf(iniFile,"VD_BASE_DIR=%s;                      \n",VD_DIR);
fprintf(iniFile,"; VD_FILENAME                              Dateiname fr Datenablage VideoDat (Raw)\n");
fprintf(iniFile,"VD_FILENAME=%s;                      \n",VDat.RawName);
fprintf(iniFile,"; VD_RAWFILE                               Videodat als RAW-File ablegen\n");
if (VD_RAW == TRUE ) fprintf(iniFile,"VD_RAWFILE=TRUE;                   \n");
else fprintf(iniFile,"VD_RAWFILE=FALSE;                   \n");

fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** Special Registers Video ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; BT848-HUE-REGISTER                   Letzter Wert im Hue-Register\n");
fprintf(iniFile,"BT848-HUE-REGISTER=%d;             \n",InitialHue);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; BT848-CONTRAST-REGISTER              Letzter Wert im Kontrast-Register\n");
fprintf(iniFile,"BT848-CONTRAST-REGISTER=%d;             \n",InitialContrast);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; BT848-BRIGHTNESS-REGISTER            Letzter Wert im Helligkeit-Register\n");
fprintf(iniFile,"BT848-BRIGHTNESS-REGISTER=%d;          \n",InitialBrightness);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; BT848-SATURATION_U-REGISTER          Letzter Wert im Farbe U -Register\n");
fprintf(iniFile,"BT848-SATURATION_U-REGISTER=%d;        \n",InitialSaturationU);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; BT848-SATURATION_V-REGISTER          Letzter Wert im Farbe V-Register\n");
fprintf(iniFile,"BT848-SATURATION_V-REGISTER=%d;        \n",InitialSaturationV);
fprintf(iniFile,"; \n");
if ( InitialIFORM != 0 ) { 
fprintf(iniFile,"; BT848-IFORM-REGISTER          IFORM - Register wenn nicht default\n");
fprintf(iniFile,"BT848-IFORM-REGISTER=%d;        \n",InitialIFORM);
fprintf(iniFile,"; \n");
}
fprintf(iniFile,"; ****************** Eigener KartenType      ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"BT848_GPIO_OUT_EN=%d;             \n",ManuellAudio[0]);
fprintf(iniFile,"BT848_GPIO_REG_INP=%d;             \n",ManuellAudio[7]);
fprintf(iniFile,"BT848_GPIO_DATA_TUNER=%d;             \n",ManuellAudio[1]);
fprintf(iniFile,"BT848_GPIO_DATA_RADIO=%d;             \n",ManuellAudio[2]);
fprintf(iniFile,"BT848_GPIO_DATA_EXTERN=%d;             \n",ManuellAudio[3]);
fprintf(iniFile,"BT848_GPIO_DATA_INTERN=%d;             \n",ManuellAudio[4]);
fprintf(iniFile,"BT848_GPIO_DATA_AUS=%d;             \n",ManuellAudio[5]);
fprintf(iniFile,"BT848_GPIO_DATA_AN=%d;             \n",ManuellAudio[6]);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ****************** Special Registers Audio ****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; MSPMODE                           MSP-Initialisierung\n");
fprintf(iniFile,";                                      0 = AM (for carrier detect / msp3400\n");
fprintf(iniFile,";                                      1 = AM (for carrier detect / msp3410\n");
fprintf(iniFile,";                                      2 = FM Radio\n");
fprintf(iniFile,";                                      3 = Terrestial FM-mono + FM-stereo\n");
fprintf(iniFile,";                                      4 = Sat FM-mono\n");
fprintf(iniFile,";                                      5 = NICAM B/G, D/K\n");
fprintf(iniFile,";                                      6 = NICAM I\n");
fprintf(iniFile,"MSPMODE=%d\n",MSPMode);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; MSPMAJOR                           MSP-Initialisierung Gruppe 0\n");
fprintf(iniFile,";                                      0 = 4.5   NTSC\n");
fprintf(iniFile,";                                      1 = 5.5   PAL B/G\n");
fprintf(iniFile,";                                      2 = 6.0   PAL I\n");
fprintf(iniFile,";                                      3 = 5.5   PAL D/K + SAT + SECAM\n");
fprintf(iniFile,"MSPMAJOR=%d\n",MSPMajorMode);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; MSPMINOR                           MSP-Initialisierung Gruppe 1\n");
fprintf(iniFile,";                                      0 = 5.742 PAL B/G FM-stereo\n");
fprintf(iniFile,";                                      1 = 5.85  PAL B/G NICAM\n");
fprintf(iniFile,";                                      2 = 5.85  PAL D/K NICAM\n");
fprintf(iniFile,";                                      3 = 6.25  PAL D/K1 FM-stereo\n");
fprintf(iniFile,";                                      4 = 6.74  PAL D/K2 FM-stereo\n");
fprintf(iniFile,";                                      5 = 7.02  PAL SAT FM-stereo s/b\n");
fprintf(iniFile,";                                      6 = 7.20  PAL SAT FM-stereo s\n");
fprintf(iniFile,";                                      7 = 7.38  PAL SAT FM-stereo b\n");
fprintf(iniFile,"MSPMINOR=%d\n",MSPMinorMode);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; MSPSTEREO                          MSP-Initialisierung StereoMode\n");
fprintf(iniFile,";                                      1 = Mono\n");
fprintf(iniFile,";                                      2 = Stereo\n");
fprintf(iniFile,";                                      3 = ZweikanalTon Kanal 1\n");
fprintf(iniFile,";                                      4 = ZweikanalTon Kanal 2\n");
fprintf(iniFile,"MSPSTEREO=%d\n",MSPStereo);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; MSP-STEREO                         Stereomode automatisch anpassen\n");
if ( AutoStereoSelect == TRUE ) fprintf(iniFile,"MSP-STEREO=TRUE;                   \n");
else fprintf(iniFile,"MSP-STEREO=FALSE;                   \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_VOLUME                            Letzte benutzte Lautstrke\n");
fprintf(iniFile,"IC2_VOLUME=%d;             \n",InitialVolume);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_SPATIAL                          Letzter Wert im Spatial-Register\n");
fprintf(iniFile,"IC2_SPATIAL=%d;             \n",InitialSpecial);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_LOUDNESS                         Letzter Wert im Loudness-Register\n");
fprintf(iniFile,"IC2_LOUDNESS=%d;             \n",InitialLoudness);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_BASS                             Letzter Wert im Bass-Register\n");
fprintf(iniFile,"IC2_BASS=%d;          \n",InitialBass);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_TREBLE                           Letzter Wert Treble-Register\n");
fprintf(iniFile,"IC2_TREBLE=%d;        \n",InitialTreble);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_BALANCE                          Letzter Wert im Balance-Register\n");
fprintf(iniFile,"IC2_BALANCE=%d;        \n",InitialBalance);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; I2C_SUPERBASS                        Superbass aktivieren\n");
if ( InitialSuperBass == TRUE ) fprintf(iniFile,"I2C_SUPERBASS=TRUE;                   \n");
else fprintf(iniFile,"I2C_SUPERBASS=FALSE;                   \n");
fprintf(iniFile,"; IC2_EQUALIZER1                       Letzter Wert Equalizer1-Register\n");
fprintf(iniFile,"IC2_EQUALIZER1=%d;        \n",InitialEqualizer1);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_EQUALIZER2                       Letzter Wert Equalizer2-Register\n");
fprintf(iniFile,"IC2_EQUALIZER2=%d;        \n",InitialEqualizer2);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_EQUALIZER3                       Letzter Wert Equalizer3-Register\n");
fprintf(iniFile,"IC2_EQUALIZER3=%d;        \n",InitialEqualizer3);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_EQUALIZER4                       Letzter Wert Equalizer4-Register\n");
fprintf(iniFile,"IC2_EQUALIZER4=%d;        \n",InitialEqualizer4);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; IC2_EQUALIZER5                       Letzter Wert Equalizer5-Register\n");
fprintf(iniFile,"IC2_EQUALIZER5=%d;        \n",InitialEqualizer5);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; *********************** Risc - Steuerung  *****************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; CAPTUREVIDEO                            Capture Video \n");
if ( Capture_Video == TRUE ) fprintf(iniFile,"CAPTUREVIDEO=TRUE;                   \n");
else fprintf(iniFile,"CAPTUREVIDEO=FALSE;                   \n");
fprintf(iniFile,"; CAPTURETEXT                            Capture VBI-Daten \n");
if ( Capture_VBI == TRUE ) fprintf(iniFile,"CAPTUREVBI=TRUE;                   \n");
else fprintf(iniFile,"CAPTUREVBI=FALSE;                   \n");
fprintf(iniFile,"; LAENDERCODE                            Laendereinstellung\n");
fprintf(iniFile,"LAENDERCODE=%d;        \n",CountryCode);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ********************* Tuner Verwenden*************************\n");
fprintf(iniFile,"; \n");
if ( USETUNER == TRUE ) fprintf(iniFile,"TUNER_USE=TRUE;               ;Tuner wird initialisiert  \n");
else fprintf(iniFile,"TUNER_USE=FALSE;                  Tuner wird nicht initialisiert \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ********************* Karte Initialisieren *************************\n");
fprintf(iniFile,"; \n");
if ( USECARD == TRUE ) fprintf(iniFile,"CARD_USE=TRUE;               ;Karte wird initialisiert  \n");
else fprintf(iniFile,"CARD_USE=FALSE;                  Karte wird nicht initialisiert \n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ********************* Manuelle Tunerparamter  *************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"TUNER_THRESH1=%d;                         Schwellwert VHF_Low\n",Tuners[8].thresh1);
fprintf(iniFile,"TUNER_THRESH2=%d;                         Schwellwert VHF_High\n",Tuners[8].thresh2);
fprintf(iniFile,"TUNER_VHF_L=%d;                           Schaltwert  VHF_Low\n",Tuners[8].VHF_L);
fprintf(iniFile,"TUNER_VHF_H=%d;                           Schaltwert  VHF_High\n",Tuners[8].VHF_H);
fprintf(iniFile,"TUNER_UHF=%d;                             Schaltwert  UHF\n",Tuners[8].UHF);
fprintf(iniFile,"TUNER_CONFIG=%d;                          Konfigurationsparameter Tuner\n",Tuners[8].config);
fprintf(iniFile,"TUNER_I2C=%d;                             I2C - Bus - ID (automatisch!! <ndern keinen sinn, speichern eigentlich auch nicht>)\n",Tuners[8].I2C);
fprintf(iniFile,"TUNER_IFPCOFF=%d;                         Frequenz-Offset\n",Tuners[8].IFPCoff);
} else {
fprintf(iniFile,";                  ********************************\n");
fprintf(iniFile,";                  **       KEINE BT-Hardware   ***\n");
fprintf(iniFile,";                  **           gefunden        ***\n");
fprintf(iniFile,";                  ********************************\n");
}
fprintf(iniFile,"; \n");
fprintf(iniFile,"; *************************** FarbMischer *********************************\n");
fprintf(iniFile,"; \n");
if ( InvertRot == TRUE ) fprintf(iniFile,"INVERT-ROT=TRUE;               ;Rot invertieren \n");
else fprintf(iniFile,"INVERT-ROT=FALSE;                ; Rot invertieren \n");
if ( InvertGruen == TRUE ) fprintf(iniFile,"INVERT-GRUEN=TRUE;               ;Gruen invertieren \n");
else fprintf(iniFile,"INVERT-GRUEN=FALSE;                ; Gruen invertieren \n");
if ( InvertBlau == TRUE ) fprintf(iniFile,"INVERT-BLAU=TRUE;               ;Blau invertieren \n");
else fprintf(iniFile,"INVERT-BLAU=FALSE;                ; Blau invertieren \n");
if ( OffRot == TRUE ) fprintf(iniFile,"OFF-ROT=TRUE;               ;Rot aus \n");
else fprintf(iniFile,"OFF-ROT=FALSE;                ; Rot aus \n");
if ( OffGruen == TRUE ) fprintf(iniFile,"OFF-GRUEN=TRUE;               ;Gruen aus \n");
else fprintf(iniFile,"OFF-GRUEN=FALSE;                ; Gruen aus \n");
if ( OffBlau == TRUE ) fprintf(iniFile,"OFF-BLAU=TRUE;               ;Blau aus \n");
else fprintf(iniFile,"OFF-BLAU=FALSE;                ; Blau aus \n");
fprintf(iniFile,"; \n");
if ( HCMode1 == TRUE ) fprintf(iniFile,"COLORMIXMODE1=TRUE;               ;Farbmischer Typ 1  \n");
else fprintf(iniFile,"COLORMIXMODE1=FALSE;                ; Farbmischer Typ 1\n");
fprintf(iniFile,"MIXSCHWELLE=%d;                         Schwellwert Typ1 \n",HCSchwelle);
fprintf(iniFile,"MIXROT=%d;                              Typ 1 Rot erweiterung\n",HCRotFaktor);
fprintf(iniFile,"MIXGRUEN=%d;                              Typ 1 Gruen erweiterung\n",HCGruenFaktor);
fprintf(iniFile,"MIXBLAU=%d;                              Typ 1 Blau erweiterung\n",HCBlauFaktor);
fprintf(iniFile,"; \n");
if ( HCMode2 == TRUE ) fprintf(iniFile,"COLORMIXMODE2=TRUE;               ;Farbmischer Typ 2 \n");
else fprintf(iniFile,"COLORMIXMODE2=FALSE;                ; Farbmischer Typ 2\n");
fprintf(iniFile,"MIXCUTSCHWELLE=%d;                        Schwellwert Typ 2\n",HCCutFaktor);
fprintf(iniFile,"MIXCUTLOROT=%d;                           Typ 2 Rot unterhalb Schwelle\n",HCCutLoRotFaktor);
fprintf(iniFile,"MIXCUTLOGRUEN=%d;                           Typ 2 Gruen unterhalb Schwelle\n",HCCutLoGruenFaktor);
fprintf(iniFile,"MIXCUTLOBLAU=%d;                           Typ 2 Blau unterhalb Schwelle\n",HCCutLoBlauFaktor);
fprintf(iniFile,"MIXCUTHIROT=%d;                           Typ 2 Rot oberhalb Schwelle\n",HCCutHiRotFaktor);
fprintf(iniFile,"MIXCUTHIGRUEN=%d;                           Typ 2 Gruen oberhalb Schwelle\n",HCCutHiGruenFaktor);
fprintf(iniFile,"MIXCUTHIBLAU=%d;                           Typ 2 Blau oberhalb Schwelle\n",HCCutHiBlauFaktor);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ******************************************\n");
fprintf(iniFile,"; ** FILTRE BLEU/ROUGE SECAM              **\n");
fprintf(iniFile,"; ******************************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; FILTREBLEU : TRUE = activer FALSE = dsactiver\n");
if ( bFilterBlueLines == TRUE ) fprintf(iniFile,"FILTREBLEU=TRUE;                   \n");
else fprintf(iniFile,"FILTREBLEU=FALSE;                   \n");
fprintf(iniFile,"; SEUILBLEU                                : seuil de dtection de ligne bleue ,valeur en % de 1  100\n");
fprintf(iniFile,"; SEUILBLEU                                : Secam-Threshold U (Blau) in  % von ( 1 bis 100 )\n");
fprintf(iniFile,"SEUILBLEU=%3d;\n",iUFilterThresholdPCent);
fprintf(iniFile,"; SEUILROUGE : seuil de dtection de ligne rouge ,valeur en % de 1  100%\n");
fprintf(iniFile,"; SEUILROUGE                                : Secam-Threshold V (Rot) in  % von (	1 bis 100 )\n");
fprintf(iniFile,"SEUILROUGE=%3d;\n",iVFilterThresholdPCent);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; *************************** VideoText *********************************\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"; Die folgenden Werte knnen nur ber die INI-Datei verndert werden\n");
fprintf(iniFile,"; VideoText-Farbwerte\n");
fprintf(iniFile,"VT-SCHWARZ=%d\n",VTColourTable[0]);
fprintf(iniFile,"VT-ROT=%d;\n",VTColourTable[1]);
fprintf(iniFile,"VT-GRUEN=%d;\n",VTColourTable[2]);
fprintf(iniFile,"VT-GELB=%d;\n",VTColourTable[3]);
fprintf(iniFile,"VT-BLAU=%d;\n",VTColourTable[4]);
fprintf(iniFile,"VT-HELLBLAU=%d;\n",VTColourTable[6]);
fprintf(iniFile,"VT-WEIS=%d;\n",VTColourTable[7]);
fprintf(iniFile,"VT-UNSICHTBAR=%d;\n",VTColourTable[5]);
fprintf(iniFile,"VT-TRANSPARENT=%d;          (Sollte auf weis stehen )\n",VTColourTable[8]);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; *************************** Mixer-Device  *********************************\n");
fprintf(iniFile,"; \n");
if ( USE_MIXER == TRUE ) fprintf(iniFile,"USE_MIXER=TRUE;                  ;Mixersteuerung bernehmen\n");
 else fprintf(iniFile,"USE_MIXER=FALSE;                 ;Mixersteuerung nicht bernehmen\n");
fprintf(iniFile,"; \n");
fprintf(iniFile,"MIXER_VOLUME_LINKER_KANAL=%d;	;Lautstrke linker AudioKanal\n",MIXER_LINKER_KANAL);
fprintf(iniFile,"MIXER_VOLUME_RECHTER_KANAL=%d;	;Lautstrke rechter AudioKanal\n",MIXER_RECHTER_KANAL);
fprintf(iniFile,"; \n");
fprintf(iniFile,"; ******************************************\n");
fprintf(iniFile,"; **         Die folgenden Eintrge       **\n");
fprintf(iniFile,"; **         sollten nicht von Hand       **\n");
fprintf(iniFile,"; **            editiert werden           **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** Beispiel:                            **\n");
fprintf(iniFile,"; ** MIXER_VOLUME_CONTROL=AAA BBB CCC DDD **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** AAA identifiziert das Soundsubsystem **\n");
fprintf(iniFile,"; **     das auszusprechen ist.           **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** BBB identifiziert den Ausgang, der   **\n");
fprintf(iniFile,"; **     auszusprechen ist.               **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** CCC identifiziert den dazugehrigen  **\n");
fprintf(iniFile,"; **     Eingang                          **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** DDD steht fr das Control            **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** Wenn iht in den Dialog unter Ausgabe **\n");
fprintf(iniFile,"; **  -> Audio-Mixer Einstellungen geht   **\n");
fprintf(iniFile,"; ** und dort auf zuweisen klickt, so     **\n");
fprintf(iniFile,"; ** wird euch fr jedes Control die      **\n");
fprintf(iniFile,"; ** Interne ID angegeben.                **\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ** Bei den Settings in MIXER_BOOT_UP    **\n");
fprintf(iniFile,"; **          (Wenn vorhanden)            **\n");
fprintf(iniFile,"; ** sind 4 weitere Werte enthalten,      **\n");
fprintf(iniFile,"; ** Diese Werte werden in die maximal 4  **\n");
fprintf(iniFile,"; ** Kanle zum Startzeitpunkt eingestellt**\n");
fprintf(iniFile,"; **                                      **\n");
fprintf(iniFile,"; ******************************************\n");
fprintf(iniFile,";\n");
fprintf(iniFile,"MIXER_VOLUME_CONTROL=%03d %03d %03d %03d ;  Control-Einstellungen fr Volume \n",Volume.SoundSystem,Volume.Destination,Volume.Connection,Volume.Control );
fprintf(iniFile,"MIXER_MUTE_CONTROL=%03d %03d %03d %03d ;  Control-Einstellungen fr Mute \n",Mute.SoundSystem,Mute.Destination,Mute.Connection,Mute.Control );
fprintf(iniFile,";Startup-Defaults\n");
for ( i=0; i < 64; i++ ) {
	if ( MixerLoad[i].MixerAccess.SoundSystem >= 0 ) {
        fprintf(iniFile,"MIXER_BOOT_UP=%03d %03d %03d %03d %d %d %d %d\n",MixerLoad[i].MixerAccess.SoundSystem,MixerLoad[i].MixerAccess.Destination,MixerLoad[i].MixerAccess.Connection,MixerLoad[i].MixerAccess.Control,MixerLoad[i].MixerValues.Kanal1,MixerLoad[i].MixerValues.Kanal2,MixerLoad[i].MixerValues.Kanal3,MixerLoad[i].MixerValues.Kanal4);
	};
}


fclose(iniFile);
return(TRUE);
}


void fill(SHORT *pDest, DWORD bytes)
{
	_asm {
		mov ecx, bytes
        shr ecx, 1 // filling dwords
		mov edi, pDest
		xor eax, eax; // fill value is zero
		rep stosd
	}
}


void Init_Screen_Struct()
{
RECT  sRect;
int OutX;
	
             GetClientRect(hWnd, &rectscreen);
             ClientToScreen(hWnd, (POINT*)&rectscreen.left);
             ClientToScreen(hWnd, (POINT*)&rectscreen.right);
			 
			 if (rectscreen.left < 0) rectscreen.left=0;
			 if (rectscreen.top < 0) rectscreen.top=0;
			 if (rectscreen.right > GetSystemMetrics(SM_CXSCREEN)) rectscreen.right=GetSystemMetrics(SM_CXSCREEN);
			 if (rectscreen.bottom > GetSystemMetrics(SM_CYSCREEN)) rectscreen.bottom=GetSystemMetrics(SM_CYSCREEN);
	
			 if ( pDecode != NULL ) {
 				    free(pDecode);
					pDecode=NULL;
			 };                     

             Destroy_Overlay();

             if ((ModeRAWSurface == TRUE ) || (( OutDib == FALSE ) && ( ModeOverlay == FALSE ))) InvalidateRect(NULL,NULL,TRUE);
			  else if ( ModeOverlay == FALSE ) InvalidateRect(hWnd,NULL,TRUE); 
			 CurrentX=(rectscreen.right-rectscreen.left);
			 CurrentY=(rectscreen.bottom-rectscreen.top);
		     CurrentX=(CurrentX/2)*2;
			 


			 if ( Display_Status_Bar == TRUE ) CurrentY-=21;

			 if ( CurrentY <= 10 ) CurrentY=10;
			 if ( CurrentX <= 10 ) CurrentX=10;

			 MaxY=ShowY=CurrentY;
			 if ( MaxY > 1024 ) MaxY=1024;
			 MaxX=CurrentX;


             if (( DecodeNagra == TRUE ) || ( DecodeVCrypt == TRUE ) || ( DecodeDecoderVCrypt == TRUE )) {
				  CurrentY=TVSettings[TVTYPE].wCropHeight;
                 
             };
			 
			 BurstOffset=0;


			 if ( Current_Mode == 0 ) {
			 if ( CurrentX > TVSettings[TVTYPE].wCropWidth ) CurrentX=TVSettings[TVTYPE].wCropWidth;
			 if ( CurrentY > TVSettings[TVTYPE].wCropHeight) CurrentY=TVSettings[TVTYPE].wCropHeight;
			 };
			 if ( Current_Mode == 1 ) {
				 if ( ModeRAWSurface == FALSE ) {
            			 if ( CurrentX > 800 ) CurrentX=800;
			              }
						 if ( CurrentY > 576 ) CurrentY=576;
				 };

				if (( ModeOverlay == TRUE ) && ( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) {
					if ( CurrentX > 768 ) CurrentX=768;
				};
 
             
			 if ( ShowY > CurrentY ) ShowY=CurrentY;		

             if (( DecodeVCrypt == TRUE ) || ( DecodeDecoderVCrypt == TRUE )) CurrentX=720;


			 if (( TVTYPE == 5 )  && (( DecodeNagra == TRUE ) || (DecodeDecoderVCrypt == TRUE ) || ( DecodeVCrypt == TRUE )))  {
				 BurstOffset=(int)((double)CurrentX/(double)TVSettings[TVTYPE].wCropWidth*(double)76);
   			     BurstOffset=(BurstOffset/2)*2;
				 if ( (CurrentX + BurstOffset ) > TVSettings[TVTYPE].wCropWidth ) {
					    CurrentX=844;
						BurstOffset=76;
				 };
			 
			 }


			if (pDIB==NULL) return;

			pDIB->bmiHeader.biSize          = sizeof(pDIB->bmiHeader);
			pDIB->bmiHeader.biWidth         = CurrentX;
			pDIB->bmiHeader.biHeight        = MaxY;
			pDIB->bmiHeader.biPlanes        = 1;
			pDIB->bmiHeader.biBitCount      = 16;    // 16 
			pDIB->bmiHeader.biCompression   = BI_RGB;
			pDIB->bmiHeader.biSizeImage     = pDIB->bmiHeader.biWidth    *
												 pDIB->bmiHeader.biHeight   *
												 pDIB->bmiHeader.biBitCount / 8
												 +128;
			pDIB->bmiHeader.biXPelsPerMeter = 0;
			pDIB->bmiHeader.biYPelsPerMeter = 0;
			pDIB->bmiHeader.biClrUsed       = 0;
			pDIB->bmiHeader.biClrImportant  = 0;


            DibPitch=(pDIB->bmiHeader.biBitCount/8*CurrentX);

            
			m_dwDisplaySize=(pDIB->bmiHeader.biSizeImage);

			pDecode=malloc(m_dwDisplaySize+1024);
			 if ( pDecode == NULL ) {
				MessageBox(hWnd,"Kein Decoding-Memory","Multi-Decode",MB_ICONSTOP|MB_OK);
			    SendMessage(hWnd,WM_DESTROY,0,0);
				return;
             }



  	        Offset_for_WindowOut=(SurfacePitch * rectscreen.top) + (rectscreen.left*2);
			if ( Offset_for_WindowOut < 0 ) {
				 Offset_for_WindowOut=0;
			}

			if ((( ModeOverlay == TRUE ) || (ModeRAWOverlay == TRUE )) && ( Can_Overlay )) {

				  if ( MaxX < CurrentX ) ModeOverlay=CreateOverlay(MaxX,MaxY); 
				    else ModeOverlay=CreateOverlay(CurrentX,MaxY); 
				
				if (ModeOverlay == TRUE ) {
					if (( Can_Overlay_Strech == TRUE ) && (USE_DX_OV_STRECH== TRUE )) {
				                 GetClientRect(hWnd, &sRect);
                                 ClientToScreen(hWnd, (POINT*)&sRect.left);
                                 ClientToScreen(hWnd, (POINT*)&sRect.right);
                      			 if ( Display_Status_Bar == TRUE ) sRect.bottom-=21;
								 
								 if ( sRect.left < 0 ) sRect.left=0;
								 if ( sRect.top < 0 ) sRect.top=0;
			                     if (sRect.right > GetSystemMetrics(SM_CXSCREEN)) sRect.right=GetSystemMetrics(SM_CXSCREEN);
			                     if (sRect.bottom > GetSystemMetrics(SM_CYSCREEN)) sRect.bottom=GetSystemMetrics(SM_CYSCREEN);


						if (( DecodeVCrypt == TRUE ) || ( DecodeDecoderVCrypt == TRUE ))  {
						OutX=MaxX;
						if ( OutX > 712 ) OutX=712;
					   if ( MaxY < (ZEILENZAHL-(MovieScale*2)) ) OverlayUpdate(OutX,MaxY,&sRect, DDOVER_SHOW,TRUE); 
                       else OverlayUpdate(OutX,(ZEILENZAHL-(MovieScale*2)),&sRect, DDOVER_SHOW,TRUE); 
					} else if ( DecodeNagra == TRUE ) {
									  if ( NagraFullField == TRUE ) {
           					              if ( MaxY < (ZEILENZAHL-(MovieScale*2))*2 ) OverlayUpdate(CurrentX,MaxY,&sRect, DDOVER_SHOW,TRUE); 
										  else OverlayUpdate(CurrentX,(ZEILENZAHL-(MovieScale*2))*2,&sRect, DDOVER_SHOW,TRUE);
									  } else {
                    					   if ( MaxY < (ZEILENZAHL-(MovieScale*2)) ) OverlayUpdate(CurrentX,MaxY,&sRect, DDOVER_SHOW,TRUE); 
                                           else OverlayUpdate(CurrentX,(ZEILENZAHL-(MovieScale*2)),&sRect, DDOVER_SHOW,TRUE); 
									  }
					} else {
						if ( HalfTVMode == TRUE ) {
						OverlayUpdate(CurrentX,(CurrentY/2)-(MovieScale*2),&sRect, DDOVER_SHOW,TRUE);
						} else {
						OverlayUpdate(CurrentX,CurrentY-(MovieScale*4),&sRect, DDOVER_SHOW,TRUE);
						}
                    }
					
					} else {
				                 GetClientRect(hWnd, &sRect);
                                 ClientToScreen(hWnd, (POINT*)&sRect.left);
                                 ClientToScreen(hWnd, (POINT*)&sRect.right);
								 if ( sRect.right - sRect.left > CurrentX ) sRect.right=sRect.left+CurrentX;
                      			 if ( Display_Status_Bar == TRUE ) sRect.bottom-=21;
								 OverlayUpdate(CurrentX,MaxY,&sRect, DDOVER_SHOW,TRUE);

					}
					Black_Overlay();
					};
			}

			if (( Has_BT == TRUE ) && ( Current_Mode==0 )) SetGeoSize(CurrentX+BurstOffset,CurrentY);
			if (( Has_DVB == TRUE ) && ( Current_Mode==1 )) set_up_grabbing();
         return;
}

void Restore_Mode()
{
              if ( MenuSave == TRUE ) {
				           MenuSave=FALSE;   	
			               Stop_Thread();
						   Set_Capture(4);
						   Flip=MenuFlip;
						   OutDib=MenuOutDib;
						   ModeOverlay=MenuModeOverlay;
						   ModeRAWSurface=MenuModeRAWSurface;
						   ModeRAWOverlay=MenuModeRAWOverlay;
                           Init_Screen_Struct();
			               Set_Capture(5);
			  };

}

void Save_Mode()
{ 
              if ( MenuSave == FALSE ) {
                           if ( OutDib == TRUE ) return; 
				           MenuSave=TRUE;   			  
		                   Stop_Thread();
						   Set_Capture(4);
						   MenuFlip=Flip;
						   MenuOutDib=OutDib;
						   MenuModeOverlay=ModeOverlay;
						   MenuModeRAWSurface=ModeRAWSurface;
						   MenuModeRAWOverlay=ModeRAWOverlay;
						   Flip=1;
						   OutDib=TRUE;
						   ModeOverlay=FALSE;
						   ModeRAWSurface=FALSE;
						   ModeRAWOverlay=FALSE;
                           Init_Screen_Struct();
			               Set_Capture(5);
             
			  }
}


void Clear_Status()
{
			AutoLockCount=0;
			UntilEven=0;
			UntilOdd=0;
            BlackEven=-1;
            BlackOdd=-1;
			FirstWidthEvenCount=0;
			FirstWidthOddCount=0;
            FirstWidthEven=TESTPIXEL;
            FirstWidthOdd=TESTPIXEL;
			Line286BlackEven=FALSE;
			Line286BlackOdd=FALSE;
			Line285BlackEven=FALSE;
			Line285BlackOdd=FALSE;
			Line0BlackEven=FALSE;
			Line0BlackOdd=FALSE;
			Line1BlackEven=FALSE;
			Line1BlackOdd=FALSE;

			MatrixModeEven=FALSE;
			MatrixModeOdd=FALSE;
			MatrixCountEven=0;
			MatrixCountOdd=0;
			MoreLinesLock=FALSE;
}



int G_Wert(int Wert1,int Wert2) 
{ if (Wert1>=Wert2) return(Wert1); 
  else return(Wert2);
}


void Init_HCYUV2RGBTabelle(BOOL  RGB15)
{
   int nY;
   int nV;
   int nU;
   int nR;
   int nG;
   int nB;

   double Faktor;

   Faktor=(double)(255-HCSchwelle)/255;
   HCInit15=RGB15;
   //
   // Das Format der Tabelle YUV2RGB:
   //
   //   0x3F00    0x0FC0  0x003F
   //  17--V--12 11--U--6 5--Y--0
   //  MSB                    LSB
   //
   for(nY=0; nY<256; nY+=4)  
   {
      for(nU=0; nU<256; nU+=4)
      {
         for(nV=0; nV<256; nV+=4)
         {


            
            if ( HCMode1 == TRUE ) {
				if ( nY < HCSchwelle ) {
					nR=0;
					nG=0;
					nB=0;
				} else {
			nB = (116*(nY-16)                + 202*(nU-128)) / 100;
            nG = (116*(nY-16) -  81*(nV-128) -  39*(nU-128)) / 100;
            nR = (116*(nY-16) + 160*(nV-128)               ) / 100;
				}            
			} else if ( HCMode2 != TRUE ) {
            nB = (116*(nY-16)                + 202*(nU-128)) / 100;
            nG = (116*(nY-16) -  81*(nV-128) -  39*(nU-128)) / 100;
            nR = (116*(nY-16) + 160*(nV-128)               ) / 100;
			}


            if ( HCMode1 == TRUE ) {
                   nR=nR+HCRotFaktor;
				   nG=nG+HCGruenFaktor;
				   nB=nB+HCBlauFaktor;
			}

            if ( HCMode2 == TRUE ) {
				if ( nY < HCCutFaktor ) {
			       nR=HCCutLoRotFaktor;
				   nG=HCCutLoGruenFaktor;
				   nB=HCCutLoBlauFaktor;
				} else {
			       nR=HCCutHiRotFaktor;
				   nG=HCCutHiGruenFaktor;
				   nB=HCCutHiBlauFaktor;

				}

			}


			if ( InvertRot) nR=255-nR ;
			if ( InvertGruen) nG=255-nG ;
			if ( InvertBlau) nB=255-nB ;

			if ( OffRot) nR=0;
			if ( OffGruen) nG=0;
			if ( OffBlau) nB=0;


            if(nR>0xff) nR=0xff;
			        else if (nR<0) nR=0;
            if(nG>0xff) nG=0xff;
			        else if (nG<0) nG=0;
            if(nB>0xff) nB=0xff;
			        else if (nB<0) nB=0;


            if(RGB15)
               HCYUV2RGBTabelle[((nV>>2)<<12) | ((nU>>2)<<6) | nY>>2] = (USHORT)((nB>>3) | ((nG>>3)<<5) | ((nR>>3)<<10));
            else
               HCYUV2RGBTabelle[((nV>>2)<<12) | ((nU>>2)<<6) | nY>>2] = (USHORT)((nB>>3) | ((nG>>2)<<5) | ((nR>>3)<<11));
         }
      }
   }
}



void HCZeileAusgeben(DWORD *pQuelle,DWORD *pZiel, int Count)
{
   int    nPixel;
   DWORD  nUV;
   DWORD  nRGB1;
   DWORD  nRGB2;
 


               // v = v, u = u
               for(nPixel=0; nPixel<Count; nPixel+=2)
               {
                  nUV = *pQuelle>>4 & 0xfc0 | *pQuelle>>14 & 0x3f000;


                  nRGB1 = HCYUV2RGBTabelle[*pQuelle>>2 & 0x3f | nUV];
                  nRGB2 = HCYUV2RGBTabelle[*pQuelle>>18 & 0x3f | nUV];

                  *pZiel++ = nRGB1 | nRGB2<<16;
                  pQuelle++;
               }

     }

void HCZeileAusgeben_2(DWORD *pQuelle,DWORD  *pZiel,int Pitch, int Count)
{
   int    nPixel;
   DWORD  nUV;
   DWORD  nRGB1;
   DWORD  nRGB2;
   DWORD nRGB;
   int P=Pitch/4;
   
               // v = v, u = u
               for(nPixel=0; nPixel<Count; nPixel+=2)
               {
                  nUV = *pQuelle>>4 & 0xfc0 | *pQuelle>>14 & 0x3f000;

                  nRGB1 = HCYUV2RGBTabelle[*pQuelle>>2 & 0x3f | nUV];
                  nRGB2 = HCYUV2RGBTabelle[*pQuelle>>18 & 0x3f | nUV];
                  nRGB  = nRGB1 | nRGB2<<16;
                  *(pZiel+P)=nRGB;
                  *pZiel++=nRGB;
                 pQuelle++;
               }
     }

void HCZeileAusgeben_3(DWORD *pQuelle,DWORD *pZiel,int Pitch, int Count)
{
   int    nPixel;
   DWORD  nUV;
   DWORD  nRGB1;
   DWORD  nRGB2;
   DWORD nRGB; 
   int P=Pitch/4;
   int P1=Pitch/2;

               // v = v, u = u
               for(nPixel=0; nPixel<Count; nPixel+=2)
               {
                  nUV = *pQuelle>>4 & 0xfc0 | *pQuelle>>14 & 0x3f000;

                  nRGB1 = HCYUV2RGBTabelle[*pQuelle>>2 & 0x3f | nUV];
                  nRGB2 = HCYUV2RGBTabelle[*pQuelle>>18 & 0x3f | nUV];
                  nRGB  = nRGB1 | nRGB2<<16;
                  *(pZiel+P)=nRGB;
                  *(pZiel+P1)=nRGB;
                  *pZiel++=nRGB;
                  pQuelle++;
               }

     }

void HCZeileAusgeben_4(DWORD *pQuelle,DWORD *pZiel,int Pitch, int Count)
{
   int    nPixel;
   DWORD  nUV;
   DWORD  nRGB1;
   DWORD  nRGB2;
   DWORD nRGB;
   int P=Pitch/4;
   int P1=Pitch/2;
   int P2=Pitch;

 

               // v = v, u = u
               for(nPixel=0; nPixel<Count; nPixel+=2)
               {
                  nUV = *pQuelle>>4 & 0xfc0 | *pQuelle>>14 & 0x3f000;

                  nRGB1 = HCYUV2RGBTabelle[*pQuelle>>2 & 0x3f | nUV];
                  nRGB2 = HCYUV2RGBTabelle[*pQuelle>>18 & 0x3f | nUV];
                  nRGB  = nRGB1 | nRGB2<<16;
                  *(pZiel+P)=nRGB;
                  *(pZiel+P1)=nRGB;
                  *(pZiel+P2)=nRGB;
                  *pZiel++=nRGB;
                  pQuelle++;
               }

     }


BOOL APIENTRY ColorSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
int x,y,i;
   
	switch (message) {
        case WM_INITDIALOG:

            CheckDlgButton(hDlg, IDC_CHECK3, InvertRot);
            CheckDlgButton(hDlg, IDC_CHECK4, InvertGruen);
            CheckDlgButton(hDlg, IDC_CHECK5, InvertBlau);
            CheckDlgButton(hDlg, IDC_CHECK8, OffRot);
            CheckDlgButton(hDlg, IDC_CHECK9, OffGruen);
            CheckDlgButton(hDlg, IDC_CHECK10,OffBlau);
            CheckDlgButton(hDlg, IDC_CHECK7, HCMode1);
            CheckDlgButton(hDlg, IDC_CHECK6, HCMode2);
            

			y=(int)(269-((double)(HCSchwelle)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),40,y-4,22,8,FALSE);
		    SetDlgItemInt(hDlg,IDC_D1,HCSchwelle,FALSE);

			y=(int)(189-((double)(HCRotFaktor)/512*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),116,y-4,22,8,FALSE);
            SetDlgItemInt(hDlg,IDC_D2,HCRotFaktor,TRUE);

			y=(int)(189-((double)(HCGruenFaktor)/512*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),191,y-4,22,8,FALSE);
            SetDlgItemInt(hDlg,IDC_D3,HCGruenFaktor,TRUE);

			y=(int)(189-((double)(HCBlauFaktor)/512*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),264,y-4,22,8,FALSE);
            SetDlgItemInt(hDlg,IDC_D4,HCBlauFaktor,TRUE);

			y=(int)(269-((double)(HCCutFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),377,y-4,22,8,FALSE);
            SetDlgItemInt(hDlg,IDC_D5,HCCutFaktor,FALSE);

			x=(int)(503+((double)(HCCutHiRotFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S6),x-4,49,8,22,FALSE);
            SetDlgItemInt(hDlg,IDC_D6,HCCutHiRotFaktor,FALSE);

			x=(int)(503+((double)(HCCutHiGruenFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S7),x-4,94,8,22,FALSE);
            SetDlgItemInt(hDlg,IDC_D7,HCCutHiGruenFaktor,FALSE);

			x=(int)(503+((double)(HCCutHiBlauFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S8),x-4,141,8,22,FALSE);
            SetDlgItemInt(hDlg,IDC_D8,HCCutHiBlauFaktor,FALSE);

			x=(int)(503+((double)(HCCutLoRotFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S9),x-4,187,8,22,FALSE);
            SetDlgItemInt(hDlg,IDC_D9,HCCutLoRotFaktor,FALSE);

			x=(int)(503+((double)(HCCutLoGruenFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S10),x-4,231,8,22,FALSE);
            SetDlgItemInt(hDlg,IDC_D10,HCCutLoGruenFaktor,FALSE);

			x=(int)(503+((double)(HCCutLoBlauFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S11),x-4,278,8,22,FALSE);
            SetDlgItemInt(hDlg,IDC_D11,HCCutLoBlauFaktor,FALSE);

			break;



        case WM_MOUSEMOVE:

                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
			if (wParam == MK_LBUTTON) {
				if (( y >= 109) && ( y <= 269 )) {
					if (( x >= 40) && ( x <= 62 )) {

						i=(int)((double)(y-269)/160*256);
                        i=-i;
						if ( i < 0 ) i=0;
						 else if ( i > 255 ) i=255;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S1),40,y-2,22,8,TRUE);
						  HCSchwelle=i;
						  SetDlgItemInt(hDlg,IDC_D1,HCSchwelle,FALSE);
					}

					if (( x >= 116) && ( x <= 138 )) {
            			i=(int)((double)(y-189)/160*512);
                        if ( i < -255) i=-255;
						 else if ( i > 255 ) i=255;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S2),116,y-2,22,8,TRUE);
						  SetDlgItemInt(hDlg,IDC_D2,i,TRUE);
						  HCRotFaktor=i;
					}


					if (( x >= 191) && ( x <= 213 )) {
            			i=(int)((double)(y-189)/160*512);
                        if ( i < -255) i=-255;
						 else if ( i > 255 ) i=255;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S3),191,y-2,22,8,TRUE);
						  SetDlgItemInt(hDlg,IDC_D3,i,TRUE);
						  HCGruenFaktor=i;
					}

					if (( x >= 264) && ( x <= 286 )) {
            			i=(int)((double)(y-189)/160*512);
                        if ( i < -255) i=-255;
						 else if ( i > 255 ) i=255;
						  i=-i;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S4),264,y-2,22,8,TRUE);
						  SetDlgItemInt(hDlg,IDC_D4,i,TRUE);
						  HCBlauFaktor=i;
					}

					if (( x >= 377) && ( x <= 399 )) {
						i=(int)((double)(y-269)/160*256);
                        i=-i;
						if ( i < 0 ) i=0;
						 else if ( i > 255 ) i=255;
                 		  MoveWindow(GetDlgItem(hDlg,IDC_S5),377,y-2,22,8,TRUE);
						  SetDlgItemInt(hDlg,IDC_D5,i,FALSE);
      					  HCCutFaktor=i;
					}
				Init_HCYUV2RGBTabelle(HCInit15);
                }

				if (( x >= 503 ) && ( x <= 663 )) {

					if (( y >=49 ) && ( y <=71)) {
					i=(int)((double)(x-503)/160*255);
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						SetDlgItemInt(hDlg,IDC_D6,i,TRUE);
             			MoveWindow(GetDlgItem(hDlg,IDC_S6),x-4,49,8,22,TRUE);
						HCCutHiRotFaktor=i;
					}
					if (( y >=94 ) && ( y <=116)) {
					i=(int)((double)(x-503)/160*255);
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						SetDlgItemInt(hDlg,IDC_D7,i,TRUE);
             			MoveWindow(GetDlgItem(hDlg,IDC_S7),x-4,94,8,22,TRUE);
						HCCutHiGruenFaktor=i;
					}
					if (( y >=141 ) && ( y <=163)) {
					i=(int)((double)(x-503)/160*255);
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						SetDlgItemInt(hDlg,IDC_D8,i,TRUE);
             			MoveWindow(GetDlgItem(hDlg,IDC_S8),x-4,141,8,22,TRUE);
						HCCutHiBlauFaktor=i;
					}

					if (( y >=187 ) && ( y <=209)) {
					i=(int)((double)(x-503)/160*255);
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						SetDlgItemInt(hDlg,IDC_D9,i,TRUE);
             			MoveWindow(GetDlgItem(hDlg,IDC_S9),x-4,187,8,22,TRUE);
						HCCutLoRotFaktor=i;
					}
					if (( y >=231 ) && ( y <=253)) {
					i=(int)((double)(x-503)/160*255);
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						SetDlgItemInt(hDlg,IDC_D10,i,TRUE);
             			MoveWindow(GetDlgItem(hDlg,IDC_S10),x-4,231,8,22,TRUE);
						HCCutLoGruenFaktor=i;
					}
					if (( y >=278 ) && ( y <=300)) {
					i=(int)((double)(x-503)/160*255);
                        if ( i < 0) i=0;
						 else if ( i > 255 ) i=255;
						SetDlgItemInt(hDlg,IDC_D11,i,TRUE);
             			MoveWindow(GetDlgItem(hDlg,IDC_S11),x-4,278,8,22,TRUE);
						HCCutLoBlauFaktor=i;
					}
				Init_HCYUV2RGBTabelle(HCInit15);
			}
			
			}
           return(FALSE);
        case WM_COMMAND:
             if (((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK3)) ||
				 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK4)) ||
                 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK5)) ||
				 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK6)) ||
				 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK7)) ||
                 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK8)) ||
                 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK9)) ||
                 ((HWND)lParam==GetDlgItem(hDlg,IDC_CHECK10))) {
					InvertRot=IsDlgButtonChecked(hDlg, IDC_CHECK3);
					InvertGruen=IsDlgButtonChecked(hDlg, IDC_CHECK4);
					InvertBlau=IsDlgButtonChecked(hDlg, IDC_CHECK5);
					OffRot=IsDlgButtonChecked(hDlg, IDC_CHECK8);
					OffGruen=IsDlgButtonChecked(hDlg, IDC_CHECK9);
					OffBlau=IsDlgButtonChecked(hDlg, IDC_CHECK10);
					HCMode1=IsDlgButtonChecked(hDlg, IDC_CHECK7);
					HCMode2=IsDlgButtonChecked(hDlg, IDC_CHECK6);
					Init_HCYUV2RGBTabelle(HCInit15);
			 }				 
         			
			if (LOWORD(wParam) == IDOK ) {

					EndDialog(hDlg,TRUE);
			}


               if ( LOWORD(wParam) == IDDEFAULT) {
					InvertRot=FALSE;
					InvertGruen=FALSE;
					InvertBlau=FALSE;
					OffRot=FALSE;
					OffGruen=FALSE;
					OffBlau=FALSE;
					HCMode1=FALSE;
					HCMode2=FALSE;
					HCSchwelle=0x00;
					HCRotFaktor=0x00;
					HCGruenFaktor=0x00;
					HCBlauFaktor=0x00;
					HCCutFaktor=0x00;
					HCCutHiRotFaktor=0x00;
					HCCutHiGruenFaktor=0x00;
					HCCutHiBlauFaktor=0x00;
					HCCutLoRotFaktor=0x00;
					HCCutLoGruenFaktor=0x00;
					HCCutLoBlauFaktor=0x00;
    				Init_HCYUV2RGBTabelle(HCInit15);

            CheckDlgButton(hDlg, IDC_CHECK3, InvertRot);
            CheckDlgButton(hDlg, IDC_CHECK4, InvertGruen);
            CheckDlgButton(hDlg, IDC_CHECK5, InvertBlau);
            CheckDlgButton(hDlg, IDC_CHECK8, OffRot);
            CheckDlgButton(hDlg, IDC_CHECK9, OffGruen);
            CheckDlgButton(hDlg, IDC_CHECK10,OffBlau);
            CheckDlgButton(hDlg, IDC_CHECK6, HCMode1);
            CheckDlgButton(hDlg, IDC_CHECK7, HCMode2);
            

			y=(int)(269-((double)(HCSchwelle)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S1),40,y-4,22,8,TRUE);
		    SetDlgItemInt(hDlg,IDC_D1,HCSchwelle,FALSE);

			y=(int)(189-((double)(HCRotFaktor)/512*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S2),116,y-4,22,8,TRUE);
            SetDlgItemInt(hDlg,IDC_D2,HCRotFaktor,TRUE);

			y=(int)(189-((double)(HCGruenFaktor)/512*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S3),191,y-4,22,8,TRUE);
            SetDlgItemInt(hDlg,IDC_D3,HCGruenFaktor,TRUE);

			y=(int)(189-((double)(HCBlauFaktor)/512*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S4),264,y-4,22,8,TRUE);
            SetDlgItemInt(hDlg,IDC_D4,HCBlauFaktor,TRUE);

			y=(int)(269-((double)(HCCutFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S5),377,y-4,22,8,TRUE);
            SetDlgItemInt(hDlg,IDC_D5,HCCutFaktor,FALSE);

			x=(int)(503+((double)(HCCutHiRotFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S6),x-4,49,8,22,TRUE);
            SetDlgItemInt(hDlg,IDC_D6,HCCutHiRotFaktor,FALSE);

			x=(int)(503+((double)(HCCutHiGruenFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S7),x-4,94,8,22,TRUE);
            SetDlgItemInt(hDlg,IDC_D7,HCCutHiGruenFaktor,FALSE);

			x=(int)(503+((double)(HCCutHiBlauFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S8),x-4,141,8,22,TRUE);
            SetDlgItemInt(hDlg,IDC_D8,HCCutHiBlauFaktor,FALSE);

			x=(int)(503+((double)(HCCutLoRotFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S9),x-4,187,8,22,TRUE);
            SetDlgItemInt(hDlg,IDC_D9,HCCutLoRotFaktor,FALSE);

			x=(int)(503+((double)(HCCutLoGruenFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S10),x-4,231,8,22,TRUE);
            SetDlgItemInt(hDlg,IDC_D10,HCCutLoGruenFaktor,FALSE);

			x=(int)(503+((double)(HCCutLoBlauFaktor)/256*160));
			MoveWindow(GetDlgItem(hDlg,IDC_S11),x-4,278,8,22,TRUE);
            SetDlgItemInt(hDlg,IDC_D11,HCCutLoBlauFaktor,FALSE);


			   
			 }

			 break;
    }

return(FALSE);
}


BOOL APIENTRY CryptModeProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
char Text[120];
   
	switch (message) {
        case WM_INITDIALOG:
			 SetTimer(hDlg,0,20,NULL);
		case WM_TIMER:
			if ( CryptInfo.LastCryptMode == 0 ) {
        	 SetDlgItemText(hDlg,TEXT0,"Free-TV");
			 SetDlgItemText(hDlg,TEXT1,"");
			 SetDlgItemText(hDlg,TEXT2,"");
			 SetDlgItemText(hDlg,TEXT3,"");
			 SetDlgItemText(hDlg,TEXT4,"");
			} else if ( CryptInfo.LastCryptMode == 1 ) {
        	 SetDlgItemText(hDlg,TEXT0,"Syster/NagraVision");
			 SetDlgItemText(hDlg,TEXT1,"");
			 SetDlgItemText(hDlg,TEXT2,"");
			 SetDlgItemText(hDlg,TEXT3,"");
			 SetDlgItemText(hDlg,TEXT4,"");
			} 
//			else {
            if ( CryptInfo.LastCryptMode==2 ) SetDlgItemText(hDlg,TEXT0,"VideoCrypt I Dekodermodus");
            if ( CryptInfo.LastCryptMode==3 ) SetDlgItemText(hDlg,TEXT0,"VideoCrypt I");
 			if ( CryptInfo.OSD0Set == 1 ) {
			        CryptInfo.OSD0Set = 0;
					SetDlgItemText(hDlg,W1,"X");
					sprintf(Text,"OSD0   %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",CryptInfo.OSD0[0],CryptInfo.OSD0[1],CryptInfo.OSD0[2],CryptInfo.OSD0[3],CryptInfo.OSD0[4],CryptInfo.OSD0[5],CryptInfo.OSD0[6],CryptInfo.OSD0[7],CryptInfo.OSD0[8],CryptInfo.OSD0[9]);
					SetDlgItemText(hDlg,TEXT1,Text);
				} else SetDlgItemText(hDlg,W1,"");
			if ( CryptInfo.OSD1Set == 1 ) {
					SetDlgItemText(hDlg,W2,"X");
				    CryptInfo.OSD1Set = 0;
 					sprintf(Text,"OSD1   %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",CryptInfo.OSD1[0],CryptInfo.OSD1[1],CryptInfo.OSD1[2],CryptInfo.OSD1[3],CryptInfo.OSD1[4],CryptInfo.OSD1[5],CryptInfo.OSD1[6],CryptInfo.OSD1[7],CryptInfo.OSD1[8],CryptInfo.OSD1[9]);
					SetDlgItemText(hDlg,TEXT2,Text);
			} else SetDlgItemText(hDlg,W2,"");
			if ( CryptInfo.MSG0Set == 1 ) {
				SetDlgItemText(hDlg,W3,"X");
				CryptInfo.MSG0Set = 0;
			 sprintf(Text,"MSG0   %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",CryptInfo.MSG0[0],CryptInfo.MSG0[1],CryptInfo.MSG0[2],CryptInfo.MSG0[3],CryptInfo.MSG0[4],CryptInfo.MSG0[5],CryptInfo.MSG0[6],CryptInfo.MSG0[7],CryptInfo.MSG0[8],CryptInfo.MSG0[9]);
			 SetDlgItemText(hDlg,TEXT3,Text);
			} else SetDlgItemText(hDlg,W3,"");
			if ( CryptInfo.MSG1Set == 1 ) {
			        CryptInfo.MSG1Set = 0;
					SetDlgItemText(hDlg,W4,"X");
					sprintf(Text,"MSG1   %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x",CryptInfo.MSG1[0],CryptInfo.MSG1[1],CryptInfo.MSG1[2],CryptInfo.MSG1[3],CryptInfo.MSG1[4],CryptInfo.MSG1[5],CryptInfo.MSG1[6],CryptInfo.MSG1[7],CryptInfo.MSG1[8],CryptInfo.MSG1[9]);
				    SetDlgItemText(hDlg,TEXT4,Text);
			} else SetDlgItemText(hDlg,W4,"");
//			}
			break;
        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
			    KillTimer(hDlg,0);
				EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}


BOOL APIENTRY AboutProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
   
	switch (message) {
        case WM_INITDIALOG:
			break;
        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
				EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}


BOOL APIENTRY NagraKeySetProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
   
	switch (message) {
        case WM_INITDIALOG:
            SetDlgItemText(hDlg,EDIT1,OPKEY[0].Name);
            SetDlgItemText(hDlg,EDIT2,OPKEY[0].Extension);
            SetDlgItemText(hDlg,EDIT3,OPKEY[1].Name);
            SetDlgItemText(hDlg,EDIT4,OPKEY[1].Extension);
            SetDlgItemText(hDlg,EDIT5,OPKEY[2].Name);
            SetDlgItemText(hDlg,EDIT6,OPKEY[2].Extension);
            SetDlgItemText(hDlg,EDIT7,OPKEY[3].Name);
            SetDlgItemText(hDlg,EDIT8,OPKEY[3].Extension);
            if ( ActiveKey == 0 ) CheckDlgButton(hDlg,IDC_RADIO1,TRUE);
			  else if ( ActiveKey == 1 ) CheckDlgButton(hDlg,IDC_RADIO2,TRUE);
			  else if ( ActiveKey == 2 ) CheckDlgButton(hDlg,IDC_RADIO3,TRUE);
			  else if ( ActiveKey == 3 ) CheckDlgButton(hDlg,IDC_RADIO4,TRUE);
			break;
        case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
            GetDlgItemText(hDlg,EDIT1,OPKEY[0].Name,20);
            GetDlgItemText(hDlg,EDIT2,OPKEY[0].Extension,4);
            GetDlgItemText(hDlg,EDIT3,OPKEY[1].Name,20);
            GetDlgItemText(hDlg,EDIT4,OPKEY[1].Extension,4);
            GetDlgItemText(hDlg,EDIT5,OPKEY[2].Name,20);
            GetDlgItemText(hDlg,EDIT6,OPKEY[2].Extension,4);
            GetDlgItemText(hDlg,EDIT7,OPKEY[3].Name,20);
            GetDlgItemText(hDlg,EDIT8,OPKEY[3].Extension,4);
			OPKEY[0].Extension[3]=0x00;
			OPKEY[1].Extension[3]=0x00;
			OPKEY[2].Extension[3]=0x00;
			OPKEY[3].Extension[3]=0x00;
            if ( IsDlgButtonChecked(hDlg, IDC_RADIO1)) ActiveKey=0;
             else if ( IsDlgButtonChecked(hDlg, IDC_RADIO2)) ActiveKey=1;
             else if ( IsDlgButtonChecked(hDlg, IDC_RADIO3)) ActiveKey=2;
             else if ( IsDlgButtonChecked(hDlg, IDC_RADIO4)) ActiveKey=3;
				 if ( !Init_Nagra_Decoding(MasterTestzeilen)) {
					 SendMessage(hWnd,WM_COMMAND,IDM_DECODING_OFF,0);
					 break;
				 };
			 EndDialog(hDlg,TRUE);
			};

			if (LOWORD(wParam) == IDCANCEL ) {
				EndDialog(hDlg,TRUE);
			}
			break;
    }

return(FALSE);
}



BOOL APIENTRY VTInfoProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG:
             ShowVTInfo=hDlg;
			 SetTimer(hDlg,0,2000,NULL);
        case WM_TIMER:
			 if ( UTPages[0] !=  0 ) SetDlgItemInt(hDlg,TEXT8,UTPages[0],FALSE);
			 if ( UTPages[1] !=  0 ) SetDlgItemInt(hDlg,TEXT9,UTPages[1],FALSE);
			 if ( UTPages[2] !=  0 ) SetDlgItemInt(hDlg,TEXT10,UTPages[2],FALSE);
			 if ( UTPages[3] !=  0 ) SetDlgItemInt(hDlg,TEXT11,UTPages[3],FALSE);
			 if ( UTPages[4] !=  0 ) SetDlgItemInt(hDlg,TEXT12,UTPages[4],FALSE);
			 if ( UTPages[5] !=  0 ) SetDlgItemInt(hDlg,TEXT13,UTPages[5],FALSE);
			 if ( UTPages[6] !=  0 ) SetDlgItemInt(hDlg,TEXT14,UTPages[6],FALSE);
			 if ( UTPages[7] !=  0 ) SetDlgItemInt(hDlg,TEXT15,UTPages[7],FALSE);
			 if ( UTPages[8] !=  0 ) SetDlgItemInt(hDlg,TEXT16,UTPages[8],FALSE);
			 if ( UTPages[9] !=  0 ) SetDlgItemInt(hDlg,TEXT17,UTPages[9],FALSE);
			 if ( UTPages[10] !=  0 ) SetDlgItemInt(hDlg,TEXT18,UTPages[10],FALSE);
			 if ( UTPages[11] !=  0 ) SetDlgItemInt(hDlg,TEXT19,UTPages[11],FALSE);
			 SetDlgItemInt(hDlg,IDT_VBI_FPS,VBI_FPS,FALSE);
  
			 break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
        			KillTimer(hDlg,0);
					ShowVTInfo=NULL;
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}

BOOL APIENTRY DetectSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
  
	switch (message) {
        case WM_INITDIALOG:
		 CheckDlgButton(hDlg, IDC_CHECK1, AutoDetect_Nagra);
		 CheckDlgButton(hDlg, IDC_CHECK2, AutoDetect_VC);
		break;


		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
			   AutoDetect_Nagra=IsDlgButtonChecked(hDlg, IDC_CHECK1);
			   AutoDetect_VC=IsDlgButtonChecked(hDlg, IDC_CHECK2);
            EndDialog(hDlg,TRUE);
			break;  
}

      if (LOWORD(wParam) == IDCANCEL ) {
           EndDialog(hDlg,TRUE);
          break;  
}
 }

return(FALSE);
}



BOOL APIENTRY ToggleSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
  
	switch (message) {
        case WM_INITDIALOG:
		 if ( Toggle_WithOut_Frame == TRUE ) CheckDlgButton(hDlg, IDC_RADIO1, TRUE);
		     else CheckDlgButton(hDlg, IDC_RADIO2, TRUE);
		 break;


		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
			   Toggle_WithOut_Frame=IsDlgButtonChecked(hDlg, IDC_RADIO1);
            EndDialog(hDlg,TRUE);
			break;  
}

      if (LOWORD(wParam) == IDCANCEL ) {
           EndDialog(hDlg,TRUE);
          break;  
}
 }

return(FALSE);
}





BOOL APIENTRY VPSInfoProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG:
             ShowVPSInfo=hDlg;
             SetTimer(hDlg,100,1000,NULL);
             break;
        case WM_TIMER:
			  SetDlgItemInt(hDlg,IDT_VBI_FPS,VBI_FPS,FALSE);
			  break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
				    ShowVPSInfo=NULL;
			        KillTimer(hDlg,100); 
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}

BOOL APIENTRY ICSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG:
            SetDlgItemText(hDlg,IDC_EDIT1,IC_BASE_DIR);
			break;


        case WM_COMMAND:
			if (LOWORD(wParam) == IDOK ) {
                    GetDlgItemText(hDlg,IDC_EDIT1,IC_BASE_DIR,sizeof(IC_BASE_DIR));
					i=(int)CreateDirectory(IC_BASE_DIR,NULL);
					EndDialog(hDlg,TRUE);
			}
			
				if (LOWORD(wParam) == IDCANCEL ) {
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}

BOOL APIENTRY VDSettingProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
char FileName[255];
unsigned char Buffer[10];
FILE *sFile;

	switch (message) {
        case WM_INITDIALOG:
            SetDlgItemText(hDlg,IDC_EDIT1,VD_DIR);
            SetDlgItemText(hDlg,IDC_EDIT2,VDat.RawName);

			CheckDlgButton(hDlg, IDC_CHECK1, VD_RAW);
			
			if (VBI_Flags&VBI_VD) EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE); // Videodat luft also umwandeln nicht mglich !!
            sprintf(FileName,"%s//%s",VD_DIR,VDat.RawName);
            sFile = fopen(FileName, "rb");
			if ( sFile == NULL ) EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE); // Keine RAW-Datei da !!
			else fclose(sFile);
			if ( VD_RAW == FALSE ) {
              EnableWindow(GetDlgItem(hDlg,IDC_EDIT2),FALSE);
              EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
			}
			break;


        case WM_COMMAND:
            
			if ( (HWND)lParam==GetDlgItem(hDlg,IDC_CHECK1) ){
				    VD_RAW=IsDlgButtonChecked(hDlg, IDC_CHECK1);
 		        	if ( VD_RAW == FALSE ) {
                    EnableWindow(GetDlgItem(hDlg,IDC_EDIT2),FALSE);
                    EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE);
					} else if ( VD_RAW == TRUE ) {
                    EnableWindow(GetDlgItem(hDlg,IDC_EDIT2),TRUE);
                    EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),TRUE);
					}
			};


			if (LOWORD(wParam) == IDC_BUTTON1 ) {
               sprintf(FileName,"%s//%s",VD_DIR,VDat.RawName);
               sFile = fopen(FileName, "rb");
			   if ( sFile == NULL ) {
				   EnableWindow(GetDlgItem(hDlg,IDC_BUTTON1),FALSE); // Keine RAW-Datei da !!
				   return(TRUE);
			   };
          VideoDat_Init();
	      while ( fread(Buffer, sizeof(unsigned char), 10, sFile) == (size_t)10 )  {
			  Work_VideoDat(Buffer);
		  };                  
	   fclose(sFile);
	   return(TRUE);
			}

			if (LOWORD(wParam) == IDOK ) {
				    VD_RAW=IsDlgButtonChecked(hDlg, IDC_CHECK1);
                    GetDlgItemText(hDlg,IDC_EDIT1,VD_DIR,sizeof(VD_DIR));
					i=(int)CreateDirectory(VD_DIR,NULL);
                    GetDlgItemText(hDlg,IDC_EDIT2,VDat.RawName,sizeof(VDat.RawName));
					EndDialog(hDlg,TRUE);
			}
			
				if (LOWORD(wParam) == IDCANCEL ) {
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}



BOOL APIENTRY ICInfoProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG:
             SetTimer(hDlg,0,500,NULL);
		case WM_TIMER:
			SetDlgItemText(hDlg,TEXT1,InterCast.fname);
			SetDlgItemInt(hDlg,TEXT2,InterCast.total,FALSE);
			SetDlgItemInt(hDlg,TEXT3,InterCast.packnum,FALSE);
			SetDlgItemInt(hDlg,TEXT4,InterCast.packtot,FALSE);
			SetDlgItemInt(hDlg,TEXT5,InterCast.packlen,FALSE);
			SetDlgItemInt(hDlg,TEXT9,InterCast.BytesSoFar,FALSE);
			SetDlgItemInt(hDlg,TEXT6,InterCast.total,FALSE);
			SetDlgItemText(hDlg,TEXT10,InterCast.Error);
			SetDlgItemInt(hDlg,IDT_VBI_FPS,VBI_FPS,FALSE);
            
        break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) { 
				    KillTimer(hDlg,0);
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}



BOOL APIENTRY VDInfoProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG:
             SetTimer(hDlg,0,500,NULL);
		case WM_TIMER:
			SetDlgItemText(hDlg,TEXT3,SOTInfoRec.GeneralName);
			SetDlgItemText(hDlg,TEXT11,SOTInfoRec.Kommentar);
			SetDlgItemInt(hDlg,TEXT13, SOTInfoRec.date,FALSE);
			SetDlgItemInt(hDlg,TEXT9,SOTInfoRec.fanz,FALSE);
			SetDlgItemText(hDlg,TEXT1,VDat.FileName);
			SetDlgItemInt(hDlg,TEXT2, VDat.FileSize,FALSE);
			SetDlgItemInt(hDlg,TEXT8,VDat.BlockSoFar,FALSE);
			SetDlgItemInt(hDlg,TEXT6,VDat.CRCError,FALSE);
			SetDlgItemInt(hDlg,TEXT4,VDat.LBN,FALSE);
			SetDlgItemInt(hDlg,TEXT5,VDat.Lenght,FALSE);
			SetDlgItemInt(hDlg,TEXT7,VDat.KEY,FALSE);
			SetDlgItemText(hDlg,TEXT10,VDat.Error);
			SetDlgItemInt(hDlg,IDT_VBI_FPS,VBI_FPS,FALSE);
            
        break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) { 
				    KillTimer(hDlg,0);
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}



BOOL APIENTRY VDInfoProcRaw
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

	switch (message) {
        case WM_INITDIALOG:
             SetTimer(hDlg,0,500,NULL);
		case WM_TIMER:
			SetDlgItemText(hDlg,TEXT1,VD_DIR);
			SetDlgItemText(hDlg,TEXT2,VDat.RawName);
			SetDlgItemInt(hDlg,TEXT3,VDat.BlocksOK,FALSE);
			SetDlgItemInt(hDlg,TEXT5,VDat.BlocksError,FALSE);
			SetDlgItemText(hDlg,TEXT10,VDat.Error);
		    SetDlgItemInt(hDlg,IDT_VBI_FPS,VBI_FPS,FALSE);
        break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) { 
				    KillTimer(hDlg,0);
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}




BOOL APIENTRY PDCProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
	switch (message) {
        case WM_INITDIALOG:
             ShowPDCInfo=hDlg;
             SetTimer(hDlg,100,1000,NULL);
             break;

        case WM_TIMER:
			  SetDlgItemInt(hDlg,IDT_VBI_FPS,VBI_FPS,FALSE);
			  break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
			        KillTimer(hDlg,100); 
				    ShowPDCInfo=NULL;
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}

BOOL APIENTRY VideoTextUnterTitelProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
LPDRAWITEMSTRUCT    lpdis;
LPMEASUREITEMSTRUCT lpmis;
RECT       ptrtoWndPos;
int currX,currY;
int row,n;
int i;
unsigned short CurrentFg, CurrentBg, RealBkg;
BOOL bGraph,bHoldGraph,bSepGraph,bBox,bFlash,bDouble,bConceal,bHasDouble;
BYTE nLastGraph;
BYTE c,ch;
unsigned short Black,ForceBlack,ForceTransparent;
unsigned char buffer[40];

char VTUBuffer[400];
unsigned short VTUBufferFg[400];
char ZielChar;
int BufferFill;
int InsertPos;
   
	switch (message) {
        case WM_INITDIALOG:
            SetDlgItemInt(hDlg,IDC_EDIT1,UTPage,TRUE);
            currFont = CreateFontIndirect(&lf);
			UTList=CreateWindow("LISTBOX",NULL,
								 WS_BORDER | 
								 WS_CHILD | 
								 WS_VISIBLE |
                             // LBS_NOINTEGRALHEIGHT | 
                              LBS_NOTIFY |
                              // LBS_HASSTRINGS | 
                             // LBS_WANTKEYBOARDINPUT |
							  LBS_OWNERDRAWVARIABLE |
							  WS_VSCROLL ,
						//	  WS_HSCROLL |
						//	  LBS_SORT , 
                       //       LBS_DISABLENOSCROLL ,
								    0, 0, 0, 0,
                                    hDlg,
                                    NULL,
                                    hInst,
                                    NULL);


         SendMessage(UTList,
                     WM_SETFONT,
                     (WPARAM)currFont,
                     TRUE);

        SetTimer(hDlg,0,500,NULL);


		case WM_SIZE:
         GetWindowRect(hDlg,
                       &ptrtoWndPos);
					   currY=ptrtoWndPos.bottom-ptrtoWndPos.top;
					   currX=ptrtoWndPos.right-ptrtoWndPos.left;
					   currY=currY-90;
					   currX=currX-20;

         MoveWindow(UTList,
                    6,
                    35,
                    currX,
					currY,
                    TRUE);

         MoveWindow(GetDlgItem(hDlg,IDOK),
                    currX/2-10,
                    40+currY,
                    40,
					20,
                    TRUE);

		 break;
		

       case WM_DRAWITEM:
            /* Get pointer to the DRAWITEMSTRUCT */
            lpdis = (LPDRAWITEMSTRUCT)lParam;

            if (lpdis->itemID == -1)
            {
                /* We have a request to draw an item in the list box, yet there
                 * are no list box items. This is sent when the user TABS into
                 * an empty list box or an empty list box gets the focus. We
                 * have to indicate (somehow) that this owner-draw list box has
                 * the focus. We do it in response to this message. Note that
                 * lpdis->itemData field would be invalid in this instance so
                 * we can't allow it to fall into our standard routines.
                 */
                HandleFocusState(UTList,lpdis);
            }
            else
            {
                switch (lpdis->itemAction)
                {
                        case ODA_DRAWENTIRE:
                                DrawEntireItem(UTList,lpdis,0);
                                break;

                        case ODA_SELECT:
                                HandleFocusState(UTList,lpdis);
                                break;

                        case ODA_FOCUS:
                                HandleFocusState(UTList,lpdis);
                                break;
                }
            }

            /* Return TRUE meaning that we processed this message. */
            return(TRUE);
            break;

        case WM_MEASUREITEM:
            lpmis = (LPMEASUREITEMSTRUCT)lParam;

            /* All the items are the same height since the list box style is
             * LBS_OWNERDRAWFIXED
             */
            lpmis->itemHeight = 14;
            return(TRUE);


		case WM_TIMER:

			 if ( VTFrame[UTPage].SubCount==0 ) return(TRUE);
             BufferFill=0;
             InsertPos=0;			 
 for ( row = 20; row < 25; row++ ) {
	 if ( VTFrame[UTPage].SubPage[0].LineUpdate[row] == 1 ) {

		 VTFrame[UTPage].SubPage[0].LineUpdate[row]=0;
		bGraph=bHoldGraph=bSepGraph=bBox=bFlash=bDouble=bConceal=bHasDouble=FALSE;
		nLastGraph=32;
       	Black=VTColourTable[0]; // 
	    ForceTransparent=VTColourTable[8];
        ForceBlack=VTColourTable[0];

 		for(n=0; n<40; n++)
		{
			buffer[n]=VTFrame[UTPage].SubPage[0].Frame[row][n]&0x7f;
		}

		CurrentFg=VTColourTable[7];
		for(n=0; n<40; n++)
		{
			c=buffer[n];
			ch=c;
			if(c<32)
			{
				if(c<8)
				{
					CurrentFg=VTColourTable[c];
					bGraph=FALSE;
				}
				if(c>=0x10 && c<=0x17)
				{
					bGraph=TRUE;
					CurrentFg=VTColourTable[c-0x10];
				}
				if(c==0x1d)
				{
					CurrentBg=(bBox || Black!=ForceTransparent)?CurrentFg:ForceTransparent;
					RealBkg=CurrentFg;
				}
				if(c==0x1c)
				{
					CurrentBg=bBox?ForceBlack:Black;
					RealBkg=ForceBlack;
				}
				if(c==0x08) bFlash=TRUE;
				if(c==0x09) bFlash=FALSE;
				if(c==0x0c) bDouble=FALSE;
				if(c==0x0d) bDouble=TRUE;
				if(c==0x18) bConceal=TRUE;
				if(c==0x19) bSepGraph=FALSE;
				if(c==0x1a) bSepGraph=TRUE;
				if(c==0x1e) bHoldGraph=TRUE;
				if(c==0x1f) bHoldGraph=FALSE;
				ch=bHoldGraph?nLastGraph:32;
			}
			nLastGraph=32;
			if(bGraph && (ch&0x20))
			{
				nLastGraph=ch;
				ch=(ch&0x1f)|((ch&0x40)>>1);
				ch+=96;
				if(bSepGraph) ch+=64;
			}
			else ch-=32;
        
    ZielChar=' ';
	if ( ch < 96 ) {
		ZielChar=VTtoAscii[ch];
	if (( BufferFill == 0 ) && ( ZielChar != ' ' )) {
	      VTUBuffer[BufferFill]=ZielChar;
		  VTUBufferFg[BufferFill]=CurrentFg;
          BufferFill++; 
	} else if ( BufferFill > 0 ) {
		if (( ZielChar == ' ' ) && (VTUBuffer[BufferFill-1] != ' ' )) {
	      VTUBuffer[BufferFill]=ZielChar;
		  VTUBufferFg[BufferFill]=CurrentFg;
          BufferFill++; 
		} else if ( ZielChar != ' ' ) {
	      VTUBuffer[BufferFill]=ZielChar;
		  VTUBufferFg[BufferFill]=CurrentFg;
          BufferFill++; 
		}
	}
	}
		}

	if ( BufferFill > 0 ) {
		if ( VTUBuffer[BufferFill-1] != ' ' ) {
	      VTUBuffer[BufferFill]=0x20;
		  VTUBufferFg[BufferFill]=CurrentFg;
          BufferFill++; 
		}
	}
}
}


i=0;
n=0;



while ( n < BufferFill) { 		

if ( i == 0 ) UT[UTLoop].Fg=VTUBufferFg[n];

UT[UTLoop].Zeile[i] = VTUBuffer[n];
i++;
n++;
UT[UTLoop].Zeile[i] = 0x00;

if ( ((n == BufferFill ) ||
     ( VTUBufferFg[n] != UT[UTLoop].Fg )) && 
	( strlen(UT[UTLoop].Zeile) > 0 )) {
			 SendMessage(UTList,LB_INSERTSTRING,InsertPos++,(LPARAM)UTLoop);
			 SendMessage(UTList,LB_DELETESTRING,128,(LPARAM)0);
			 UTLoop++;
			 i=0;
			 if ( UTLoop > 127 ) UTLoop=0;
}	
}		
		
		// Zeile Voll //
break;

		
		case WM_COMMAND:

			if ( (HWND)lParam==GetDlgItem(hDlg,IDC_EDIT1) ){
				i=GetDlgItemInt(hDlg,IDC_EDIT1,NULL,FALSE);		  
                if (( i >= 100 ) && ( i <= 899 )) UTPage=i-100;
              break;
			};
			
			
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) {
                    Restore_Mode();
				    KillTimer(hDlg,0);
					EndDialog(hDlg,TRUE);
			}
break;
    }

return(FALSE);
}

VOID APIENTRY HandleFocusState(HWND hDlg,LPDRAWITEMSTRUCT lpdis)
{
		int Typ;
        if (( lpdis->itemState & ODS_FOCUS) || (lpdis->itemState & ODS_SELECTED))
        {
				Typ=1;
        }
        else
        {
				Typ=0;
        }
		
		DrawEntireItem(hDlg,lpdis,Typ);
}

VOID APIENTRY DrawEntireItem(HWND hDlg,LPDRAWITEMSTRUCT lpdis,INT Typ)
{
		HFONT OldFont;
        BYTE R,G,B;


        OldFont = SelectObject(lpdis->hDC, currFont);
		R=(BYTE)((UT[lpdis->itemData].Fg&0x7C00)>>10)<<3;
		G=(BYTE)((UT[lpdis->itemData].Fg&0x3E0)>>5)<<3;
		B=(BYTE)((UT[lpdis->itemData].Fg&0x1F))<<3;
		if ( 32767 == UT[lpdis->itemData].Fg ) {
			R=0;
			G=0;
			B=0;
		};

		SetTextColor(lpdis->hDC,RGB(R,G,B));
	    SetBkColor(lpdis->hDC,RGB(255,255,255));
  		TextOut(lpdis->hDC,10,lpdis->rcItem.top+1,UT[lpdis->itemData].Zeile,strlen(UT[lpdis->itemData].Zeile));
		SelectObject(lpdis->hDC,OldFont);
		return;
}

void  SetMenuAnalog()
{
Setup_Coutry_Menu(GetMenu(hWnd));
if ( Has_DVB == FALSE ) EnableMenuItem(GetMenu(hWnd),IDM_SWAPMODE,MF_GRAYED);
CheckMenuItem( GetMenu(hWnd), ThreadClassId+1150, MF_CHECKED );
CheckMenuItem( GetMenu(hWnd), PriorClassId+1160, MF_CHECKED );
if ( Sync_Irq == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_SYNC_IRQ, MF_CHECKED );
if ( WindowStyle == 0 ) {
		CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_CHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );
	} else if  ( WindowStyle == 1 ) {
		CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_CHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );
	} else if	( WindowStyle == 2 ) {
		CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_CHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_UNCHECKED );
	} else if	( WindowStyle == 3 ) {
		CheckMenuItem( GetMenu(hWnd), IDM_FENSTER, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_640x480, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_800x600, MF_UNCHECKED );
		CheckMenuItem( GetMenu(hWnd), IDM_OWN_RES, MF_CHECKED );
};
				  
	if ( WTVBPP == 0 ) {
		EnableMenuItem(GetMenu(hWnd),IDM_INTERN_SURFACE,MF_GRAYED);
		EnableMenuItem(GetMenu(hWnd),IDM_RAW_SURFACE,MF_GRAYED);
	}		
		if ( Can_Overlay) {
	EnableMenuItem(GetMenu(hWnd),IDM_OVERLAY,MF_ENABLED);
	EnableMenuItem(GetMenu(hWnd),IDM_RAW_OVERLAY,MF_ENABLED);
	if ( Can_Overlay_Strech == FALSE ) EnableMenuItem(GetMenu(hWnd),IDM_DX_OV_STRECH,MF_GRAYED);
		else EnableMenuItem(GetMenu(hWnd),IDM_DX_OV_STRECH,MF_ENABLED);
	} else {
		EnableMenuItem(GetMenu(hWnd),IDM_OVERLAY,MF_GRAYED);
		EnableMenuItem(GetMenu(hWnd),IDM_DX_OV_STRECH,MF_GRAYED);
		EnableMenuItem(GetMenu(hWnd),IDM_RAW_OVERLAY,MF_GRAYED);
	}
   if ( bFilterBlueLines == TRUE )CheckMenuItem( GetMenu(hWnd), IDM_NOBLUELINES, MF_CHECKED );
   if ( USE_DX_OV_STRECH == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_DX_OV_STRECH, MF_CHECKED );
   if ( WAIT_DX_VBI == TRUE )  CheckMenuItem( GetMenu(hWnd), IDM_DX_AUSTAST, MF_CHECKED );
   if ( USE_DX_LOCK == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_DX_LOCK, MF_CHECKED );
   if ( ColorMix == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_COLORMIX, MF_CHECKED ); 
   if ( HalfTVMode == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_HALFMODE, MF_CHECKED ); 
   if ( Decode_AutoDetect == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_AUTODETECT, MF_CHECKED ); 
    if (VBI_Flags&VBI_VT) {
					   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VT, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXTSMALL,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_CALL_VIDEOTEXT,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_VT_RESET,MF_ENABLED);
 	                    EnableMenuItem(GetMenu(hWnd),IDM_UNTERTITEL,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_PDC_OUT,MF_ENABLED);
		                EnableMenuItem(GetMenu(hWnd),IDM_VT_OUT,MF_ENABLED);
					   }
				   }
				   if (VBI_Flags&VBI_IC) {
					    CheckMenuItem( GetMenu(hWnd), IDM_VBI_IC, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_IC_OUT,MF_ENABLED);
				   }
                   }
						
				  if (VBI_Flags&VBI_VC) {
					   CheckMenuItem( GetMenu(hWnd), IDM_VBI_VC, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_CRYPTSTATUS,MF_ENABLED);
				   }
                   }
				  if (VBI_Flags&VBI_VPS) {
					  CheckMenuItem( GetMenu(hWnd), IDM_VBI_VPS, MF_CHECKED );
					   if ( Capture_VBI == TRUE ) {
					    EnableMenuItem(GetMenu(hWnd),IDM_VPS_OUT,MF_ENABLED);
				   }
                  }				   
					  
				   if ( Auto_MovieBoost == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_AUTOMB, MF_CHECKED ); 

				  if ( USECARD == FALSE ) CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH_CARD, MF_CHECKED ); 

     			 if ( USETUNER == FALSE ) {
					 CheckMenuItem( GetMenu(hWnd), IDM_DONT_TOUCH, MF_CHECKED );
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_0,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_1,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_2,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_3,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_5,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_6,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_7,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_TUNER_8,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNELPLUS,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNELMINUS,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNEL_SEARCH,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_FREQ_SEARCH,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_CHANNEL_SEARCH,MF_GRAYED);
					 EnableMenuItem(GetMenu(hWnd),IDM_MANUELL_TUNER,MF_GRAYED);
				 };
				  
	CheckMenuItem( GetMenu(hWnd), CountryCode+5000, MF_CHECKED );
	CheckMenuItem( GetMenu(hWnd), CardType+1080, MF_CHECKED );
    CheckMenuItem( GetMenu(hWnd), AudioSource+1110, MF_CHECKED );
	CheckMenuItem( GetMenu(hWnd), TVTYPE+1120, MF_CHECKED );
	CheckMenuItem( GetMenu(hWnd), ColourFormat+1130, MF_CHECKED );
    if ( VideoSource > 0 ) CheckMenuItem( GetMenu(hWnd), VideoSource+1089, MF_CHECKED );
		else {
	CheckMenuItem( GetMenu(hWnd), TunerType+1100, MF_CHECKED );
	}
	CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_UNCHECKED );
	CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_UNCHECKED );
	CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_UNCHECKED );
	CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_UNCHECKED );
	CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_UNCHECKED );

    if ( ModeRAWSurface==TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_RAW_SURFACE, MF_CHECKED );
      else if ( ModeRAWOverlay==TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_RAW_OVERLAY, MF_CHECKED );
		else if ( OutDib==TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_DIB, MF_CHECKED );
			 else if ( ModeOverlay == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_OVERLAY, MF_CHECKED );
				  else  CheckMenuItem( GetMenu(hWnd), IDM_INTERN_SURFACE, MF_CHECKED );

CheckMenuItem( GetMenu(hWnd), 1600+MSPMode, MF_CHECKED );
CheckMenuItem( GetMenu(hWnd), 1630+MSPStereo, MF_CHECKED );
CheckMenuItem( GetMenu(hWnd), 1610+MSPMajorMode, MF_CHECKED );
CheckMenuItem( GetMenu(hWnd), 1620+MSPMinorMode, MF_CHECKED );
if ( Capture_Video==TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_VIDEO, MF_CHECKED );
if ( Capture_VBI ==TRUE ) {
		CheckMenuItem( GetMenu(hWnd), IDM_VBI, MF_CHECKED );
        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VT,MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd),IDM_VBI_IC,MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd),IDM_VBI_VD,MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),IDM_VBI_VC,MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),IDM_VBI_VPS,MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),IDM_AUTODETECT,MF_ENABLED);
};
};

void  SetMenuDigital()
{
if ( Has_BT == FALSE ) EnableMenuItem(hMenu,IDM_SWAPMODE,MF_GRAYED);

CheckMenuItem( hMenu, DVBType+1080, MF_CHECKED );
CheckMenuItem( hMenu, DVBTuner+1100, MF_CHECKED );

CheckMenuItem( hMenu, ThreadClassId+1150, MF_CHECKED );
CheckMenuItem( hMenu, PriorClassId+1160, MF_CHECKED );
if ( Keep_DVB_Loaded == TRUE ) CheckMenuItem( hMenu, IDM_KEEP_LOADED, MF_CHECKED );
if ( Sync_Irq == TRUE ) CheckMenuItem( GetMenu(hWnd), IDM_SYNC_IRQ, MF_CHECKED );
if ( WindowStyle == 0 ) {
		CheckMenuItem( hMenu, IDM_FENSTER, MF_CHECKED );
		CheckMenuItem( hMenu, IDM_640x480, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_800x600, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_OWN_RES, MF_UNCHECKED );
	} else if  ( WindowStyle == 1 ) {
		CheckMenuItem( hMenu, IDM_FENSTER, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_640x480, MF_CHECKED );
		CheckMenuItem( hMenu, IDM_800x600, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_OWN_RES, MF_UNCHECKED );
	} else if	( WindowStyle == 2 ) {
		CheckMenuItem( hMenu, IDM_FENSTER, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_640x480, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_800x600, MF_CHECKED );
		CheckMenuItem( hMenu, IDM_OWN_RES, MF_UNCHECKED );
	} else if	( WindowStyle == 3 ) {
		CheckMenuItem( hMenu, IDM_FENSTER, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_640x480, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_800x600, MF_UNCHECKED );
		CheckMenuItem( hMenu, IDM_OWN_RES, MF_CHECKED );
};
				  
	if ( WTVBPP == 0 ) {
		EnableMenuItem(hMenu,IDM_INTERN_SURFACE,MF_GRAYED);
		EnableMenuItem(hMenu,IDM_RAW_SURFACE,MF_GRAYED);
	}		
 if ( Can_Overlay) {
	EnableMenuItem(hMenu,IDM_OVERLAY,MF_ENABLED);
	EnableMenuItem(hMenu,IDM_RAW_OVERLAY,MF_ENABLED);
	if ( Can_Overlay_Strech == FALSE ) EnableMenuItem(hMenu,IDM_DX_OV_STRECH,MF_GRAYED);
		else EnableMenuItem(hMenu,IDM_DX_OV_STRECH,MF_ENABLED);
	} else {
		EnableMenuItem(hMenu,IDM_OVERLAY,MF_GRAYED);
		EnableMenuItem(hMenu,IDM_DX_OV_STRECH,MF_GRAYED);
		EnableMenuItem(hMenu,IDM_RAW_OVERLAY,MF_GRAYED);
	}
   if ( USE_DX_OV_STRECH == TRUE ) CheckMenuItem( hMenu, IDM_DX_OV_STRECH, MF_CHECKED );
   if ( WAIT_DX_VBI == TRUE )  CheckMenuItem( hMenu, IDM_DX_AUSTAST, MF_CHECKED );
   if ( USE_DX_LOCK == TRUE ) CheckMenuItem( hMenu, IDM_DX_LOCK, MF_CHECKED );
   if ( ColorMix == TRUE ) CheckMenuItem( hMenu, IDM_COLORMIX, MF_CHECKED ); 
   if ( HalfTVMode == TRUE ) CheckMenuItem( hMenu, IDM_HALFMODE, MF_CHECKED ); 
					  
   if ( Auto_MovieBoost == TRUE ) CheckMenuItem( hMenu, IDM_AUTOMB, MF_CHECKED ); 
	CheckMenuItem( hMenu, CardType+1080, MF_CHECKED );
    CheckMenuItem( hMenu, AudioSource+1110, MF_CHECKED );
	CheckMenuItem( hMenu, TVTYPE+1120, MF_CHECKED );
	CheckMenuItem( hMenu, ColourFormat+1130, MF_CHECKED );
	CheckMenuItem( hMenu, IDM_RAW_SURFACE, MF_UNCHECKED );
	CheckMenuItem( hMenu, IDM_RAW_OVERLAY, MF_UNCHECKED );
	CheckMenuItem( hMenu, IDM_INTERN_SURFACE, MF_UNCHECKED );
	CheckMenuItem( hMenu, IDM_OVERLAY, MF_UNCHECKED );
	CheckMenuItem( hMenu, IDM_DIB, MF_UNCHECKED );

    if ( ModeRAWSurface==TRUE ) CheckMenuItem( hMenu, IDM_RAW_SURFACE, MF_CHECKED );
      else if ( ModeRAWOverlay==TRUE ) CheckMenuItem( hMenu, IDM_RAW_OVERLAY, MF_CHECKED );
		else if ( OutDib==TRUE ) CheckMenuItem( hMenu, IDM_DIB, MF_CHECKED );
			 else if ( ModeOverlay == TRUE ) CheckMenuItem( hMenu, IDM_OVERLAY, MF_CHECKED );
				  else  CheckMenuItem( hMenu, IDM_INTERN_SURFACE, MF_CHECKED );
};


BOOL ValidModes(char Mode)
{
	if (( Mode == 'A' ) && ( Has_BT == TRUE )) return(TRUE);
	if (( Mode == 'D' ) && ( Has_DVB == TRUE )) return(TRUE);
return(FALSE);
}

void Set_Mode_Digital( void )
{
				 DOSIZE=FALSE;
				 Set_Capture(4);
				 Sleep(20);
				 Stop_Thread();
				 Sleep(10);
				 Run_BT_Irq(FALSE);
                 ResetIrq=0;
				 DecodeVCrypt=FALSE; 
			     DecodeNagra=FALSE;
				 MoreLinesLock=FALSE;
				 DecodeDecoderVCrypt=FALSE;
				 Free_Nagra_Decoding();
                 DestroyMenu(hMenu);
				 hMenu=LoadMenu(hInst,"DIGITALMENU");
				 if ( Show_Menu == TRUE ) SetMenu(hWnd,hMenu);
				 SetMenuDigital();
				 DestroyAcceleratorTable(hAccel);
				 hAccel = LoadAccelerators (hInst, "DIGITALACCEL");

				 // Digital  // 2 Screens-Buffer
              	for ( i=0; i < 2 ; i++ ) {
                   pDisplay[i]=DVB_Display_dma[i]->pUserAddr;
				}

				 Current_Mode = 1; 
                 ResetIrq=0;
                 Init_Screen_Struct();
				 DOSIZE=TRUE;
  				 Run_DVB_Irq(TRUE);
			 	 Set_Capture(5);

};

void Set_Mode_Analog( void )
{
	int i;
	
	             DOSIZE=FALSE;
				 Set_Capture(4);
				 Stop_Thread();
				 Run_DVB_Irq(FALSE);
                 DestroyMenu(hMenu);
				 hMenu=LoadMenu(hInst,"ANALOGMENU");
				 if ( Show_Menu == TRUE ) SetMenu(hWnd,hMenu);
			     SetMenuAnalog();
				 DestroyAcceleratorTable(hAccel);
				 hAccel = LoadAccelerators(hInst, "ANALOGACCEL");
                 Current_Mode=0;
                 ResetIrq=0;
				 for ( i=0; i < 5 ; i++ ) {
                       pDisplay[i]=Display_dma[i]->pUserAddr;
					}
                 Init_Screen_Struct();
				 Run_BT_Irq(TRUE);
				 DOSIZE=TRUE;
				 Set_Capture(5);
				 Sleep(100);
                 ResetIrq=0;
				 SetAudioSource(AudioSource);

};


void Init_Kernel_Memory( void )
{ 
	if ( Has_BT == TRUE ) {
		if ( !Init_BT_Kernel_Memory() ) {
			HardWareFound--;
			Has_BT = FALSE;
		};
	};

	if ( Has_DVB == TRUE ) {
		if ( !Init_DVB_Memory() ) {
				  Free_SAA7146_DMA(&debi_mem_dma);
	              Free_DVB_Display_DMA(0);
	              Free_DVB_Display_DMA(1);
				  Free_SAA7146_DMA(&rps0_mem_dma);

			HardWareFound--;
			Has_DVB = FALSE;
		};
};
};



void Write_Log(LPSTR Text)
{
 FILE* iniFile;

 if ((iniFile=fopen("NewMode.txt","a")) == NULL )  {
				 return;
			   }
fprintf(iniFile,"%s\n",Text);
fclose(iniFile);
};
